/* TradeClient <http://tradeclient.sourceforge.net>
 * $Id: calender-callbacks.h,v 1.14 2001/03/20 20:12:34 ttabner Exp $
 *
 * Copyright (C) 1999-2000 Bynari Inc.
 * Copyright (C) 2001 Project TradeClient
 *
 * LGPL
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#ifndef _CALENDER_CALLBACKS_H_
#define _CALENDER_CALLBACKS_H_
#include "puma.h"
#include "main-window-callbacks.h"
#include "tcal.h"

typedef enum CalendarView
{
	CALENDAR_VIEW_TODO,
	CALENDAR_VIEW_DAILY,
	CALENDAR_VIEW_WEEK,
	CALENDAR_VIEW_WORK,
	CALENDAR_VIEW_MONTH,
	CALENDAR_VIEW_YEAR,
} CalendarView;



void calendar_set_widget (GtkWidget *widget);
GtkWidget *calendar_get_widget ();
void calendar_destroy ();
int calendar_hide (GtkWidget *widget, GdkEvent *event, gpointer data);
void calendar_load_print (GtkWidget *widget, GtkCalendar *cal, EventTime *time);
void calendar_show ();
void calendar_daycal_day_selected (GtkCalendar *cal);
void calendar_daycal_month_changed (GtkCalendar *cal);

void calendar_event_categories (GtkWidget *widget, gpointer data);
void calendar_event_categories2 (GtkWidget *widget, gpointer data);
void calendar_new_event (GtkWidget *widget, gpointer data);
void calendar_event_destroy (GtkWidget *widget, gpointer data);
void canceled_event (GtkWidget *widget, CalendarEvent *event);
void calendar_event_accept (GtkWidget *widget, gpointer data);
void calendar_focus_child (Schedule *schedule, CalendarEvent *event);
void calendar_child_changed (Schedule *schedule, char *text, CalendarEvent *event);
void calendar_child_selected (Schedule *schedule, char *text, gpointer data, time_t start, time_t end);
void calendar_add_recipient (GtkWidget *widget, gpointer data);
void calendar_attendee_selected (GtkTree *tree, GtkWidget *child);
void calendar_event_edit (GtkWidget *w, gpointer data);
void calendar_event_delete (GtkWidget *widget, gpointer data);
void calendar_display_event (CalendarEvent *event);
void calendar_clear_event ();
void calendar_event_double_clicked (Schedule *schedule, char *text, CalendarEvent *event, time_t start, time_t stop);

void calendar_category_accept (GtkWidget *widget, gpointer data);
void calendar_category_cancel (GtkWidget *widget, gpointer data);

void event_select_potential (GtkCList *clist, gint row, gint column, 
                             GdkEventButton *event, gpointer data);
void event_unselect_potential (GtkCList *clist, gint row, gint column, 
                             GdkEventButton *event, gpointer data);
void event_select_attendee (GtkCList *clist, gint row, gint column, 
                            GdkEventButton *event, gpointer data);
void event_unselect_attendee (GtkCList *clist, gint row, gint column, 
                            GdkEventButton *event, gpointer data);
void event_select_all_potential (GtkWidget *widget, gpointer data);
void event_select_none_potential (GtkWidget *widget, gpointer data);
void event_select_all_attendee (GtkWidget *widget, gpointer data);
void event_select_none_attendee (GtkWidget *widget, gpointer data);
void event_add_required (GtkWidget *widget, gpointer data);
void event_add_optional (GtkWidget *widget, gpointer data);
void event_add_resource (GtkWidget *widget, gpointer data);
void event_select_accept (GtkWidget *widget, gpointer data);
void event_select_cancel (GtkWidget *widget, gpointer data);
void event_select_remove_attendees (GtkWidget *widget, gpointer data);
void event_select_set_rlist (Llist *list);

void calendar_weekcal_day_selected (GtkCalendar *cal);
void calendar_weekly_event_selected (GtkCList *clist, gint row, gint column, GdkEventButton *event, gpointer data);

void calendar_monthly_changed (GtkEditable *editable, gpointer data);
void calendar_monthly_year_changed (GtkEditable *editable, gpointer data);
void calendar_yearly_year_changed (GtkEditable *spin, gpointer data);
void calendar_yearly_event_selected (GtkTCal *tcal, CalendarEvent *event);
void calendar_workweekcal_day_selected (GtkCalendar *cal);

void calendar_todo_activated (GtkEntry *entry);
void calendar_todo_activated2 (GtkEntry *entry);
void calendar_todo_delete (GtkWidget *widget, gpointer data);
void calendar_todo_child_selected (GtkTree *tree, GtkWidget *child);
void calendar_todo_child_unselected (GtkTree *tree, GtkWidget *child);
void calendar_todo_completion_toggled (GtkToggleButton *toggle, GtkTree *tree);
void calendar_todo_changed (GtkEditable *editable);
void calendar_todo_due_changed (GtkEditable *editable);
void calendar_todo_rehash ();
void calendar_workweekly_populate (EventTime *time);
void calendar_weekly_populate (EventTime *time);
void calendar_switch_page (GtkNotebook *notebook, GtkNotebookPage *page,
                           guint page_num);
void calendar_update_all_uis ();
void mail_todo_callback (GtkWidget *widget, gpointer userdata);
GtkWidget *todo_popup(void);
void todo_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer userdata);
void new_event_subject_changed( GtkWidget *widget, gpointer data ) ;

#endif /* CALENDAR_CALLBACKS_H_ */
