/* TradeClient <http://tradeclient.sourceforge.net>
 * $Id: clipboard.h,v 1.4 2001/03/20 20:12:34 ttabner Exp $
 *
 * Copyright (C) 1999-2000 Bynari Inc.
 * Copyright (C) 2001 Project TradeClient
 *
 * LGPL
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#ifndef _CLIPBOARD_H_
#define _CLIPBOARD_H_

/*#include <gtk/gtkeditable.h>
#include <gtk/gtkwidget.h>
#include <gtk/gtkcontainer.h>*/
#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include "lang-support.h"


typedef enum DeltaType {
	DELTA_DELETE_BLOCK,
	DELTA_ADD_BLOCK,
	DELTA_DELETE_ALL
} DeltaType;

typedef struct UndoNode {
	GtkWidget *relative;
	DeltaType delta;
	char *charecter;
	guint length;
	guint offset;
	char *last;
	time_t timestamp;
} UndoNode;

void clip_focus_in_event (GtkWidget *widget);
void clip_button_press_event (GtkWidget *widget, GdkEventButton *button);
void clip_cut (GtkWidget *widget);
void clip_copy (GtkWidget *widget);
void clip_paste (GtkWidget *widget);
void clip_clear (GtkWidget *widget);
void clip_select_all (GtkWidget *widget);
void clear_undo_list();

GtkWidget *clip_create_menu ();
GtkWidget *clip_create_menuitem (GtkWidget *parent, GtkAccelGroup *accel_group);
void clip_handle_editable (GtkWidget *editable);
void undo_undo ();

#endif
