/* TradeClient <http://tradeclient.sourceforge.net>
 * $Id: file-selector-callbacks.h,v 1.3 2001/03/20 20:12:34 ttabner Exp $
 *
 * Copyright (C) 1999-2000 Bynari Inc.
 * Copyright (C) 2001 Project TradeClient
 *
 * LGPL
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#ifndef _FILE_SELECTOR_CALLBACKS_H_
#define _FILE_SELECTOR_CALLBACKS_H_
#include "puma.h"

typedef struct fs_node_info {
	char *name;
	int recursed;
	GtkCTreeNode *dummychild;
} fs_node_info;

typedef struct fs_accept_info {
	GtkSignalFunc func;
	GtkSignalFunc cancel;
	gpointer data;
} fs_accept_info;

void set_curnode (GtkCTreeNode *node);
void file_selector_destroy (GtkWidget *widget, GdkEvent *event, gpointer data);
void file_selector_cancel (GtkWidget *widget, gpointer data);
void file_selector_tree_expand (GtkCTree *ctree, GtkCTreeNode *node);
void file_selector_tree_select_row (GtkWidget *widget, GtkCTreeNode *node, gint column);
void file_selector_mask_activate (GtkWidget *widget);
void file_selector_tree_unselect_row (GtkCTree *widget, GtkCTreeNode *node, gint column);
void file_selector_file_selected (GtkWidget *widget, gint row, gint column, GdkEventButton *event, gpointer data);
void file_selector_file_unselected (GtkWidget *widget);
void file_selector_accept (GtkWidget *widget, gpointer data);
void file_selector_newdir_accept (GtkWidget *widget, GtkCTree *ctree);
void file_selector_newdir_cancel (GtkWidget *widget);
void file_selector_rename_accept (GtkWidget *widget, GtkCList *clist);
void file_selector_rename_cancel (GtkWidget *widget);
void file_selector_delete (GtkWidget *widget);

#endif /* _FILE_SELECTOR_CALLBACKS_H_ */

