/* TradeClient <http://tradeclient.sourceforge.net>
 * $Id: filter-opts.h,v 1.8 2001/03/20 20:12:34 ttabner Exp $
 *
 * Copyright (C) 1999-2000 Bynari Inc.
 * Copyright (C) 2001 Project TradeClient
 *
 * LGPL
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#ifndef _FILTER_OPTS_H_
#define _FILTER_OPTS_H_

#include "puma.h"

#define	F_ACTION_NONE			0x00
#define	F_ACTION_MOVE			(1<<0)
#define F_ACTION_DELETE			(1<<1)

#define F_SUBJECT			0
#define F_FROM				1
#define F_TO				2
#define F_CC				3
#define F_BCC				4
#define F_MSG				5
#define F_KEY				6
#define F_REPLYTO			7

#define F_AND				0
#define F_NOT				1
#define F_EQUAL				2

typedef struct FilterAction {
	int action;
	char *folder;
} FilterAction;

typedef struct FilterRule {
	int action;
	int matchline;
	int type;
	char *text;
	char *folder;

//	void *prev, *next; deprecated
	
} FilterRule;

/*
#define CRITERIA_SENDER_CONTAINS_ADDRESS      ( 1 << 0 )
#define CRITERIA_SUBJECT_CONTAINS_WORDS       ( 1 << 1 )
#define CRITERIA_MESSAGE_CONTAINS_WORDS       ( 1 << 2 )
#define CRITERIA_TO_LINE_CONTAINS_ADDRESS     ( 1 << 3 )
#define CRITERIA_CC_LINE_CONTAINS_ADDRESS     ( 1 << 4 )
#define CRITERIA_MESSAGE_GREATER              ( 1 << 5 )
#define CRITERIA_MESSAGE_LESSER               ( 1 << 6 )
#define CRITERIA_HAS_ATTACHMENT               ( 1 << 7 )
#define CRITERIA_ALL_MESSAGES                 ( 1 << 8 )

#define ACTION_MOVE_TO_FOLDER                 ( 1 << 0 )
#define ACTION_COPY_TO_FOLDER                 ( 1 << 1 )
#define ACTION_DELETE_MESSAGE                 ( 1 << 2 )
#define ACTION_FORWARD_MESSAGE                ( 1 << 3 )
#define ACTION_MARK_READ                      ( 1 << 4 )
#define ACTION_MARK_FLAGGED                   ( 1 << 5 )
#define ACTION_REPLY_TO                       ( 1 << 6 )
#define ACTION_LEAVE_ON_SERVER                ( 1 << 7 )
#define ACTION_STOP_RULES_PROCESSING          ( 1 << 8 )
#define ACTION_DO_NOT_DELETE                  ( 1 << 9 )


typedef enum RuleOperator {
	OP_AND,
	OP_NOT
} RuleOperator;

typedef struct RuleBoolean {
	RuleOperator oper;
	char *data;
	void *prev, *next;
} RuleBoolean;

typedef struct FilterRule {
	char *name;
	unsigned long criteria, actions;
	Llist *affected;
	Llist *sender_addresses;
	Llist *subject_words;
	Llist *message_words;
	Llist *toline_addresses;
	Llist *ccline_addresses;
	unsigned long max_size, min_size;
	char *folder_destination;
	Llist *folder_list;	
	void *prev, *next;
} FilterRule;

extern FilterRule *rules_list;
*/

GList *filter_first ();
FilterRule *filter_new_rule ();
void filter_add_rule (char *filt);
char *filter_to_char (FilterRule *rule);
char *filter_to_hr (FilterRule *rule);
FilterAction *filter_message (char *, char *, char *, char *, char *, char *, char *, char *);
void filter_delete_rule (FilterRule *rule);
void filter_move_up (FilterRule *rule);
void filter_move_down (FilterRule *rule);
void rule_destroy_all ();
void filter_action_destroy (FilterAction *fact);


#endif /* _FILTER_OPTS_H_ */
