/* TradeClient <http://tradeclient.sourceforge.net>
 * $Id: main-window-callbacks.h,v 1.17 2001/03/20 20:12:35 ttabner Exp $
 *
 * Copyright (C) 1999-2000 Bynari Inc.
 * Copyright (C) 2001 Project TradeClient
 *
 * LGPL
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#ifndef _MAIN_WINDOW_CALLBACKS_H_
#define _MAIN_WINDOW_CALLBACKS_H_
#include "pop3smtp.h"

int parse_from_line (char *fromline, char **email, char **first, char **last);
GtkWidget *make_new_message_window (GtkWidget *, gpointer);
void get_messages (GtkWidget *, gpointer);
void get_messages_iteration (int);
void replyto_clicked (GtkWidget *, gpointer);
void forward_clicked (GtkWidget *, gpointer);
void make_preferences (GtkWidget *, gpointer);
void clicked_on_message_handler (GtkWidget *, gint row, gint column, GdkEventButton *event, gpointer);
GList *message_get_selection ();
void message_selection_null ();
void unclicked_on_message (GtkWidget *, gint row, gint column, GdkEventButton *event, gpointer);
void folder_display (GtkCList *clist, Folder *fl);
void clicked_on_folder (GtkWidget *, GtkCTreeNode *, int column);
void unclicked_on_folder (GtkWidget *, GtkCTreeNode *, int column);
void destroy_selected_message (GtkWidget *, gpointer);
void replyto_clicked (GtkWidget *, gpointer);
void forward_clicked (GtkWidget *, gpointer);
void clicked_on_message (GtkWidget *, GdkEventButton *event, gpointer);
void destroy_message_popup (GtkWidget *, gpointer);
void empty_trash_callback (GtkWidget *, gpointer);
void replyto_activate (GtkWidget *, gpointer);
void replytoall_activate (GtkWidget *, gpointer);
void forward_activate (GtkWidget *, gpointer);
void delete_activate (GtkWidget *, gpointer);
void msearch_callback (GtkWidget *widget, gpointer data);
void mark_unread_callback (GtkWidget *widget, gpointer data);
void send_to_html_callback (GtkWidget *widget, gpointer data);
void move_to_activate (GtkWidget *, gpointer);
void add_to_activate (GtkWidget *widget, gpointer data);
void strip_format_activate (GtkWidget *, gpointer);
void t_clicked_on_folder (GtkWidget *, GdkEventButton *event, gpointer);
void empty_folder_activate (GtkWidget *, gpointer);
void new_folder_activate (GtkWidget *, gpointer);
void delete_folder_activate (GtkWidget *, gpointer);
void clicked_on_folder_in_create (GtkWidget *, gpointer);
void unclicked_on_folder_in_create (GtkWidget *, gpointer);
void accept_create_folder (GtkWidget *, gpointer);
void destroy_create_folder (GtkWidget *, gpointer);
void delete_folder_clicked (GtkWidget *, gpointer);
void address_book_clicked (GtkWidget *widget, gpointer data);
void accept_create_folder_two (GtkWidget *widget, gpointer data);
void save_message_activate (GtkWidget *widget, gpointer data);
void save_message_destroy (GtkWidget *widget, gpointer data);
void save_message_accept (GtkWidget *, char *, gpointer);
void filter_show_window (GtkWidget *widget, gpointer data);


/* Drag 'N Drop prototypes */

enum {
  TARGET_STRING,
  TARGET_ROOTWIN,
  TARGET_URL
};


void message_clist_data_get (GtkWidget          *widget,
		       GdkDragContext     *context,
		       GtkSelectionData   *selection_data,
		       guint               info,
		       guint               time,
		       gpointer            data);
					 
void message_clist_data_delete ();

void folder_ctree_drag_drop (GtkWidget	       *widget,
			    GdkDragContext     *context,
			    gint                x,
			    gint                y,
			    guint               time);
void folder_ctree_drag_motion (GtkWidget	       *widget,
			    GdkDragContext     *context,
			    gint                x,
			    gint                y,
			    guint               time);
void folder_ctree_drag_leave (GtkWidget	*widget, GdkDragContext *context, guint time);
void folder_ctree_data_received (GtkWidget *widget, GdkDragContext *context,
                                 gint x, gint y, GtkSelectionData *data,
                                 guint info, guint time);
void folder_ctree_set_background (GtkCTree *ctree, GtkCTreeNode *node, gpointer data);
void message_clist_clicked_column (GtkWidget *clist, gint column, gpointer data);

void message_resend (GtkWidget *widget, gpointer data);
void clicked_on_attachment (GtkWidget *widget, gint row, gint column, GdkEventButton *event, gpointer data);
void clicked_on_attachment_event (GtkWidget *widget, GdkEventButton *event, gpointer data);

void attachment_save (GtkWidget *widget, gpointer data);
void attachment_view (GtkWidget *widget, gpointer data);
void attachment_view_source (GtkWidget *widget, gpointer data);
void attachment_open_with (GtkWidget *widget, gpointer data);

void message_clist_remove_row (GtkCList *clist, int row);
void message_print (GtkWidget *widget, gpointer data);
void reply_to_all_stream (char *message);
void reply_to_all_clicked (GtkWidget *widget, gpointer data);
void main_window_sender_add (GtkWidget *widget, gpointer data);
void send_on_its_merry_way_stream (char *msg, char *type);
void message_print_stream (char *stream);
int message_event_loop ();
int calendar_event_loop() ;
int calendar_event_trigger(CalendarEvent *) ;
void popup_reminder(char *);
void en_button_clicked (GtkWidget *, gpointer);
void folder_shade_row( GtkCList *clist, int rowNum, int msgCnt, int unread, char * ) ;
gint new_clist_sort_func(GtkCList *clist, gconstpointer *row1, gconstpointer *row2);

#endif /* _MAIN_WINDOW_CALLBACKS_H_ */
