/* TradeClient <http://tradeclient.sourceforge.net>
 * $Id: message-fun.h,v 1.10 2001/03/20 20:12:35 ttabner Exp $
 *
 * Copyright (C) 1999-2000 Bynari Inc.
 * Copyright (C) 2001 Project TradeClient
 *
 * LGPL
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#ifndef _MESSAGE_FUN_H_
#define _MESSAGE_FUN_H_

#include "puma.h"

typedef struct Header_Info {
	char *from;
	char *to;
	char *cc;
	char *bcc;
	char *subject;
	char *priority;
	char *replyto;
	char *sensitivity;
	char *replyby;
	char *expiry;
	char *keywords;
	char *date;
	char *content_type;
	char *content_t_e;
	char *content_d;
	char *disposition_notify;
	char *uidl;
	char *mid;
} Header_Info;

typedef struct CNSS {
	char *str;
	unsigned long pos;
	unsigned long len;
} CNSS;

void destroy_hinfo (Header_Info *hinfo);
Header_Info *parse_header (char *head);
char *message_get_reply_quoted (Message *msg);
char *message_get_reply_quoted_stream (char *body);
void message_transpose_folders (Folder *fl);
char *header_displayable (char *head);
void hinfo_destroy (Header_Info *hinfo);
char *message_fix_for_send (char *string);
int index_find_uidl( const char *uidl, const char *msgID ) ;
char *find_message_uidl(char *msg);

#endif /* _MESSAGE_FUN_H_ */
