/* TradeClient <http://tradeclient.sourceforge.net>
 * $Id: mime.h,v 1.8 2001/03/20 20:12:35 ttabner Exp $
 *
 * Copyright (C) 1999-2000 Bynari Inc.
 * Copyright (C) 2001 Project TradeClient
 *
 * LGPL
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#ifndef _MIME_H_
#define _MIME_H_

#include "puma.h"

enum {
	MIMEHANDLE_NONE,
	MIMEHANDLE_SAVE,
	MIMEHANDLE_PROMPT,
	MIMEHANDLE_INT,
	MIMEHANDLE_EXT
};

enum {
	ENC_NONE,
	ENC_BASE64,
	ENC_QP
};

typedef struct multipart {
	char *tdata;
	int thead;
	char *bdata;
	int bhead;
} multipart;

typedef struct MimeType {
	char *type;
	char *handle;
	char *ext;
} MimeType;

typedef struct Attachment  {
	char *name;
	char *fname;
	char *mtype;
	unsigned long offset;
	unsigned long length;
	char *msg;
  struct Attachment *next;
} Attachment;

char gethex (int num);
void attachments_destroy (Attachment *att);
char *generate_boundary (unsigned int seed, int length);
MimeType *mime_type_add (char *type, char *handle, char *ext);
MimeType *mime_type_search_type (char *type);
MimeType *mime_type_search_ext (char *ext);
void mime_type_delete (char *type);
Llist *mime_type_first ();
void mime_type_add_defaults ();
int mime_handle (char *ttype);
char *get_boundary (char *content_type);
char *get_name (char *content_type);
char *get_filename (char *content_d);
int mime_enc_type (char *content_t_e);
char *mime_dec_base64 (char *data, unsigned long *bpos);
char *mime_dec_qp (char *data, unsigned long *bpos);
void message_save_body (GtkWidget *widget, gpointer data);
void message_use_ext_prog (GtkWidget *widget, gpointer data);
char *mime_process (char *message, Attachment *att, int popup);
char *mime_get_attachment (char *message, Attachment *att);
char *mime_encode (char *from, char *replyto, char *org, char *to, char *cc,
                   char *bcc, char *subject, char *timestamp, Llist *atlst,
                   int returnreceipt, char *priority);

MailMessage *new_mime_encode (char *from, char *replyto, char *org, char *to, char *cc,
			      char *bcc, char *subject, char *timestamp, Llist *atlst,
			      int returnreceipt, char *priority, char *sensitivity,
			      char *keyword, char *expire, char *replyby,
			      char *messageflag ) ;

#endif /* _MIME_H_ */
