/* TradeClient <http://tradeclient.sourceforge.net>
 * $Id: new-message-callbacks.h,v 1.10 2001/03/20 20:12:35 ttabner Exp $
 *
 * Copyright (C) 1999-2000 Bynari Inc.
 * Copyright (C) 2001 Project TradeClient
 *
 * LGPL
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#ifndef _NEW_MESSAGE_CALLBACKS_H_
#define _NEW_MESSAGE_CALLBACKS_H_

#define RECIPIENT_TO   0
#define RECIPIENT_CC   1
#define RECIPIENT_BCC  2

#include "puma.h"

typedef struct AFS_ {
	char *filename;
	char *data;
	char *type;
} AFS;

typedef struct StupidFunc_ {
	GtkSignalFunc func;
	GtkFunction failure;
	GtkWidget *widget;
	char *messagebody;
} StupidFunc;

void accept_new_message_window (GtkWidget *, gpointer);	
void destroy_new_message_window (GtkWidget *, gpointer);
void to_button_clicked (GtkWidget *widget, gpointer data);
void cc_button_clicked (GtkWidget *widget, gpointer data);
void bcc_button_clicked (GtkWidget *widget, gpointer data);
void new_message_changed_rows (GtkWidget *widget);
void new_message_save (GtkWidget *widget, gpointer data);
void new_message_print (GtkWidget *widget, gpointer data);
void new_message_add_attachment (GtkWidget *widget, gpointer data);
void new_message_accept_add_attachment (GtkWidget *fs, char *filename, gpointer data);
void new_message_attachment_selected (GtkWidget *widget, gint row, gint column, GdkEventButton *event, gpointer data);
void new_message_attachment_unselected (GtkWidget *widget, gint row, gint column, GdkEventButton *event, gpointer data);
void new_message_delete_attachment (GtkWidget *widget, gpointer data);

void new_message_drag_data_received (GtkWidget *widget, GdkDragContext *context,
                                 gint x, gint y, GtkSelectionData *data,
                                 guint info, guint time);
void new_message_check_names (GtkWidget *widget, gpointer data);
void new_message_recip_changed (GtkWidget *entry, gpointer data);
void new_message_recip_check (GtkWidget *entry, gpointer data);

void new_message_select_recipients (GtkWidget *widget, gpointer data);
void new_message_select_recipients_accept (GList *recips, GtkTree *tree);
char *word_wrap_body( char *msg, int wl ) ;
int is_emailv( char *addr );
void msgexp_cal(GtkWidget *widget, gpointer data);
void replyto_cal(GtkWidget *widget, gpointer data);


#endif /* _NEW_MESSAGE_CALLBACKS_H_ */
