/* TradeClient <http://tradeclient.sourceforge.net>
 * $Id: pref-windows-callbacks.h,v 1.12 2001/03/20 20:12:35 ttabner Exp $
 *
 * Copyright (C) 1999-2000 Bynari Inc.
 * Copyright (C) 2001 Project TradeClient
 *
 * LGPL
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#ifndef _PREF_WINDOWS_CALLBACKS_H_
#define _PREF_WINDOWS_CALLBACKS_H_

#include "puma.h"

GtkWidget *prefs_get_widget ();
void prefs_show (int);
int prefs_hide ();
void prefs_server_selected (GtkCList *clist, int row);
void prefs_server_unselected (GtkCList *clist);
void prefs_pop3_new ();
void prefs_imap_new ();
void window_sizes_rehash();
void window_sizes_set(char *);
void paned_pos_rehash();
void paned_pos_set(char *);
void clist_pos_rehash();
void clist_pos_set (char *sizes);
void prefs_edit_account ();
void prefs_delete_account ();
void prefs_display_server (GtkCList *clist, PopAccount *account);
void prefs_accept_pop3 (GtkWidget *widget, PopAccount *account);
void prefs_cancel_pop3 (GtkWidget *widget, PopAccount *account);

void mime_types_display_type (GtkCList *clist, MimeType *type);
void mime_types_select_row (GtkWidget *widget, gint row, gint column, GdkEventButton *event, gpointer data);
void mime_types_unselect_row (GtkWidget *widget, gint row, gint column, GdkEventButton *event, gpointer data);
void mime_types_add_type (GtkWidget *widget, gpointer data);
void mime_types_edit_type (GtkWidget *widget, gpointer data);
void mime_types_delete_type (GtkWidget *widget, gpointer data);
void mime_types_accept_window (GtkWidget *widget, MimeType *mtype);
void mime_types_destroy_window (GtkWidget *widget, GdkEvent *event, gpointer data);
void mime_types_cancel_window (GtkWidget *widget, gpointer data);
void mime_types_internal_toggle (GtkWidget *widget, gpointer data);
void mime_types_external_toggle (GtkWidget *widget, gpointer data);
void mime_types_rehash_clist ();

void reply_none_selected (GtkWidget *widget, gpointer data);
void reply_quoted_selected (GtkWidget *widget, gpointer data);
void reply_attached_selected (GtkWidget *widget, gpointer data);

void wasted_value_changed (GtkAdjustment *adjustment);

void compact_folders (GtkWidget *widget, gpointer data);
void undelete_messages (GtkWidget *widget, gpointer data);

void header_none_selected (GtkWidget *widget, gpointer data);
void header_some_selected (GtkWidget *widget, gpointer data);
void header_all_selected (GtkWidget *widget, gpointer data);

void filter_rules_select_rule (GtkWidget *widget, gint row, gint column, GdkEventButton *event, gpointer data);
void filter_rules_unselect_rule (GtkWidget *widget, gint row, gint column, GdkEventButton *event, gpointer data);
void filter_rules_add_rule  (GtkWidget *widget, gpointer data);
void filter_rules_edit_rule (GtkWidget *widget, gpointer data);
void filter_rules_delete_rule (GtkWidget *widget, gpointer data);
void filter_rules_move_up (GtkWidget *widget, gpointer data);
void filter_rules_move_down (GtkWidget *widget, gpointer data);
void preferences_hide_status_toggled (GtkWidget *widget, gpointer data);
void wsize_set_msw(GtkWidget *widget, GdkEvent *event, gpointer data);
void wsize_set_mnw(GtkWidget *widget, GdkEvent *event, gpointer data);
void wsize_set_msgw(GtkWidget *widget, GdkEvent *event, gpointer data);
void wsize_set_nmsgw(GtkWidget *widget, GdkEvent *event, gpointer data);
void wsize_set_calw(GtkWidget *widget, GdkEvent *event, gpointer data);
void ppos_set_mnw(GtkWidget *widget, GdkEvent *event, gpointer data);
void ppos_set_msgw(GtkWidget *widget, GdkEvent *event, gpointer data);
void cpos_set_msw(GtkCList *clist, gint column, gint width, gpointer data);
void cpos_set_mnw_fl(GtkCList *clist, gint column, gint width, gpointer data);
void cpos_set_mnw_msg(GtkCList *clist, gint column, gint width, gpointer data);
void cpos_set_mnw_mime(GtkCList *clist, gint column, gint width, gpointer data);
void cpos_set_msgw(GtkCList *clist, gint column, gint width, gpointer data);
void cpos_set_nmsgw(GtkCList *clist, gint column, gint width, gpointer data);
void cpos_set_ab(GtkCList *clist, gint column, gint width, gpointer data);
void insert_autosig_callback (GtkWidget *, gpointer);
void prefs_server_bpe(GtkWidget *, GdkEvent *, gpointer);

#endif /* _PREF_WINDOWS_CALLBACKS_H_ */
