/* TradeClient <http://tradeclient.sourceforge.net>
 * $Id: spelling.h,v 1.3 2001/03/20 20:12:35 ttabner Exp $
 *
 * Copyright (C) 1999-2000 Bynari Inc.
 * Copyright (C) 2001 Project TradeClient
 *
 * LGPL
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#ifndef _SPELLING_H_
#define _SPELLING_H_

#include "puma.h"

typedef struct Misspelled {
	int correct; // used for spell_check_word
	char *origword;
	int numofsugg;
	char **sugg;
} Misspelled;

typedef struct CheckSpelling {
	int numofmsw;
	char *text;
	int ph1, ph2, curimsw;
	Misspelled **msws;
	void *extra;
} CheckSpelling;

void spell_print_msw (Misspelled *msw);
void spell_print_cs (CheckSpelling *cs);
char *spell_fix_text (char *text);
Misspelled **spell_add_misspell (char *tline, Misspelled **msws, int *numemb);
CheckSpelling *spell_check_spelling (char *text);
Misspelled *spell_check_word (char *word);
Misspelled *spell_getnext_misspelled (CheckSpelling *cs);
void spell_insert_correction (CheckSpelling *cs, char *cword);
void spell_insert_todict_word (char *word);
void spell_destroy_msw (Misspelled *msw);
void spell_destroy_cs (CheckSpelling *cs);

#endif /* _SPELLING_H_ */
