/* TradeClient <http://tradeclient.sourceforge.net>
 * $Id: support.h,v 1.6 2001/03/20 20:12:35 ttabner Exp $
 *
 * Copyright (C) 1999-2000 Bynari Inc.
 * Copyright (C) 2001 Project TradeClient
 *
 * LGPL
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#include <gtk/gtk.h>

typedef struct SaveStringInfo {
	char *filename;
	char *data;
	unsigned long size;
} SaveStringInfo;

// object, parent, signal, function, data

GtkWidget*  lookup_widget (GtkWidget *widget, const gchar *widget_name);
void add_pixmap_directory (const gchar *directory);
GtkWidget* create_pixmap (GtkWidget *widget, const gchar *filename);
GtkWidget* create_pixmap_from_data (GtkWidget *widget, char **data);
GtkWidget* create_ewmd_dialog (int type, char *title, char *message);
GtkWidget* create_icon_text_menu_item (char *pixmap, char *name);
void cleanup ();
char *generate_timestamp ();
char *generate_os_info ();

/* Llist functions */
Llist *llist_append (Llist *, void *);
Llist *llist_prepend (Llist *begin, void *data);
Llist *llist_seek (Llist *, void *);
Llist *llist_seek_by_name (Llist *, char *);
Llist *llist_remove_by_node (Llist *);
Llist *llist_remove (Llist *, void *);
Llist *llist_blow_away (Llist *);
Llist *llist_blow_away_and_destroy (Llist *begin);
int llist_set_node_name (Llist *, char *);
Llist *llist_detach_by_node (Llist *node);
Llist *llist_detach (Llist *node, void *data);
int llist_length (Llist *begin);

void preferences_rehash_interface ();
void preferences_rehash_varibles ();

void save_string (char *data, unsigned long size, char *filename);
GList *pop_create_glist ();
GList *folder_create_glist ();

/*
 * replacement for system()
 */
void	spawn_with_status(char *cmd, int wait);
int format_name( int bufSize, char *dest, char *first, char *last, char *email ) ;

/*
 * this is to right align widgets that fall into GTK_MISC category
 *
 */
void right_align (GtkWidget *widget);
