/* TradeClient <http://tradeclient.sourceforge.net>
 * $Id: abook-callbacks.c,v 1.21 2001/03/20 22:19:33 ttabner Exp $
 *
 * Copyright (C) 1999-2000 Bynari Inc.
 * Copyright (C) 2001 Project TradeClient
 *
 * LGPL
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#include "abook-main.h"

GtkWidget *abook_widget;
Abook *current_abook=NULL;
GtkCTreeNode *current_node=NULL;
Abook_rd *selection=NULL;
GtkCTreeNode *all_entries=NULL;

Abook *abook_get_current () {
	return current_abook;
}

void abook_widget_rehash_abook_clist (Abook *abook, GtkCTree *ctree) {
	GList *seek, *seek2;
	Abook *abook2;
	Abook_entry *entry;
	Abook_group *group;	
	Abook_rd *rd;
	GtkCTreeNode *node, *tnode;
	GtkStyle *bold, *blue;
	gchar *ct_data[2];
	static GdkFont *bold_font=NULL;

/*	g_return_if_fail (abook != NULL);
 */	
	g_return_if_fail (ctree != NULL);

	if (!bold_font) 
		bold_font=gdk_font_load ("-*-helvetica-bold-r-*--*-*-*-*-*-*-*-1");

	gtk_clist_freeze (GTK_CLIST (GTK_WIDGET (ctree)));
	gtk_clist_clear (GTK_CLIST (GTK_WIDGET (ctree)));
	
	for (seek=abook_first();seek;seek=seek->next) {
		abook2=(Abook *)seek->data;
		for (seek2=abook2->entrys;seek2;seek2=seek2->next) {
			entry=(Abook_entry *)seek2->data;
			g_list_free (entry->nodes);
			entry->nodes=NULL;
		}
	}

	bold=gtk_style_copy (GTK_WIDGET (ctree)->style);
	bold->font=bold_font;
	bold->base[GTK_STATE_NORMAL].red=(0xe0 << 8);
	bold->base[GTK_STATE_NORMAL].green=(0xe0 << 8);
	bold->base[GTK_STATE_NORMAL].blue=(0xe0 << 8);
	blue=gtk_style_copy (GTK_WIDGET (ctree)->style);
	blue->font=bold_font;
	blue->base[GTK_STATE_NORMAL].red=(0xe0 << 8);
	blue->base[GTK_STATE_NORMAL].green=(0xe0 << 8);

	if(abook!=NULL){
	for (seek=abook->groups;seek;seek=seek->next) {
		group=(Abook_group *)seek->data;
		ct_data[0]=group->name;
		ct_data[1]=NULL;
		rd=(Abook_rd *)calloc (1, sizeof (Abook_rd));
		rd->type=ABOOK_GROUP;
		rd->group=group;
		group->node=gtk_ctree_insert_node (ctree, NULL, NULL, ct_data, 0, NULL,
		                                   NULL, NULL, NULL, 0, TRUE);
		gtk_ctree_node_set_row_style (ctree, group->node, bold);
		gtk_ctree_node_set_row_data_full (ctree, group->node, (gpointer)rd, 
		                                 (GtkDestroyNotify)abook_widget_destroy_row);
	}
	}
	if(abook!=NULL){
	ct_data[0]=(char *)calloc (1024, sizeof (char));
	for (seek=abook->entrys;seek;seek=seek->next) {
		entry=(Abook_entry *)seek->data;
		for (seek2=entry->groups;seek2;seek2=seek2->next) {
			group=(Abook_group *)seek2->data;
			rd=(Abook_rd *)calloc (1, sizeof (Abook_rd));
			rd->type=ABOOK_ENTRY;
			rd->entry=entry;
#if 0
			format_name (ct_data[0], entry->first, entry->last);
#else
			format_name( 1024, ct_data[0], entry->first, entry->last, entry->def_email ) ;
#endif
			ct_data[1]=entry->def_email;
			node=gtk_ctree_insert_node (ctree, group->node, NULL, ct_data, 0, 
			                            NULL, NULL, NULL, NULL, 0, TRUE);
			entry->nodes=g_list_append (entry->nodes, node);			
			gtk_ctree_node_set_row_data_full (ctree, node, (gpointer)rd, 
			                                 (GtkDestroyNotify)abook_widget_destroy_row);
		}
	}
	free (ct_data[0]);
	}
	ct_data[0]=strdup ("All Entries");
	ct_data[1]=NULL;
	node=gtk_ctree_insert_node (ctree, NULL, NULL, ct_data, 0, NULL,
	                            NULL, NULL, NULL, 0, TRUE);
	all_entries=node;
	gtk_ctree_node_set_row_style (ctree, node, blue);
	free (ct_data[0]);
	
	if(abook!=NULL){
	ct_data[0]=(char *)calloc (1024, sizeof (char));
	for (seek=abook->entrys;seek;seek=seek->next) {
		entry=(Abook_entry *)seek->data;
#if 0
		format_name (ct_data[0], entry->first, entry->last);
#else
		format_name (1024, ct_data[0], entry->first, entry->last, NULL ) ;
#endif
		ct_data[1]=entry->def_email;
		rd=(Abook_rd *)calloc (1, sizeof (Abook_rd));
		rd->type=ABOOK_ENTRY;
		rd->entry=entry;
		tnode=gtk_ctree_insert_node (ctree, node, NULL, ct_data, 0, NULL,
	                               NULL, NULL, NULL, 0, TRUE);
		gtk_ctree_node_set_row_data_full (ctree, tnode, (gpointer)rd, 
		                                 (GtkDestroyNotify)abook_widget_destroy_row);
		entry->nodes=g_list_append (entry->nodes, tnode);
	}
	free (ct_data[0]);
	}
	gtk_clist_thaw (GTK_CLIST (GTK_WIDGET (ctree)));
	current_abook=abook;
}

void abook_widget_rehash_abook (Abook *abook) {
	GtkCTree *ctree;
	/*if (!abook)
		return;
*/
	if (!abook_widget)
		return;
	ctree=GTK_CTREE (lw (abook_widget, "entry_ctree"));
	abook_widget_rehash_abook_clist (abook, ctree);
}

void abook_widget_rehash_optionmenu (GtkOptionMenu *omenu, GtkSignalFunc func) {
	GtkWidget *abook_om;
	GtkWidget *menuitem;
	GList *seek;
	Abook *abook;
	abook_om=gtk_menu_new ();
	gtk_widget_show (abook_om);
	for (seek=abook_first();seek;seek=seek->next) {
		abook=(Abook *)seek->data;
	  menuitem = gtk_menu_item_new_with_label (abook->name);
  	gtk_widget_show (menuitem);
		gtk_signal_connect (GTK_OBJECT (menuitem), "activate",
		                    func, (gpointer)abook);
  	gtk_menu_append (GTK_MENU (abook_om), menuitem);
	}
	if (abook_om) gtk_option_menu_set_menu (omenu, abook_om);
}

void abook_widget_rehash () {
	Abook *abook;
	GList *seek;
	
	if (!abook_widget)
		return;
	g_return_if_fail (GTK_IS_WIDGET (abook_widget));
	if (!abook_first()) {
		gtk_widget_set_sensitive (lw (abook_widget, "add_entry"), FALSE);
		gtk_widget_set_sensitive (lw (abook_widget, "add_group"), FALSE);
	} else {
		gtk_widget_set_sensitive (lw (abook_widget, "add_entry"), TRUE);
		gtk_widget_set_sensitive (lw (abook_widget, "add_group"), TRUE);
	}
/*	seek=abook_first ();  
	if (!seek){
	abook_widget_rehash_optionmenu (GTK_OPTION_MENU (lw (abook_widget, "abook_optionmenu")),
					                  GTK_SIGNAL_FUNC (abook_widget_changed_abook));   
	  return;}
	abook=seek->data;
	abook_widget_rehash_optionmenu (GTK_OPTION_MENU (lw (abook_widget, "abook_optionmenu")), 
	                                GTK_SIGNAL_FUNC (abook_widget_changed_abook));
	abook_widget_rehash_abook (abook);
*/
	if ((seek=abook_first())) abook=seek->data; 
	else abook=NULL;
	 abook_widget_rehash_optionmenu (GTK_OPTION_MENU (lw (abook_widget, "abook_optionmenu")),
					                  GTK_SIGNAL_FUNC (abook_widget_changed_abook));
    abook_widget_rehash_abook (abook); 
	return;

}

void abook_widget_show (GtkSignalFunc kill_func) {
	if (!GTK_IS_WIDGET (abook_widget)) {
		abook_create_main (kill_func);
		abook_widget_rehash ();
	}
	gtk_widget_show (abook_widget);
}

void abook_widget_set (GtkWidget *widget) {
	if (!GTK_IS_WIDGET (abook_widget)) {
		abook_widget=widget;
	}	
}

void abook_widget_unset () {
	if (GTK_IS_WIDGET (abook_widget)) {
		gtk_widget_destroy (abook_widget);
	}
	abook_widget=NULL;
}

GtkWidget *abook_widget_get () {
	return abook_widget;
}

void abook_widget_hide () {
	if (GTK_IS_WIDGET (abook_widget)) {
		abooks_save_all ();
		gtk_widget_hide (abook_widget);
	}
}

void abook_widget_changed_abook (GtkMenuItem *item, gpointer data) {
	abook_widget_rehash_abook (data);
	current_abook=data;
	selection=NULL;
}

void abook_widget_select_row (GtkCTree *ctree, GtkCTreeNode *node, gint column) {
	Abook_rd *rd=gtk_ctree_node_get_row_data (ctree, node);
	if (rd) {
		if (rd->type==ABOOK_GROUP) {
			gtk_label_set_text (GTK_LABEL (GTK_BIN (lw (abook_widget, "delete_entry"))->child), 
			                    "Remove Group");
			gtk_label_set_text (GTK_LABEL (GTK_BIN (lw (abook_widget, "edit_entry"))->child), 
			                    "Edit Group");

		} else {
			gtk_label_set_text (GTK_LABEL (GTK_BIN (lw (abook_widget, "delete_entry"))->child), 
			                    "Remove Entry");
			gtk_label_set_text (GTK_LABEL (GTK_BIN (lw (abook_widget, "edit_entry"))->child), 
			                    "Edit Entry");
		}
		gtk_widget_set_sensitive (lw (abook_widget, "edit_entry"), TRUE);
		gtk_widget_set_sensitive (lw (abook_widget, "delete_entry"), TRUE);
	}
	current_node=node;
}

void abook_widget_unselect_row (GtkCTree *ctree, GtkCTreeNode *node, gint column) {
	gtk_label_set_text (GTK_LABEL (GTK_BIN (lw (abook_widget, "delete_entry"))->child), "Remove Entry");
	gtk_widget_set_sensitive (lw (abook_widget, "edit_entry"), FALSE);
	gtk_widget_set_sensitive (lw (abook_widget, "delete_entry"), FALSE);
	current_node=NULL;
}

void abook_widget_destroy_row (gpointer data) {
	if (data) free (data);
}

void abook_widget_add_entry (GtkWidget *widget, gpointer data) {
	if (current_abook) {
		Abook_entry *entry=abook_entry_new (current_abook);
		abook_entry_create (entry, entry);
	} 
}

void abook_widget_add_group (GtkWidget *widget, gpointer data) {
	if (current_abook) {
		Abook_group *group=abook_group_new (current_abook);
		abook_create_group_editor (group, current_abook);
	} 
}

void abook_widget_edit_entry (GtkWidget *widget, gpointer data) {
	if (current_abook && current_node) {
		Abook_rd *rd=gtk_ctree_node_get_row_data(GTK_CTREE (lw (widget, "entry_ctree")), current_node);
		if (!rd)
			return;
		switch (rd->type) {
			case ABOOK_GROUP:
				abook_create_group_editor (rd->group, current_abook);
				break;
			case ABOOK_ENTRY:
				abook_entry_create (rd->entry, NULL);
				break;
		}
	} 
}



void abook_widget_delete_entry () {
	GtkCTree *ctree=GTK_CTREE (lw (abook_widget, "entry_ctree"));
	Abook_rd *rd;
	Abook_entry *entry;
	GList *seek;


	/* This this is valid, we'll simply return when it happens */
	if( current_node == NULL ) return ;

	if( (rd=gtk_ctree_node_get_row_data (ctree, current_node)) == NULL ) return ;

	/* Otherwise, we know we have a value to switch on */
	switch (rd->type) {
		case ABOOK_ENTRY:
		  abook_entry_destroy (current_abook, rd->entry);
		  abook_widget_rehash_abook (current_abook);
		  current_node = NULL ;
		  break;
		case ABOOK_GROUP:
		  for (seek=current_abook->entrys;seek;seek=seek->next) {
		    entry=seek->data;
		    if (g_list_find (entry->groups, rd->group)) {
		      entry->groups=g_list_remove (entry->groups, rd->group);
		    }
		  }
		  abook_group_destroy (current_abook, rd->group);
		  abook_widget_rehash_abook (current_abook);
		  current_node = NULL ;
		  break;
	}
}

void abook_widget_new_abook (GtkWidget *widget, gpointer data) {
	abook_create_new_abook ();
}

void abook_widget_delete_abook_final (GtkWidget *widget, gpointer data) {
	char *filename;
	gtk_widget_destroy (lw (widget, "yesno"));
	filename=(char *)calloc (1024, sizeof (char));
	snprintf (filename, 1023, "$(HOME)/.tradeclient/Addressbooks/%s", current_abook->name);
	env_srch_rep (filename);
	unlink (filename);
	abook_destroy (current_abook);
	abook_widget_rehash ();
	free (filename);
}

void abook_widget_delete_abook (GtkWidget *widget, gpointer data) {
	/*if (!current_abook)*/
	if(!abook_first())  /* Check against the option menu list */
		return;
	abook_question ("Delete Address Book", 
	                "Are you sure you want to delete the current addressbook?", 
	                GTK_SIGNAL_FUNC (abook_widget_delete_abook_final), NULL);
}

int email_row=-1;

void abook_widget_entry_destroy (GtkWidget *widget, GdkEvent *event, Abook_entry *entry) {
	if (entry)
		abook_entry_destroy (current_abook, entry);
	gtk_widget_destroy (lw (widget, "abook_entry"));
	email_row=-1;
}



void 
abook_widget_entry_accept (GtkWidget *widget, Abook_entry *entry) {	
  char *street, *notes;
  g_return_if_fail (entry != NULL);	
  street=gtk_editable_get_chars (GTK_EDITABLE (lw (widget, "street_address")), 0, -1);
  notes=gtk_editable_get_chars (GTK_EDITABLE (lw (widget, "notes")), 0, -1);
  
  abook_entry_edit (entry,
		    gtk_entry_get_text (GTK_ENTRY (lw (widget, "first_name"))), 
		    gtk_entry_get_text (GTK_ENTRY (lw (widget, "middle_name"))), 
		    gtk_entry_get_text (GTK_ENTRY (lw (widget, "last_name"))), 
		    gtk_entry_get_text (GTK_ENTRY (lw (widget, "title"))), 
		    gtk_entry_get_text (GTK_ENTRY (lw (widget, "nickname"))), 
		    gtk_entry_get_text (GTK_ENTRY (lw (widget, "sex"))),
		    gtk_entry_get_text (GTK_ENTRY (lw (widget, "home_phone"))), 
		    gtk_entry_get_text (GTK_ENTRY (lw (widget, "work_phone"))), 
		    gtk_entry_get_text (GTK_ENTRY (lw (widget, "mobile_phone"))), 
		    gtk_entry_get_text (GTK_ENTRY (lw (widget, "pager"))), 
		    gtk_entry_get_text (GTK_ENTRY (lw (widget, "fax"))), 
		    street, 
		    gtk_entry_get_text (GTK_ENTRY (lw (widget, "web_page"))), 
		    gtk_entry_get_text (GTK_ENTRY (lw (widget, "company"))),
		    gtk_entry_get_text (GTK_ENTRY (lw (widget, "position"))),
		    gtk_entry_get_text (GTK_ENTRY (lw (widget, "caddress"))),
		    gtk_entry_get_text (GTK_ENTRY (lw (widget, "ccity"))),
		    gtk_entry_get_text (GTK_ENTRY (lw (widget, "cstate"))),
		    gtk_entry_get_text (GTK_ENTRY (lw (widget, "czip"))),
		    gtk_entry_get_text (GTK_ENTRY (lw (widget, "ccountry"))),
		    NULL,
		    gtk_entry_get_text (GTK_ENTRY (lw (widget, "cphone1"))),
		    gtk_entry_get_text (GTK_ENTRY (lw (widget, "cphone2"))),
		    gtk_entry_get_text (GTK_ENTRY (lw (widget, "cfax"))),
		    gtk_entry_get_text (GTK_ENTRY (lw (widget, "cpager"))),
		    gtk_entry_get_text (GTK_ENTRY (lw (widget, "cwebpage"))),
		    gtk_entry_get_text (GTK_ENTRY (lw (widget, "cmanager"))),
		    gtk_entry_get_text (GTK_ENTRY (lw (widget, "cassistant"))),
		    notes);
  g_free (street);
  g_free (notes);
  
  abook_widget_rehash_abook (current_abook);
  abook_widget_entry_destroy (widget, NULL, NULL);

  return ;
}

void abook_widget_entry_cancel (GtkWidget *widget, Abook_entry *entry) {
	abook_widget_entry_destroy (widget, NULL, entry);
}

void abook_widget_entry_email_activate (GtkEntry *widget, Abook_entry *entry) {
	GtkCList *clist=GTK_CLIST (lw (GTK_WIDGET (widget), "addr_clist"));
	g_return_if_fail (entry != NULL);
	g_return_if_fail (gtk_entry_get_text (widget) > 0);
	if (email_row==-1) {
		char *cl_data[2];
		char *tmp;
		int row;
		cl_data[0]=gtk_entry_get_text (widget);
		if (!entry->email) {
			cl_data[1]=strdup ("DEFAULT");
		} else {
			cl_data[1]=NULL;
		}
		row=gtk_clist_append (clist, cl_data);
		tmp=abook_entry_add_email (entry, cl_data[0]);
		if (!entry->def_email)
			entry->def_email=tmp;
		gtk_clist_set_row_data (clist, row, tmp);
		gtk_entry_set_text (widget, "");
		if (cl_data[1]) free (cl_data[1]);
	} else {
		char *oldmail=gtk_clist_get_row_data (clist, email_row);
		char *newmail=gtk_entry_get_text (widget);
		char *stored;
		g_return_if_fail (oldmail != NULL);
		stored=abook_entry_edit_email (entry, oldmail, newmail);
		
		gtk_clist_set_row_data (clist, email_row, stored);
		gtk_clist_set_text (clist, email_row, 0, stored);
	}
}

void abook_widget_entry_add_email (GtkWidget *widget, gpointer data) {
	abook_widget_entry_email_activate (GTK_ENTRY (lw (widget, "email_address_entry")), data);
}

void abook_widget_entry_email_selectrow (GtkWidget *widget, gint row, 
                   gint column, GdkEventButton *event, gpointer data) {
	GtkEntry *entry=GTK_ENTRY (lw (widget, "email_address_entry"));
	gtk_entry_set_text (entry, gtk_clist_get_row_data (GTK_CLIST (widget), row));
	email_row=row;
}

void abook_widget_entry_email_unselectrow (GtkWidget *widget, gint row, 
                   gint column, GdkEventButton *event, gpointer data) {
	GtkEntry *entry=GTK_ENTRY (lw (widget, "email_address_entry"));
	gtk_entry_set_text (entry, "");
	email_row=-1;
}

void abook_widget_entry_set_default_email (GtkWidget *widget, Abook_entry *entry) {
	GtkCList *clist=GTK_CLIST (lw (widget, "addr_clist"));
	char *email;
	int row;
	g_return_if_fail (entry != NULL);
	if (email_row==-1)
		return;
	email=gtk_clist_get_row_data (clist, email_row);
	row=gtk_clist_find_row_from_data (clist, entry->def_email);
	gtk_clist_set_text (clist, row, 1, "");
	gtk_clist_set_text (clist, email_row, 1, "DEFAULT");
	abook_entry_set_default (entry, email);
}

void abook_widget_entry_remove_email (GtkWidget *widget, Abook_entry *entry) {
	GtkCList *clist=GTK_CLIST (lw (widget, "addr_clist"));
	char *email;
	if (email_row==-1)
		return;
	email=gtk_clist_get_row_data (clist, email_row);
	g_return_if_fail (email != NULL);
	gtk_clist_remove (clist, email_row);
	abook_entry_remove_email (entry, email);
	if (entry->def_email) {
		email_row=gtk_clist_find_row_from_data (clist, entry->def_email);
		gtk_clist_set_text (clist, email_row, 1, "DEFAULT");
	}
	email_row=-1;
}

int ngroup=-1, ogroup=-1;

void abook_widget_entry_newgroup_sel (GtkWidget *widget, gint row, 
                   gint column, GdkEventButton *event, Abook_entry *entry) {	
	ngroup=row;
}

void abook_widget_entry_newgroup_unsel (GtkWidget *widget, gint row, 
                   gint column, GdkEventButton *event, Abook_entry *entry) {
	ngroup=-1;
}

void abook_widget_entry_memgroup_sel (GtkWidget *widget, gint row, 
                   gint column, GdkEventButton *event, Abook_entry *entry) {
	ogroup=row;
}

void abook_widget_entry_memgroup_unsel (GtkWidget *widget, gint row, 
                   gint column, GdkEventButton *event, Abook_entry *entry) {
	ogroup=-1;
}

void abook_widget_entry_addgroup (GtkWidget *widget, Abook_entry *entry) {
	GtkCList *clist1, *clist2;
	Abook_group *group;
	clist1=GTK_CLIST (lw (widget, "groups_avail"));
	clist2=GTK_CLIST (lw (widget, "groups_member"));
	if (ngroup!=-1) {
		group=gtk_clist_get_row_data (clist1, ngroup);
		if (!g_list_find (entry->groups, group)) {
			char *cl_data[1];
			int row;
			entry->groups=g_list_append (entry->groups, group);
			cl_data[0]=group->name;
			row=gtk_clist_append (clist2, cl_data);
			gtk_clist_set_row_data (clist2, row, group);
		}
	}
}

void abook_widget_entry_delgroup (GtkWidget *widget, Abook_entry *entry) {
	Abook_group *group;
	if (ogroup!=-1) {
		GtkCList *clist=GTK_CLIST (lw (widget, "groups_member"));
		group=gtk_clist_get_row_data (clist, ogroup);
		entry->groups=g_list_remove (entry->groups, group);
		gtk_clist_remove (clist, ogroup);
	}
}


int gr1=-1, gr2=-1;

void abook_widget_group_accept (GtkWidget *widget, Abook_group *group) {
	char *group_name=gtk_entry_get_text (GTK_ENTRY (lw (widget, "group_name")));
	if (strlen (group_name)>0) {
		if (group->name) free (group->name);
		group->name=strdup (group_name);
	} else {
		insert_message ("The group must have a name\n");
		return;
	}
	abook_widget_rehash_abook (current_abook);
	gtk_widget_destroy (lw (widget, "group_editor"));
}

void abook_widget_group_cancel (GtkWidget *widget, Abook_group *group) {
	gtk_widget_destroy (lw (widget, "group_editor"));
}


void abook_widget_group_selentry (GtkWidget *widget, gint row) {
	gr1=row;
}

void abook_widget_group_unselentry () {
	gr1=-1;
}

void abook_widget_group_selmember (GtkWidget *widget, gint row) {
	gr2=row;
}

void abook_widget_group_unselmember () {
	gr2=-1;
}

void abook_widget_group_addmember (GtkWidget *widget, Abook_group *group) {
	if (gr1!=-1) {
		GtkCList *entries=GTK_CLIST (lw (widget, "entries"));
		GtkCList *members=GTK_CLIST (lw (widget, "members"));
		Abook_entry *entry=gtk_clist_get_row_data (entries, gr1);
		char *cl_data[2];
		int row;
		if (gtk_clist_find_row_from_data (members, entry)<0) {
			entry->groups=g_list_append (entry->groups, group);
			cl_data[0]=(char *)calloc (1024, sizeof (char));
#if 0
			format_name (cl_data[0], entry->first, entry->last);
#else
			format_name (1024, cl_data[0], entry->first, entry->last, entry->def_email );
#endif
			cl_data[1]=entry->def_email;
			row=gtk_clist_append (members, cl_data);
			gtk_clist_set_row_data (members, row, (gpointer)entry);
		}
	}
}

void abook_widget_group_delmember (GtkWidget *widget, Abook_group *group) {
	if (gr2!=-1) {
		GtkCList *clist=GTK_CLIST (lw (widget, "members"));
		Abook_entry *entry=gtk_clist_get_row_data (clist, gr2);
		entry->groups=g_list_remove (entry->groups, group);
		gtk_clist_remove (clist, gr2);
		gr2=-1;
	}
}

void abook_widget_new_accept (GtkWidget *widget, gpointer data) {
	char *name=gtk_entry_get_text (GTK_ENTRY (lw (widget, "abook_entry")));
	if (strlen (name)>0) {
		Abook *abook=abook_new ();
		abook->name=rm_crlf (name);
		gtk_widget_destroy (lw (widget, "new_abook"));
		abook_widget_rehash ();
	} else {
		insert_message ("Must have a name for this addressbook\n");
	}
}

void abook_widget_new_cancel (GtkWidget *widget, gpointer data) {
	gtk_widget_destroy (lw (widget, "new_abook"));	
}

gint compare_function (Abook_rd *rd, Abook_entry *entry) {
	if (!rd)
		return FALSE;
	if (rd->entry==entry)
		return TRUE;
	return FALSE;
}



void
abook_widget_find_entry_changed (GtkEditable *edit) {
  char *tmp=gtk_entry_get_text (GTK_ENTRY (edit));
  GtkCTree *ctree=GTK_CTREE (lw (abook_widget, "entry_ctree"));
  GtkCTreeNode *node=NULL;
  Abook_entry *entry;

  if (current_abook==NULL)
    return;

  entry=abook_entry_seek_name_in_part (current_abook, tmp);

  if (entry) {
    GList *seek;
    for (seek=entry->nodes;seek;seek=seek->next)
      node=seek->data;
    gtk_ctree_select (ctree, node);
    gtk_ctree_node_moveto (ctree, node, 0, 0, 0);
  } else {
    gtk_clist_unselect_all (GTK_CLIST (ctree));		
  }

  return ;
}



GList *list=NULL;
GList *types=NULL;
int rsel;
GtkCTreeNode *lsel;

gboolean my_compare_func (Abook_rd *rd1, Abook_rd *rd2) {
	if (rd1 && rd2) {
		if (rd1->entry && rd2->entry) {
			if (rd1->entry==rd2->entry) {
				return FALSE;
			}
		}
		if (rd1->group && rd2->group && rd2->group==rd2->group)
			return FALSE;
	}
	return TRUE;
}

gint gtk_clist_find_by_row_data_custom (GtkCList *clist, gpointer data, GCompareFunc func) {
	int i=0;
	g_return_val_if_fail (clist != NULL, -1);	
	for (i=0;i<clist->rows;i++) {
		gpointer row_data=gtk_clist_get_row_data (clist, i);
		if (!func (row_data, data)==TRUE)
			return i;
	}
	return -1;
}

void abook_widget_set_types (GList *list) {
	if (types)
		g_list_free (types);
	types=list;
}

void abook_widget_set_list (GList *l) {
	if (list)
		g_list_free (list);
	list=l;
}

void abook_widget_selector_lsel (GtkCTree *ctree, GtkCTreeNode *node, gint column) {
	lsel=node;
}

void abook_widget_selector_lunsel (GtkCTree *ctree, GtkCTreeNode *node, gint column) {
	lsel=NULL;
}

void abook_widget_selector_rsel (GtkWidget *widget, gint row, gint column, GdkEventButton *event, gpointer data) {
	rsel=row;
}

void abook_widget_selector_runsel (GtkWidget *widget, gint row, gint column, GdkEventButton *event, gpointer data) {
	rsel=-1;
}




void 
abook_widget_selector_add (GtkWidget *widget, gint type) {
  int row ;
  char *cl_data[2] ;
  GList *tmp ;
  Abook_rd *rd ;
  GtkCTree *ctree ;
  GtkCList *clist ;

  clist=GTK_CLIST (lw (widget, "select_clist"));
  ctree=GTK_CTREE (lw (widget, "entry_ctree"));

  rd = gtk_ctree_node_get_row_data (ctree, lsel) ;
  if (rd) {
    tmp=g_list_find_custom (list, rd, (GCompareFunc)my_compare_func);
    if (tmp) {
      row=gtk_clist_find_by_row_data_custom (clist, rd, (GCompareFunc)my_compare_func);
      gtk_clist_set_text (clist, row, 1, g_list_nth_data (types, type));
      if (rd->entry) {
	rd->entry->type=type;
      } else {
	rd->group->type=type;
      }
    } else {
      cl_data[0]=(char *)calloc( 4096, sizeof (char) );
      cl_data[1]=g_list_nth_data (types, type);
      if (rd->entry) {
	rd->entry->type=type;
#if 0
	format_name (cl_data[0], rd->entry->first, rd->entry->last);
#else
	format_name (4096, cl_data[0], rd->entry->first, rd->entry->last, rd->entry->def_email );
#endif
      } else {
	rd->group->type=type;
	cl_data[0]=strdup (rd->group->name);
      }
      row=gtk_clist_append (clist, cl_data);
      free (cl_data[0]);
      gtk_clist_set_row_data (clist, row, rd);
      list=g_list_append (list, rd);
    }
  }

  return ;
}




void abook_widget_selector_del (GtkWidget *widget) {
	GtkCList *clist=GTK_CLIST (lw (widget, "select_clist"));
	if (rsel == -1)
		return;
	{
//	for (seek=rsel;seek;seek=seek->next) {
		Abook_rd *rd=gtk_clist_get_row_data (clist, rsel);
		if (!rd) return;
#if DEBUG > 4
		if (rd->entry)
			printf ("Deleting entry: %s %s\n", rd->entry->first, rd->entry->last);
		else 
			printf ("Deleting group: %s\n", rd->group->name);
#endif
		gtk_clist_remove (clist, rsel);
		list=g_list_remove (list, rd);
		rsel=-1;
	}
}

void entry_ctree_clicked_column (GtkWidget *clist, gint column, gpointer data) {
	if (GTK_CLIST (clist)->sort_type==GTK_SORT_ASCENDING) {
	    GTK_CLIST (clist)->sort_type=GTK_SORT_DESCENDING;
	} else {
	    GTK_CLIST (clist)->sort_type=GTK_SORT_ASCENDING;
	}
	gtk_clist_freeze (GTK_CLIST(clist));
	gtk_clist_set_sort_column (GTK_CLIST(clist), column);
	gtk_clist_sort (GTK_CLIST (clist));
	gtk_clist_thaw (GTK_CLIST (clist));
}


void abook_widget_selector_changebook (GtkWidget *widget, Abook *abook) {
	abook_widget_rehash_abook_clist (abook, GTK_CTREE (lw (widget, "entry_ctree")));
}



void 
abook_widget_selector_accept (GtkWidget *widget, UserData *data) {
  int row ;
  int type ;
  char *addr ;
  char *send ;
  int retValue ;
  Recipient *recp;
  GList *ret=NULL;
  GtkCList *clist ;


  /* Fetch the list of email addresses that have been added */
#if 1
  clist=GTK_CLIST (lw (widget, "select_clist"));

  /* Okay, walk through the list of nodes in our list */
  row = 0 ;
  addr = send = NULL ;
  while( (retValue = gtk_clist_get_text( clist, row, 0, &addr )) )
    {
      /* Now that we have the text, get the send type */
      retValue = gtk_clist_get_text( clist, row, 1, &send ) ;
#if DEBUG > 3
      printf( "addr = '%s %s'\n", send, addr ) ;
#endif

      /*
       * Data switch breaks out as:
       * C = CC(1), B= BCC(2) , R = Required(0), Resource(2), O = Optional(2)
       * where 0 = To, 1 = CC, 2 = BCC
       */
      switch( send[0] )
	{
	case 'C':
	  type = 1 ;
	  break ;

	case 'B':
	  type = 2 ;
	  break ;

	case 'R':
	  if( strcasecmp( send, "Required" ) == 0 ) type = 0 ;
	  else type = 2 ;
	  break ;

	case 'O':
	  type = 1 ;
	  break ;

	default:  
	  /* This addresses TO and any screw ups */
	  type = 0 ;
	  break ;
	}

      /* Now that we have our data items, let's add them to the real recip list */
      recp = (Recipient *)malloc( sizeof(Recipient) ) ;
      recp->email=strdup( addr ) ;
      recp->type=type ;
      ret = g_list_append( ret, recp ) ;

      /* Gotta advance the row index else we loop infintium */
      row++ ;
    }

#else
  for (seek=list;seek;seek=seek->next) {
    rd=seek->data;
    if (rd->entry) {
      recp=(Recipient *)calloc(1, sizeof (Recipient));
      recp->email=strdup(rd->entry->def_email);
      recp->type=rd->entry->type;
      ret=g_list_append (ret, recp);
    } else {
      if (rd->group->email) {
	recp=(Recipient *)calloc(1, sizeof (Recipient));
	recp->email=strdup(rd->group->email);
	recp->type=rd->group->type;
	ret=g_list_append (ret, recp);
      } else {
	GList *members=abook_group_get_members (rd->group);
	GList *tmp;
	for (tmp=members;tmp;tmp=tmp->next) {
	  Abook_entry *entry=tmp->data;
	  recp=(Recipient *)calloc(1, sizeof (Recipient));
	  recp->email=strdup(entry->def_email);
	  recp->type=rd->group->type;
	  ret=g_list_append (ret, recp);
	}
      }
    }
  }
#endif
	
  if (data->func) 
    data->func (ret, data->data); // uhhmm. Ok ;)
		
  abook_widget_selector_destroy (widget, NULL, data);

  return ;
}



void abook_widget_selector_cancel (GtkWidget *widget, gpointer data) {
	abook_widget_selector_destroy (widget, NULL, data);
}



void abook_widget_selector_destroy (GtkWidget *widget, GdkEvent *event, gpointer data) {
  rsel=-1;
  lsel=NULL;

#ifdef DMALLOC
  dmalloc_verify( 0 ) ;
#endif

  g_list_free (list);list=NULL;
#if 0
  if( data ) free( data ) ;
#endif

  abook_destroy_dummys ();
  gtk_widget_destroy (lw (widget, "selector"));
#if 0
  if (abook_widget) 
    abook_widget_rehash_abook_clist (current_abook, GTK_CTREE (lw (abook_widget, "entry_ctree")));
#endif
#ifdef DMALLOC
  dmalloc_verify( 0 ) ;
#endif

  return ;
}

void abook_widget_selector_search_changed (GtkEditable *editable) {
	char *tmp=gtk_entry_get_text (GTK_ENTRY (editable));
	GtkCTree *ctree=GTK_CTREE (lw (GTK_WIDGET (editable), "entry_ctree"));
	GtkCTreeNode *node=NULL;
	Abook_entry *entry;
	if (current_abook==NULL)
		return;
	entry=abook_entry_seek_name_in_part (current_abook, tmp);
	if (entry) {
		GList *seek;
		for (seek=entry->nodes;seek;seek=seek->next)
			node=seek->data;
		gtk_ctree_select (ctree, node);
		gtk_ctree_node_moveto (ctree, node, 0, 0, 0);
	} else {
		gtk_clist_unselect_all (GTK_CLIST (ctree));		
	}
}

GtkSignalFunc updator_func=NULL;
gpointer updator_func_data=NULL;

void abook_widget_selector_set_updator (GtkSignalFunc func, gpointer data) {
	updator_func=func;
	updator_func_data=data;
}

void abook_widget_selector_search_custom (GtkWidget *widget, gpointer data) {
	char *text=gtk_entry_get_text (GTK_ENTRY (lw (widget, "find_entry")));
	if (!current_abook)
		return;
	if (strcmp (current_abook->name, gabName )==0) {
		Abook_entry *entry=abook_entry_seek_name_in_part (current_abook, text);
		GtkCTree *ctree=GTK_CTREE (lw (widget, "entry_ctree"));
		GtkCTreeNode *node=NULL;
		GList *seek;
#ifdef WANTLDAP
		gab_update_search (NULL, text);
#endif
		entry=abook_entry_seek_name_in_part (current_abook, text);
		abook_widget_rehash_abook_clist (current_abook, ctree);   
		if (!entry) {
			if (strlen(text))
				insert_message (_("'%s' Not found\n"), text);
			return;
		}
		for (seek=entry->nodes;seek;seek=seek->next)
			node=seek->data;
		gtk_ctree_select (ctree, node);
		gtk_ctree_node_moveto (ctree, node, 0, 0, 0);		
	}	
}

void goto_webpage_callback (GtkWidget *widget, GtkWidget *webpage) {
  char *url = gtk_entry_get_text (GTK_ENTRY (webpage));
  char *browser = getenv ("BROWSER");
  char *command;
  char *handler = NULL;
  char *orph ;
  MimeType *tmpmtype = mime_type_search_ext ("html");
 
  if (!strlen(url)) return;

  if (tmpmtype) {
    handler = (char *)calloc (strlen (orph=cut_string(tmpmtype->handle, ' ', 1, 1)),
		    sizeof (char));
    free( orph ) ;
    sprintf (handler, "%s", orph=cut_string(tmpmtype->handle, ' ', 1, 1));
    free( orph ) ;
  }

  if (browser) {
#if DEBUG > 3
    printf ("using $BROWSER.\n");
#endif
    command = (char *)calloc (strlen (browser) + 1 + strlen (url) + 2,
		    sizeof (char));
    sprintf (command, "%s %s &", browser, url);
  } else if (strlen (handler)) {
#if DEBUG > 3
    printf ("using MIME type for text/html.\n");
#endif
    command = (char *)calloc (strlen (handler) + 1 + strlen (url) + 2,
		    sizeof (char));
    sprintf (command, "%s %s &", handler, url);
  } else {
#if DEBUG > 3
    printf ("using the default, netscape.\n");
#endif
    command = (char *)calloc (strlen ("netscape") + 1 + strlen (url) + 2,
		    sizeof (char));
    sprintf (command, "netscape %s &", url);
  }

  if (handler) free (handler);
  
  if (command) {
#if DEBUG > 3
    printf ("executing \"%s\"...\n", command);
#endif
    system (command);
    free (command);
  }
}

void abook_entry_bpe(GtkWidget *widget, GdkEvent *event, gpointer data) {
        if (event->type == GDK_BUTTON_PRESS) return;
        abook_widget_edit_entry (widget, NULL);
}
