/* TradeClient <http://tradeclient.sourceforge.net>
 * $Id: abook-window.c,v 1.29 2001/03/20 22:19:33 ttabner Exp $
 *
 * Copyright (C) 1999-2000 Bynari Inc.
 * Copyright (C) 2001 Project TradeClient
 *
 * LGPL
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#include "abook-main.h"

GtkWidget *create_abook (void) {
  GtkWidget *abook;
  GtkWidget *vbox1;
  GtkWidget *handlebox1;
  GtkWidget *menubar1;
  GtkWidget *file1;
  GtkWidget *file1_menu;
  GtkWidget *tearoff;
  GtkAccelGroup *file1_menu_accels;
  GtkWidget *addressbook1;
  GtkWidget *addressbook1_menu;
  GtkAccelGroup *addressbook1_menu_accels;
  GtkWidget *item2;
  GtkWidget *item2_menu;
  GtkAccelGroup *item2_menu_accels;
  GtkWidget *edit_entry1;
  GtkWidget *delete1;
  GtkWidget *delete1_menu;
  GtkAccelGroup *delete1_menu_accels;
  GtkWidget *help1;
  GtkWidget *help1_menu;
  GtkAccelGroup *help1_menu_accels;
  GtkWidget *frame2;
  GtkWidget *vbox13;
  GtkWidget *hbox2;
  GtkWidget *label1;
  GtkWidget *abook_optionmenu;
  GtkWidget *add_button;
  GtkWidget *remove_book;
  GtkWidget *hbox26;
  GtkWidget *label83;
  GtkWidget *find_entry;
	GtkWidget *search;
  GtkWidget *hbox1;
  GtkWidget *scrolledwindow1;
  GtkWidget *entry_ctree;
  GtkWidget *label55;
  GtkWidget *label56;
  GtkWidget *frame1;
  GtkWidget *vbox2;
  GtkWidget *add_entry;
  GtkWidget *add_group;
  GtkWidget *edit_entry;
  GtkWidget *delete_entry;
  GtkWidget *some_sep, *done_button;
  GtkAccelGroup *accel_group;

  accel_group = gtk_accel_group_new ();

#define mi(p, n, l) menuitem_new (p, abook, n, l, NULL, 0, 0)

	abook=window_new ("abook", _("Address Book"), 150, 150, 480, 330);
	vbox1=vb_new (abook, FALSE, 0);

  handlebox1 = gtk_handle_box_new ();
  ws (handlebox1);
  gtk_box_pack_start (GTK_BOX (vbox1), handlebox1, FALSE, FALSE, 0);

	menubar1 = menubar_new (handlebox1);
	file1 = menuitem_new (menubar1, abook, NULL, _("File"), NULL, 0, 0);
	file1_menu = menu_new (file1, abook, &file1_menu_accels);

	tearoff=gtk_tearoff_menu_item_new ();
	gtk_widget_show (tearoff);
	gtk_container_add (GTK_CONTAINER (file1_menu), tearoff);
	
	/*mi (file1_menu, "save1", _("Save")); */
	mi (file1_menu, "close1", "Close");
gtk_widget_add_accelerator (lookup_widget(file1_menu, "close1"), "activate", accel_group,
                              GDK_w, GDK_MOD1_MASK,
                              GTK_ACCEL_VISIBLE);
	seper_new (file1_menu);
	mi (file1_menu, "exit", "Exit TradeClient");
gtk_widget_add_accelerator (lookup_widget(file1_menu, "exit"), "activate", accel_group,
                              GDK_q, GDK_MOD1_MASK,
                              GTK_ACCEL_VISIBLE);
	
	clip_create_menuitem (menubar1, accel_group);

	addressbook1 = mi (menubar1, "addressbook1", "Addressbook");
	addressbook1_menu=menu_new (addressbook1, abook, &addressbook1_menu_accels);
	tearoff=gtk_tearoff_menu_item_new ();
	gtk_widget_show (tearoff);
	gtk_container_add (GTK_CONTAINER (addressbook1_menu), tearoff);

	item2 = menuitem2_new (addressbook1_menu, _("New..."));
	item2_menu = menu_new (item2, abook, &item2_menu_accels);
	tearoff=gtk_tearoff_menu_item_new ();
	gtk_widget_show (tearoff);
	gtk_container_add (GTK_CONTAINER (item2_menu), tearoff);
	mi (item2_menu, "addressbook2", _("Address Book"));
gtk_widget_add_accelerator (lookup_widget(file1_menu, "addressbook2"), "activate", accel_group,
                              GDK_b, GDK_MOD1_MASK,
                              GTK_ACCEL_VISIBLE);
	mi (item2_menu, "addressbook_entry", _("Addressbook Entry"));
gtk_widget_add_accelerator (lookup_widget(file1_menu, "addressbook_entry"), "activate", accel_group,
                              GDK_n, GDK_MOD1_MASK,
                              GTK_ACCEL_VISIBLE);
	mi (item2_menu, "group", _("Group"));
gtk_widget_add_accelerator (lookup_widget(file1_menu, "group"), "activate", accel_group,
                              GDK_g, GDK_MOD1_MASK,
                              GTK_ACCEL_VISIBLE);

	/*seper_new (item2_menu);*/
	edit_entry1 = mi (addressbook1_menu, "edit_entry1", _("Edit Entry"));	
gtk_widget_add_accelerator (lookup_widget(file1_menu, "edit_entry1"), "activate", accel_group,
                              GDK_e, GDK_MOD1_MASK,
                              GTK_ACCEL_VISIBLE);
	seper_new (addressbook1_menu);

	delete1=mi (addressbook1_menu, "delete1", _("Delete..."));
	delete1_menu = menu_new (delete1, abook, &delete1_menu_accels);
	tearoff=gtk_tearoff_menu_item_new ();
	gtk_widget_show (tearoff);
	gtk_container_add (GTK_CONTAINER (delete1_menu), tearoff);
	mi (delete1_menu, "addressbook3", _("Address Book"));
	mi (delete1_menu, "addressbook_entry2", _("Addressbook Entry"));
gtk_widget_add_accelerator (lookup_widget(file1_menu, "addressbook_entry2"), "activate", accel_group,
                              GDK_d, GDK_MOD1_MASK,
                              GTK_ACCEL_VISIBLE);
	
	help1=mi (menubar1, "help1", _("Help"));
	gtk_menu_item_right_justify (GTK_MENU_ITEM (help1));
	help1_menu=menu_new (help1, abook, &help1_menu_accels);
	tearoff=gtk_tearoff_menu_item_new ();
	gtk_widget_show (tearoff);
	gtk_container_add (GTK_CONTAINER (help1_menu), tearoff);
	mi (help1_menu, "about_bynari_tradeclient1", _("About TradeClient"));

  frame2 = gtk_frame_new (NULL);
  gtk_widget_set_name (frame2, "frame2");
  gtk_widget_ref (frame2);
  gtk_object_set_data_full (GTK_OBJECT (abook), "frame2", frame2,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (frame2);
  gtk_box_pack_start (GTK_BOX (vbox1), frame2, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame2), 2);

  vbox13 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox13, "vbox13");
  gtk_widget_ref (vbox13);
  gtk_object_set_data_full (GTK_OBJECT (abook), "vbox13", vbox13,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (vbox13);
  gtk_container_add (GTK_CONTAINER (frame2), vbox13);

  hbox2 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox2, "hbox2");
  gtk_widget_ref (hbox2);
  gtk_object_set_data_full (GTK_OBJECT (abook), "hbox2", hbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (hbox2);
  gtk_box_pack_start (GTK_BOX (vbox13), hbox2, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox2), 2);

  label1 = gtk_label_new (_("View Address in "));
  gtk_widget_set_name (label1, "label1");
  gtk_widget_ref (label1);
  gtk_object_set_data_full (GTK_OBJECT (abook), "label1", label1,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (label1);
  gtk_box_pack_start (GTK_BOX (hbox2), label1, FALSE, FALSE, 0);

  abook_optionmenu = gtk_option_menu_new ();
  gtk_widget_set_name (abook_optionmenu, "abook_optionmenu");
  gtk_widget_ref (abook_optionmenu);
  gtk_object_set_data_full (GTK_OBJECT (abook), "abook_optionmenu", abook_optionmenu,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (abook_optionmenu);
  gtk_box_pack_start (GTK_BOX (hbox2), abook_optionmenu, TRUE, TRUE, 0);
/*  abook_optionmenu_menu = gtk_menu_new ();
  glade_menuitem = gtk_menu_item_new_with_label (_(gabName));
  ws (glade_menuitem);
  gtk_menu_append (GTK_MENU (abook_optionmenu_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label (_("Personal Address Book"));
  ws (glade_menuitem);
  gtk_menu_append (GTK_MENU (abook_optionmenu_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label (_("Someone's Address Book"));
  ws (glade_menuitem);
  gtk_menu_append (GTK_MENU (abook_optionmenu_menu), glade_menuitem);
  gtk_option_menu_set_menu (GTK_OPTION_MENU (abook_optionmenu), abook_optionmenu_menu);*/

  add_button = gtk_button_new_with_label (_("Add Book"));
  gtk_widget_set_name (add_button, "add_button");
  gtk_widget_ref (add_button);
  gtk_object_set_data_full (GTK_OBJECT (abook), "add_button", add_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (add_button);
  gtk_box_pack_start (GTK_BOX (hbox2), add_button, FALSE, FALSE, 0);

  remove_book = gtk_button_new_with_label (_("Remove Book"));
  gtk_widget_set_name (remove_book, "remove_book");
  gtk_widget_ref (remove_book);
  gtk_object_set_data_full (GTK_OBJECT (abook), "remove_book", remove_book,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (remove_book);
  gtk_box_pack_start (GTK_BOX (hbox2), remove_book, FALSE, FALSE, 0);

  hbox26 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox26, "hbox26");
  gtk_widget_ref (hbox26);
  gtk_object_set_data_full (GTK_OBJECT (abook), "hbox26", hbox26,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (hbox26);
  gtk_box_pack_start (GTK_BOX (vbox13), hbox26, TRUE, TRUE, 0);

  label83 = gtk_label_new (_(" Find: "));
  gtk_widget_set_name (label83, "label83");
  gtk_widget_ref (label83);
  gtk_object_set_data_full (GTK_OBJECT (abook), "label83", label83,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (label83);
  gtk_box_pack_start (GTK_BOX (hbox26), label83, FALSE, FALSE, 0);

  find_entry = gtk_entry_new ();
  gtk_widget_set_name (find_entry, "find_entry");
  gtk_widget_ref (find_entry);
  gtk_object_set_data_full (GTK_OBJECT (abook), "find_entry", find_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (find_entry);
  gtk_box_pack_start (GTK_BOX (hbox26), find_entry, TRUE, TRUE, 0);
	
	search = gtk_button_new_with_label ("Search");
	gtk_widget_set_name (search, "search");
	gtk_widget_ref (find_entry);
	gtk_object_set_data_full (GTK_OBJECT (abook), "search", search,
	                          (GtkDestroyNotify) gtk_widget_unref);
	ws (search);
	gtk_box_pack_start (GTK_BOX (hbox26), search, FALSE, FALSE, 0);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox1, "hbox1");
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT (abook), "hbox1", hbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, TRUE, TRUE, 0);

  scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_set_name (scrolledwindow1, "scrolledwindow1");
  gtk_widget_ref (scrolledwindow1);
  gtk_object_set_data_full (GTK_OBJECT (abook), "scrolledwindow1", scrolledwindow1,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (scrolledwindow1);
  gtk_box_pack_start (GTK_BOX (hbox1), scrolledwindow1, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  entry_ctree = gtk_ctree_new (2, 0);
  gtk_widget_set_name (entry_ctree, "entry_ctree");
  gtk_widget_ref (entry_ctree);
  gtk_object_set_data_full (GTK_OBJECT (abook), "entry_ctree", entry_ctree,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (entry_ctree);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), entry_ctree);

  gtk_clist_set_column_width (GTK_CLIST (entry_ctree), 0, tm_globs->cpos.ab[0]);
  gtk_clist_set_column_width (GTK_CLIST (entry_ctree), 1, tm_globs->cpos.ab[1]);

  gtk_clist_column_titles_show (GTK_CLIST (entry_ctree));

  gtk_signal_connect (GTK_OBJECT (entry_ctree), "resize_column",
                         GTK_SIGNAL_FUNC (cpos_set_ab), NULL);

  label55 = gtk_label_new (_("Name"));
  gtk_widget_set_name (label55, "label55");
  gtk_widget_ref (label55);
  gtk_object_set_data_full (GTK_OBJECT (abook), "label55", label55,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (label55);
  gtk_clist_set_column_widget (GTK_CLIST (entry_ctree), 0, label55);

  label56 = gtk_label_new (_("Email Address"));
  gtk_widget_set_name (label56, "label56");
  gtk_widget_ref (label56);
  gtk_object_set_data_full (GTK_OBJECT (abook), "label56", label56,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (label56);
  gtk_clist_set_column_widget (GTK_CLIST (entry_ctree), 1, label56);

  frame1 = gtk_frame_new (NULL);
  gtk_widget_set_name (frame1, "frame1");
  gtk_widget_ref (frame1);
  gtk_object_set_data_full (GTK_OBJECT (abook), "frame1", frame1,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (frame1);
  gtk_box_pack_start (GTK_BOX (hbox1), frame1, FALSE, FALSE, 2);

  vbox2 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox2, "vbox2");
  gtk_widget_ref (vbox2);
  gtk_object_set_data_full (GTK_OBJECT (abook), "vbox2", vbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (vbox2);
  gtk_container_add (GTK_CONTAINER (frame1), vbox2);
  gtk_container_set_border_width (GTK_CONTAINER (vbox2), 2);

  add_entry = gtk_button_new_with_label (_("Add Entry"));
  gtk_widget_set_name (add_entry, "add_entry");
  gtk_widget_ref (add_entry);
  gtk_object_set_data_full (GTK_OBJECT (abook), "add_entry", add_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (add_entry);
  gtk_box_pack_start (GTK_BOX (vbox2), add_entry, TRUE, FALSE, 0);

  add_group = gtk_button_new_with_label (_("Add Group"));
  gtk_widget_set_name (add_group, "add_group");
  gtk_widget_ref (add_group);
  gtk_object_set_data_full (GTK_OBJECT (abook), "add_group", add_group,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (add_group);
  gtk_box_pack_start (GTK_BOX (vbox2), add_group, TRUE, FALSE, 0);

  edit_entry = gtk_button_new_with_label (_("Edit Entry"));
  gtk_widget_set_name (edit_entry, "edit_entry");
  gtk_widget_ref (edit_entry);
  gtk_object_set_data_full (GTK_OBJECT (abook), "edit_entry", edit_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (edit_entry);
  gtk_box_pack_start (GTK_BOX (vbox2), edit_entry, TRUE, FALSE, 0);

  delete_entry = gtk_button_new_with_label (_("Remove Entry"));
  gtk_widget_set_name (delete_entry, "delete_entry");
  gtk_widget_ref (delete_entry);
  gtk_object_set_data_full (GTK_OBJECT (abook), "delete_entry", delete_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (delete_entry);
  gtk_box_pack_start (GTK_BOX (vbox2), delete_entry, TRUE, FALSE, 0);

  some_sep = gtk_hseparator_new ();
  gtk_widget_show (some_sep);
  gtk_box_pack_start (GTK_BOX (vbox2), some_sep, TRUE, FALSE, 0);

  done_button = gtk_button_new_with_label (_("Done"));
  gtk_widget_set_name (done_button, "done_button");
  gtk_widget_ref (done_button);
  gtk_object_set_data_full (GTK_OBJECT (abook), "done_button", done_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (done_button);
  gtk_box_pack_start (GTK_BOX (vbox2), done_button, TRUE, FALSE, 0);

  gtk_signal_connect (GTK_OBJECT (entry_ctree), "click_column",
				      GTK_SIGNAL_FUNC (entry_ctree_clicked_column), NULL);
  gtk_signal_connect (GTK_OBJECT (entry_ctree), "button_press_event",
                      GTK_SIGNAL_FUNC (abook_entry_bpe), NULL);
	gtk_window_add_accel_group (GTK_WINDOW (abook), accel_group);
  
  return abook;
}

GtkWidget *create_abook_entry (void) {
  GtkWidget *abook_entry;
  GtkWidget *dialog_vbox2;
  GtkWidget *notebook1;
  GtkWidget *frame6;
  GtkWidget *vbox5;
  GtkWidget *hbox7;
  GtkWidget *label36;
  GtkWidget *first_name;
  GtkWidget *label37;
  GtkWidget *last_name;
  GtkWidget *hbox8;
  GtkWidget *label38;
  GtkWidget *middle_name;
  GtkWidget *label39;
  GtkWidget *title;
  GtkWidget *hbox12;
  GtkWidget *label51;
  GtkWidget *nickname;
  GtkWidget *label68;
  GtkWidget *combo1;
  GList *combo1_items = NULL;
  GtkWidget *sex;
  GtkWidget *scrolledwindow7;
  GtkWidget *notes;
  GtkWidget *label21;
  GtkWidget *frame10;
  GtkWidget *table3;
  GtkWidget *label42;
  GtkWidget *scrolledwindow6;
  GtkWidget *street_address;
  GtkWidget *label43;
  GtkWidget *home_phone;
  GtkWidget *label44;
  GtkWidget *work_phone;
  GtkWidget *label45;
  GtkWidget *label46;
  GtkWidget *fax;
  GtkWidget *mobile_phone;
  GtkWidget *label47;
  GtkWidget *pager;
  GtkWidget *label34;
  GtkWidget *frame18;
  GtkWidget *table4;
  GtkWidget *label69;
  GtkWidget *company;
  GtkWidget *label70;
  GtkWidget *position;
  GtkWidget *label71;
  GtkWidget *label72;
  GtkWidget *caddress;
  GtkWidget *hbox22;
  GtkWidget *ccity;
  GtkWidget *label73;
  GtkWidget *cstate;
  GtkWidget *label74;
  GtkWidget *czip;
  GtkWidget *label75;
  GtkWidget *hbox23;
  GtkWidget *cphone1;
  GtkWidget *label76;
  GtkWidget *cphone2;
  GtkWidget *label77;
  GtkWidget *hbox24;
  GtkWidget *cfax;
  GtkWidget *label78;
  GtkWidget *cpager;
  GtkWidget *label79;
  GtkWidget *ccountry;
  GtkWidget *label80;
  GtkWidget *label81;
  GtkWidget *hbox25;
  GtkWidget *cmanager;
  GtkWidget *label82;
  GtkWidget *cassistant;
  GtkWidget *cwebpage;
  GtkWidget *label67;
  GtkWidget *frame7;
  GtkWidget *vbox6;
  GtkWidget *hbox9;
  GtkWidget *label40;
  GtkWidget *web_page;
  GtkWidget *goto_webpage;
  GtkWidget *hbox10;
  GtkWidget *vbox7;
  GtkWidget *hbox11;
  GtkWidget *label41;
  GtkWidget *email_address_entry;
  GtkWidget *frame11;
  GtkWidget *scrolledwindow5;
  GtkWidget *addr_clist;
  GtkWidget *label49;
  GtkWidget *label50;
  GtkWidget *frame12;
  GtkWidget *vbox8;
  GtkWidget *add_addr;
  GtkWidget *edit_addr;
  GtkWidget *delete_addr;
  GtkWidget *default_addr;
  GtkWidget *label22;
  GtkWidget *frame16;
  GtkWidget *hbox18;
  GtkWidget *scrolledwindow8;
  GtkWidget *groups_avail;
  GtkWidget *label53;
  GtkWidget *vbox9;
  GtkWidget *add_grp;
  GtkWidget *remove_grp;
  GtkWidget *scrolledwindow9;
  GtkWidget *groups_member;
  GtkWidget *label54;
  GtkWidget *label52;
  GtkWidget *dialog_action_area2;
  GtkWidget *hbox6;
  GtkWidget *ok_button;
  GtkWidget *cancel_button;
  GtkTooltips *tooltips;

  tooltips = gtk_tooltips_new ();

  abook_entry = gtk_dialog_new ();
  gtk_widget_set_name (abook_entry, "abook_entry");
  gtk_object_set_data (GTK_OBJECT (abook_entry), "abook_entry", abook_entry);
  gtk_window_set_title (GTK_WINDOW (abook_entry), _("Address Book Entry"));
  gtk_window_set_policy (GTK_WINDOW (abook_entry), TRUE, TRUE, TRUE);

  dialog_vbox2 = GTK_DIALOG (abook_entry)->vbox;
  gtk_widget_set_name (dialog_vbox2, "dialog_vbox2");
  gtk_object_set_data (GTK_OBJECT (abook_entry), "dialog_vbox2", dialog_vbox2);
  ws (dialog_vbox2);

  notebook1 = gtk_notebook_new ();
  gtk_widget_set_name (notebook1, "notebook1");
  gtk_widget_ref (notebook1);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "notebook1", notebook1,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (notebook1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox2), notebook1, TRUE, TRUE, 0);

  frame6 = gtk_frame_new (NULL);
  gtk_widget_set_name (frame6, "frame6");
  gtk_widget_ref (frame6);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "frame6", frame6,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (frame6);
  gtk_container_add (GTK_CONTAINER (notebook1), frame6);
  gtk_container_set_border_width (GTK_CONTAINER (frame6), 2);

  vbox5 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox5, "vbox5");
  gtk_widget_ref (vbox5);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "vbox5", vbox5,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (vbox5);
  gtk_container_add (GTK_CONTAINER (frame6), vbox5);
  gtk_container_set_border_width (GTK_CONTAINER (vbox5), 2);

  hbox7 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox7, "hbox7");
  gtk_widget_ref (hbox7);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "hbox7", hbox7,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (hbox7);
  gtk_box_pack_start (GTK_BOX (vbox5), hbox7, FALSE, TRUE, 0);

  label36 = gtk_label_new (_("First Name:"));
  gtk_widget_set_name (label36, "label36");
  gtk_widget_ref (label36);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "label36", label36,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (label36);
  gtk_box_pack_start (GTK_BOX (hbox7), label36, FALSE, FALSE, 0);
  gtk_misc_set_padding (GTK_MISC (label36), 2, 0);

  first_name = gtk_entry_new ();
  gtk_widget_set_name (first_name, "first_name");
  gtk_widget_ref (first_name);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "first_name", first_name,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (first_name);
  gtk_box_pack_start (GTK_BOX (hbox7), first_name, TRUE, TRUE, 0);

  label37 = gtk_label_new (_("Last Name:"));
  gtk_widget_set_name (label37, "label37");
  gtk_widget_ref (label37);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "label37", label37,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (label37);
  gtk_box_pack_start (GTK_BOX (hbox7), label37, FALSE, FALSE, 0);
  gtk_misc_set_padding (GTK_MISC (label37), 2, 0);

  last_name = gtk_entry_new ();
  gtk_widget_set_name (last_name, "last_name");
  gtk_widget_ref (last_name);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "last_name", last_name,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (last_name);
  gtk_box_pack_start (GTK_BOX (hbox7), last_name, TRUE, TRUE, 0);

  hbox8 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox8, "hbox8");
  gtk_widget_ref (hbox8);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "hbox8", hbox8,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (hbox8);
  gtk_box_pack_start (GTK_BOX (vbox5), hbox8, FALSE, TRUE, 0);

  label38 = gtk_label_new (_("Middle Name:"));
  gtk_widget_set_name (label38, "label38");
  gtk_widget_ref (label38);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "label38", label38,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (label38);
  gtk_box_pack_start (GTK_BOX (hbox8), label38, FALSE, FALSE, 0);
  gtk_misc_set_padding (GTK_MISC (label38), 2, 0);

  middle_name = gtk_entry_new ();
  gtk_widget_set_name (middle_name, "middle_name");
  gtk_widget_ref (middle_name);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "middle_name", middle_name,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (middle_name);
  gtk_box_pack_start (GTK_BOX (hbox8), middle_name, TRUE, TRUE, 0);

  label39 = gtk_label_new (_("Title:"));
  gtk_widget_set_name (label39, "label39");
  gtk_widget_ref (label39);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "label39", label39,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (label39);
  gtk_box_pack_start (GTK_BOX (hbox8), label39, FALSE, FALSE, 0);
  gtk_misc_set_padding (GTK_MISC (label39), 2, 0);

  title = gtk_entry_new ();
  gtk_widget_set_name (title, "title");
  gtk_widget_ref (title);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "title", title,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (title);
  gtk_box_pack_start (GTK_BOX (hbox8), title, TRUE, TRUE, 0);

  hbox12 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox12, "hbox12");
  gtk_widget_ref (hbox12);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "hbox12", hbox12,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (hbox12);
  gtk_box_pack_start (GTK_BOX (vbox5), hbox12, FALSE, TRUE, 0);

  label51 = gtk_label_new (_("Nickname:"));
  gtk_widget_set_name (label51, "label51");
  gtk_widget_ref (label51);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "label51", label51,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (label51);
  gtk_box_pack_start (GTK_BOX (hbox12), label51, FALSE, FALSE, 0);

  nickname = gtk_entry_new ();
  gtk_widget_set_name (nickname, "nickname");
  gtk_widget_ref (nickname);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "nickname", nickname,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (nickname);
  gtk_box_pack_start (GTK_BOX (hbox12), nickname, TRUE, TRUE, 0);

  label68 = gtk_label_new (_("Sex: "));
  gtk_widget_set_name (label68, "label68");
  gtk_widget_ref (label68);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "label68", label68,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (label68);
  gtk_box_pack_start (GTK_BOX (hbox12), label68, FALSE, FALSE, 0);

  combo1 = gtk_combo_new ();
  gtk_widget_set_name (combo1, "combo1");
  gtk_widget_ref (combo1);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "combo1", combo1,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (combo1);
  gtk_box_pack_start (GTK_BOX (hbox12), combo1, FALSE, FALSE, 0);
  combo1_items = g_list_append (combo1_items, _("Male"));
  combo1_items = g_list_append (combo1_items, _("Female"));
  gtk_combo_set_popdown_strings (GTK_COMBO (combo1), combo1_items);
  g_list_free (combo1_items);

  sex = GTK_COMBO (combo1)->entry;
  gtk_widget_set_name (sex, "sex");
  gtk_widget_ref (sex);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "sex", sex,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (sex);
  gtk_entry_set_editable (GTK_ENTRY (sex), FALSE);
  //gtk_entry_set_text (GTK_ENTRY (sex), _("Male"));

  scrolledwindow7 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_set_name (scrolledwindow7, "scrolledwindow7");
  gtk_widget_ref (scrolledwindow7);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "scrolledwindow7", scrolledwindow7,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (scrolledwindow7);
  gtk_box_pack_start (GTK_BOX (vbox5), scrolledwindow7, FALSE, FALSE, 0);
  gtk_widget_set_usize (scrolledwindow7, -2, 104);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow7), GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);

  notes = gtk_text_new (NULL, NULL);
  gtk_widget_set_name (notes, "notes");
  gtk_widget_ref (notes);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "notes", notes,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (notes);
  gtk_container_add (GTK_CONTAINER (scrolledwindow7), notes);
	gtk_editable_set_editable (GTK_EDITABLE (notes), TRUE);

  label21 = gtk_label_new (_("Identity Info"));
  gtk_widget_set_name (label21, "label21");
  gtk_widget_ref (label21);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "label21", label21,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (label21);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 0), label21);

  frame10 = gtk_frame_new (NULL);
  gtk_widget_set_name (frame10, "frame10");
  gtk_widget_ref (frame10);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "frame10", frame10,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (frame10);
  gtk_container_add (GTK_CONTAINER (notebook1), frame10);
  gtk_container_set_border_width (GTK_CONTAINER (frame10), 2);

  table3 = gtk_table_new (6, 2, FALSE);
  gtk_widget_set_name (table3, "table3");
  gtk_widget_ref (table3);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "table3", table3,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (table3);
  gtk_container_add (GTK_CONTAINER (frame10), table3);
  gtk_container_set_border_width (GTK_CONTAINER (table3), 2);

  label42 = gtk_label_new (_("Street Address"));
  gtk_widget_set_name (label42, "label42");
  gtk_widget_ref (label42);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "label42", label42,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (label42);
  gtk_table_attach (GTK_TABLE (table3), label42, 0, 1, 0, 1,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  scrolledwindow6 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_set_name (scrolledwindow6, "scrolledwindow6");
  gtk_widget_ref (scrolledwindow6);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "scrolledwindow6", scrolledwindow6,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (scrolledwindow6);
  gtk_table_attach (GTK_TABLE (table3), scrolledwindow6, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow6), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  street_address = gtk_text_new (NULL, NULL);
  gtk_widget_set_name (street_address, "street_address");
  gtk_widget_ref (street_address);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "street_address", street_address,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (street_address);
  gtk_container_add (GTK_CONTAINER (scrolledwindow6), street_address);
  gtk_text_set_editable (GTK_TEXT (street_address), TRUE);

  label43 = gtk_label_new (_("Home Phone"));
  gtk_widget_set_name (label43, "label43");
  gtk_widget_ref (label43);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "label43", label43,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (label43);
  gtk_table_attach (GTK_TABLE (table3), label43, 0, 1, 1, 2,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  home_phone = gtk_entry_new ();
  gtk_widget_set_name (home_phone, "home_phone");
  gtk_widget_ref (home_phone);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "home_phone", home_phone,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (home_phone);
  gtk_table_attach (GTK_TABLE (table3), home_phone, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  label44 = gtk_label_new (_("Work Phone"));
  gtk_widget_set_name (label44, "label44");
  gtk_widget_ref (label44);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "label44", label44,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (label44);
  gtk_table_attach (GTK_TABLE (table3), label44, 0, 1, 2, 3,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  work_phone = gtk_entry_new ();
  gtk_widget_set_name (work_phone, "work_phone");
  gtk_widget_ref (work_phone);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "work_phone", work_phone,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (work_phone);
  gtk_table_attach (GTK_TABLE (table3), work_phone, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  label45 = gtk_label_new (_("Fax"));
  gtk_widget_set_name (label45, "label45");
  gtk_widget_ref (label45);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "label45", label45,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (label45);
  gtk_table_attach (GTK_TABLE (table3), label45, 0, 1, 3, 4,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  label46 = gtk_label_new (_("Mobile Phone"));
  gtk_widget_set_name (label46, "label46");
  gtk_widget_ref (label46);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "label46", label46,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (label46);
  gtk_table_attach (GTK_TABLE (table3), label46, 0, 1, 4, 5,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  fax = gtk_entry_new ();
  gtk_widget_set_name (fax, "fax");
  gtk_widget_ref (fax);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "fax", fax,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (fax);
  gtk_table_attach (GTK_TABLE (table3), fax, 1, 2, 3, 4,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  mobile_phone = gtk_entry_new ();
  gtk_widget_set_name (mobile_phone, "mobile_phone");
  gtk_widget_ref (mobile_phone);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "mobile_phone", mobile_phone,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (mobile_phone);
  gtk_table_attach (GTK_TABLE (table3), mobile_phone, 1, 2, 4, 5,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  label47 = gtk_label_new (_("Pager"));
  gtk_widget_set_name (label47, "label47");
  gtk_widget_ref (label47);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "label47", label47,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (label47);
  gtk_table_attach (GTK_TABLE (table3), label47, 0, 1, 5, 6,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  pager = gtk_entry_new ();
  gtk_widget_set_name (pager, "pager");
  gtk_widget_ref (pager);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "pager", pager,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (pager);
  gtk_table_attach (GTK_TABLE (table3), pager, 1, 2, 5, 6,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  label34 = gtk_label_new (_("Personal Info"));
  gtk_widget_set_name (label34, "label34");
  gtk_widget_ref (label34);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "label34", label34,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (label34);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 1), label34);

  frame18 = gtk_frame_new (NULL);
  gtk_widget_set_name (frame18, "frame18");
  gtk_widget_ref (frame18);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "frame18", frame18,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (frame18);
  gtk_container_add (GTK_CONTAINER (notebook1), frame18);
  gtk_container_set_border_width (GTK_CONTAINER (frame18), 2);

  table4 = gtk_table_new (9, 2, FALSE);
  gtk_widget_set_name (table4, "table4");
  gtk_widget_ref (table4);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "table4", table4,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (table4);
  gtk_container_add (GTK_CONTAINER (frame18), table4);
  gtk_container_set_border_width (GTK_CONTAINER (table4), 2);

  label69 = gtk_label_new (_("Company: "));
  gtk_widget_set_name (label69, "label69");
  gtk_widget_ref (label69);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "label69", label69,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (label69);
  gtk_table_attach (GTK_TABLE (table4), label69, 0, 1, 0, 1,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  company = gtk_entry_new ();
  gtk_widget_set_name (company, "company");
  gtk_widget_ref (company);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "company", company,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (company);
  gtk_table_attach (GTK_TABLE (table4), company, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  label70 = gtk_label_new (_("Position:"));
  gtk_widget_set_name (label70, "label70");
  gtk_widget_ref (label70);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "label70", label70,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (label70);
  gtk_table_attach (GTK_TABLE (table4), label70, 0, 1, 1, 2,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  position = gtk_entry_new ();
  gtk_widget_set_name (position, "position");
  gtk_widget_ref (position);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "position", position,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (position);
  gtk_table_attach (GTK_TABLE (table4), position, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  label71 = gtk_label_new (_("Street Address:"));
  gtk_widget_set_name (label71, "label71");
  gtk_widget_ref (label71);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "label71", label71,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (label71);
  gtk_table_attach (GTK_TABLE (table4), label71, 0, 1, 2, 3,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  label72 = gtk_label_new (_("City:"));
  gtk_widget_set_name (label72, "label72");
  gtk_widget_ref (label72);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "label72", label72,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (label72);
  gtk_table_attach (GTK_TABLE (table4), label72, 0, 1, 3, 4,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  caddress = gtk_entry_new ();
  gtk_widget_set_name (caddress, "caddress");
  gtk_widget_ref (caddress);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "caddress", caddress,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (caddress);
  gtk_table_attach (GTK_TABLE (table4), caddress, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  hbox22 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox22, "hbox22");
  gtk_widget_ref (hbox22);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "hbox22", hbox22,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (hbox22);
  gtk_table_attach (GTK_TABLE (table4), hbox22, 1, 2, 3, 4,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);

  ccity = gtk_entry_new ();
  gtk_widget_set_name (ccity, "ccity");
  gtk_widget_ref (ccity);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "ccity", ccity,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (ccity);
  gtk_box_pack_start (GTK_BOX (hbox22), ccity, FALSE, FALSE, 0);
  gtk_widget_set_usize (ccity, 116, -2);

  label73 = gtk_label_new (_(" State: "));
  gtk_widget_set_name (label73, "label73");
  gtk_widget_ref (label73);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "label73", label73,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (label73);
  gtk_box_pack_start (GTK_BOX (hbox22), label73, FALSE, FALSE, 0);

  cstate = gtk_entry_new ();
  gtk_widget_set_name (cstate, "cstate");
  gtk_widget_ref (cstate);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "cstate", cstate,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (cstate);
  gtk_box_pack_start (GTK_BOX (hbox22), cstate, FALSE, FALSE, 0);
  gtk_widget_set_usize (cstate, 103, -2);

  label74 = gtk_label_new (_(" Zip: "));
  gtk_widget_set_name (label74, "label74");
  gtk_widget_ref (label74);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "label74", label74,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (label74);
  gtk_box_pack_start (GTK_BOX (hbox22), label74, FALSE, FALSE, 0);

  czip = gtk_entry_new ();
  gtk_widget_set_name (czip, "czip");
  gtk_widget_ref (czip);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "czip", czip,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (czip);
  gtk_box_pack_start (GTK_BOX (hbox22), czip, TRUE, TRUE, 0);
  gtk_widget_set_usize (czip, 105, -2);

  label75 = gtk_label_new (_("Phone #1:"));
  gtk_widget_set_name (label75, "label75");
  gtk_widget_ref (label75);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "label75", label75,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (label75);
  gtk_table_attach (GTK_TABLE (table4), label75, 0, 1, 5, 6,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  hbox23 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox23, "hbox23");
  gtk_widget_ref (hbox23);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "hbox23", hbox23,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (hbox23);
  gtk_table_attach (GTK_TABLE (table4), hbox23, 1, 2, 5, 6,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);

  cphone1 = gtk_entry_new ();
  gtk_widget_set_name (cphone1, "cphone1");
  gtk_widget_ref (cphone1);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "cphone1", cphone1,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (cphone1);
  gtk_box_pack_start (GTK_BOX (hbox23), cphone1, TRUE, TRUE, 0);

  label76 = gtk_label_new (_(" Phone #2: "));
  gtk_widget_set_name (label76, "label76");
  gtk_widget_ref (label76);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "label76", label76,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (label76);
  gtk_box_pack_start (GTK_BOX (hbox23), label76, FALSE, FALSE, 0);

  cphone2 = gtk_entry_new ();
  gtk_widget_set_name (cphone2, "cphone2");
  gtk_widget_ref (cphone2);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "cphone2", cphone2,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (cphone2);
  gtk_box_pack_start (GTK_BOX (hbox23), cphone2, TRUE, TRUE, 0);

  label77 = gtk_label_new (_("Fax:"));
  gtk_widget_set_name (label77, "label77");
  gtk_widget_ref (label77);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "label77", label77,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (label77);
  gtk_table_attach (GTK_TABLE (table4), label77, 0, 1, 6, 7,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  hbox24 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox24, "hbox24");
  gtk_widget_ref (hbox24);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "hbox24", hbox24,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (hbox24);
  gtk_table_attach (GTK_TABLE (table4), hbox24, 1, 2, 6, 7,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);

  cfax = gtk_entry_new ();
  gtk_widget_set_name (cfax, "cfax");
  gtk_widget_ref (cfax);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "cfax", cfax,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (cfax);
  gtk_box_pack_start (GTK_BOX (hbox24), cfax, TRUE, TRUE, 0);

  label78 = gtk_label_new (_(" Pager: "));
  gtk_widget_set_name (label78, "label78");
  gtk_widget_ref (label78);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "label78", label78,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (label78);
  gtk_box_pack_start (GTK_BOX (hbox24), label78, FALSE, FALSE, 0);

  cpager = gtk_entry_new ();
  gtk_widget_set_name (cpager, "cpager");
  gtk_widget_ref (cpager);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "cpager", cpager,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (cpager);
  gtk_box_pack_start (GTK_BOX (hbox24), cpager, TRUE, TRUE, 0);

  label79 = gtk_label_new (_("Country:"));
  gtk_widget_set_name (label79, "label79");
  gtk_widget_ref (label79);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "label79", label79,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (label79);
  gtk_table_attach (GTK_TABLE (table4), label79, 0, 1, 4, 5,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  ccountry = gtk_entry_new ();
  gtk_widget_set_name (ccountry, "ccountry");
  gtk_widget_ref (ccountry);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "ccountry", ccountry,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (ccountry);
  gtk_table_attach (GTK_TABLE (table4), ccountry, 1, 2, 4, 5,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  label80 = gtk_label_new (_("Webpage: "));
  gtk_widget_set_name (label80, "label80");
  gtk_widget_ref (label80);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "label80", label80,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (label80);
  gtk_table_attach (GTK_TABLE (table4), label80, 0, 1, 7, 8,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  label81 = gtk_label_new (_("Manager:"));
  gtk_widget_set_name (label81, "label81");
  gtk_widget_ref (label81);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "label81", label81,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (label81);
  gtk_table_attach (GTK_TABLE (table4), label81, 0, 1, 8, 9,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  hbox25 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox25, "hbox25");
  gtk_widget_ref (hbox25);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "hbox25", hbox25,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (hbox25);
  gtk_table_attach (GTK_TABLE (table4), hbox25, 1, 2, 8, 9,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);

  cmanager = gtk_entry_new ();
  gtk_widget_set_name (cmanager, "cmanager");
  gtk_widget_ref (cmanager);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "cmanager", cmanager,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (cmanager);
  gtk_box_pack_start (GTK_BOX (hbox25), cmanager, TRUE, TRUE, 0);

  label82 = gtk_label_new (_(" Assistant: "));
  gtk_widget_set_name (label82, "label82");
  gtk_widget_ref (label82);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "label82", label82,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (label82);
  gtk_box_pack_start (GTK_BOX (hbox25), label82, FALSE, FALSE, 0);

  cassistant = gtk_entry_new ();
  gtk_widget_set_name (cassistant, "cassistant");
  gtk_widget_ref (cassistant);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "cassistant", cassistant,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (cassistant);
  gtk_box_pack_start (GTK_BOX (hbox25), cassistant, TRUE, TRUE, 0);

  cwebpage = gtk_entry_new ();
  gtk_widget_set_name (cwebpage, "cwebpage");
  gtk_widget_ref (cwebpage);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "cwebpage", cwebpage,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (cwebpage);
  gtk_table_attach (GTK_TABLE (table4), cwebpage, 1, 2, 7, 8,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  label67 = gtk_label_new (_("Business Info"));
  gtk_widget_set_name (label67, "label67");
  gtk_widget_ref (label67);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "label67", label67,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (label67);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 2), label67);

  frame7 = gtk_frame_new (NULL);
  gtk_widget_set_name (frame7, "frame7");
  gtk_widget_ref (frame7);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "frame7", frame7,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (frame7);
  gtk_container_add (GTK_CONTAINER (notebook1), frame7);
  gtk_container_set_border_width (GTK_CONTAINER (frame7), 2);

  vbox6 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox6, "vbox6");
  gtk_widget_ref (vbox6);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "vbox6", vbox6,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (vbox6);
  gtk_container_add (GTK_CONTAINER (frame7), vbox6);
  gtk_container_set_border_width (GTK_CONTAINER (vbox6), 2);

  hbox9 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox9, "hbox9");
  gtk_widget_ref (hbox9);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "hbox9", hbox9,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (hbox9);
  gtk_box_pack_start (GTK_BOX (vbox6), hbox9, FALSE, TRUE, 0);

  label40 = gtk_label_new (_("Web Page"));
  gtk_widget_set_name (label40, "label40");
  gtk_widget_ref (label40);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "label40", label40,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (label40);
  gtk_box_pack_start (GTK_BOX (hbox9), label40, FALSE, FALSE, 0);

  web_page = gtk_entry_new ();
  gtk_widget_set_name (web_page, "web_page");
  gtk_widget_ref (web_page);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "web_page", web_page,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (web_page);
  gtk_box_pack_start (GTK_BOX (hbox9), web_page, TRUE, TRUE, 0);

  goto_webpage = gtk_button_new_with_label (_("Go To Web Page"));
  gtk_widget_set_name (goto_webpage, "goto_webpage");
  gtk_widget_ref (goto_webpage);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "goto_webpage", goto_webpage,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (goto_webpage);
  gtk_box_pack_start (GTK_BOX (hbox9), goto_webpage, FALSE, FALSE, 0);

  hbox10 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox10, "hbox10");
  gtk_widget_ref (hbox10);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "hbox10", hbox10,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (hbox10);
  gtk_box_pack_start (GTK_BOX (vbox6), hbox10, TRUE, TRUE, 0);

  vbox7 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox7, "vbox7");
  gtk_widget_ref (vbox7);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "vbox7", vbox7,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (vbox7);
  gtk_box_pack_start (GTK_BOX (hbox10), vbox7, TRUE, TRUE, 0);

  hbox11 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox11, "hbox11");
  gtk_widget_ref (hbox11);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "hbox11", hbox11,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (hbox11);
  gtk_box_pack_start (GTK_BOX (vbox7), hbox11, FALSE, TRUE, 0);

  label41 = gtk_label_new (_("Email Addresses "));
  gtk_widget_set_name (label41, "label41");
  gtk_widget_ref (label41);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "label41", label41,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (label41);
  gtk_box_pack_start (GTK_BOX (hbox11), label41, FALSE, FALSE, 0);

  email_address_entry = gtk_entry_new ();
  gtk_widget_set_name (email_address_entry, "email_address_entry");
  gtk_widget_ref (email_address_entry);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "email_address_entry", email_address_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (email_address_entry);
  gtk_box_pack_start (GTK_BOX (hbox11), email_address_entry, TRUE, TRUE, 0);

  frame11 = gtk_frame_new (NULL);
  gtk_widget_set_name (frame11, "frame11");
  gtk_widget_ref (frame11);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "frame11", frame11,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (frame11);
  gtk_box_pack_start (GTK_BOX (vbox7), frame11, TRUE, TRUE, 0);
  gtk_frame_set_shadow_type (GTK_FRAME (frame11), GTK_SHADOW_IN);

  scrolledwindow5 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_set_name (scrolledwindow5, "scrolledwindow5");
  gtk_widget_ref (scrolledwindow5);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "scrolledwindow5", scrolledwindow5,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (scrolledwindow5);
  gtk_container_add (GTK_CONTAINER (frame11), scrolledwindow5);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow5), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  addr_clist = gtk_clist_new (2);
  gtk_widget_set_name (addr_clist, "addr_clist");
  gtk_widget_ref (addr_clist);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "addr_clist", addr_clist,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (addr_clist);
  gtk_container_add (GTK_CONTAINER (scrolledwindow5), addr_clist);
  gtk_clist_set_column_width (GTK_CLIST (addr_clist), 0, 198);
  gtk_clist_set_column_width (GTK_CLIST (addr_clist), 1, 80);
  gtk_clist_column_titles_show (GTK_CLIST (addr_clist));

  label49 = gtk_label_new (_("Email Addresses"));
  gtk_widget_set_name (label49, "label49");
  gtk_widget_ref (label49);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "label49", label49,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (label49);
  gtk_clist_set_column_widget (GTK_CLIST (addr_clist), 0, label49);

  label50 = gtk_label_new (_("Default"));
  gtk_widget_set_name (label50, "label50");
  gtk_widget_ref (label50);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "label50", label50,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (label50);
  gtk_clist_set_column_widget (GTK_CLIST (addr_clist), 1, label50);

  frame12 = gtk_frame_new (NULL);
  gtk_widget_set_name (frame12, "frame12");
  gtk_widget_ref (frame12);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "frame12", frame12,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (frame12);
  gtk_box_pack_start (GTK_BOX (hbox10), frame12, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame12), 2);
  gtk_frame_set_shadow_type (GTK_FRAME (frame12), GTK_SHADOW_OUT);

  vbox8 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox8, "vbox8");
  gtk_widget_ref (vbox8);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "vbox8", vbox8,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (vbox8);
  gtk_container_add (GTK_CONTAINER (frame12), vbox8);
  gtk_container_set_border_width (GTK_CONTAINER (vbox8), 2);

  add_addr = gtk_button_new_with_label (_("Add/Edit"));
  gtk_widget_set_name (add_addr, "add_addr");
  gtk_widget_ref (add_addr);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "add_addr", add_addr,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (add_addr);
  gtk_box_pack_start (GTK_BOX (vbox8), add_addr, TRUE, FALSE, 0);

  edit_addr = gtk_button_new_with_label (_("Edit"));
  gtk_widget_set_name (edit_addr, "edit_addr");
  gtk_widget_ref (edit_addr);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "edit_addr", edit_addr,
                            (GtkDestroyNotify) gtk_widget_unref);
//  ws (edit_addr);
  gtk_box_pack_start (GTK_BOX (vbox8), edit_addr, TRUE, FALSE, 0);

  delete_addr = gtk_button_new_with_label (_("Delete"));
  gtk_widget_set_name (delete_addr, "delete_addr");
  gtk_widget_ref (delete_addr);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "delete_addr", delete_addr,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (delete_addr);
  gtk_box_pack_start (GTK_BOX (vbox8), delete_addr, TRUE, FALSE, 0);

  default_addr = gtk_button_new_with_label (_("Set as Default"));
  gtk_widget_set_name (default_addr, "default_addr");
  gtk_widget_ref (default_addr);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "default_addr", default_addr,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (default_addr);
  gtk_box_pack_start (GTK_BOX (vbox8), default_addr, TRUE, FALSE, 0);

  label22 = gtk_label_new (_("Online Contact Info"));
  gtk_widget_set_name (label22, "label22");
  gtk_widget_ref (label22);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "label22", label22,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (label22);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 3), label22);

  frame16 = gtk_frame_new (NULL);
  gtk_widget_set_name (frame16, "frame16");
  gtk_widget_ref (frame16);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "frame16", frame16,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (frame16);
  gtk_container_add (GTK_CONTAINER (notebook1), frame16);
  gtk_container_set_border_width (GTK_CONTAINER (frame16), 2);

  hbox18 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox18, "hbox18");
  gtk_widget_ref (hbox18);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "hbox18", hbox18,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (hbox18);
  gtk_container_add (GTK_CONTAINER (frame16), hbox18);

  scrolledwindow8 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_set_name (scrolledwindow8, "scrolledwindow8");
  gtk_widget_ref (scrolledwindow8);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "scrolledwindow8", scrolledwindow8,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (scrolledwindow8);
  gtk_box_pack_start (GTK_BOX (hbox18), scrolledwindow8, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow8), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  groups_avail = gtk_clist_new (1);
  gtk_widget_set_name (groups_avail, "groups_avail");
  gtk_widget_ref (groups_avail);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "groups_avail", groups_avail,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (groups_avail);
  gtk_container_add (GTK_CONTAINER (scrolledwindow8), groups_avail);
  gtk_clist_set_column_width (GTK_CLIST (groups_avail), 0, 80);
  gtk_clist_column_titles_show (GTK_CLIST (groups_avail));

  label53 = gtk_label_new (_("Available Groups"));
  gtk_widget_set_name (label53, "label53");
  gtk_widget_ref (label53);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "label53", label53,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (label53);
  gtk_clist_set_column_widget (GTK_CLIST (groups_avail), 0, label53);

  vbox9 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox9, "vbox9");
  gtk_widget_ref (vbox9);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "vbox9", vbox9,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (vbox9);
  gtk_box_pack_start (GTK_BOX (hbox18), vbox9, FALSE, FALSE, 0);

  add_grp = gtk_button_new_with_label (_("Add: -->"));
  gtk_widget_set_name (add_grp, "add_grp");
  gtk_widget_ref (add_grp);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "add_grp", add_grp,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (add_grp);
  gtk_box_pack_start (GTK_BOX (vbox9), add_grp, TRUE, FALSE, 0);

  remove_grp = gtk_button_new_with_label (_("<-- Remove:"));
  gtk_widget_set_name (remove_grp, "remove_grp");
  gtk_widget_ref (remove_grp);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "remove_grp", remove_grp,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (remove_grp);
  gtk_box_pack_start (GTK_BOX (vbox9), remove_grp, TRUE, FALSE, 0);

  scrolledwindow9 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_set_name (scrolledwindow9, "scrolledwindow9");
  gtk_widget_ref (scrolledwindow9);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "scrolledwindow9", scrolledwindow9,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (scrolledwindow9);
  gtk_box_pack_start (GTK_BOX (hbox18), scrolledwindow9, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow9), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  groups_member = gtk_clist_new (1);
  gtk_widget_set_name (groups_member, "groups_member");
  gtk_widget_ref (groups_member);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "groups_member", groups_member,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (groups_member);
  gtk_container_add (GTK_CONTAINER (scrolledwindow9), groups_member);
  gtk_clist_set_column_width (GTK_CLIST (groups_member), 0, 80);
  gtk_clist_column_titles_show (GTK_CLIST (groups_member));

  label54 = gtk_label_new (_("Membership"));
  gtk_widget_set_name (label54, "label54");
  gtk_widget_ref (label54);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "label54", label54,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (label54);
  gtk_clist_set_column_widget (GTK_CLIST (groups_member), 0, label54);

  label52 = gtk_label_new (_("Group Memberships"));
  gtk_widget_set_name (label52, "label52");
  gtk_widget_ref (label52);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "label52", label52,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (label52);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 4), label52);

  dialog_action_area2 = GTK_DIALOG (abook_entry)->action_area;
  gtk_widget_set_name (dialog_action_area2, "dialog_action_area2");
  gtk_object_set_data (GTK_OBJECT (abook_entry), "dialog_action_area2", dialog_action_area2);
  ws (dialog_action_area2);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area2), 10);

  hbox6 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox6, "hbox6");
  gtk_widget_ref (hbox6);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "hbox6", hbox6,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (hbox6);
  gtk_box_pack_start (GTK_BOX (dialog_action_area2), hbox6, TRUE, TRUE, 0);

  ok_button = gtk_button_new_with_label (_("Ok"));
  gtk_widget_set_name (ok_button, "ok_button");
  gtk_widget_ref (ok_button);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "ok_button", ok_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (ok_button);
  gtk_box_pack_start (GTK_BOX (hbox6), ok_button, TRUE, TRUE, 0);
  GTK_WIDGET_SET_FLAGS (ok_button, GTK_CAN_DEFAULT);
  gtk_tooltips_set_tip (tooltips, ok_button, _("Yes, I'm done."), NULL);

  cancel_button = gtk_button_new_with_label (_("Cancel"));
  gtk_widget_set_name (cancel_button, "cancel_button");
  gtk_widget_ref (cancel_button);
  gtk_object_set_data_full (GTK_OBJECT (abook_entry), "cancel_button", cancel_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (cancel_button);
  gtk_box_pack_start (GTK_BOX (hbox6), cancel_button, TRUE, TRUE, 0);
  gtk_tooltips_set_tip (tooltips, cancel_button, _("Noo! I messed up!"), NULL);

  gtk_widget_grab_focus (ok_button);
  gtk_widget_grab_default (ok_button);
  gtk_object_set_data (GTK_OBJECT (abook_entry), "tooltips", tooltips);

  return abook_entry;
}

GtkWidget *create_group_editor (void) {
  GtkWidget *group_editor;
  GtkWidget *dialog_vbox5;
  GtkWidget *frame17;
  GtkWidget *vbox10;
  GtkWidget *hbox20;
  GtkWidget *label61;
  GtkWidget *group_name;
  GtkWidget *hbox21;
  GtkWidget *scrolledwindow12;
  GtkWidget *entries;
  GtkWidget *label63;
  GtkWidget *label64;
  GtkWidget *vbox12;
  GtkWidget *add_entry;
  GtkWidget *remove_entry;
  GtkWidget *scrolledwindow13;
  GtkWidget *members;
  GtkWidget *label65;
  GtkWidget *label66;
  GtkWidget *dialog_action_area5;
  GtkWidget *ok_button;
  GtkWidget *cancel_button;

  group_editor = gtk_dialog_new ();
  gtk_widget_set_name (group_editor, "group_editor");
  gtk_object_set_data (GTK_OBJECT (group_editor), "group_editor", group_editor);
  gtk_window_set_title (GTK_WINDOW (group_editor), _("New/Edit Group"));
  gtk_window_set_policy (GTK_WINDOW (group_editor), TRUE, TRUE, TRUE);

  dialog_vbox5 = GTK_DIALOG (group_editor)->vbox;
  gtk_widget_set_name (dialog_vbox5, "dialog_vbox5");
  gtk_object_set_data (GTK_OBJECT (group_editor), "dialog_vbox5", dialog_vbox5);
  ws (dialog_vbox5);

  frame17 = gtk_frame_new (NULL);
  gtk_widget_set_name (frame17, "frame17");
  gtk_widget_ref (frame17);
  gtk_object_set_data_full (GTK_OBJECT (group_editor), "frame17", frame17,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (frame17);
  gtk_box_pack_start (GTK_BOX (dialog_vbox5), frame17, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame17), 2);

  vbox10 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox10, "vbox10");
  gtk_widget_ref (vbox10);
  gtk_object_set_data_full (GTK_OBJECT (group_editor), "vbox10", vbox10,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (vbox10);
  gtk_container_add (GTK_CONTAINER (frame17), vbox10);
  gtk_container_set_border_width (GTK_CONTAINER (vbox10), 2);

  hbox20 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox20, "hbox20");
  gtk_widget_ref (hbox20);
  gtk_object_set_data_full (GTK_OBJECT (group_editor), "hbox20", hbox20,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (hbox20);
  gtk_box_pack_start (GTK_BOX (vbox10), hbox20, FALSE, FALSE, 0);

  label61 = gtk_label_new (_("Group Name: "));
  gtk_widget_set_name (label61, "label61");
  gtk_widget_ref (label61);
  gtk_object_set_data_full (GTK_OBJECT (group_editor), "label61", label61,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (label61);
  gtk_box_pack_start (GTK_BOX (hbox20), label61, FALSE, FALSE, 0);

  group_name = gtk_entry_new ();
  gtk_widget_set_name (group_name, "group_name");
  gtk_widget_ref (group_name);
  gtk_object_set_data_full (GTK_OBJECT (group_editor), "group_name", group_name,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (group_name);
  gtk_box_pack_start (GTK_BOX (hbox20), group_name, TRUE, TRUE, 0);

  hbox21 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox21, "hbox21");
  gtk_widget_ref (hbox21);
  gtk_object_set_data_full (GTK_OBJECT (group_editor), "hbox21", hbox21,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (hbox21);
  gtk_box_pack_start (GTK_BOX (vbox10), hbox21, TRUE, TRUE, 0);

  scrolledwindow12 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_set_name (scrolledwindow12, "scrolledwindow12");
  gtk_widget_ref (scrolledwindow12);
  gtk_object_set_data_full (GTK_OBJECT (group_editor), "scrolledwindow12", scrolledwindow12,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (scrolledwindow12);
  gtk_box_pack_start (GTK_BOX (hbox21), scrolledwindow12, TRUE, TRUE, 0);
  gtk_widget_set_usize (scrolledwindow12, 250, 224);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow12), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  entries = gtk_clist_new (2);
  gtk_widget_set_name (entries, "entries");
  gtk_widget_ref (entries);
  gtk_object_set_data_full (GTK_OBJECT (group_editor), "entries", entries,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (entries);
  gtk_container_add (GTK_CONTAINER (scrolledwindow12), entries);
  gtk_clist_set_column_width (GTK_CLIST (entries), 0, 150);
  gtk_clist_set_column_width (GTK_CLIST (entries), 1, 54);
  gtk_clist_column_titles_show (GTK_CLIST (entries));

  label63 = gtk_label_new (_("Name"));
  gtk_widget_set_name (label63, "label63");
  gtk_widget_ref (label63);
  gtk_object_set_data_full (GTK_OBJECT (group_editor), "label63", label63,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (label63);
  gtk_clist_set_column_widget (GTK_CLIST (entries), 0, label63);

  label64 = gtk_label_new (_("Email"));
  gtk_widget_set_name (label64, "label64");
  gtk_widget_ref (label64);
  gtk_object_set_data_full (GTK_OBJECT (group_editor), "label64", label64,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (label64);
  gtk_clist_set_column_widget (GTK_CLIST (entries), 1, label64);

  vbox12 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox12, "vbox12");
  gtk_widget_ref (vbox12);
  gtk_object_set_data_full (GTK_OBJECT (group_editor), "vbox12", vbox12,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (vbox12);
  gtk_box_pack_start (GTK_BOX (hbox21), vbox12, FALSE, FALSE, 0);

  add_entry = gtk_button_new_with_label (_("Add: -->"));
  gtk_widget_set_name (add_entry, "add_entry");
  gtk_widget_ref (add_entry);
  gtk_object_set_data_full (GTK_OBJECT (group_editor), "add_entry", add_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (add_entry);
  gtk_box_pack_start (GTK_BOX (vbox12), add_entry, TRUE, FALSE, 0);

  remove_entry = gtk_button_new_with_label (_("<-- Remove:"));
  gtk_widget_set_name (remove_entry, "remove_entry");
  gtk_widget_ref (remove_entry);
  gtk_object_set_data_full (GTK_OBJECT (group_editor), "remove_entry", remove_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (remove_entry);
  gtk_box_pack_start (GTK_BOX (vbox12), remove_entry, TRUE, FALSE, 0);

  scrolledwindow13 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_set_name (scrolledwindow13, "scrolledwindow13");
  gtk_widget_ref (scrolledwindow13);
  gtk_object_set_data_full (GTK_OBJECT (group_editor), "scrolledwindow13", scrolledwindow13,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (scrolledwindow13);
  gtk_box_pack_start (GTK_BOX (hbox21), scrolledwindow13, TRUE, TRUE, 0);
  gtk_widget_set_usize (scrolledwindow13, 250, -2);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow13), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  members = gtk_clist_new (2);
  gtk_widget_set_name (members, "members");
  gtk_widget_ref (members);
  gtk_object_set_data_full (GTK_OBJECT (group_editor), "members", members,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (members);
  gtk_container_add (GTK_CONTAINER (scrolledwindow13), members);
  gtk_clist_set_column_width (GTK_CLIST (members), 0, 147);
  gtk_clist_set_column_width (GTK_CLIST (members), 1, 45);
  gtk_clist_column_titles_show (GTK_CLIST (members));

  label65 = gtk_label_new (_("Name"));
  gtk_widget_set_name (label65, "label65");
  gtk_widget_ref (label65);
  gtk_object_set_data_full (GTK_OBJECT (group_editor), "label65", label65,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (label65);
  gtk_clist_set_column_widget (GTK_CLIST (members), 0, label65);

  label66 = gtk_label_new (_("Email"));
  gtk_widget_set_name (label66, "label66");
  gtk_widget_ref (label66);
  gtk_object_set_data_full (GTK_OBJECT (group_editor), "label66", label66,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (label66);
  gtk_clist_set_column_widget (GTK_CLIST (members), 1, label66);

  dialog_action_area5 = GTK_DIALOG (group_editor)->action_area;
  gtk_widget_set_name (dialog_action_area5, "dialog_action_area5");
  gtk_object_set_data (GTK_OBJECT (group_editor), "dialog_action_area5", dialog_action_area5);
  ws (dialog_action_area5);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area5), 10);

  ok_button = gtk_button_new_with_label (_("Ok"));
  gtk_widget_set_name (ok_button, "ok_button");
  gtk_widget_ref (ok_button);
  gtk_object_set_data_full (GTK_OBJECT (group_editor), "ok_button", ok_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (ok_button);
  gtk_box_pack_start (GTK_BOX (dialog_action_area5), ok_button, TRUE, TRUE, 0);
  GTK_WIDGET_SET_FLAGS (ok_button, GTK_CAN_DEFAULT);

  cancel_button = gtk_button_new_with_label (_("Cancel"));
  gtk_widget_set_name (cancel_button, "cancel_button");
  gtk_widget_ref (cancel_button);
  gtk_object_set_data_full (GTK_OBJECT (group_editor), "cancel_button", cancel_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (cancel_button);
  gtk_box_pack_start (GTK_BOX (dialog_action_area5), cancel_button, TRUE, TRUE, 0);

  gtk_widget_grab_focus (ok_button);
  gtk_widget_grab_default (ok_button);
  return group_editor;
}

GtkWidget *create_new_abook (void) {
  GtkWidget *new_abook;
  GtkWidget *dialog_vbox4;
  GtkWidget *frame15;
  GtkWidget *hbox19;
  GtkWidget *abook_entry;
  GtkWidget *dialog_action_area4;
  GtkWidget *hbox15;
  GtkWidget *ok_button;
  GtkWidget *cancel_button;

  new_abook = gtk_dialog_new ();
  gtk_widget_set_name (new_abook, "new_abook");
  gtk_object_set_data (GTK_OBJECT (new_abook), "new_abook", new_abook);
  gtk_window_set_title (GTK_WINDOW (new_abook), _("New Address Book"));
  gtk_window_set_modal (GTK_WINDOW (new_abook), TRUE);
  gtk_window_set_policy (GTK_WINDOW (new_abook), TRUE, TRUE, FALSE);

  dialog_vbox4 = GTK_DIALOG (new_abook)->vbox;
  gtk_widget_set_name (dialog_vbox4, "dialog_vbox4");
  gtk_object_set_data (GTK_OBJECT (new_abook), "dialog_vbox4", dialog_vbox4);
  ws (dialog_vbox4);

  frame15 = gtk_frame_new (_("Enter a name for a new Address Book"));
  gtk_widget_set_name (frame15, "frame15");
  gtk_widget_ref (frame15);
  gtk_object_set_data_full (GTK_OBJECT (new_abook), "frame15", frame15,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (frame15);
  gtk_box_pack_start (GTK_BOX (dialog_vbox4), frame15, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame15), 2);

  hbox19 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox19, "hbox19");
  gtk_widget_ref (hbox19);
  gtk_object_set_data_full (GTK_OBJECT (new_abook), "hbox19", hbox19,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (hbox19);
  gtk_container_add (GTK_CONTAINER (frame15), hbox19);
  gtk_container_set_border_width (GTK_CONTAINER (hbox19), 2);

  abook_entry = gtk_entry_new ();
  gtk_widget_set_name (abook_entry, "abook_entry");
  gtk_widget_ref (abook_entry);
  gtk_object_set_data_full (GTK_OBJECT (new_abook), "abook_entry", abook_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (abook_entry);
  gtk_box_pack_start (GTK_BOX (hbox19), abook_entry, TRUE, TRUE, 0);

  dialog_action_area4 = GTK_DIALOG (new_abook)->action_area;
  gtk_widget_set_name (dialog_action_area4, "dialog_action_area4");
  gtk_object_set_data (GTK_OBJECT (new_abook), "dialog_action_area4", dialog_action_area4);
  ws (dialog_action_area4);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area4), 10);

  hbox15 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox15, "hbox15");
  gtk_widget_ref (hbox15);
  gtk_object_set_data_full (GTK_OBJECT (new_abook), "hbox15", hbox15,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (hbox15);
  gtk_box_pack_start (GTK_BOX (dialog_action_area4), hbox15, TRUE, TRUE, 0);

  ok_button = gtk_button_new_with_label (_("Ok"));
  gtk_widget_set_name (ok_button, "ok_button");
  gtk_widget_ref (ok_button);
  gtk_object_set_data_full (GTK_OBJECT (new_abook), "ok_button", ok_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (ok_button);
  gtk_box_pack_start (GTK_BOX (hbox15), ok_button, TRUE, TRUE, 0);
  GTK_WIDGET_SET_FLAGS (ok_button, GTK_CAN_DEFAULT);

  cancel_button = gtk_button_new_with_label (_("Cancel"));
  gtk_widget_set_name (cancel_button, "cancel_button");
  gtk_widget_ref (cancel_button);
  gtk_object_set_data_full (GTK_OBJECT (new_abook), "cancel_button", cancel_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (cancel_button);
  gtk_box_pack_start (GTK_BOX (hbox15), cancel_button, TRUE, TRUE, 0);

  gtk_widget_grab_focus (ok_button);
  gtk_widget_grab_default (ok_button);
  return new_abook;
}

GtkWidget *create_selector (void) {
  GtkWidget *selector;
  GtkWidget *dialog_vbox1;
  GtkWidget *table1;
  GtkWidget *frame3;
  GtkWidget *hbox4;
  GtkWidget *label12;
  GtkWidget *abook_optionmenu;
  GtkWidget *abook_optionmenu_menu;
  GtkWidget *glade_menuitem;
  GtkWidget *frame4;
  GtkWidget *hbox5;
  GtkWidget *label20;
  GtkWidget *find_entry;
  GtkWidget *search;
  GtkWidget *frame5;
  GtkWidget *vbox4;
  GtkWidget *hbox16;
  GtkWidget *all_entries;
  GtkWidget *none_entries;
  GtkWidget *hbox17;
  GtkWidget *all_member;
  GtkWidget *none_member;
  GtkWidget *hseparator1;
  GtkWidget *scrolledwindow10;
  GtkWidget *entry_ctree;
  GtkWidget *label57;
  GtkWidget *label58;
  GtkWidget *scrolledwindow11;
  GtkWidget *select_clist;
  GtkWidget *label84;
  GtkWidget *label85;
  GtkWidget *dialog_action_area1;
  GtkWidget *hbox3;
  GtkWidget *ok_button;
  GtkWidget *cancel_button;
  GtkTooltips *tooltips;

  tooltips = gtk_tooltips_new ();

  selector = gtk_dialog_new ();
  gtk_widget_set_name (selector, "selector");
  gtk_object_set_data (GTK_OBJECT (selector), "selector", selector);
  /*gtk_widget_set_usize (selector, 400, 400);*/
  gtk_window_set_title (GTK_WINDOW (selector), _("Select Recipients"));
  gtk_window_set_modal (GTK_WINDOW (selector), TRUE);
  gtk_window_set_default_size (GTK_WINDOW (selector), 620, 400);
  gtk_window_set_policy (GTK_WINDOW (selector), TRUE, TRUE, TRUE);

  dialog_vbox1 = GTK_DIALOG (selector)->vbox;
  gtk_widget_set_name (dialog_vbox1, "dialog_vbox1");
  gtk_object_set_data (GTK_OBJECT (selector), "dialog_vbox1", dialog_vbox1);
  ws (dialog_vbox1);

  table1 = gtk_table_new (4, 3, FALSE);
  gtk_widget_set_name (table1, "table1");
  gtk_widget_ref (table1);
  gtk_object_set_data_full (GTK_OBJECT (selector), "table1", table1,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (table1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), table1, TRUE, TRUE, 0);

  frame3 = gtk_frame_new (NULL);
  gtk_widget_set_name (frame3, "frame3");
  gtk_widget_ref (frame3);
  gtk_object_set_data_full (GTK_OBJECT (selector), "frame3", frame3,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (frame3);
  gtk_table_attach (GTK_TABLE (table1), frame3, 0, 3, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame3), 2);

  hbox4 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox4, "hbox4");
  gtk_widget_ref (hbox4);
  gtk_object_set_data_full (GTK_OBJECT (selector), "hbox4", hbox4,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (hbox4);
  gtk_container_add (GTK_CONTAINER (frame3), hbox4);
  gtk_container_set_border_width (GTK_CONTAINER (hbox4), 2);

  label12 = gtk_label_new (_(" Address Book "));
  gtk_widget_set_name (label12, "label12");
  gtk_widget_ref (label12);
  gtk_object_set_data_full (GTK_OBJECT (selector), "label12", label12,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (label12);
  gtk_box_pack_start (GTK_BOX (hbox4), label12, FALSE, FALSE, 0);

  abook_optionmenu = gtk_option_menu_new ();
  gtk_widget_set_name (abook_optionmenu, "abook_optionmenu");
  gtk_widget_ref (abook_optionmenu);
  gtk_object_set_data_full (GTK_OBJECT (selector), "abook_optionmenu", abook_optionmenu,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (abook_optionmenu);
  gtk_box_pack_start (GTK_BOX (hbox4), abook_optionmenu, TRUE, TRUE, 0);
  abook_optionmenu_menu = gtk_menu_new ();
  glade_menuitem = gtk_menu_item_new_with_label (_(gabName));
  ws (glade_menuitem);
  gtk_menu_append (GTK_MENU (abook_optionmenu_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label ("Personal Address Book");
  ws (glade_menuitem);
  gtk_menu_append (GTK_MENU (abook_optionmenu_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label ("Book");
  ws (glade_menuitem);
  gtk_menu_append (GTK_MENU (abook_optionmenu_menu), glade_menuitem);
  gtk_option_menu_set_menu (GTK_OPTION_MENU (abook_optionmenu), abook_optionmenu_menu);

  frame4 = gtk_frame_new (NULL);
  gtk_widget_set_name (frame4, "frame4");
  gtk_widget_ref (frame4);
  gtk_object_set_data_full (GTK_OBJECT (selector), "frame4", frame4,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (frame4);
  gtk_table_attach (GTK_TABLE (table1), frame4, 0, 3, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame4), 2);

  hbox5 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox5, "hbox5");
  gtk_widget_ref (hbox5);
  gtk_object_set_data_full (GTK_OBJECT (selector), "hbox5", hbox5,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (hbox5);
  gtk_container_add (GTK_CONTAINER (frame4), hbox5);
  gtk_container_set_border_width (GTK_CONTAINER (hbox5), 2);

  label20 = gtk_label_new (_(" Find: "));
  gtk_widget_set_name (label20, "label20");
  gtk_widget_ref (label20);
  gtk_object_set_data_full (GTK_OBJECT (selector), "label20", label20,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (label20);
  gtk_box_pack_start (GTK_BOX (hbox5), label20, FALSE, FALSE, 0);

  find_entry = gtk_entry_new ();
  gtk_widget_set_name (find_entry, "find_entry");
  gtk_widget_ref (find_entry);
  gtk_object_set_data_full (GTK_OBJECT (selector), "find_entry", find_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (find_entry);
  gtk_box_pack_start (GTK_BOX (hbox5), find_entry, TRUE, TRUE, 0);

  search = gtk_button_new_with_label ("Search");
  gtk_widget_set_name (search, "search");
  gtk_widget_ref (search);
  gtk_object_set_data_full (GTK_OBJECT (selector), "search", search,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_box_pack_start (GTK_BOX (hbox5), search, FALSE, FALSE, 0);
  ws (search);
  
  frame5 = gtk_frame_new (NULL);
  gtk_widget_set_name (frame5, "frame5");
  gtk_widget_ref (frame5);
  gtk_object_set_data_full (GTK_OBJECT (selector), "frame5", frame5,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (frame5);
  gtk_table_attach (GTK_TABLE (table1), frame5, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame5), 2);

  vbox4 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox4, "vbox4");
  gtk_widget_set_usize (vbox4, 10, -1);
  gtk_widget_ref (vbox4);
  gtk_object_set_data_full (GTK_OBJECT (selector), "vbox4", vbox4,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (vbox4);
  gtk_container_add (GTK_CONTAINER (frame5), vbox4);
  gtk_container_set_border_width (GTK_CONTAINER (vbox4), 2);

  hbox16 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox16, "hbox16");
  gtk_widget_ref (hbox16);
  gtk_object_set_data_full (GTK_OBJECT (selector), "hbox16", hbox16,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (hbox16);
  gtk_table_attach (GTK_TABLE (table1), hbox16, 0, 1, 3, 4,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);

  all_entries = gtk_button_new_with_label (_("All"));
  gtk_widget_set_name (all_entries, "all_entries");
  gtk_widget_ref (all_entries);
  gtk_object_set_data_full (GTK_OBJECT (selector), "all_entries", all_entries,
                            (GtkDestroyNotify) gtk_widget_unref);
  /*ws (all_entries); */
  gtk_box_pack_start (GTK_BOX (hbox16), all_entries, TRUE, TRUE, 0);

  none_entries = gtk_button_new_with_label (_("None"));
  gtk_widget_set_name (none_entries, "none_entries");
  gtk_widget_ref (none_entries);
  gtk_object_set_data_full (GTK_OBJECT (selector), "none_entries", none_entries,
                            (GtkDestroyNotify) gtk_widget_unref);
  /*ws (none_entries); */
  gtk_box_pack_start (GTK_BOX (hbox16), none_entries, TRUE, TRUE, 0);

  hbox17 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox17, "hbox17");
  gtk_widget_ref (hbox17);
  gtk_object_set_data_full (GTK_OBJECT (selector), "hbox17", hbox17,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (hbox17);
  gtk_table_attach (GTK_TABLE (table1), hbox17, 2, 3, 3, 4,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);

  all_member = gtk_button_new_with_label (_("All"));
  gtk_widget_set_name (all_member, "all_member");
  gtk_widget_ref (all_member);
  gtk_object_set_data_full (GTK_OBJECT (selector), "all_member", all_member,
                            (GtkDestroyNotify) gtk_widget_unref);
  /* ws (all_member); */
  gtk_box_pack_start (GTK_BOX (hbox17), all_member, TRUE, TRUE, 0);

  none_member = gtk_button_new_with_label (_("None"));
  gtk_widget_set_name (none_member, "none_member");
  gtk_widget_ref (none_member);
  gtk_object_set_data_full (GTK_OBJECT (selector), "none_member", none_member,
                            (GtkDestroyNotify) gtk_widget_unref);
  /*ws (none_member);*/
  gtk_box_pack_start (GTK_BOX (hbox17), none_member, TRUE, TRUE, 0);

  hseparator1 = gtk_hseparator_new ();
  gtk_widget_set_name (hseparator1, "hseparator1");
  gtk_widget_ref (hseparator1);
  gtk_object_set_data_full (GTK_OBJECT (selector), "hseparator1", hseparator1,
                            (GtkDestroyNotify) gtk_widget_unref);
  /*ws (hseparator1);*/
  gtk_table_attach (GTK_TABLE (table1), hseparator1, 1, 2, 3, 4,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);

  scrolledwindow10 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_set_name (scrolledwindow10, "scrolledwindow10");
  gtk_widget_ref (scrolledwindow10);
  gtk_object_set_data_full (GTK_OBJECT (selector), "scrolledwindow10", scrolledwindow10,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (scrolledwindow10);
  gtk_table_attach (GTK_TABLE (table1), scrolledwindow10, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow10), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  entry_ctree = gtk_ctree_new (2, 0);
  gtk_widget_set_name (entry_ctree, "entry_ctree");
  gtk_widget_ref (entry_ctree);
  gtk_object_set_data_full (GTK_OBJECT (selector), "entry_ctree", entry_ctree,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (entry_ctree);
  gtk_container_add (GTK_CONTAINER (scrolledwindow10), entry_ctree);
  gtk_clist_set_column_width (GTK_CLIST (entry_ctree), 0, 113);
  gtk_clist_set_column_width (GTK_CLIST (entry_ctree), 1, 68);
  gtk_clist_column_titles_show (GTK_CLIST (entry_ctree));

  label57 = gtk_label_new (_("Name"));
  gtk_widget_set_name (label57, "label57");
  gtk_widget_ref (label57);
  gtk_object_set_data_full (GTK_OBJECT (selector), "label57", label57,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (label57);
  gtk_clist_set_column_widget (GTK_CLIST (entry_ctree), 0, label57);

  label58 = gtk_label_new (_("Email"));
  gtk_widget_set_name (label58, "label58");
  gtk_widget_ref (label58);
  gtk_object_set_data_full (GTK_OBJECT (selector), "label58", label58,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (label58);
  gtk_clist_set_column_widget (GTK_CLIST (entry_ctree), 1, label58);

  scrolledwindow11 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_set_name (scrolledwindow11, "scrolledwindow11");
  gtk_widget_ref (scrolledwindow11);
  gtk_object_set_data_full (GTK_OBJECT (selector), "scrolledwindow11", scrolledwindow11,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (scrolledwindow11);
  gtk_table_attach (GTK_TABLE (table1), scrolledwindow11, 2, 3, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow11), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  select_clist = gtk_clist_new (2);
  gtk_widget_set_name (select_clist, "select_clist");
  gtk_widget_ref (select_clist);
  gtk_object_set_data_full (GTK_OBJECT (selector), "select_clist", select_clist,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (select_clist);
  gtk_container_add (GTK_CONTAINER (scrolledwindow11), select_clist);
  gtk_clist_set_column_width (GTK_CLIST (select_clist), 0, 185);
  /*gtk_clist_set_column_width (GTK_CLIST (select_clist), 1, 80);*/
  gtk_clist_column_titles_show (GTK_CLIST (select_clist));

  label84 = gtk_label_new (_("Name"));
  gtk_widget_set_name (label84, "label84");
  gtk_widget_ref (label84);
  gtk_object_set_data_full (GTK_OBJECT (selector), "label84", label84,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (label84);
  gtk_clist_set_column_widget (GTK_CLIST (select_clist), 0, label84);

  label85 = gtk_label_new (_("Type"));
  gtk_widget_set_name (label85, "label85");
  gtk_widget_ref (label85);
  gtk_object_set_data_full (GTK_OBJECT (selector), "label85", label85,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (label85);
  gtk_clist_set_column_widget (GTK_CLIST (select_clist), 1, label85);

  dialog_action_area1 = GTK_DIALOG (selector)->action_area;
  gtk_widget_set_name (dialog_action_area1, "dialog_action_area1");
  gtk_object_set_data (GTK_OBJECT (selector), "dialog_action_area1", dialog_action_area1);
  ws (dialog_action_area1);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area1), 10);

  hbox3 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox3, "hbox3");
  gtk_widget_ref (hbox3);
  gtk_object_set_data_full (GTK_OBJECT (selector), "hbox3", hbox3,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (hbox3);
  gtk_box_pack_start (GTK_BOX (dialog_action_area1), hbox3, TRUE, TRUE, 0);

  ok_button = gtk_button_new_with_label (_("Ok"));
  gtk_widget_set_name (ok_button, "ok_button");
  gtk_widget_ref (ok_button);
  gtk_object_set_data_full (GTK_OBJECT (selector), "ok_button", ok_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (ok_button);
  gtk_box_pack_start (GTK_BOX (hbox3), ok_button, TRUE, TRUE, 0);
  GTK_WIDGET_SET_FLAGS (ok_button, GTK_CAN_DEFAULT);

  cancel_button = gtk_button_new_with_label (_("Cancel"));
  gtk_widget_set_name (cancel_button, "cancel_button");
  gtk_widget_ref (cancel_button);
  gtk_object_set_data_full (GTK_OBJECT (selector), "cancel_button", cancel_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (cancel_button);
  gtk_box_pack_start (GTK_BOX (hbox3), cancel_button, TRUE, TRUE, 0);

  gtk_widget_grab_focus (ok_button);
  gtk_widget_grab_default (ok_button);
  gtk_object_set_data (GTK_OBJECT (selector), "tooltips", tooltips);

  return selector;
}

GtkWidget *abook_create_main (GtkSignalFunc kill_func) {
	GtkWidget *widget=create_abook ();
	abook_widget_set (widget);	
	gtk_signal_connect (GTK_OBJECT (widget), "delete_event",
	                    GTK_SIGNAL_FUNC (abook_widget_hide), NULL);
	gtk_signal_connect (GTK_OBJECT (lw (widget, "close1")), "activate",
	                    GTK_SIGNAL_FUNC (abook_widget_hide), NULL);
        gtk_signal_connect (GTK_OBJECT (lw (widget, "done_button")), "clicked",
                            GTK_SIGNAL_FUNC (abook_widget_hide), NULL);
	gtk_signal_connect (GTK_OBJECT (lw (widget, "entry_ctree")), "tree_select_row",
	                    GTK_SIGNAL_FUNC (abook_widget_select_row), NULL);
	gtk_signal_connect (GTK_OBJECT (lw (widget, "entry_ctree")), "tree_unselect_row",
	                    GTK_SIGNAL_FUNC (abook_widget_unselect_row), NULL);
	gtk_signal_connect (GTK_OBJECT (lw (widget, "add_entry")), "clicked",
	                    GTK_SIGNAL_FUNC (abook_widget_add_entry), NULL);
	gtk_signal_connect (GTK_OBJECT (lw (widget, "addressbook_entry")), "activate",
	                    GTK_SIGNAL_FUNC (abook_widget_add_entry), NULL);
	gtk_signal_connect (GTK_OBJECT (lw (widget, "add_group")), "clicked",
	                    GTK_SIGNAL_FUNC (abook_widget_add_group), NULL);
	gtk_signal_connect (GTK_OBJECT (lw (widget, "group")), "activate",
	                    GTK_SIGNAL_FUNC (abook_widget_add_group), NULL);
	gtk_signal_connect (GTK_OBJECT (lw (widget, "edit_entry")), "clicked",
	                    GTK_SIGNAL_FUNC (abook_widget_edit_entry), NULL);
	gtk_signal_connect (GTK_OBJECT (lw (widget, "edit_entry1")), "activate",
	                    GTK_SIGNAL_FUNC (abook_widget_edit_entry), NULL);
	gtk_signal_connect (GTK_OBJECT (lw (widget, "delete_entry")), "clicked",
	                    GTK_SIGNAL_FUNC (abook_widget_delete_entry), NULL);
	gtk_signal_connect (GTK_OBJECT (lw (widget, "addressbook_entry2")), "activate",
	                    GTK_SIGNAL_FUNC (abook_widget_delete_entry), NULL);
	gtk_signal_connect (GTK_OBJECT (lw (widget, "add_button")), "clicked",
	                    GTK_SIGNAL_FUNC (abook_widget_new_abook), NULL);
	gtk_signal_connect (GTK_OBJECT (lw (widget, "addressbook2")), "activate",
	                    GTK_SIGNAL_FUNC (abook_widget_new_abook), NULL);
	gtk_signal_connect (GTK_OBJECT (lw (widget, "remove_book")), "clicked",
	                    GTK_SIGNAL_FUNC (abook_widget_delete_abook), NULL);
	gtk_signal_connect (GTK_OBJECT (lw (widget, "find_entry")), "changed",
	                    GTK_SIGNAL_FUNC (abook_widget_find_entry_changed), NULL);
	gtk_signal_connect (GTK_OBJECT (lw (widget, "find_entry")), "activate",
		GTK_SIGNAL_FUNC (abook_widget_selector_search_custom), NULL);
	gtk_signal_connect (GTK_OBJECT (lw (widget, "search")), "clicked",
	                    GTK_SIGNAL_FUNC (abook_widget_selector_search_custom), NULL);
	gtk_signal_connect (GTK_OBJECT (lw (widget,"about_bynari_tradeclient1")), "activate",
					    GTK_SIGNAL_FUNC (activate_aboutbox), NULL);  
	gtk_widget_set_sensitive (lw (widget, "delete_entry"), FALSE);
	gtk_widget_set_sensitive (lw (widget, "edit_entry"), FALSE);
	
	clip_handle_editable (lw (widget, "find_entry"));

	if (kill_func) {
		gtk_signal_connect (GTK_OBJECT (lw (widget, "exit")), "activate",
		                    kill_func, NULL);
	}
	ws (widget);
	return widget;
}

GtkWidget *abook_entry_create (Abook_entry *ok_data, Abook_entry *cancel_data) {
	GtkWidget *widget=create_abook_entry ();
	GtkCList *clist=GTK_CLIST (lw (widget, "addr_clist"));
	GList *seek;
	Abook *abook=abook_entry_find_book (ok_data);
	Abook_group *group;
	char *cl_data[2];
	int row;
	gtk_signal_connect (GTK_OBJECT (widget), "delete_event", 
	                    GTK_SIGNAL_FUNC (abook_widget_entry_destroy), cancel_data);
	gtk_signal_connect (GTK_OBJECT (lw (widget, "ok_button")), "clicked",
	                    GTK_SIGNAL_FUNC (abook_widget_entry_accept), ok_data);
	gtk_signal_connect (GTK_OBJECT (lw (widget, "cancel_button")), "clicked",
	                    GTK_SIGNAL_FUNC (abook_widget_entry_cancel), cancel_data);
	gtk_signal_connect (GTK_OBJECT (lw (widget, "addr_clist")), "select_row",
	                    GTK_SIGNAL_FUNC (abook_widget_entry_email_selectrow), NULL);
	gtk_signal_connect (GTK_OBJECT (lw (widget, "addr_clist")), "unselect_row",
	                    GTK_SIGNAL_FUNC (abook_widget_entry_email_unselectrow), NULL);
	gtk_signal_connect (GTK_OBJECT (lw (widget, "email_address_entry")), "activate", 
	                    GTK_SIGNAL_FUNC (abook_widget_entry_email_activate), ok_data);
	gtk_signal_connect (GTK_OBJECT (lw (widget, "add_addr")), "clicked", 
	                    GTK_SIGNAL_FUNC (abook_widget_entry_add_email), ok_data);
	gtk_signal_connect (GTK_OBJECT (lw (widget, "goto_webpage")), "clicked",
			GTK_SIGNAL_FUNC (goto_webpage_callback),
			lw (widget, "web_page"));
	gtk_signal_connect (GTK_OBJECT (lw (widget, "default_addr")), "clicked",
	                    GTK_SIGNAL_FUNC (abook_widget_entry_set_default_email), ok_data);
	gtk_signal_connect (GTK_OBJECT (lw (widget, "delete_addr")), "clicked",
	                    GTK_SIGNAL_FUNC (abook_widget_entry_remove_email), ok_data);
	gtk_signal_connect (GTK_OBJECT (lw (widget, "groups_avail")), "select_row",
	                    GTK_SIGNAL_FUNC (abook_widget_entry_newgroup_sel), NULL);
	gtk_signal_connect (GTK_OBJECT (lw (widget, "groups_avail")), "unselect_row",
	                    GTK_SIGNAL_FUNC (abook_widget_entry_newgroup_unsel), NULL);
	gtk_signal_connect (GTK_OBJECT (lw (widget, "groups_member")), "select_row",
	                    GTK_SIGNAL_FUNC (abook_widget_entry_memgroup_sel), NULL);
	gtk_signal_connect (GTK_OBJECT (lw (widget, "groups_member")), "unselect_row",
	                    GTK_SIGNAL_FUNC (abook_widget_entry_memgroup_unsel), NULL);
	gtk_signal_connect (GTK_OBJECT (lw (widget, "add_grp")), "clicked",
	                    GTK_SIGNAL_FUNC (abook_widget_entry_addgroup), ok_data);
	gtk_signal_connect (GTK_OBJECT (lw (widget, "remove_grp")), "clicked",
	                    GTK_SIGNAL_FUNC (abook_widget_entry_delgroup), ok_data);
	if (ok_data) {
		if (ok_data->first)
			gtk_entry_set_text (GTK_ENTRY (lw (widget, "first_name")), ok_data->first);
		if (ok_data->middle)
			gtk_entry_set_text (GTK_ENTRY (lw (widget, "middle_name")), ok_data->middle);
		if (ok_data->last)
			gtk_entry_set_text (GTK_ENTRY (lw (widget, "last_name")), ok_data->last);
		if (ok_data->position)
			gtk_entry_set_text (GTK_ENTRY (lw (widget, "title")), ok_data->position);
		if (ok_data->nickname)
			gtk_entry_set_text (GTK_ENTRY (lw (widget, "nickname")), ok_data->nickname);
		if (ok_data->sex)
			gtk_entry_set_text (GTK_ENTRY (lw (widget, "sex")), ok_data->sex);
		if (ok_data->hphone)
			gtk_entry_set_text (GTK_ENTRY (lw (widget, "home_phone")), ok_data->hphone);
		if (ok_data->cphone1)
			gtk_entry_set_text (GTK_ENTRY (lw (widget, "work_phone")), ok_data->cphone1);
		if (ok_data->mphone)
			gtk_entry_set_text (GTK_ENTRY (lw (widget, "mobile_phone")), ok_data->mphone);
		if (ok_data->pager)
			gtk_entry_set_text (GTK_ENTRY (lw (widget, "pager")), ok_data->pager);
		if (ok_data->fax)
			gtk_entry_set_text (GTK_ENTRY (lw (widget, "fax")), ok_data->fax);
		if (ok_data->webpage)
			gtk_entry_set_text (GTK_ENTRY (lw (widget, "web_page")), ok_data->webpage);
		if (ok_data->street)
			gtk_text_insert (GTK_TEXT (lw (widget, "street_address")), NULL, NULL, NULL, ok_data->street, -1);
		if (ok_data->notes)
			gtk_text_insert (GTK_TEXT (lw (widget, "notes")), NULL, NULL, NULL, ok_data->notes, -1);

		if (ok_data->company)
			gtk_entry_set_text (GTK_ENTRY (lw (widget, "company")), ok_data->company);
		if (ok_data->position)
			gtk_entry_set_text (GTK_ENTRY (lw (widget, "position")), ok_data->position);
		if (ok_data->cstreet)
			gtk_entry_set_text (GTK_ENTRY (lw (widget, "caddress")), ok_data->cstreet);
		if (ok_data->ccity)
			gtk_entry_set_text (GTK_ENTRY (lw (widget, "ccity")), ok_data->ccity);
		if (ok_data->cstate)
			gtk_entry_set_text (GTK_ENTRY (lw (widget, "cstate")), ok_data->cstate);
		if (ok_data->czip)
			gtk_entry_set_text (GTK_ENTRY (lw (widget, "czip")), ok_data->czip);
		if (ok_data->ccountry)
			gtk_entry_set_text (GTK_ENTRY (lw (widget, "ccountry")), ok_data->ccountry);
		if (ok_data->cphone1)
			gtk_entry_set_text (GTK_ENTRY (lw (widget, "cphone1")), ok_data->cphone1);
		if (ok_data->cphone2)
			gtk_entry_set_text (GTK_ENTRY (lw (widget, "cphone2")), ok_data->cphone2);
		if (ok_data->cfax)
			gtk_entry_set_text (GTK_ENTRY (lw (widget, "cfax")), ok_data->cfax);
		if (ok_data->pager)
			gtk_entry_set_text (GTK_ENTRY (lw (widget, "cpager")), ok_data->pager);
		if (ok_data->webpage)
			gtk_entry_set_text (GTK_ENTRY (lw (widget, "cwebpage")), ok_data->webpage);
		if (ok_data->cmanager)
			gtk_entry_set_text (GTK_ENTRY (lw (widget, "cmanager")), ok_data->cmanager);
		if (ok_data->cassistant)
			gtk_entry_set_text (GTK_ENTRY (lw (widget, "cassistant")), ok_data->cassistant);
			
		for (seek=ok_data->email;seek;seek=seek->next) {	
			cl_data[0]=seek->data;
			cl_data[1]=NULL;
			if (strcasecmp (ok_data->def_email, (char *)seek->data)==0)
				cl_data[1]=strdup ("DEFAULT");
			row=gtk_clist_append (clist, cl_data);
			gtk_clist_set_row_data (clist, row, seek->data);
			if (cl_data[1]) free (cl_data[1]);
		}
		clist=GTK_CLIST (lw (widget, "groups_member"));
		for (seek=ok_data->groups;seek;seek=seek->next) {
			group=seek->data;
			cl_data[0]=group->name;
			row=gtk_clist_append (clist, cl_data);
			gtk_clist_set_row_data (clist, row, group);
		}
	}
	clist=GTK_CLIST (lw (widget, "groups_avail"));
	for (seek=abook->groups;seek;seek=seek->next) {
		group=seek->data;
		cl_data[0]=group->name;
		row=gtk_clist_append (clist, cl_data);
		gtk_clist_set_row_data (clist, row, group);
	}
	ws (widget);
	clip_handle_editable (lw (widget, "first_name"));
	clip_handle_editable (lw (widget, "last_name"));
	clip_handle_editable (lw (widget, "middle_name"));
	clip_handle_editable (lw (widget, "title"));
	clip_handle_editable (lw (widget, "nickname"));
	clip_handle_editable (lw (widget, "sex"));
	clip_handle_editable (lw (widget, "home_phone"));
	clip_handle_editable (lw (widget, "work_phone"));
	clip_handle_editable (lw (widget, "fax"));
	clip_handle_editable (lw (widget, "mobile_phone"));
	clip_handle_editable (lw (widget, "pager"));
	clip_handle_editable (lw (widget, "position"));
	clip_handle_editable (lw (widget, "company"));
	clip_handle_editable (lw (widget, "caddress"));
	clip_handle_editable (lw (widget, "ccity"));
	clip_handle_editable (lw (widget, "cstate"));
	clip_handle_editable (lw (widget, "czip"));
	clip_handle_editable (lw (widget, "cphone1"));
	clip_handle_editable (lw (widget, "cphone2"));
	clip_handle_editable (lw (widget, "cfax"));
	clip_handle_editable (lw (widget, "cpager"));
	clip_handle_editable (lw (widget, "ccountry"));
	clip_handle_editable (lw (widget, "cmanager"));
	clip_handle_editable (lw (widget, "cassistant"));
	clip_handle_editable (lw (widget, "cwebpage"));
	clip_handle_editable (lw (widget, "web_page"));
	clip_handle_editable (lw (widget, "email_address_entry"));
//	clip_handle_editable (lw (widget, "abook_entry"));
	return widget;
}

GtkWidget *abook_create_group_editor (Abook_group *group, Abook *abook) {
	Abook_entry *entry;
	GtkWidget *widget;
	char *cl_data[2];
	GtkCList *clist, *mems;
	GList *seek;
	int row;
	
	g_return_val_if_fail (abook != NULL, NULL);
	widget=create_group_editor ();
	
	if (group->name)
		gtk_entry_set_text (GTK_ENTRY (lw (widget, "group_name")), group->name);
	
	clist=GTK_CLIST (lw (widget, "entries"));
	mems=GTK_CLIST (lw (widget, "members"));
	cl_data[0]=(char *)calloc (1024, sizeof (char));
	
	for (seek=abook->entrys;seek;seek=seek->next) {
		entry=seek->data;
#if 0
		format_name (cl_data[0], entry->first, entry->last);
#else
		format_name (1024, cl_data[0], entry->first, entry->last, entry->def_email ) ;
#endif
		cl_data[1]=entry->def_email;
		row=gtk_clist_append (clist, cl_data);
		gtk_clist_set_row_data (clist, row, (gpointer)entry);
		if (g_list_find (entry->groups, group)) {
			row=gtk_clist_append (mems, cl_data);
			gtk_clist_set_row_data (mems, row, (gpointer)entry);
		}
	}
	free (cl_data[0]);
	
	gtk_signal_connect (GTK_OBJECT (lw (widget, "ok_button")), "clicked",
	                    GTK_SIGNAL_FUNC (abook_widget_group_accept), (gpointer)group);	
	gtk_signal_connect (GTK_OBJECT (lw (widget, "cancel_button")), "clicked",
	                    GTK_SIGNAL_FUNC (abook_widget_group_cancel), (gpointer)group);	
	gtk_signal_connect (GTK_OBJECT (lw (widget, "entries")), "select_row",
	                    GTK_SIGNAL_FUNC (abook_widget_group_selentry), NULL);
	gtk_signal_connect (GTK_OBJECT (lw (widget, "entries")), "unselect_row",
	                    GTK_SIGNAL_FUNC (abook_widget_group_unselentry), NULL);
	gtk_signal_connect (GTK_OBJECT (lw (widget, "members")), "select_row",
	                    GTK_SIGNAL_FUNC (abook_widget_group_selmember), NULL);
	gtk_signal_connect (GTK_OBJECT (lw (widget, "members")), "unselect_row",
	                    GTK_SIGNAL_FUNC (abook_widget_group_unselmember), NULL);
	gtk_signal_connect (GTK_OBJECT (lw (widget, "add_entry")), "clicked",
	                    GTK_SIGNAL_FUNC (abook_widget_group_addmember), (gpointer)group);
	gtk_signal_connect (GTK_OBJECT (lw (widget, "remove_entry")), "clicked",
	                    GTK_SIGNAL_FUNC (abook_widget_group_delmember), (gpointer)group);
	clip_handle_editable (lw (widget, "group_name"));
	ws (widget);
	return widget;
}

GtkWidget *abook_create_new_abook () {
	GtkWidget *widget=create_new_abook ();
	gtk_signal_connect (GTK_OBJECT (widget), "delete_event",
	                    GTK_SIGNAL_FUNC (abook_widget_new_cancel), NULL);
	gtk_signal_connect (GTK_OBJECT (lw (widget, "abook_entry")), "activate",
	                    GTK_SIGNAL_FUNC (abook_widget_new_accept), NULL);
	gtk_signal_connect (GTK_OBJECT (lw (widget, "ok_button")), "clicked",
	                    GTK_SIGNAL_FUNC (abook_widget_new_accept), NULL);
	gtk_signal_connect (GTK_OBJECT (lw (widget, "cancel_button")), "clicked",
	                    GTK_SIGNAL_FUNC (abook_widget_new_cancel), NULL);
	ws (widget);
	return widget;
}

GtkWidget *abook_selector_create (GList *types, 
                                  GList *current, GtkSignalFunc accept_func, 
                                  gpointer user_data) {
	GtkWidget *widget=create_selector ();
	GtkWidget *adder;
	GList *seek, *list=NULL;
	int count=0;
	UserData *data;
	char *cl_data[2];
	GtkVBox *vbox=GTK_VBOX (lw (widget, "vbox4"));
	if (!abook_first ())
		return NULL;
	abook_widget_rehash_optionmenu (GTK_OPTION_MENU (lw (widget, "abook_optionmenu")), 
	                                GTK_SIGNAL_FUNC (abook_widget_selector_changebook));
	
	for (seek=types;seek;seek=seek->next) {
	  adder = gtk_button_new_with_label (_(seek->data));
	  gtk_widget_set_name (adder, "adder");
	  gtk_widget_ref (adder);
	  gtk_object_set_data_full (GTK_OBJECT (widget), "adder", adder,
	                            (GtkDestroyNotify) gtk_widget_unref);
	  ws (adder);
	  gtk_box_pack_start (GTK_BOX (vbox), adder, TRUE, FALSE, 0);
		gtk_signal_connect (GTK_OBJECT (adder), "clicked",
		                    GTK_SIGNAL_FUNC (abook_widget_selector_add), (gpointer)count);
		count++;
	}
	adder = gtk_button_new_with_label (_("Remove:"));
  gtk_widget_set_name (adder, "adder");
  gtk_widget_ref (adder);
  gtk_object_set_data_full (GTK_OBJECT (widget), "adder", adder,
                            (GtkDestroyNotify) gtk_widget_unref);
  ws (adder);
  gtk_box_pack_start (GTK_BOX (vbox), adder, TRUE, FALSE, 0);
	gtk_signal_connect (GTK_OBJECT (adder), "clicked",
	                    GTK_SIGNAL_FUNC (abook_widget_selector_del), NULL);

	gtk_signal_connect (GTK_OBJECT (lw (widget, "entry_ctree")), "tree_select_row",
	                    GTK_SIGNAL_FUNC (abook_widget_selector_lsel), NULL);
	gtk_signal_connect (GTK_OBJECT (lw (widget, "entry_ctree")), "tree_unselect_row",
	                    GTK_SIGNAL_FUNC (abook_widget_selector_lunsel), NULL);
	gtk_signal_connect (GTK_OBJECT (lw (widget, "select_clist")), "select_row",
	                    GTK_SIGNAL_FUNC (abook_widget_selector_rsel), NULL);
	gtk_signal_connect (GTK_OBJECT (lw (widget, "select_clist")), "unselect_row",
	                    GTK_SIGNAL_FUNC (abook_widget_selector_runsel), NULL);
	gtk_signal_connect (GTK_OBJECT (lw (widget, "find_entry")), "changed",
	                    GTK_SIGNAL_FUNC (abook_widget_selector_search_changed), NULL);
gtk_signal_connect (GTK_OBJECT (lw (widget, "find_entry")), "activate",
                GTK_SIGNAL_FUNC (abook_widget_selector_search_custom), NULL);
        gtk_signal_connect (GTK_OBJECT (lw (widget, "search")), "clicked",
                GTK_SIGNAL_FUNC (abook_widget_selector_search_custom), NULL);
        gtk_signal_connect (GTK_OBJECT (lw (widget, "entry_ctree")), "click_column",
                        GTK_SIGNAL_FUNC (entry_ctree_clicked_column), NULL);
        gtk_signal_connect (GTK_OBJECT (lw (widget, "select_clist")), "click_column",
                        GTK_SIGNAL_FUNC (entry_ctree_clicked_column), NULL);
	data=(UserData *)calloc (1, sizeof (UserData));
	data->func=accept_func;
	data->data=user_data;
	gtk_signal_connect (GTK_OBJECT (lw (widget, "ok_button")), "clicked",
	                    GTK_SIGNAL_FUNC (abook_widget_selector_accept), data);
	gtk_signal_connect (GTK_OBJECT (lw (widget, "cancel_button")), "clicked",
	                    GTK_SIGNAL_FUNC (abook_widget_selector_cancel), data);
											
	abook_widget_set_types (types);

	abook_widget_rehash_abook_clist (abook_first()->data, GTK_CTREE (lw (widget, "entry_ctree")));

	cl_data[0]=(char *)calloc (1024, sizeof (char));
	for (seek=current;seek;seek=seek->next) {
		Recipient *recp=seek->data;
		Abook_entry *entry=abook_entry_seek_by_email (NULL, recp->email);
		Abook_rd *rd;
		int row;
		if (!entry) {
			entry=abook_create_dummy (recp->email);
			entry->type=recp->type;
		}
		rd=(Abook_rd *)calloc (1, sizeof (Abook_rd));
		rd->entry=entry;
		list=g_list_append (list, rd);
#if 0
		format_name (cl_data[0], entry->first, entry->last);
#else
		format_name (1024, cl_data[0], entry->first, entry->last, recp->email ) ;
#endif
		cl_data[1]=g_list_nth_data (types, recp->type);
		row=gtk_clist_append (GTK_CLIST (lw (widget, "select_clist")), cl_data);
		gtk_clist_set_row_data (GTK_CLIST (lw (widget, "select_clist")), row, rd);
	}
	free (cl_data[0]);
	abook_widget_set_list (list);
	clip_handle_editable (lw (widget, "find_entry"));
	ws (widget);
	return widget;
}

