/* TradeClient <http://tradeclient.sourceforge.net>
 * $Id: calender-callbacks.c,v 1.39 2001/03/20 22:19:33 ttabner Exp $
 *
 * Copyright (C) 1999-2000 Bynari Inc.
 * Copyright (C) 2001 Project TradeClient
 *
 * LGPL
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#include "puma.h"
#include "tcal.h"

GtkWidget *calendar_window=NULL;
CalendarEvent *cur_event=NULL;
guint curyear=-1, curmonth=-1, curday=-1;
CalendarView current_view=CALENDAR_VIEW_DAILY;



void event_store_updated () {
        GtkTCal *tcal;


	tcal=GTK_TCAL (lw (calendar_window, "monthly"));
	gtk_tcal_event_store_updated (tcal);
	tcal=GTK_TCAL (lw (calendar_window, "yearly"));
	gtk_tcal_event_store_updated (tcal);
}

void calendar_set_widget (GtkWidget *widget) {
	if (calendar_window && GTK_IS_WIDGET (calendar_window)) {
		return;
	}
	calendar_window=widget;
}

GtkWidget *calendar_get_widget () {
	return calendar_window;
}


void calendar_destroy () {
}

int calendar_hide (GtkWidget *widget, GdkEvent *event, gpointer data) {
/*	if (!GTK_IS_WIDGET (calendar_window)) {
		main_calendar_create (); 
	}*/
	gtk_widget_hide (calendar_window);
	return FALSE;
}

gint calendar_week_custom_sorter (GtkCList *clist, GtkCListRow *row1,
				                                  GtkCListRow *row2) {
		    CalendarEvent *event1=(CalendarEvent *)row1->data;
			    CalendarEvent *event2=(CalendarEvent *)row2->data;
				/*  printf ("event1->time: %lu event2->time: %lu\n",
				 *              event1->start->time, event2->start->time);*/
				/*  printf ("Row1: [%p] data: [%p]\n", row1, row1->data);
				 *      printf ("Row2: [%p] data: [%p]\n", row2, row2->data);*/
				    if (event1->start->time > event2->start->time)
							        return 1;
					    if (event1->start->time < event2->start->time)
								        return -1;
						    return 0;
}



void calendar_load_print (GtkWidget *widge, GtkCalendar *cal, EventTime *time)  /* function to load information to print the view */
{
  FILE *fd;                             /* file pointer */
  char *tmpfilename;                    /* temp file name */
  char tmpname[4096];					  /* size of tmp file */
  GList *seek; 						  /* creates a GList variable seek */
  Llist *cseek=event_first ();          /* create cseek and place its value at first event on list */
  Schedule *schedule=SCHEDULE (lookup_widget (calendar_window, "schedule"));
  char *tmp;                            /* create char temp */
  CalendarEvent *event;                 /* create a CalendarEvent named event */
  time_t upper;
  char am_or_pm;                        /* create a char to hold am or pm for start time */
  char am_or_pm2;                       /* create a char to hold am or pm for stop time */
  int year=0, month=0, date=0;          /* create int for year, month, date */
  int printday;                         /* create int to hold the day selected to print */
  int printmonth;                       /* create int to hold the month selected to print */
  int printyear;                        /* create int to hold the year selected to print */
        
  int day;                              /* create int to hold day of week */
  EventTime etime; 
  static char *clist_names[7]={"sunday_clist", "monday_clist", "tuesday_clist",
			       "wednesday_clist", "thursday_clist", "friday_clist","saturday_clist"};
  GtkCList *clist;
  char *temp=event_date_to_char (&etime);
  time_t t=event_time_to_time_t (&etime);
  struct tm *t2=localtime (&t);
  t-=(t2->tm_wday+1) * 24 * 60 * 60;
  event_time_dump (&etime);
  temp=event_date_to_char (&etime);
																														
		  
		
  tmpfilename = tmpnam(NULL);           /* creates a temp file named tmpfilename */	
  insert_message ("Loading information to Print....");  /* inserts a message to the user */
  fd=fopen(tmpfilename, "w+");          /* opens the file for writing */
  if (fd == (FILE *)NULL)               /* if the file is equal to NULL */
    {
      insert_message ("Sorry.. not Loading!\n");  /* insert message to user */
      return;										/* return */
    }
  switch (current_view)					/* switch depending on the view */
    {
    case CALENDAR_VIEW_TODO:
      fprintf (fd, "\n\nTODO List for %s\n", getenv("USER"));  /* write to file */
      fprintf (fd, "--------------------\n\n");
      for (seek=todo_first ();seek;seek=seek->next)      /* seek the GList*/
	{
	  Todo *todo=seek->data;                     /* seek the information */ 
	  fprintf (fd, "Item: %s\n", todo->text);    /* write item to file */
	  fprintf (fd, "Due: %s\n\n", todo->due);    /* write due to file */
	}
      break;                     /* break */
						
    case CALENDAR_VIEW_DAILY:
      year=GTK_CALENDAR (lw (calendar_window, "daily_calendar"))->year;
      month=GTK_CALENDAR (lw (calendar_window, "daily_calendar"))->month;
      date=GTK_CALENDAR (lw (calendar_window, "daily_calendar"))->selected_day;	
      printday = date;                              /* int to hold date selected */
      printmonth=month;                             /* int to hold month selected */
      printyear=year;                               /* int to hold year selected */
						
      if (cal->month != curmonth ||
	  cal->year != curyear ||
	  cal->selected_day != curday)
	{
	  etime.minute=0;
	  etime.hour=0;
	  upper=event_time_to_time_t (&etime);
	  schedule_destroy_children (schedule);
	  schedule_set_upper (schedule, upper);
	  curmonth=etime.month=cal->month;
	  curyear=etime.year=cal->year;
	  curday=etime.date=cal->selected_day;
						
	  fprintf (fd, "\n\nDaily Calendar for %s\n", getenv("USER"));    /* write to file */
	  fprintf (fd, "-----------------------------------\n\n");		
	  event_get_today(&curyear, &curmonth, &curday);
	  while (cseek != NULL)                     /* go threw entire list until EOF */
	    {
	      event=(CalendarEvent *)cseek->data;       
	      tmp=rm_crlf (event->subject);	
	      if (event->start->date == printday)      /* if event date equal to date selected */
		{
		  if (event->start->month == printmonth)  /* if event month equal to month selected */
		    {
		      if (event->start->year == printyear) /* if event year equal to year selected */
			{
			  schedule_add_child (SCHEDULE (lookup_widget (calendar_window, "schedule")),
					      tmp, event->start->time, event->stop->time, event);
			  free (tmp); 				  
			  fprintf (fd, "Date:  %d/%d/%d\n", event->start->month+1, event->start->date, event->start->year); /* write to file*/
			  if (event->start->hour <= 11)       /* if start hour less than or equal to 11 */
			    am_or_pm = 'a';            /* place a in am or pm */
			  else 
			    {
			      event->start->hour -= 12;           /* if start hour greater than or equal to 12 */
			      am_or_pm = 'p';             /* place p in am or pm */
			    }
			  if (event->stop->hour <= 11)        /* if stop hour less than or equal to 11 */
			    am_or_pm2 = 'a';            /* place a in am or pm */
			  else
			    {
			      event->stop->hour -= 12;     /* if stop hour greater than or equal to 12 */
			      am_or_pm2 = 'p';             /* place p in am or pm */
			    }
			  if (event->start->hour == 0)        /* if start hour equal to zero */
			    event->start->hour = 12;   /* start hour is 12 */
			  if (event->stop->hour == 0)         /* if stop hour equal to zero */
			    event->stop->hour = 12;    /* stop hour is 12 */
			  fprintf (fd, "Time:     Start:  %d:%.2d%c     End:  %d:%.2d%c\n", event->start->hour, event->start->minute, am_or_pm, event->stop->hour, event->stop->minute, am_or_pm2);     /* write to file  */
			  fprintf (fd, "Location:  %s\n", event->location);  /* write to file */
			  fprintf (fd, "Subject:  %s\n", event->subject);     /* write to file  */
			  fprintf (fd, "Information:  %s\n\n\n", event->information);  /* write to file */
			}
		    }
		}
	      cseek=cseek->next;     /* look for next in the list */
	    }			    
	}
      break;				    /* break */
					
    case CALENDAR_VIEW_WORK:
      year=GTK_CALENDAR (lw (calendar_window, "calendar2"))->year;
      month=GTK_CALENDAR (lw (calendar_window, "calendar2"))->month;
      date=GTK_CALENDAR (lw (calendar_window, "calendar2"))->selected_day;                
      printday = date;
      printmonth = month;
      printyear = year;						
   						
      fprintf (fd, "\n\nWork Week Calendar for %s\n", getenv("USER"));     /* write to file */
      fprintf (fd, "-------------------------------------\n\n");

      for (day=1;day<6;day++)
	{
	  clist=GTK_CLIST (lw (calendar_window, clist_names[day]));
	  gtk_clist_set_compare_func (clist, (GtkCListCompareFunc)calendar_week_custom_sorter);
	  gtk_clist_freeze (clist);
	  for (cseek=event_first();cseek;cseek=cseek->next)
	    {
	      event=cseek->data;
	      if (event->start->date==printday)
		{
		  if (event->start->month==printmonth)
		    {
		      if (event->start->year==printyear)
			{
			  fprintf (fd, "Date:  %d/%d/%d\n", event->start->month+1, event->start->date, event->start->year);
			  if (event->start->hour <= 11)
			    am_or_pm = 'a';
			  else
			    {
			      event->start->hour -= 12;
			      am_or_pm = 'p';
			    }
			  if (event->stop->hour <= 11)
			    am_or_pm2 = 'a';
			  else
			    {
			      event->stop->hour -= 12;
			      am_or_pm2 = 'p';
			    }
			  if (event->start->hour == 0)
			    event->start->hour = 12;
			  if (event->stop->hour == 0)
			    event->stop->hour = 12;
			  fprintf (fd, "Time:     Start:  %d:%.2d%c     End:  %d:%.2d%c\n", event->start->hour, event->start->minute, am_or_pm, event->stop->hour, event->stop->minute, am_or_pm2);
			  fprintf (fd, "Location:  %s\n", event->location);
			  fprintf (fd, "Subject:  %s\n", event->subject);
			  fprintf (fd, "Information:  %s\n\n\n", event->information);
			}
		    }
		}
	    }
	  gtk_clist_sort (clist);
	  gtk_clist_thaw (clist);
	  printday++;
	}
      break;
																								                                                          					 
    case CALENDAR_VIEW_WEEK:
      year=GTK_CALENDAR (lw (calendar_window, "weekly_calendar"))->year;
      month=GTK_CALENDAR (lw (calendar_window, "weekly_calendar"))->month;
      date=GTK_CALENDAR (lw (calendar_window, "weekly_calendar"))->selected_day;
      printday = date;	
      printmonth = month;
      printyear = year;
						 
      fprintf (fd, "\n\nWeekly Calendar for %s\n", getenv("USER"));     /* write to file */
      fprintf (fd, "-------------------------------------\n\n");

								 
						 
      for (day=0;day<7;day++)
	{
	  clist=GTK_CLIST (lw (calendar_window, clist_names[day]));
	  gtk_clist_set_compare_func (clist, (GtkCListCompareFunc)calendar_week_custom_sorter);
	  gtk_clist_freeze (clist);
																																					   
	  for (cseek=event_first();cseek;cseek=cseek->next)
	    {
	      event=cseek->data;
	      if (event->start->date==printday) 
		{
		  if (event->start->month==printmonth)
		    {
		      if (event->start->year==printyear)
			{ 
			  fprintf (fd, "Date:  %d/%d/%d\n", event->start->month+1, event->start->date, event->start->year);
			  if (event->start->hour <= 11)
			    am_or_pm = 'a';
			  else
			    {
			      event->start->hour -= 12;
			      am_or_pm = 'p';
			    }
			  if (event->stop->hour <= 11)
			    am_or_pm2 = 'a';
			  else
			    {
			      event->stop->hour -= 12;
			      am_or_pm2 = 'p';
			    }
			  if (event->start->hour == 0)
			    event->start->hour = 12;
			  if (event->stop->hour == 0)
			    event->stop->hour = 12;
			  fprintf (fd, "Time:     Start:  %d:%.2d%c     End:  %d:%.2d%c\n", event->start->hour, event->start->minute, am_or_pm, event->stop->hour, event->stop->minute, am_or_pm2);
			  fprintf (fd, "Location:  %s\n", event->location);
			  fprintf (fd, "Subject:  %s\n", event->subject);
			  fprintf (fd, "Information:  %s\n\n\n", event->information);
			} 
		    } 
		}
	    }
	  gtk_clist_sort (clist);
	  gtk_clist_thaw (clist); 
	  printday++; 
	}
      break;
						 
    case CALENDAR_VIEW_MONTH:
      year=GTK_CALENDAR (lw (calendar_window, "calendar2"))->year;
      month=GTK_CALENDAR (lw (calendar_window, "calendar2"))->month;
      date=GTK_CALENDAR (lw (calendar_window, "calendar2"))->selected_day;
      printmonth=month;                            /* int to hold month selected */
      printyear=year;                              /* int to hold year selected */
						 
      if (cal->month != curmonth ||
	  cal->year != curyear ||
	  cal->selected_day != curday)
	{
	  etime.minute=0;
	  etime.hour=0;
	  upper=event_time_to_time_t (&etime);
	  schedule_destroy_children (schedule);
	  schedule_set_upper (schedule, upper);
	  curmonth=etime.month=cal->month;
	  curyear=etime.year=cal->year;
	  curday=etime.date=cal->selected_day;	
						 
	  fprintf (fd, "\n\nMonthly Calendar for %s\n", getenv("USER"));     /* write to file */
	  fprintf (fd, "--------------------\n\n"); 
	  event_get_today(&curyear, &curmonth, &curday);                         
	  while (cseek != NULL)                         /* go threw entire list until EOF */
	    {                         
	      event=(CalendarEvent *)cseek->data;                         
	      tmp=rm_crlf (event->subject);                         
	      schedule_add_child (SCHEDULE (lookup_widget (calendar_window, "schedule")),                         tmp, event->start->time, event->stop->time, event);                         
	      free (tmp);                                   
	      if (event->start->month == printmonth)          /* if event month equal to selected month*/
		{
		  if (event->start->year == printyear)        /* if event year equal to selected year */
		    {			
		      fprintf (fd, "Date:  %d/%d/%d\n", event->start->month+1, event->start->date, event->start->year);                                     
		      if (event->start->hour <= 11)          /* if start hour less than or equal to 11 */
			am_or_pm = 'a';               /* place a in am or pm */                      
		      else                         
			{                         
			  event->start->hour -= 12;      /* if start hour greater than or equal to 12 */ 
			  am_or_pm = 'p';               /* place p in am or pm */
			}                                
		      if (event->stop->hour <= 11)           /* if stop hour less than or equal to 11 */            
			am_or_pm2 = 'a';              /* place a in am or pm */
		      else
			{
			  event->stop->hour -= 12;       /* if stop hour greater than or equal to 12 */
			  am_or_pm2 = 'p';              /* place p in am or pm */
			}
		      if (event->start->hour == 0)           /* if start hour equal zero */
			event->start->hour = 12;           /* hour equals 12 */
		      if (event->stop->hour == 0)            /* if stop hour equal to zero */
			event->stop->hour = 12;            /* hour equals 12 */
		      fprintf (fd, "Time:     Start:  %d:%.2d%c     End:  %d:%.2d%c\n", event->start->hour, event->start->minute, am_or_pm, event->stop->hour, event->stop->minute, am_or_pm2);                                /* write to file */
		      fprintf (fd, "Location:  %s\n", event->location);           /* write to file */
		      fprintf (fd, "Subject:  %s\n", event->subject);               /* write to file */
		      fprintf (fd, "Information:  %s\n\n\n", event->information);   /* write to file */
		    }
		}
	      cseek=cseek->next;                        /* go to the next on the list */
	    }
	}
      break;                      /* break */
						 
    case CALENDAR_VIEW_YEAR:
      year=GTK_CALENDAR (lw (calendar_window, "calendar2"))->year;
      month=GTK_CALENDAR (lw (calendar_window, "calendar2"))->month;
      date=GTK_CALENDAR (lw (calendar_window, "calendar2"))->selected_day;	
      printyear=year;                 /* int year to hold selected year */
 
      if (cal->month != curmonth ||
	  cal->year != curyear ||
	  cal->selected_day != curday)
	{
	  etime.minute=0;
	  etime.hour=0;
	  upper=event_time_to_time_t (&etime);
	  schedule_destroy_children (schedule);
	  schedule_set_upper (schedule, upper);
	  curmonth=etime.month=cal->month;
	  curyear=etime.year=cal->year;
	  curday=etime.date=cal->selected_day;   						 
						 
	  fprintf (fd, "\n\nYearly Calendar for %s\n", getenv("USER"));      /* write to file */
	  fprintf (fd, "--------------------\n\n");
	  event_get_today(&curyear, &curmonth, &curday);
	  while (cseek != NULL)               /* go threw entire list until EOF */
	    {
	      event=(CalendarEvent *)cseek->data;
	      tmp=rm_crlf (event->subject);
	      schedule_add_child (SCHEDULE (lookup_widget (calendar_window, "schedule")),
				  tmp, event->start->time, event->stop->time, event);
	      free (tmp);
	      if (event->start->year == printyear)     /* if event year equal to selected year */
		{
		  fprintf (fd, "Date:  %d/%d/%d\n", event->start->month+1, event->start->date, event->start->year);
		  if (event->start->hour <= 11)           /* if start hour less than or equal to 11 */
		    am_or_pm = 'a';             /* place a in am or pm */
		  else
		    {
		      event->start->hour -= 12;           /* if start hour greater than or equal to 12 */
		      am_or_pm = 'p';             /* place p in am or pm */
		    }
		  if (event->stop->hour <= 11)            /* if stop hour less than or equal to 11 */
		    am_or_pm2 = 'a';            /* place a in am or pm */
		  else
		    {
		      event->stop->hour -= 12;            /* if stop hour greater than or equal to 12 */
		      am_or_pm2 = 'p';            /* place p in am or pm */ 
		    }
		  if (event->start->hour == 0)            /* if start hour equal to zero */
		    event->start->hour = 12;            /* hour equals 12 */
		  if (event->stop->hour == 0)             /* if stop hour equal to zero */
		    event->stop->hour = 12;             /* hour equals 12 */
		  fprintf (fd, "Time:     Start:  %d:%.2d%c     End:  %d:%.2d%c\n", event->start->hour, event->start->minute, am_or_pm, event->stop->hour, event->stop->minute, am_or_pm2);                            /* write to file */
		  fprintf (fd, "Location:  %s\n", event->location);       /* write to file */
		  fprintf (fd, "Subject:  %s\n", event->subject);           /* write to file */
		  fprintf (fd, "Information:  %s\n\n\n", event->information); /* write to file */
		}
	      cseek=cseek->next;               /* get next on list */
	    }
	}                         
      break;               /* break */
    }						 
  fclose (fd);				 /* close file */

  sprintf (tmpname, "%s %s", tm_globs->printer, tmpfilename);  /* send file to print */
  system (tmpname);
  unlink(tmpfilename);                       /* free file */
  insert_message ("Done !\n");               /* insert message to user */
}

void calendar_show () {
	if (!GTK_IS_WIDGET (calendar_window)) {
		guint year, month, date;		

		event_get_today (&year, &month, &date);
		main_calendar_create ();
		gtk_widget_show (calendar_window);
		calendar_rehash ();
	}
	event_get_today (&curyear, &curmonth, &curday);
	gtk_widget_show (calendar_window);
}

void calendar_new_event (GtkWidget *widget, gpointer data) {
	GtkWidget *window=NULL;
	int type=(int)data;
	int year=0, month=0, date=0;
	switch (current_view) {
		case CALENDAR_VIEW_TODO:
			break;
		case CALENDAR_VIEW_DAILY:
			year=GTK_CALENDAR (lw (calendar_window, "daily_calendar"))->year;
			month=GTK_CALENDAR (lw (calendar_window, "daily_calendar"))->month;
			date=GTK_CALENDAR (lw (calendar_window, "daily_calendar"))->selected_day;			
			break;
		case CALENDAR_VIEW_WORK:
			year=GTK_CALENDAR (lw (calendar_window, "calendar2"))->year;
			month=GTK_CALENDAR (lw (calendar_window, "calendar2"))->month;
			date=GTK_CALENDAR (lw (calendar_window, "calendar2"))->selected_day;			
			break;
		case CALENDAR_VIEW_WEEK:
			year=GTK_CALENDAR (lw (calendar_window, "weekly_calendar"))->year;
			month=GTK_CALENDAR (lw (calendar_window, "weekly_calendar"))->month;
			date=GTK_CALENDAR (lw (calendar_window, "weekly_calendar"))->selected_day;			
			break;
		case CALENDAR_VIEW_MONTH:
	        year=GTK_CALENDAR (lw (calendar_window, "calendar2"))->year;                
			month=GTK_CALENDAR (lw (calendar_window, "calendar2"))->month;            
			date=GTK_CALENDAR (lw (calendar_window, "calendar2"))->selected_day;        
			break;
		case CALENDAR_VIEW_YEAR:
	        year=GTK_CALENDAR (lw (calendar_window, "calendar2"))->year;            
			month=GTK_CALENDAR (lw (calendar_window, "calendar2"))->month;            
			date=GTK_CALENDAR (lw (calendar_window, "calendar2"))->selected_day;      
			break;
	}
			
	switch (type) {
		case 1:
			window=calendar_event_new_window (_("Meeting Request"), year, month, date);
			break;
		case 2:
			window=calendar_event_new_window (_("Appointment"), year, month, date);
			break;
		default:
	}
	gtk_widget_show (window);
}

void calendar_daycal_day_selected (GtkCalendar *cal) {
	if (cal->month != curmonth || 
	    cal->year != curyear ||
			cal->selected_day != curday) {
		Schedule *schedule=SCHEDULE (lookup_widget (calendar_window, "schedule"));
		Llist *seek=event_first ();
		EventTime time;
		time_t upper;
		char *tmp;
		CalendarEvent *event;
		calendar_dump ();
		curmonth=time.month=cal->month;
		curyear=time.year=cal->year;
		curday=time.date=cal->selected_day;
		time.minute=0;
		time.hour=0;
		upper=event_time_to_time_t (&time);
		schedule_destroy_children (schedule);
		schedule_set_upper (schedule, upper);
		while (seek) {
			event=seek->data;
			if (event->start->month == cal->month &&
			    event->start->year == cal->year &&
					event->start->date == cal->selected_day) {
				tmp=rm_crlf (event->subject);
				schedule_add_child (SCHEDULE (lookup_widget (calendar_window, "schedule")), 
				                    tmp, event->start->time, event->stop->time, event);
				free (tmp);
			}
			seek=seek->next;
		}
	}
}

void calendar_daycal_month_changed (GtkCalendar *cal) {
	Llist *seek=event_first ();
	CalendarEvent *event;
	guint year, month, day;
	guint tyear, tmonth, tday;
	gtk_calendar_freeze (cal);
	gtk_calendar_clear_marks (cal);
	gtk_calendar_get_date (cal, &year, &month, &day);
	event_get_today (&tyear, &tmonth, &tday);
	if (year==tyear && month==tmonth) {
		gtk_calendar_mark_day (cal, tday);
	}
/*	while (seek) {*/
	for (seek=event_first ();seek;seek=seek->next) {
		event=(CalendarEvent *)seek->data;
		if (event->start) {
			if (event->start->month==month && event->start->year==year) {
				gtk_calendar_mark_day (cal, event->start->date);
			}
		}
/*		seek=seek->next;*/
	}
	gtk_calendar_thaw (cal);
}


void calendar_event_destroy (GtkWidget *widget, gpointer data) {
	gtk_widget_destroy (lookup_widget (widget, "event_editor"));
	calendar_event_loop();
}


void calendar_event_accept (GtkWidget *widget, gpointer data) {
  GtkTree *tree=GTK_TREE (lookup_widget (widget, "attendee_tree"));
  CalendarEvent *event=(CalendarEvent *)data;
  CalendarEvent *tmpevent;
  GtkWidget *scratch;
  Llist *list=NULL;
  GList *seek;
  int edit_flag=0;
  time_t start, end;
  EventAttendee *attend;
  GtkBoxChild *child;


  EventTime *starttime=gtk_to_event_time (GTK_ENTRY (lookup_widget (widget, "startyear")),
					  GTK_ENTRY (lookup_widget (widget, "startmonth")),
					  GTK_ENTRY (lookup_widget (widget, "startdate")),
					  GTK_ENTRY (lookup_widget (widget, "starttime")));
	
  EventTime *endtime=gtk_to_event_time (GTK_ENTRY (lookup_widget (widget, "endyear")),
					GTK_ENTRY (lookup_widget (widget, "endmonth")),
					GTK_ENTRY (lookup_widget (widget, "enddate")),
					GTK_ENTRY (lookup_widget (widget, "endtime")));


  char *subject=gtk_entry_get_text (GTK_ENTRY (lookup_widget (widget, "subject")));
  char *info=gtk_editable_get_chars (GTK_EDITABLE (lookup_widget (widget, "information")), 
				     0, gtk_text_get_length (GTK_TEXT (lookup_widget (widget, "information"))));
  char *location=gtk_entry_get_text (GTK_ENTRY (lookup_widget (widget, "location")));
  char *categories=gtk_entry_get_text (GTK_ENTRY (lookup_widget (widget, "entry9")));
  char *tmp2, *tmp;
  int i;
  tmp2=rm_crlf (info);
  g_free (info);
  info=tmp2;
  if (!starttime) {
    insert_warning (_("The event starting time is invalid\n"));
    event_time_destroy (endtime);
    return;
  }
  if (!endtime) {
    insert_warning (_("The event ending time is invalid\n"));
    event_time_destroy (starttime);
    return;
  }
  start=event_time_to_time_t (starttime);
  end=event_time_to_time_t (endtime);
  starttime->time=start;
  endtime->time=end;
  if (start==-1 || end==-1) {
    insert_warning (_("TradeClient is not Y2038 Compliant due to OS restrictions\n"));
    event_time_destroy (starttime);
    event_time_destroy (endtime);
    return;
  }
  if (end<=start) {
    insert_warning (_("You can't have an event which ends before it begins!\n"));
    event_time_destroy (starttime);
    event_time_destroy (endtime);
    return;
  }
  if ((tmpevent=event_find_conflict (start, end))!=NULL) {
    if (tmpevent!=data) {
      insert_warning (_("This event conflicts with event '%s' located at '%s' from %s to %s\n"), 
		      tmpevent->subject, tmpevent->location, ctime (&tmpevent->start->time), ctime (&tmpevent->stop->time));
    }
  }
  if (strlen (subject)==0) {
    insert_warning (_("The subject line is blank\n"));
    event_time_destroy (starttime);
    event_time_destroy (endtime);
    return;
  }

  if (strlen (location)==0) {
    insert_warning (_("The location line is blank\n"));
    event_time_destroy (starttime);
    event_time_destroy (endtime);
    return;
  }	

  if (strlen (info)==0) {
    insert_warning( _("Please let everyone know what the meeting is about\n") ) ;
    event_time_destroy (starttime);
    event_time_destroy (endtime);
    return;
  }

  if (!tree->children) {
    /* this message is redundant and should not be here */
#if 0
    insert_message( _("This must be a personal event\n") );
#endif
  } else {
    for (seek=tree->children;seek;seek=seek->next) {
      scratch=(GtkWidget *)seek->data;
      attend=(EventAttendee *)calloc (1, sizeof (EventAttendee));
      scratch=GTK_BIN (scratch)->child;
      child=GTK_BOX (scratch)->children->next->data;
      attend->name=strdup (gtk_entry_get_text (GTK_ENTRY (child->widget)));
      if (strlen (attend->name)>0) {
	child=GTK_BOX (scratch)->children->next->next->data;

#if DEBUG > 3
	printf( "Looking for '%s' in address book.\n", attend->name ) ;
#endif

	attend->entry=abook_entry_seek_by_name (NULL, attend->name);
#if 0 /*
       * So what if the entry isn't there, we've got an email, we're going
       * to go ahead and add then!
       */
	if (!attend->entry) {
#if DEBUG > 3
	  printf( _("Unable to find '%s' in any of the address books.  Name is being dropped.\n" ), attend->name ) ;
#endif
	  insert_warning( _("Unable to find '%s' in any of the address books.\n"), attend->name ) ;
#if 0
	  return;
#else
	  if( attend -> name ) free( attend -> name ) ;
	  free( attend ) ;
#endif
	} else {
#endif
	  tmp=gtk_entry_get_text (GTK_ENTRY (GTK_COMBO (child->widget)->entry));
	  if (strcasecmp (tmp, _("Required"))==0)
	    attend->priority=PRIORITY_MANDATORY;
	  if (strcasecmp (tmp, _("Optional"))==0)
	    attend->priority=PRIORITY_OPTIONAL;
	  if (strcasecmp (tmp, _("Resource"))==0) 
	    attend->priority=PRIORITY_RESOURCE;
	  if (strcasecmp (tmp, _("Organizer"))==0)
	    attend->priority = PRIORITY_ORGANIZER;
	  if (list)
	    llist_append (list, attend);
	  else
	    list=llist_append (NULL, attend);
#if 0
	  /*(comment out because the if else is commented out) */
	}
#endif
      } else {
	free (attend);
      }
    }
  }
  if (!event) {
    event=event_new ();
    event->created=(EventTime *)calloc (1, sizeof (EventTime));
    event->created->time=time (NULL);
    //		event->uid=unique_name (time (NULL), 25);
    event->uid=(char *)calloc (1, sizeof (char));
    event->sequence=-1;
    if (starttime->year == curyear && 
	starttime->month == curmonth && 
	starttime->date == curday) {
      tmp2=rm_crlf (subject);
      schedule_add_child (SCHEDULE (lookup_widget (calendar_window, "schedule")), 
			  tmp2, start, end, event);
      free (tmp2);
    }
    edit_flag=FALSE;
  } else {
    edit_flag=TRUE;
    event_store_delete (event);
  }
  if (event->start) free (event->start);
  event->start=starttime;
  if (event->stop) free (event->stop);
  event->stop=endtime;
  event->subject=strdup (subject);
  event->location=strdup (location);
  event->information=info;
  event->attendees=list;
  if (!event->created)
    event->created=time_t_to_event_time (time (NULL));
  event->reminder=-1;
  if (GTK_TOGGLE_BUTTON (lookup_widget (widget, "remind_me"))->active) {
    event->reminder=atoi (gtk_entry_get_text (GTK_ENTRY (lookup_widget (widget, "remind_duration"))));
  } else {
    event->reminder=0;
  }
  if (GTK_TOGGLE_BUTTON(lookup_widget (widget,"spawn_button"))->active){
    event->program=strdup(gtk_entry_get_text (GTK_ENTRY (lookup_widget (widget, "spawn_entry"))));
  } else {
    event->program=strdup("");
  }
  if (GTK_TOGGLE_BUTTON (lookup_widget (widget, "send_invitations"))->active) {
    event->flags |=EVENT_INVITE_RECIP;
  }
  if (GTK_TOGGLE_BUTTON (lookup_widget (widget, "recur_event"))->active) {
    event->flags |=EVENT_RECUR;
  }
  if (GTK_TOGGLE_BUTTON (lookup_widget (widget, "all_day_event"))->active) {
    event->flags |=EVENT_ALL_DAY;
  }
  event->sequence++;
  list=NULL;
  if (strlen (categories) > 0) {
    if ((count_delimiters (categories, ';')+1)>1) {
      tmp=cut_string (categories, ';', 1, 1);
      list=llist_append (list, tmp);
      for (i=1;i < (count_delimiters (categories, ';') + 1);i++) {
	tmp2=cut_string (categories, ';', 2, i);
	if (i < count_delimiters (categories, ';')) {
	  tmp=cut_string (tmp2, ';', 1, 1);
	} else {
	  tmp=strdup (tmp2);
	}
	if (*tmp==' ') {
	  memmove (tmp, tmp+1, strlen (tmp)-1);
	  *(tmp+strlen (tmp)-1)='\0';
	}
	list=llist_append (list, tmp);
	free (tmp2);
      }
    } else list=llist_append (list, strdup (categories));
  }
  tmp=gt (widget, "mark_me_as");
  if (!strcasecmp (tmp, "Free")) 
    event->status=STATUS_FREE;
  if (!strcasecmp (tmp, "Tentative"))
    event->status=STATUS_TENTATIVE;
  if (!strcasecmp (tmp, "Busy"))
    event->status=STATUS_BUSY;
  if (!strcasecmp (tmp, "Out of Office"))
    event->status=STATUS_OUT_OF_OFFICE;
  event->categories=list;
  if (edit_flag==TRUE) 
    calendar_rehash ();
  event_display (event);
  event_store_add (event);
  calendar_event_destroy (widget, data);
  calendar_save ();
  calendar_update_all_uis ();
  calendar_event_loop();
}

void calendar_event_categories (GtkWidget *widget, gpointer data) {
	GtkWidget *window=event_master_category_create (lookup_widget (widget, "event_editor"), 
	           gtk_entry_get_text (GTK_ENTRY (lookup_widget (widget, "entry9"))));
	gtk_widget_show (window);
}

void calendar_event_categories2 (GtkWidget *widget, gpointer data) {
        GtkWidget *window=event_master_category_create (lookup_widget (widget, "new_message_window"),
                   gtk_entry_get_text (GTK_ENTRY (lookup_widget (widget, "entry9"))));
        gtk_widget_show (window);
}

void calendar_renotify (GtkWidget *widget, CalendarEvent *event) {
	gtk_widget_destroy (lw (widget, "yesno"));
}

void calendar_child_changed (Schedule *schedule, char *text, CalendarEvent *event) {
	if (!event) 
		return;
	if (event->information && text) {
		time_t start, end;
		schedule_child_get_time (schedule, event, &start, &end);
		/* Notification doesn't need to exist in base TradeClient code */
		free (event->start);
		event->start=time_t_to_event_time (start);
		event_time_dump (event->start);
		free (event->stop);
		event->stop=time_t_to_event_time (end);
		event_time_dump (event->stop);
		event->subject=text;
		event_store_delete (event);
		event_store_add (event);
	}
	calendar_display_event (event);
	calendar_update_all_uis ();
}

void calendar_clear_event () {
	if (calendar_window) {
	GtkCList *clist=GTK_CLIST (lookup_widget (calendar_window, "attendee_clist"));
	gtk_clist_freeze (clist);gtk_clist_clear (clist);gtk_clist_thaw (clist);
	gtk_entry_set_text (GTK_ENTRY (lookup_widget (calendar_window, "location")), "");
	gtk_entry_set_text (GTK_ENTRY (lookup_widget (calendar_window, "location")), "");
	gtk_entry_set_text (GTK_ENTRY (lookup_widget (calendar_window, "subject_entry")), "");
	gtk_text_set_point (GTK_TEXT (lookup_widget (calendar_window, "information_text")), 0);
	gtk_text_forward_delete (GTK_TEXT (lookup_widget (calendar_window, "information_text")), 
	    gtk_text_get_length (GTK_TEXT (lookup_widget (calendar_window, "information_text"))));
	}
}

void calendar_display_event (CalendarEvent *event) {
	GtkCList *clist=GTK_CLIST (lookup_widget (calendar_window, "attendee_clist"));
	GtkCList *cats=GTK_CLIST (lookup_widget (calendar_window, "category_clist"));
	EventAttendee *attend;
	char *cl_data[2], *tmp1, *tmp2;
	Llist *seek;
	if (event->location)
		gtk_entry_set_text (GTK_ENTRY (lookup_widget (calendar_window, "location")),
	                      event->location);
	if (event->subject) 
		gtk_entry_set_text (GTK_ENTRY (lookup_widget (calendar_window, "subject_entry")),
	                      event->subject);
	gtk_text_set_point (GTK_TEXT (lookup_widget (calendar_window, "information_text")), 0);
	gtk_text_forward_delete (GTK_TEXT (lookup_widget (calendar_window, "information_text")), 
	    gtk_text_get_length (GTK_TEXT (lookup_widget (calendar_window, "information_text"))));
	if (event->information) 
		gtk_text_insert (GTK_TEXT (lookup_widget (calendar_window, "information_text")),
	                   NULL, NULL, NULL, event->information, -1);
	gtk_clist_freeze (clist);
	gtk_clist_clear (clist);
	tmp1=strdup (ctime (&event->start->time));
	tmp1[24]='\0';
	gtk_label_set_text (GTK_LABEL (lookup_widget (calendar_window, "start_time")), tmp1);
	tmp2=strdup (ctime (&event->stop->time));
	tmp2[24]='\0';
	gtk_label_set_text (GTK_LABEL (lookup_widget (calendar_window, "end_time")), tmp2);
	free (tmp1);free (tmp2);
	seek=event->attendees;
	while (seek) {
		attend=seek->data;
		if (attend) {
			cl_data[0]=attend->name;
			switch (attend->priority) {
				case PRIORITY_NONE:
				case PRIORITY_MANDATORY:
					cl_data[1]=strdup (_("Required"));
					break;
				case PRIORITY_OPTIONAL:
					cl_data[1]=strdup (_("Optional"));
					break;
				case PRIORITY_RESOURCE:
					cl_data[1]=strdup (_("Resource"));
					break;
			  case PRIORITY_ORGANIZER:
			    cl_data[1]=strdup (_("Organizer"));
			    break;
			}
			gtk_clist_append (clist, cl_data);
			free (cl_data[1]);
		}
		seek=seek->next;
	}
	gtk_clist_thaw (clist);
	gtk_clist_freeze (cats);
	gtk_clist_clear (cats);
	for (seek=event->categories;seek;seek=seek->next) {
		cl_data[0]=seek->data;
		gtk_clist_append (cats, cl_data);
	}
	gtk_clist_thaw (cats);
}

void calendar_child_selected (Schedule *schedule, char *text, gpointer data, time_t start, time_t end) {
	CalendarEvent *event=(CalendarEvent *)data;
	if (!data) 
		return;
	cur_event=event;
	calendar_display_event (event);
}

void calendar_add_recipient (GtkWidget *widget, gpointer data) {
	calendar_event_create_tree_item (GTK_TREE (lookup_widget (widget, "attendee_tree")), NULL, PRIORITY_NONE);
}

void calendar_attendee_selected (GtkTree *tree, GtkWidget *child) {
	GtkWidget *widget=GTK_BIN (child)->child;
	GtkBoxChild *bchild;
	GList *seek;
	gtk_tree_unselect_child (tree, child);
	if (GTK_IS_HBOX (widget)) {
		seek= GTK_BOX (widget)->children->next;
		bchild=seek->data;
		if (GTK_IS_ENTRY (bchild->widget)) {
			gtk_widget_grab_focus (bchild->widget);
		}
	}
}

void calendar_event_edit (GtkWidget *w, gpointer data) {
	GtkWidget *widget;
	EventAttendee *attend;
	Llist *seek;
	char *tmp;
	if (!cur_event) 
		return;	
	widget=create_event_editor ();
	if (cur_event->flags & EVENT_APPOINTMENT) {
		gtk_window_set_title (GTK_WINDOW (widget), _("Appointment") );
	} else {
		gtk_window_set_title (GTK_WINDOW (widget), _("Meeting Request") );
	}
	for (seek=cur_event->attendees;seek;seek=seek->next) {
		attend=seek->data;
		calendar_event_create_tree_item (GTK_TREE (lookup_widget (widget, "attendee_tree")),
  	                                 attend->name, attend->priority);
	}
	gtk_entry_set_text (GTK_ENTRY (lookup_widget (widget, "location")), 
	                    cur_event->location);
	gtk_entry_set_text (GTK_ENTRY (lookup_widget (widget, "subject")), 
	                    cur_event->subject);

	gtk_entry_set_text (GTK_ENTRY (lookup_widget (widget, "startyear")), 
	                    event_int_to_year(cur_event->start->year));
	gtk_entry_set_text (GTK_ENTRY (lookup_widget (widget, "endyear")), 
	                    event_int_to_year(cur_event->stop->year));
	
	tmp=event_int_to_month(cur_event->start->month);
	gtk_entry_set_text (GTK_ENTRY (lookup_widget (widget, "startmonth")), tmp);
	free (tmp);
	tmp=event_int_to_month(cur_event->stop->month);
	gtk_entry_set_text (GTK_ENTRY (lookup_widget (widget, "endmonth")), tmp);
	free (tmp);
	gtk_entry_set_text (GTK_ENTRY (lookup_widget (widget, "startdate")), 
	                    event_int_to_day(cur_event->start->date));
	gtk_entry_set_text (GTK_ENTRY (lookup_widget (widget, "enddate")), 
	                    event_int_to_day(cur_event->stop->date));
		
	gtk_entry_set_text (GTK_ENTRY (lookup_widget (widget, "starttime")), 
	                    event_time_to_char(cur_event->start->hour, cur_event->start->minute));
	gtk_entry_set_text (GTK_ENTRY (lookup_widget (widget, "endtime")), 
	                    event_time_to_char(cur_event->stop->hour, cur_event->stop->minute));
	tmp=event_categories_to_char (cur_event->categories);
	gtk_entry_set_text (GTK_ENTRY (lookup_widget (widget, "entry9")), tmp);
	free (tmp);

	gtk_text_insert (GTK_TEXT (lookup_widget (widget, "information")), NULL, NULL, NULL, cur_event->information, -1);
	
	clip_handle_editable (lw (widget, "subject"));
	clip_handle_editable (lw (widget, "startyear"));
	clip_handle_editable (lw (widget, "endyear"));
	clip_handle_editable (lw (widget, "entry9"));
	clip_handle_editable (lw (widget, "information"));
	clip_handle_editable (lw (widget, "location"));
	gtk_signal_connect (GTK_OBJECT (widget), "delete_event",
	                    GTK_SIGNAL_FUNC (calendar_event_destroy), NULL);
	gtk_signal_connect (GTK_OBJECT (lookup_widget (widget, "add_attendee_row")), "clicked",
	                    GTK_SIGNAL_FUNC (calendar_add_recipient), NULL);
	gtk_signal_connect (GTK_OBJECT (lookup_widget (widget, "cancel_button")), "clicked",
	                    GTK_SIGNAL_FUNC (calendar_event_destroy), NULL);
	gtk_signal_connect (GTK_OBJECT (lookup_widget (widget, "ok_button")), "clicked",
	                    GTK_SIGNAL_FUNC (calendar_event_accept), cur_event);
	gtk_signal_connect (GTK_OBJECT (lookup_widget (widget, "attendee_tree")), "select_child",
	                    GTK_SIGNAL_FUNC (calendar_attendee_selected), NULL);		
	gtk_signal_connect (GTK_OBJECT (lookup_widget (widget, "select_categories")), "clicked",
	                    GTK_SIGNAL_FUNC (calendar_event_categories), NULL);
	gtk_signal_connect (GTK_OBJECT (lookup_widget (widget, "subject")), "focus-out-event",
	                    GTK_SIGNAL_FUNC (new_event_subject_changed), NULL);

	if ((cur_event->reminder)>0) {
	tmp=(char *)calloc (80, sizeof(char));
	snprintf(tmp, sizeof(tmp), "%d", cur_event->reminder);
	gtk_entry_set_text(GTK_ENTRY(lookup_widget(widget,"remind_duration")),tmp);
	free (tmp);
	} else {
		gtk_entry_set_text(GTK_ENTRY(lookup_widget(widget,"remind_duration")),"");
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON (lookup_widget (widget, "remind_me")),FALSE);
	}

	if (strlen(cur_event->program)>0){
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON (lookup_widget(widget, "spawn_button")),TRUE);
		gtk_entry_set_text(GTK_ENTRY(lookup_widget(widget,"spawn_entry")),cur_event->program);
	}

	if (cur_event->status){
		switch (cur_event->status)
		{
			case STATUS_BUSY:
				gtk_entry_set_text (GTK_ENTRY(lookup_widget(widget,"mark_me_as")), _("Busy"));
				break;
			case STATUS_FREE:
				gtk_entry_set_text (GTK_ENTRY(lookup_widget(widget,"mark_me_as")), _("Free"));
				break;
			case STATUS_TENTATIVE:
				gtk_entry_set_text (GTK_ENTRY(lookup_widget(widget,"mark_me_as")), _("Tentative"));
				break;
			case STATUS_OUT_OF_OFFICE:
				gtk_entry_set_text (GTK_ENTRY(lookup_widget(widget,"mark_me_as")), _("Out of Office"));
				break;
		}
	}

	if (cur_event->flags & EVENT_INVITE_RECIP)
	{
		tba (widget, "send_invitations");
	} else {
		tbn (widget, "send_invitations");
	}

	if (cur_event->flags & EVENT_RECUR)
        {
                tba (widget, "recur_event");
        } else {
                tbn (widget, "recur_event");
        }

	if (cur_event->flags & EVENT_ALL_DAY)
	{
		tba (widget, "all_day_event");
	} else {
		tbn (widget, "all_day_event");
	}


	/* Now, force the title bar update!! */
	new_event_subject_changed( lookup_widget( widget, "subject" ), NULL ) ;

	/* Now, show the populated widget along with the updated title bar! */
	gtk_widget_show (widget);
}

void canceled_event (GtkWidget *widget, CalendarEvent *event) {
	gtk_widget_destroy (lookup_widget (widget, "yesno"));

	event_store_delete (event);
	event_destroy (event);
	if (calendar_window) {
		calendar_update_all_uis ();		
		calendar_rehash ();
		calendar_clear_event ();        
	}
	calendar_save ();
	calendar_event_loop ();
}

void calendar_event_delete_accept (GtkWidget *widget, CalendarEvent *event) {
	event_store_delete (event);
	event_destroy (event);
	calendar_update_all_uis ();		

	calendar_rehash ();
	cur_event=NULL;
	calendar_save ();
	calendar_clear_event ();	
	gtk_widget_destroy (lw (widget, "yesno"));
	calendar_event_loop();
}



void 
calendar_event_delete (GtkWidget *widget, gpointer data) {
	if (cur_event) {	
		event_store_delete (cur_event);
		event_destroy (cur_event);
		calendar_update_all_uis ();		

		calendar_rehash ();
		cur_event=NULL;
	}
	calendar_save ();
	calendar_clear_event ();

  return ;
}

void calendar_category_accept (GtkWidget *widget, gpointer data) {
	GtkWidget *parent=(GtkWidget *)data;
	GtkTree *tree=GTK_TREE (lookup_widget (widget, "master_category_tree"));
	GtkWidget *scratch;
	GtkBoxChild *child;
	GList *seek, *cats=NULL;
	char *tmpc;
	int len;
	for (seek=tree->children;seek;seek=seek->next) {
		scratch=(GtkWidget *)seek->data;
		if (!scratch) break;
		scratch=GTK_BIN (scratch)->child;
		if (!scratch) break;
		child=GTK_BOX (scratch)->children->data;
		if (!child) break;
		if (GTK_TOGGLE_BUTTON (GTK_WIDGET (child->widget))->active) {
			child=GTK_BOX (scratch)->children->next->data;
			tmpc=(char *)calloc (1024, sizeof (char));
			gtk_label_get (GTK_LABEL (child->widget), &tmpc);
			cats=g_list_append (cats, tmpc);
		}
	}
	len=0;
	for (seek=cats;seek;seek=seek->next) {
		len+=strlen ((char *)seek->data)+2;
	}
	len+=5;
	tmpc=(char *)calloc (len, sizeof (char));
	
	for (seek=cats;seek;seek=seek->next) {
		if (seek->prev)
			sprintf (tmpc, "%s; %s", tmpc, (char *)seek->data);
		else
			sprintf (tmpc, "%s", (char *)seek->data);
	}
	if (cats) g_list_free (cats);	
	if (tmpc) gtk_entry_set_text (GTK_ENTRY (lookup_widget (parent, "entry9")), tmpc);
	if (tmpc) free (tmpc);
	gtk_widget_destroy (lookup_widget (widget, "master_category"));
}
 
void calendar_category_cancel (GtkWidget *widget, gpointer data) {
	gtk_widget_destroy (lookup_widget (widget, "master_category"));
}

static char *clist_names[8]={"sunday_clist", "monday_clist", "tuesday_clist", 
                             "wednesday_clist", "thursday_clist", "friday_clist", 
			     "saturday_clist", NULL };

														
void calendar_weekly_populate (EventTime *time) {
	GtkCList *clist;
	int day;
	char *tmp=event_date_to_char (time);
	time_t t=event_time_to_time_t (time);
	struct tm *t2=localtime (&t);
	t-=(t2->tm_wday+1) * 24 * 60 * 60;
	time=time_t_to_event_time (t);
	event_time_dump (time);
	tmp=event_date_to_char (time);
	g_return_if_fail (time!=NULL);

	gtk_label_set_text (GTK_LABEL (lw (calendar_window, "label118")), tmp);

	for (day=0;day<7;day++) {
		CalendarEvent *event;
		char *cl_data[1];
		Llist *seek;
		int row;
		clist=GTK_CLIST (lw (calendar_window, clist_names[day]));
		gtk_clist_set_compare_func (clist, (GtkCListCompareFunc)calendar_week_custom_sorter);
		gtk_clist_freeze (clist);
		gtk_clist_clear (clist);
		time->date++;

		for (seek=event_first();seek;seek=seek->next) {	
			event=seek->data;
			if (event->start->month==time->month &&
			    event->start->year==time->year &&
					event->start->date==time->date) {
				cl_data[0]=event->subject;
				row=gtk_clist_append (clist, cl_data);
				gtk_clist_set_row_data (clist, row, (gpointer)event);
			}
		}
		gtk_clist_sort (clist);
		gtk_clist_thaw (clist);
	}
}

static char *clist2_names[7]={NULL, "monday_clist1", "tuesday_clist1", 
                             "wednesday_clist1", "thursday_clist1", "friday_clist1", NULL };

void calendar_workweekly_populate (EventTime *time) {
	GtkCList *clist;
	int day;
	time_t t=event_time_to_time_t (time);
	struct tm *t2=localtime (&t);
	event_time_dump (time);
	t-=(t2->tm_wday-1) * 24 * 60 * 60;	
	time=time_t_to_event_time (t);
	event_time_dump (time);
	for (day=1;day<6;day++) {
		CalendarEvent *event;
		char *cl_data[1];
		Llist *seek;
		int row;
		clist=GTK_CLIST (lw (calendar_window, clist2_names[day]));
		gtk_clist_set_compare_func (clist, (GtkCListCompareFunc)calendar_week_custom_sorter);
		gtk_clist_freeze (clist);
		gtk_clist_clear (clist);
		
		for (seek=event_first();seek;seek=seek->next) {	
			event=seek->data;
			if (event->start->month==time->month &&
			    event->start->year==time->year &&
					event->start->date==time->date) {
				cl_data[0]=event->subject;
				row=gtk_clist_append (clist, cl_data);
				gtk_clist_set_row_data (clist, row, (gpointer)event);
			}
		}
		gtk_clist_sort (clist);
		gtk_clist_thaw (clist);
		time->date++;
	}
}

void calendar_weekcal_day_selected (GtkCalendar *cal) {
	EventTime time;
	memset (&time, 0, sizeof (EventTime));
	time.year=cal->year;
	time.month=cal->month;
	time.date=cal->selected_day;
	calendar_weekly_populate (&time);
}

void calendar_workweekcal_day_selected (GtkCalendar *cal) {
	EventTime time;
	memset (&time, 0, sizeof (EventTime));
	time.year=cal->year;
	time.month=cal->month;
	time.date=cal->selected_day;
	calendar_workweekly_populate (&time);
}

void calendar_weekly_event_selected (GtkCList *clist, gint row, gint column, GdkEventButton *event, gpointer data) {
	CalendarEvent *cevent=gtk_clist_get_row_data (clist, row);
	cur_event=cevent;
	calendar_display_event (cevent);
}

void calendar_monthly_changed (GtkEditable *editable, gpointer data) {
	char *month=gtk_entry_get_text (GTK_ENTRY (editable));
	int mon=month_string_to_int (month);
	gtk_tcal_set (GTK_TCAL (lw (GTK_WIDGET (editable), "monthly")), 
	              gtk_spin_button_get_value_as_int (GTK_SPIN_BUTTON (
								   lw (GTK_WIDGET (editable), "monthly_year"))), mon);
}

void calendar_monthly_year_changed (GtkEditable *spin, gpointer data) {
	char *month=gtk_entry_get_text (GTK_ENTRY (lw (GTK_WIDGET (spin), "monthly_month")));
	int mon=month_string_to_int (month);
	int year=gtk_spin_button_get_value_as_int (GTK_SPIN_BUTTON (spin));
	gtk_tcal_set (GTK_TCAL (lw (GTK_WIDGET (spin), "monthly")), 
	              year, mon);
}

void calendar_yearly_year_changed (GtkEditable *spin, gpointer data) {
	int year=gtk_spin_button_get_value_as_int (GTK_SPIN_BUTTON (spin));
	gtk_tcal_set (GTK_TCAL (lw (GTK_WIDGET (spin), "yearly")), 
	              year, -1);
}

void calendar_yearly_event_selected (GtkTCal *tcal, CalendarEvent *event) {
	if (event) {
		calendar_display_event (event);
	}
}

GtkWidget *todo_child=NULL;

void calendar_todo_rehash () {	
	GtkTree *tree=GTK_TREE (lw (calendar_window, "todo_tree"));
	GList *seek;
	gtk_tree_clear_items (tree, 0, g_list_length (tree->children));
	for (seek=todo_first ();seek;seek=seek->next) {
		Todo *todo=seek->data;
		todo->treeitem=calendar_todo_add (tree, todo->text, todo->due, todo->complete);
	}
}

void calendar_todo_activated (GtkEntry *entry) {
	char *text=gtk_entry_get_text (entry);
	char *due=gtk_entry_get_text (GTK_ENTRY (lw (calendar_window, "todo_due")));
	GtkWidget *widget=calendar_todo_add (GTK_TREE (lw (calendar_window, "todo_tree")), text, due, FALSE);
	Todo *todo=todo_new ();
	todo->text=strdup (text);
	todo->due=strdup (due);
	todo->treeitem=widget;
	gtk_entry_set_text (entry, "");
	gtk_entry_set_text (GTK_ENTRY (lw (calendar_window, "todo_due")), "");
}

void calendar_todo_activated2 (GtkEntry *entry) {
        char *text=gtk_entry_get_text (GTK_ENTRY (lw (calendar_window, "todo_entry")));
        char *due=gtk_entry_get_text (GTK_ENTRY (lw (calendar_window, "todo_due")));
        GtkWidget *widget=calendar_todo_add (GTK_TREE (lw (calendar_window, "todo_tree")), text, due, FALSE);
        Todo *todo=todo_new ();
        todo->text=strdup (text);
        todo->due=strdup (due);
        todo->treeitem=widget;
        gtk_entry_set_text (entry, "");
        gtk_entry_set_text (GTK_ENTRY (lw (calendar_window, "todo_due")), "");
}

void calendar_todo_changed (GtkEditable *editable) {
	GtkWidget *widget=GTK_WIDGET (editable);
	char *text=gtk_entry_get_text (GTK_ENTRY (editable));
	widget=widget->parent->parent; 
	if (GTK_IS_TREE_ITEM (widget)) {
		Todo *todo=todo_find_from_tree (widget);
		if (todo) {
			if (todo->text) free (todo->text);
			todo->text=strdup (text);
		}
	}
}

void calendar_todo_due_changed (GtkEditable *editable) {
	GtkWidget *widget=GTK_WIDGET (editable);
	char *text=gtk_entry_get_text (GTK_ENTRY (editable));
	widget=widget->parent->parent->parent; 
	if (GTK_IS_TREE_ITEM (widget)) {
		Todo *todo=todo_find_from_tree (widget);
		if (todo) {
			if (todo->due) free (todo->due);
			todo->due=strdup (text);
		}
	}
}

void calendar_todo_delete (GtkWidget *widget, gpointer data) {
	Todo *todo=data;

	todo_delete (todo);
	calendar_todo_rehash();
	todo_child=NULL;
}

void calendar_todo_select (GtkWidget *widget, gpointer data) {
	GtkWidget *window = lookup_widget (widget, "main_calendar");
	create_calendar (3, window);
}

void calendar_todo_child_selected (GtkTree *tree, GtkWidget *child) {
	todo_child=child;
	gtk_tree_unselect_child (tree, child);
}

void calendar_todo_completion_toggled (GtkToggleButton *toggle, GtkTree *tree) {
	GtkWidget *widget=GTK_WIDGET (toggle);
	GtkBox *hbox=GTK_BOX (widget->parent);
	
	GtkBoxChild *child=hbox->children->next->data;
	GtkWidget *entry=child->widget;
	GtkWidget *combo;
	GtkWidget *treeitem=GTK_WIDGET (hbox)->parent;
	Todo *todo=todo_find_from_tree (treeitem);
	child=hbox->children->data;
	toggle=GTK_TOGGLE_BUTTON (child->widget);
	child=hbox->children->next->next->data;
	combo=child->widget;
	if (toggle->active) {
		todo->complete=TRUE;
		gtk_widget_set_sensitive (GTK_WIDGET (entry), FALSE);
		gtk_widget_set_sensitive (combo, FALSE);
	} else {
		todo->complete=FALSE;
		gtk_widget_set_sensitive (GTK_WIDGET (entry), TRUE);
		gtk_widget_set_sensitive (combo, TRUE);
	}
}

void calendar_switch_page (GtkNotebook *notebook, GtkNotebookPage *page,
                           guint page_num) {

  /* Force an update, just in case */
  calendar_update_all_uis() ;

  switch (page_num)
    {
    case 0:
      current_view=CALENDAR_VIEW_TODO;
      break;

    case 1:  
      current_view=CALENDAR_VIEW_DAILY;
      break;

    case 2:
      current_view=CALENDAR_VIEW_WORK;
      break;

    case 3:
      current_view=CALENDAR_VIEW_WEEK;
      break;

    case 4:
      current_view=CALENDAR_VIEW_MONTH;
      break;

    case 5: 
      current_view=CALENDAR_VIEW_YEAR;
      break;

    }
					
  /*	if (page_num == 1) 
		current_view=CALENDAR_VIEW_DAILY;
	
	if (page_num == 2) 

		current_view=CALENDAR_VIEW_WORK;

	if (page_num == 3) 
		current_view=CALENDAR_VIEW_WEEK;
	 Function has been deprecated due to fix supplied by George Mason for
	 * tcal redraw problem.  Thanks George!
	 */
  if (page_num==1) {
#if 0
    GtkWidget *daily=lw (calendar_window, "schedule");
    GdkRectangle rect;
    if (!daily)
      return;
    rect.height=SCHEDULE (daily)->height;
    rect.width=SCHEDULE (daily)->width;
    rect.x=0;
    rect.y=0;
    schedule_paint (daily, &rect);
#endif
  }
  if (page_num==4) {
    GtkWidget *monthly=lw (calendar_window, "monthly");
    if (!monthly)
      return;
    gtk_tcal_paint (monthly, NULL);
  }
  if (page_num==5) {
    GtkWidget *yearly=lw (calendar_window, "yearly");
    if (!yearly)
      return;
    gtk_tcal_paint (yearly, NULL);
  }
}



void calendar_update_all_uis () {
	if (!calendar_window)
		return;
	event_store_updated ();

	calendar_daycal_day_selected (GTK_CALENDAR (lw (calendar_window, "daily_calendar")));
	calendar_weekcal_day_selected (GTK_CALENDAR (lw (calendar_window, "weekly_calendar")));
	calendar_workweekcal_day_selected (GTK_CALENDAR (lw (calendar_window, "calendar2")));
	calendar_daycal_month_changed (GTK_CALENDAR (lw (calendar_window, "daily_calendar")));	
	return ;
}

void mail_todo_callback (GtkWidget *widget, gpointer userdata)
{
	Todo *todo = userdata;
	char *subject_line;
	GtkWidget *window = make_new_message_window (NULL, NULL);
	GtkWidget *subject = lookup_widget (window, "subject_entry");
	GtkWidget *body = lookup_widget (window, "body_textbox");

	subject_line = (char *)calloc (strlen (todo->due) + 7, sizeof (char));
	sprintf (subject_line, "TODO: %s", todo->due);

	gtk_entry_set_text (GTK_ENTRY (subject), subject_line);
	gtk_text_insert (GTK_TEXT (body), NULL, NULL, NULL, todo->text, -1);

	if (subject_line) free (subject_line);
}

GtkWidget *todo_popup ()
{
	GtkWidget *menu;
	GtkWidget *title, *sep, *mail, *delete;

	menu = gtk_menu_new();
	gtk_object_set_data (GTK_OBJECT (menu), "menu", menu);

	title= gtk_menu_item_new_with_label ("Todo Actions");
        gtk_widget_ref (title);
        gtk_object_set_data_full (GTK_OBJECT (menu), "title", title,
                                        (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(title);
        gtk_container_add (GTK_CONTAINER (menu), title);

	sep = gtk_menu_item_new();
	gtk_widget_show(sep);
	gtk_container_add (GTK_CONTAINER (menu), sep);

	mail = gtk_menu_item_new_with_label ("Mail Item");
	gtk_widget_ref (mail);
	gtk_object_set_data_full (GTK_OBJECT (menu), "mail", mail,
					(GtkDestroyNotify) gtk_widget_unref);
	gtk_container_add (GTK_CONTAINER (menu), mail);
	gtk_widget_show(mail);

        delete = gtk_menu_item_new_with_label ("Delete Item");
        gtk_widget_ref (delete);
        gtk_object_set_data_full (GTK_OBJECT (menu), "delete", delete,
                                        (GtkDestroyNotify) gtk_widget_unref);
        gtk_container_add (GTK_CONTAINER (menu), delete);
        gtk_widget_show(delete);

	return menu;
}

void todo_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer userdata)
{
	Todo *todo = todo_find_from_tree (widget);
	GtkWidget *menu = todo_popup();

        gtk_signal_connect (GTK_OBJECT (lookup_widget (menu,"mail")),
		"activate", GTK_SIGNAL_FUNC (mail_todo_callback), todo);
        gtk_signal_connect (GTK_OBJECT (lookup_widget (menu,"delete")),
		"activate", GTK_SIGNAL_FUNC (calendar_todo_delete), todo);

	if (event->button == 3)
		gtk_menu_popup (GTK_MENU (menu), NULL, NULL, NULL, NULL, 1, 0);
}



/*
 * Warning, this function is directly accessing some GTK
 * attributes.  This may break in future releases of GTK.
 * On the other hand, there isn't a way to otherwise do this
 * because GTK, being lame, doesn't properly expose an interface
 * to common sense attributes.
 */
void
new_event_subject_changed( GtkWidget *widget, gpointer data )
{
  GtkWidget *window ;
  char *text ;
  char *newText ;
  char *subject ;
  int length ;
  char compText[] = ": " ;


  window = lookup_widget (widget, "event_editor" ) ;
  text = gtk_entry_get_text (GTK_ENTRY (widget));

  if ( (text) && (length = strlen( text )) )
    {
      subject = GTK_WINDOW(window) -> title ;
      length = strlen( subject ) + strlen( compText ) + strlen( text ) ;
      subject = strstr( GTK_WINDOW(window) -> title, compText ) ;
      if( subject ) *subject = (char)0x00 ;
      subject = GTK_WINDOW(window) -> title ;
      newText = (char *)calloc( length+10, sizeof (char) ) ;
      sprintf( newText, "%s%s%s", subject, compText, text ) ;
      gtk_window_set_title (GTK_WINDOW (window), newText);
      free( newText ) ;
    }
  else
    {
      text = strstr( GTK_WINDOW(window) -> title, compText ) ;
      if( text )
	{
	  *text = (char)0x00 ;
	  newText = strdup( GTK_WINDOW(window) -> title ) ;
	  gtk_window_set_title (GTK_WINDOW (window), newText ) ;
	  free( newText ) ;
	}
    }

  return ;
}
