/* TradeClient <http://tradeclient.sourceforge.net>
 * $Id: dialogs.c,v 1.46 2001/03/20 22:19:33 ttabner Exp $
 *
 * Copyright (C) 1999-2000 Bynari Inc.
 * Copyright (C) 2001 Project TradeClient
 *
 * LGPL
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#include "puma.h"

GtkWidget* create_enter_password (PopAccount *pop) {
  GtkWidget *enter_password;
  GtkWidget *dialog_vbox1;
  GtkWidget *frame1;
  GtkWidget *vbox1;
  GtkWidget *label1;
  GtkWidget *entry1;
  GtkWidget *dialog_action_area1;
  GtkWidget *hbox1;
  GtkWidget *button1;
  GtkWidget *button2;
  char *label ;

  insert_warning( _("New password will take effect next time mail is checked.\n") ) ;
  label = (char *)calloc(strlen(_("Please enter password for account "))+strlen(pop->name)+1, sizeof(char)) ;
  snprintf (label, strlen(_("Please enter password for account "))+strlen(pop->name)+1, _("Please enter password for account %s"), pop->name);
  enter_password = gtk_dialog_new ();
  gtk_object_set_data (GTK_OBJECT (enter_password), "enter_password", enter_password);
  gtk_window_set_title (GTK_WINDOW (enter_password), _("Enter Password"));
  gtk_window_set_policy (GTK_WINDOW (enter_password), TRUE, TRUE, FALSE);
	gtk_widget_set_uposition (enter_password, 280, 215);
  dialog_vbox1 = GTK_DIALOG (enter_password)->vbox;
  gtk_object_set_data (GTK_OBJECT (enter_password), "dialog_vbox1", dialog_vbox1);
  gtk_widget_show (dialog_vbox1);

  frame1 = gtk_frame_new (_("Password Incorrect or Undefined"));
  gtk_widget_ref (frame1);
  gtk_object_set_data_full (GTK_OBJECT (enter_password), "frame1", frame1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), frame1, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame1), 2);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (enter_password), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (frame1), vbox1);
  gtk_container_set_border_width (GTK_CONTAINER (vbox1), 2);

  label1 = gtk_label_new (label);
  gtk_widget_ref (label1);
  gtk_object_set_data_full (GTK_OBJECT (enter_password), "label1", label1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label1);
  gtk_box_pack_start (GTK_BOX (vbox1), label1, TRUE, TRUE, 0);

  entry1 = gtk_entry_new ();
  gtk_widget_ref (entry1);
  gtk_object_set_data_full (GTK_OBJECT (enter_password), "entry1", entry1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry1);
  gtk_box_pack_start (GTK_BOX (vbox1), entry1, TRUE, TRUE, 0);
	gtk_entry_set_visibility (GTK_ENTRY(entry1), FALSE);
	
  dialog_action_area1 = GTK_DIALOG (enter_password)->action_area;
  gtk_object_set_data (GTK_OBJECT (enter_password), "dialog_action_area1", dialog_action_area1);
  gtk_widget_show (dialog_action_area1);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area1), 10);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT (enter_password), "hbox1", hbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (dialog_action_area1), hbox1, TRUE, TRUE, 0);

  button1 = gtk_button_new_with_label (_("Ok"));
  gtk_widget_ref (button1);
  gtk_object_set_data_full (GTK_OBJECT (enter_password), "button1", button1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button1);
  gtk_box_pack_start (GTK_BOX (hbox1), button1, TRUE, TRUE, 0);
  GTK_WIDGET_SET_FLAGS (button1, GTK_CAN_DEFAULT);

  button2 = gtk_button_new_with_label (_("Cancel"));
  gtk_widget_ref (button2);
  gtk_object_set_data_full (GTK_OBJECT (enter_password), "button2", button2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button2);
  gtk_box_pack_start (GTK_BOX (hbox1), button2, TRUE, TRUE, 0);

	gtk_signal_connect (GTK_OBJECT (button1), "clicked", 
											GTK_SIGNAL_FUNC (accept_new_password_dialog), (gpointer)pop);
	gtk_signal_connect (GTK_OBJECT (button2), "clicked",
											GTK_SIGNAL_FUNC (destroy_new_password_dialog), (gpointer)pop);
	gtk_signal_connect (GTK_OBJECT (enter_password), "delete_event",
											GTK_SIGNAL_FUNC (destroy_new_password_dialog), (gpointer)pop);
  gtk_widget_grab_focus (button1);
  gtk_widget_grab_default (button1);
  return enter_password;
}
GtkWidget* create_about_box (void) {
  GtkWidget *about_box;
  GtkWidget *dialog_vbox1;
  GtkWidget *frame1;
  GtkWidget *hbox1;
  GtkWidget *vbox1;
  GtkWidget *pixmap1;
  GtkWidget *hseparator1;
  GtkWidget *label2;
  GtkWidget *hseparator2;
  GtkWidget *label3;
  GtkWidget *scrolledwindow1;
  GtkWidget *text1;
  GtkWidget *dialog_action_area1;
  GtkWidget *close_button;

  about_box = gtk_dialog_new ();
  gtk_widget_set_name (about_box, "about_box");
  gtk_object_set_data (GTK_OBJECT (about_box), "about_box", about_box);
  gtk_window_set_title (GTK_WINDOW (about_box), _("About TradeClient"));
  gtk_window_set_default_size (GTK_WINDOW (about_box), 620, -1);
  gtk_window_set_policy (GTK_WINDOW (about_box), TRUE, TRUE, TRUE);

  dialog_vbox1 = GTK_DIALOG (about_box)->vbox;
  gtk_widget_set_name (dialog_vbox1, "dialog_vbox1");
  gtk_object_set_data (GTK_OBJECT (about_box), "dialog_vbox1", dialog_vbox1);
  gtk_widget_show (dialog_vbox1);

  frame1 = gtk_frame_new (NULL);
  gtk_widget_set_name (frame1, "frame1");
  gtk_widget_ref (frame1);
  gtk_object_set_data_full (GTK_OBJECT (about_box), "frame1", frame1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), frame1, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame1), 2);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox1, "hbox1");
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT (about_box), "hbox1", hbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox1);
  gtk_container_add (GTK_CONTAINER (frame1), hbox1);
  gtk_container_set_border_width (GTK_CONTAINER (hbox1), 2);

  vbox1 = gtk_vbox_new (FALSE, 5);
  gtk_widget_set_name (vbox1, "vbox1");
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (about_box), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_box_pack_start (GTK_BOX (hbox1), vbox1, FALSE, TRUE, 0);

  pixmap1 = pixmap_widget_create (vbox1, PIXMAP_BYNARI);
  gtk_widget_set_name (pixmap1, "pixmap1");
  gtk_widget_ref (pixmap1);
  gtk_object_set_data_full (GTK_OBJECT (about_box), "pixmap1", pixmap1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pixmap1);
  gtk_box_pack_start (GTK_BOX (vbox1), pixmap1, FALSE, FALSE, 0);
  gtk_misc_set_padding (GTK_MISC (pixmap1), 0, 4);

  hseparator1 = gtk_hseparator_new ();
  gtk_widget_set_name (hseparator1, "hseparator1");
  gtk_widget_ref (hseparator1);
  gtk_object_set_data_full (GTK_OBJECT (about_box), "hseparator1", hseparator1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator1);
  gtk_box_pack_start (GTK_BOX (vbox1), hseparator1, FALSE, FALSE, 0);

  label2 = gtk_label_new ("Copyright (C) 1999-2001 Bynari Inc.\nCopyright (C) 2001 Project TradeClient");
  gtk_widget_set_name (label2, "label2");
  gtk_widget_ref (label2);
  gtk_object_set_data_full (GTK_OBJECT (about_box), "label2", label2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label2);
  gtk_box_pack_start (GTK_BOX (vbox1), label2, FALSE, FALSE, 0);

  hseparator2 = gtk_hseparator_new ();
  gtk_widget_set_name (hseparator2, "hseparator2");
  gtk_widget_ref (hseparator2);
  gtk_object_set_data_full (GTK_OBJECT (about_box), "hseparator2", hseparator2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator2);
  gtk_box_pack_start (GTK_BOX (vbox1), hseparator2, FALSE, FALSE, 0);

  label3 = gtk_label_new ("\nhttp://tradeclient.sourceforge.net\n\nMaintainer: Trey Tabner\nFounder: Tom Adelstein\n\nVisit our website for more information\nabout TradeClient and to learn about\nbecoming a developer for this project!\n");
  gtk_widget_set_name (label3, "label4");
  gtk_widget_ref (label3);
  gtk_object_set_data_full (GTK_OBJECT (about_box), "label3", label3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label3);
  gtk_box_pack_start (GTK_BOX (vbox1), label3, FALSE, FALSE, 0);

  scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_set_name (scrolledwindow1, "scrolledwindow1");
  gtk_widget_ref (scrolledwindow1);
  gtk_object_set_data_full (GTK_OBJECT (about_box), "scrolledwindow1", scrolledwindow1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow1);
  gtk_box_pack_start (GTK_BOX (hbox1), scrolledwindow1, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  text1 = gtk_text_new (NULL, NULL);
  gtk_widget_set_name (text1, "text1");
  gtk_widget_ref (text1);
  gtk_object_set_data_full (GTK_OBJECT (about_box), "text1", text1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (text1);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), text1);
  gtk_widget_realize (text1);
  gtk_text_insert (GTK_TEXT (text1), NULL, NULL, NULL,
                   "
		  GNU LIBRARY GENERAL PUBLIC LICENSE
		       Version 2, June 1991

 Copyright (C) 1991 Free Software Foundation, Inc.
    		    59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 Everyone is permitted to copy and distribute verbatim copies
 of this license document, but changing it is not allowed.

[This is the first released version of the library GPL.  It is
 numbered 2 because it goes with version 2 of the ordinary GPL.]

			    Preamble

  The licenses for most software are designed to take away your
freedom to share and change it.  By contrast, the GNU General Public
Licenses are intended to guarantee your freedom to share and change
free software--to make sure the software is free for all its users.

  This license, the Library General Public License, applies to some
specially designated Free Software Foundation software, and to any
other libraries whose authors decide to use it.  You can use it for
your libraries, too.

  When we speak of free software, we are referring to freedom, not
price.  Our General Public Licenses are designed to make sure that you
have the freedom to distribute copies of free software (and charge for
this service if you wish), that you receive source code or can get it
if you want it, that you can change the software or use pieces of it
in new free programs; and that you know you can do these things.

  To protect your rights, we need to make restrictions that forbid
anyone to deny you these rights or to ask you to surrender the rights.
These restrictions translate to certain responsibilities for you if
you distribute copies of the library, or if you modify it.

  For example, if you distribute copies of the library, whether gratis
or for a fee, you must give the recipients all the rights that we gave
you.  You must make sure that they, too, receive or can get the source
code.  If you link a program with the library, you must provide
complete object files to the recipients so that they can relink them
with the library, after making changes to the library and recompiling
it.  And you must show them these terms so they know their rights.

  Our method of protecting your rights has two steps: (1) copyright
the library, and (2) offer you this license which gives you legal
permission to copy, distribute and/or modify the library.

  Also, for each distributor's protection, we want to make certain
that everyone understands that there is no warranty for this free
library.  If the library is modified by someone else and passed on, we
want its recipients to know that what they have is not the original
version, so that any problems introduced by others will not reflect on
the original authors' reputations.

  Finally, any free program is threatened constantly by software
patents.  We wish to avoid the danger that companies distributing free
software will individually obtain patent licenses, thus in effect
transforming the program into proprietary software.  To prevent this,
we have made it clear that any patent must be licensed for everyone's
free use or not licensed at all.

  Most GNU software, including some libraries, is covered by the ordinary
GNU General Public License, which was designed for utility programs.  This
license, the GNU Library General Public License, applies to certain
designated libraries.  This license is quite different from the ordinary
one; be sure to read it in full, and don't assume that anything in it is
the same as in the ordinary license.

  The reason we have a separate public license for some libraries is that
they blur the distinction we usually make between modifying or adding to a
program and simply using it.  Linking a program with a library, without
changing the library, is in some sense simply using the library, and is
analogous to running a utility program or application program.  However, in
a textual and legal sense, the linked executable is a combined work, a
derivative of the original library, and the ordinary General Public License
treats it as such.

  Because of this blurred distinction, using the ordinary General
Public License for libraries did not effectively promote software
sharing, because most developers did not use the libraries.  We
concluded that weaker conditions might promote sharing better.

  However, unrestricted linking of non-free programs would deprive the
users of those programs of all benefit from the free status of the
libraries themselves.  This Library General Public License is intended to
permit developers of non-free programs to use free libraries, while
preserving your freedom as a user of such programs to change the free
libraries that are incorporated in them.  (We have not seen how to achieve
this as regards changes in header files, but we have achieved it as regards
changes in the actual functions of the Library.)  The hope is that this
will lead to faster development of free libraries.

  The precise terms and conditions for copying, distribution and
modification follow.  Pay close attention to the difference between a
\"work based on the library\" and a \"work that uses the library\".  The
former contains code derived from the library, while the latter only
works together with the library.

  Note that it is possible for a library to be covered by the ordinary
General Public License rather than by this special one.

		  GNU LIBRARY GENERAL PUBLIC LICENSE
   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION

  0. This License Agreement applies to any software library which
contains a notice placed by the copyright holder or other authorized
party saying it may be distributed under the terms of this Library
General Public License (also called \"this License\").  Each licensee is
addressed as \"you\".

  A \"library\" means a collection of software functions and/or data
prepared so as to be conveniently linked with application programs
(which use some of those functions and data) to form executables.

  The \"Library\", below, refers to any such software library or work
which has been distributed under these terms.  A \"work based on the
Library\" means either the Library or any derivative work under
copyright law: that is to say, a work containing the Library or a
portion of it, either verbatim or with modifications and/or translated
straightforwardly into another language.  (Hereinafter, translation is
included without limitation in the term \"modification\".)

  \"Source code\" for a work means the preferred form of the work for
making modifications to it.  For a library, complete source code means
all the source code for all modules it contains, plus any associated
interface definition files, plus the scripts used to control compilation
and installation of the library.

  Activities other than copying, distribution and modification are not
covered by this License; they are outside its scope.  The act of
running a program using the Library is not restricted, and output from
such a program is covered only if its contents constitute a work based
on the Library (independent of the use of the Library in a tool for
writing it).  Whether that is true depends on what the Library does
and what the program that uses the Library does.
  
  1. You may copy and distribute verbatim copies of the Library's
complete source code as you receive it, in any medium, provided that
you conspicuously and appropriately publish on each copy an
appropriate copyright notice and disclaimer of warranty; keep intact
all the notices that refer to this License and to the absence of any
warranty; and distribute a copy of this License along with the
Library.

  You may charge a fee for the physical act of transferring a copy,
and you may at your option offer warranty protection in exchange for a
fee.

  2. You may modify your copy or copies of the Library or any portion
of it, thus forming a work based on the Library, and copy and
distribute such modifications or work under the terms of Section 1
above, provided that you also meet all of these conditions:

    a) The modified work must itself be a software library.

    b) You must cause the files modified to carry prominent notices
    stating that you changed the files and the date of any change.

    c) You must cause the whole of the work to be licensed at no
    charge to all third parties under the terms of this License.

    d) If a facility in the modified Library refers to a function or a
    table of data to be supplied by an application program that uses
    the facility, other than as an argument passed when the facility
    is invoked, then you must make a good faith effort to ensure that,
    in the event an application does not supply such function or
    table, the facility still operates, and performs whatever part of
    its purpose remains meaningful.

    (For example, a function in a library to compute square roots has
    a purpose that is entirely well-defined independent of the
    application.  Therefore, Subsection 2d requires that any
    application-supplied function or table used by this function must
    be optional: if the application does not supply it, the square
    root function must still compute square roots.)

These requirements apply to the modified work as a whole.  If
identifiable sections of that work are not derived from the Library,
and can be reasonably considered independent and separate works in
themselves, then this License, and its terms, do not apply to those
sections when you distribute them as separate works.  But when you
distribute the same sections as part of a whole which is a work based
on the Library, the distribution of the whole must be on the terms of
this License, whose permissions for other licensees extend to the
entire whole, and thus to each and every part regardless of who wrote
it.

Thus, it is not the intent of this section to claim rights or contest
your rights to work written entirely by you; rather, the intent is to
exercise the right to control the distribution of derivative or
collective works based on the Library.

In addition, mere aggregation of another work not based on the Library
with the Library (or with a work based on the Library) on a volume of
a storage or distribution medium does not bring the other work under
the scope of this License.

  3. You may opt to apply the terms of the ordinary GNU General Public
License instead of this License to a given copy of the Library.  To do
this, you must alter all the notices that refer to this License, so
that they refer to the ordinary GNU General Public License, version 2,
instead of to this License.  (If a newer version than version 2 of the
ordinary GNU General Public License has appeared, then you can specify
that version instead if you wish.)  Do not make any other change in
these notices.

  Once this change is made in a given copy, it is irreversible for
that copy, so the ordinary GNU General Public License applies to all
subsequent copies and derivative works made from that copy.

  This option is useful when you wish to copy part of the code of
the Library into a program that is not a library.

  4. You may copy and distribute the Library (or a portion or
derivative of it, under Section 2) in object code or executable form
under the terms of Sections 1 and 2 above provided that you accompany
it with the complete corresponding machine-readable source code, which
must be distributed under the terms of Sections 1 and 2 above on a
medium customarily used for software interchange.

  If distribution of object code is made by offering access to copy
from a designated place, then offering equivalent access to copy the
source code from the same place satisfies the requirement to
distribute the source code, even though third parties are not
compelled to copy the source along with the object code.

  5. A program that contains no derivative of any portion of the
Library, but is designed to work with the Library by being compiled or
linked with it, is called a \"work that uses the Library\".  Such a
work, in isolation, is not a derivative work of the Library, and
therefore falls outside the scope of this License.

  However, linking a \"work that uses the Library\" with the Library
creates an executable that is a derivative of the Library (because it
contains portions of the Library), rather than a \"work that uses the
library\".  The executable is therefore covered by this License.
Section 6 states terms for distribution of such executables.

  When a \"work that uses the Library\" uses material from a header file
that is part of the Library, the object code for the work may be a
derivative work of the Library even though the source code is not.
Whether this is true is especially significant if the work can be
linked without the Library, or if the work is itself a library.  The
threshold for this to be true is not precisely defined by law.

  If such an object file uses only numerical parameters, data
structure layouts and accessors, and small macros and small inline
functions (ten lines or less in length), then the use of the object
file is unrestricted, regardless of whether it is legally a derivative
work.  (Executables containing this object code plus portions of the
Library will still fall under Section 6.)

  Otherwise, if the work is a derivative of the Library, you may
distribute the object code for the work under the terms of Section 6.
Any executables containing that work also fall under Section 6,
whether or not they are linked directly with the Library itself.

  6. As an exception to the Sections above, you may also compile or
link a \"work that uses the Library\" with the Library to produce a
work containing portions of the Library, and distribute that work
under terms of your choice, provided that the terms permit
modification of the work for the customer's own use and reverse
engineering for debugging such modifications.

  You must give prominent notice with each copy of the work that the
Library is used in it and that the Library and its use are covered by
this License.  You must supply a copy of this License.  If the work
during execution displays copyright notices, you must include the
copyright notice for the Library among them, as well as a reference
directing the user to the copy of this License.  Also, you must do one
of these things:

    a) Accompany the work with the complete corresponding
    machine-readable source code for the Library including whatever
    changes were used in the work (which must be distributed under
    Sections 1 and 2 above); and, if the work is an executable linked
    with the Library, with the complete machine-readable \"work that
    uses the Library\", as object code and/or source code, so that the
    user can modify the Library and then relink to produce a modified
    executable containing the modified Library.  (It is understood
    that the user who changes the contents of definitions files in the
    Library will not necessarily be able to recompile the application
    to use the modified definitions.)

    b) Accompany the work with a written offer, valid for at
    least three years, to give the same user the materials
    specified in Subsection 6a, above, for a charge no more
    than the cost of performing this distribution.

    c) If distribution of the work is made by offering access to copy
    from a designated place, offer equivalent access to copy the above
    specified materials from the same place.

    d) Verify that the user has already received a copy of these
    materials or that you have already sent this user a copy.

  For an executable, the required form of the \"work that uses the
Library\" must include any data and utility programs needed for
reproducing the executable from it.  However, as a special exception,
the source code distributed need not include anything that is normally
distributed (in either source or binary form) with the major
components (compiler, kernel, and so on) of the operating system on
which the executable runs, unless that component itself accompanies
the executable.

  It may happen that this requirement contradicts the license
restrictions of other proprietary libraries that do not normally
accompany the operating system.  Such a contradiction means you cannot
use both them and the Library together in an executable that you
distribute.

  7. You may place library facilities that are a work based on the
Library side-by-side in a single library together with other library
facilities not covered by this License, and distribute such a combined
library, provided that the separate distribution of the work based on
the Library and of the other library facilities is otherwise
permitted, and provided that you do these two things:

    a) Accompany the combined library with a copy of the same work
    based on the Library, uncombined with any other library
    facilities.  This must be distributed under the terms of the
    Sections above.

    b) Give prominent notice with the combined library of the fact
    that part of it is a work based on the Library, and explaining
    where to find the accompanying uncombined form of the same work.

  8. You may not copy, modify, sublicense, link with, or distribute
the Library except as expressly provided under this License.  Any
attempt otherwise to copy, modify, sublicense, link with, or
distribute the Library is void, and will automatically terminate your
rights under this License.  However, parties who have received copies,
or rights, from you under this License will not have their licenses
terminated so long as such parties remain in full compliance.

  9. You are not required to accept this License, since you have not
signed it.  However, nothing else grants you permission to modify or
distribute the Library or its derivative works.  These actions are
prohibited by law if you do not accept this License.  Therefore, by
modifying or distributing the Library (or any work based on the
Library), you indicate your acceptance of this License to do so, and
all its terms and conditions for copying, distributing or modifying
the Library or works based on it.

  10. Each time you redistribute the Library (or any work based on the
Library), the recipient automatically receives a license from the
original licensor to copy, distribute, link with or modify the Library
subject to these terms and conditions.  You may not impose any further
restrictions on the recipients' exercise of the rights granted herein.
You are not responsible for enforcing compliance by third parties to
this License.

  11. If, as a consequence of a court judgment or allegation of patent
infringement or for any other reason (not limited to patent issues),
conditions are imposed on you (whether by court order, agreement or
otherwise) that contradict the conditions of this License, they do not
excuse you from the conditions of this License.  If you cannot
distribute so as to satisfy simultaneously your obligations under this
License and any other pertinent obligations, then as a consequence you
may not distribute the Library at all.  For example, if a patent
license would not permit royalty-free redistribution of the Library by
all those who receive copies directly or indirectly through you, then
the only way you could satisfy both it and this License would be to
refrain entirely from distribution of the Library.

If any portion of this section is held invalid or unenforceable under any
particular circumstance, the balance of the section is intended to apply,
and the section as a whole is intended to apply in other circumstances.

It is not the purpose of this section to induce you to infringe any
patents or other property right claims or to contest validity of any
such claims; this section has the sole purpose of protecting the
integrity of the free software distribution system which is
implemented by public license practices.  Many people have made
generous contributions to the wide range of software distributed
through that system in reliance on consistent application of that
system; it is up to the author/donor to decide if he or she is willing
to distribute software through any other system and a licensee cannot
impose that choice.

This section is intended to make thoroughly clear what is believed to
be a consequence of the rest of this License.

  12. If the distribution and/or use of the Library is restricted in
certain countries either by patents or by copyrighted interfaces, the
original copyright holder who places the Library under this License may add
an explicit geographical distribution limitation excluding those countries,
so that distribution is permitted only in or among countries not thus
excluded.  In such case, this License incorporates the limitation as if
written in the body of this License.

  13. The Free Software Foundation may publish revised and/or new
versions of the Library General Public License from time to time.
Such new versions will be similar in spirit to the present version,
but may differ in detail to address new problems or concerns.

Each version is given a distinguishing version number.  If the Library
specifies a version number of this License which applies to it and
\"any later version\", you have the option of following the terms and
conditions either of that version or of any later version published by
the Free Software Foundation.  If the Library does not specify a
license version number, you may choose any version ever published by
the Free Software Foundation.

  14. If you wish to incorporate parts of the Library into other free
programs whose distribution conditions are incompatible with these,
write to the author to ask for permission.  For software which is
copyrighted by the Free Software Foundation, write to the Free
Software Foundation; we sometimes make exceptions for this.  Our
decision will be guided by the two goals of preserving the free status
of all derivatives of our free software and of promoting the sharing
and reuse of software generally.

			    NO WARRANTY

  15. BECAUSE THE LIBRARY IS LICENSED FREE OF CHARGE, THERE IS NO
WARRANTY FOR THE LIBRARY, TO THE EXTENT PERMITTED BY APPLICABLE LAW.
EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR
OTHER PARTIES PROVIDE THE LIBRARY \"AS IS\" WITHOUT WARRANTY OF ANY
KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE
LIBRARY IS WITH YOU.  SHOULD THE LIBRARY PROVE DEFECTIVE, YOU ASSUME
THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.

  16. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY
AND/OR REDISTRIBUTE THE LIBRARY AS PERMITTED ABOVE, BE LIABLE TO YOU
FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR
CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE
LIBRARY (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING
RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A
FAILURE OF THE LIBRARY TO OPERATE WITH ANY OTHER SOFTWARE), EVEN IF
SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
DAMAGES.

		     END OF TERMS AND CONDITIONS

           How to Apply These Terms to Your New Libraries

  If you develop a new library, and you want it to be of the greatest
possible use to the public, we recommend making it free software that
everyone can redistribute and change.  You can do so by permitting
redistribution under these terms (or, alternatively, under the terms of the
ordinary General Public License).

  To apply these terms, attach the following notices to the library.  It is
safest to attach them to the start of each source file to most effectively
convey the exclusion of warranty; and each file should have at least the
\"copyright\" line and a pointer to where the full notice is found.

    <one line to give the library's name and a brief idea of what it does.>
    Copyright (C) <year>  <name of author>

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ", -1);

  dialog_action_area1 = GTK_DIALOG (about_box)->action_area;
  gtk_widget_set_name (dialog_action_area1, "dialog_action_area1");
  gtk_object_set_data (GTK_OBJECT (about_box), "dialog_action_area1", dialog_action_area1);
  gtk_widget_show (dialog_action_area1);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area1), 10);

  close_button = gtk_button_new_with_label (_("Close"));
  gtk_widget_set_name (close_button, "close_button");
  gtk_widget_ref (close_button);
  gtk_object_set_data_full (GTK_OBJECT (about_box), "close_button", close_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (close_button);
  gtk_box_pack_start (GTK_BOX (dialog_action_area1), close_button, TRUE, TRUE, 0);
  GTK_WIDGET_SET_FLAGS (close_button, GTK_CAN_DEFAULT);

	gtk_signal_connect (GTK_OBJECT (close_button), "clicked", 
											GTK_SIGNAL_FUNC (destroy_aboutbox), NULL);
	gtk_signal_connect (GTK_OBJECT (about_box), "delete_event",
											GTK_SIGNAL_FUNC (destroy_aboutbox), NULL);

  gtk_widget_grab_focus (close_button);
  gtk_widget_grab_default (close_button);
  return about_box;
}

void create_popup_window (Message *message) {
	Folder *fseek=folder_first ();
	GList *aseek=abook_first ();
	GtkWidget *folder;
	GtkWidget *abook;
	if (GTK_IS_WIDGET (tm_globs->message_popup)) {
		gtk_widget_destroy (tm_globs->message_popup);
	}
	tm_globs->message_popup=create_message_popup ();
	gtk_signal_connect (GTK_OBJECT (lookup_widget (tm_globs->message_popup, "reply1")), "activate",
											GTK_SIGNAL_FUNC (replyto_activate), (gpointer)message);
	gtk_signal_connect (GTK_OBJECT (lookup_widget (tm_globs->message_popup, "reply_to_all")), "activate",
											GTK_SIGNAL_FUNC (replytoall_activate), (gpointer)message);
	gtk_signal_connect (GTK_OBJECT (lookup_widget (tm_globs->message_popup, "forward1")), "activate",
											GTK_SIGNAL_FUNC (forward_activate), (gpointer)message);
	gtk_signal_connect (GTK_OBJECT (lookup_widget (tm_globs->message_popup, "delete1")), "activate",
											GTK_SIGNAL_FUNC (delete_activate), (gpointer)message);
	gtk_signal_connect (GTK_OBJECT (lookup_widget (tm_globs->message_popup, "save_message_as")), "activate",
											GTK_SIGNAL_FUNC (save_message_activate), NULL);
	gtk_signal_connect (GTK_OBJECT (lookup_widget (tm_globs->message_popup,
	                   "mark_unread")), "activate",
                           GTK_SIGNAL_FUNC (mark_unread_callback),
                           (gpointer)message);
        gtk_signal_connect (GTK_OBJECT (lookup_widget (tm_globs->message_popup,
                           "send_to_html")), "activate",
                           GTK_SIGNAL_FUNC (send_to_html_callback),
                           (gpointer)message);
	gtk_signal_connect (GTK_OBJECT (lookup_widget (tm_globs->message_popup, "resend")), "activate",
	                    GTK_SIGNAL_FUNC (message_resend), (gpointer)message);
	gtk_signal_connect (GTK_OBJECT (lookup_widget (tm_globs->message_popup, "send_now")), "activate",
	                    GTK_SIGNAL_FUNC (message_resend), (gpointer)message);
	gtk_signal_connect (GTK_OBJECT (lookup_widget (tm_globs->message_popup, "view_document")), "activate",
	                    GTK_SIGNAL_FUNC (docsource_create), NULL);
	gtk_signal_connect (GTK_OBJECT (lookup_widget (tm_globs->message_popup, "reply_to_all")), "activate",
	                    GTK_SIGNAL_FUNC (reply_to_all_clicked), NULL);
									
	gtk_widget_set_sensitive (lookup_widget (tm_globs->message_popup, "move_to_folder1_menu"), TRUE);
	
	while (fseek) {
		folder = gtk_menu_item_new_with_label (fseek->name);
	  gtk_widget_show (folder);
		gtk_signal_connect (GTK_OBJECT (folder), "activate",
		                    GTK_SIGNAL_FUNC (move_to_activate), (gpointer)message);
 		
	  gtk_container_add (GTK_CONTAINER (lookup_widget (tm_globs->message_popup, "move_to_folder1_menu")), folder);
		fseek=fseek->next;
	}
	for (aseek=abook_first();aseek;aseek=aseek->next) {
		Abook *abk=aseek->data;
		if (strcmp(abk->name,gabName)) {
		abook = gtk_menu_item_new_with_label (abk->name);
	  gtk_widget_show (abook);
		
		gtk_signal_connect (GTK_OBJECT (abook), "activate",
												GTK_SIGNAL_FUNC (main_window_sender_add), (gpointer)abk);
 		
	  gtk_container_add (GTK_CONTAINER (lookup_widget (tm_globs->message_popup, "add_to_addressbook_menu")), abook);
	  }
	}
	gtk_menu_popup (GTK_MENU (tm_globs->message_popup), NULL, NULL, NULL, NULL, 3, 0);
}

GtkWidget* create_message_popup () {
  GtkWidget *message_popup;
  GtkAccelGroup *message_popup_accels;
	GtkWidget *save_message_as;
	GtkWidget *resend;
  GtkWidget *reply1;
  GtkWidget *reply_to_all;
  GtkWidget *forward1;
  GtkWidget *delete1;
  GtkWidget *separator1;
  GtkWidget *mark_unread;
  GtkWidget *send_to_html;
  GtkWidget *move_to_folder1;
  GtkWidget *move_to_folder1_menu;
	GtkWidget *add_to_addressbook;
	GtkWidget *add_to_addressbook_menu;
 	GtkWidget *send_now;
	GtkWidget *scratch;
	GtkWidget *mtitle, *msep;
  GtkAccelGroup *move_to_folder1_menu_accels;
  GtkAccelGroup *add_to_addressbook_menu_accels;
  GtkAccelGroup *accel_group;

  accel_group = gtk_accel_group_new ();

/* not used yet	Folder *fl=tm_globs->visable; */

  message_popup = gtk_menu_new ();
  gtk_object_set_data (GTK_OBJECT (message_popup), "message_popup", message_popup);
  message_popup_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (message_popup));

  mtitle = gtk_menu_item_new_with_label (_("Message Actions"));
  gtk_widget_ref (mtitle);
  gtk_object_set_data_full (GTK_OBJECT (message_popup), "mtitle", mtitle,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mtitle);
  gtk_container_add (GTK_CONTAINER (message_popup), mtitle);

  msep = gtk_menu_item_new();
  gtk_widget_ref (msep);
  gtk_object_set_data_full (GTK_OBJECT (message_popup), "msep", msep,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (msep);
  gtk_container_add (GTK_CONTAINER (message_popup), msep);

  resend = gtk_menu_item_new_with_label (_("Resend this message"));
  gtk_widget_ref (resend);
  gtk_object_set_data_full (GTK_OBJECT (message_popup), "resend", resend,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_container_add (GTK_CONTAINER (message_popup), resend);

  send_now = gtk_menu_item_new_with_label (_("Send this message Now"));
  gtk_widget_ref (send_now);
  gtk_object_set_data_full (GTK_OBJECT (message_popup), "send_now", send_now,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_container_add (GTK_CONTAINER (message_popup), send_now);

  separator1 = gtk_menu_item_new ();
  gtk_widget_ref (separator1);
  gtk_object_set_data_full (GTK_OBJECT (message_popup), "separator1", separator1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_container_add (GTK_CONTAINER (message_popup), separator1);
  gtk_widget_set_sensitive (separator1, FALSE);

/* not going to have this used until we get it working again

	if (strcasecmp (fl->name, _("Sent-Items"))==0) {
	  gtk_widget_show (resend);
	  gtk_widget_show (separator1);
	}
	
	if (strcasecmp (fl->name, _("Outbox"))==0) {
		gtk_widget_show (send_now);
	  gtk_widget_show (separator1);
	}	
*/

  reply1 = gtk_menu_item_new_with_label (_("Reply"));
  gtk_widget_ref (reply1);
  gtk_object_set_data_full (GTK_OBJECT (message_popup), "reply1", reply1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (reply1);
  gtk_container_add (GTK_CONTAINER (message_popup), reply1);

  reply_to_all = gtk_menu_item_new_with_label (_("Reply To All"));
  gtk_widget_ref (reply_to_all);
  gtk_object_set_data_full (GTK_OBJECT (message_popup), "reply_to_all", reply_to_all,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (reply_to_all);
  gtk_container_add (GTK_CONTAINER (message_popup), reply_to_all);

  forward1 = gtk_menu_item_new_with_label (_("Forward"));
  gtk_widget_ref (forward1);
  gtk_object_set_data_full (GTK_OBJECT (message_popup), "forward1", forward1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (forward1);
  gtk_container_add (GTK_CONTAINER (message_popup), forward1);


  delete1 = gtk_menu_item_new_with_label (_("Delete"));
  gtk_widget_ref (delete1);
  gtk_object_set_data_full (GTK_OBJECT (message_popup), "delete1", delete1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (delete1);
  gtk_container_add (GTK_CONTAINER (message_popup), delete1);

  separator1 = gtk_menu_item_new ();
  gtk_widget_ref (separator1);
  gtk_object_set_data_full (GTK_OBJECT (message_popup), "separator1", separator1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (separator1);
  gtk_container_add (GTK_CONTAINER (message_popup), separator1);
  gtk_widget_set_sensitive (separator1, FALSE);

  mark_unread = gtk_menu_item_new_with_label (_("Toggle Read State"));
  gtk_widget_ref (mark_unread);
  gtk_object_set_data_full (GTK_OBJECT (message_popup), "mark_unread", mark_unread,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mark_unread);
  gtk_container_add (GTK_CONTAINER (message_popup), mark_unread);

  send_to_html = gtk_menu_item_new_with_label (_("View with Web Browser"));
  gtk_widget_ref (send_to_html);
  gtk_object_set_data_full (GTK_OBJECT (message_popup), "send_to_html",
        send_to_html, (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (send_to_html);
  gtk_container_add (GTK_CONTAINER (message_popup), send_to_html);

  separator1 = gtk_menu_item_new ();
  gtk_widget_ref (separator1);
  gtk_object_set_data_full (GTK_OBJECT (message_popup), "separator1", separator1
,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (separator1);
  gtk_container_add (GTK_CONTAINER (message_popup), separator1);
  gtk_widget_set_sensitive (separator1, FALSE);

	save_message_as = gtk_menu_item_new_with_label (_("Save Message As..."));
  gtk_widget_ref (save_message_as);
  gtk_object_set_data_full (GTK_OBJECT (message_popup), "save_message_as", save_message_as,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (save_message_as);
  gtk_container_add (GTK_CONTAINER (message_popup), save_message_as);

	scratch = gtk_menu_item_new_with_label (_("View Document Source"));
  gtk_widget_ref (scratch);
  gtk_object_set_data_full (GTK_OBJECT (message_popup), "view_document", scratch,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scratch);
  gtk_container_add (GTK_CONTAINER (message_popup), scratch);

	scratch = gtk_menu_item_new_with_label (_("Print"));
  gtk_widget_ref (scratch);
  gtk_object_set_data_full (GTK_OBJECT (message_popup), "print", scratch,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scratch);
  gtk_container_add (GTK_CONTAINER (message_popup), scratch);

  separator1 = gtk_menu_item_new ();
  gtk_widget_ref (separator1);
  gtk_object_set_data_full (GTK_OBJECT (message_popup), "separator1", separator1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (separator1);
  gtk_container_add (GTK_CONTAINER (message_popup), separator1);
  gtk_widget_set_sensitive (separator1, FALSE);

  move_to_folder1 = gtk_menu_item_new_with_label (_("Move to Folder"));
  gtk_widget_ref (move_to_folder1);
  gtk_object_set_data_full (GTK_OBJECT (message_popup), "move_to_folder1", move_to_folder1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (move_to_folder1);
  gtk_container_add (GTK_CONTAINER (message_popup), move_to_folder1);

  move_to_folder1_menu = gtk_menu_new ();
  gtk_widget_ref (move_to_folder1_menu);
  gtk_object_set_data_full (GTK_OBJECT (message_popup), "move_to_folder1_menu", move_to_folder1_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (move_to_folder1), move_to_folder1_menu);
  move_to_folder1_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (move_to_folder1_menu));

  add_to_addressbook = gtk_menu_item_new_with_label (_("Add Sender to Addressbook"));
  gtk_widget_ref (add_to_addressbook);
  gtk_object_set_data_full (GTK_OBJECT (message_popup), "add_to_addressbook", add_to_addressbook,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (add_to_addressbook);
  gtk_container_add (GTK_CONTAINER (message_popup), add_to_addressbook);

  add_to_addressbook_menu = gtk_menu_new ();
  gtk_widget_ref (add_to_addressbook_menu);
  gtk_object_set_data_full (GTK_OBJECT (message_popup), "add_to_addressbook_menu", add_to_addressbook_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (add_to_addressbook), add_to_addressbook_menu);
  add_to_addressbook_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (add_to_addressbook_menu));

  return message_popup;
}

GtkWidget* create_folder_popup () {
  GtkWidget *folder_popup;
  GtkAccelGroup *folder_popup_accels;
  GtkWidget *poptitle, *popsep;
  GtkWidget *new_folder1;
  GtkWidget *delete_folder1;

  folder_popup = gtk_menu_new ();
  gtk_object_set_data (GTK_OBJECT (folder_popup), "folder_popup", folder_popup);
  folder_popup_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (folder_popup));

  poptitle = gtk_menu_item_new_with_label ("Folder Actions");
  gtk_widget_ref (poptitle);
  gtk_widget_show (poptitle);
  gtk_container_add (GTK_CONTAINER (folder_popup), poptitle);

  popsep = gtk_menu_item_new ();
  gtk_widget_ref (popsep);
  gtk_widget_show (popsep);
  gtk_container_add (GTK_CONTAINER (folder_popup), popsep);

  new_folder1 = gtk_menu_item_new_with_label (_("New Folder..."));
  gtk_widget_ref (new_folder1);
  gtk_object_set_data_full (GTK_OBJECT (folder_popup), "new_folder1", new_folder1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (new_folder1);
  gtk_container_add (GTK_CONTAINER (folder_popup), new_folder1);

  delete_folder1 = gtk_menu_item_new_with_label (_("Delete Folder"));
  gtk_widget_ref (delete_folder1);
  gtk_object_set_data_full (GTK_OBJECT (folder_popup), "delete_folder1", delete_folder1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (delete_folder1);
  gtk_container_add (GTK_CONTAINER (folder_popup), delete_folder1);
	gtk_widget_set_sensitive (delete_folder1, FALSE);

  return folder_popup;
}

GtkWidget* create_yesno (char *question, char *explanation, GtkSignalFunc func, gpointer data) {
  GtkWidget *yesno;
  GtkWidget *dialog_vbox1;
  GtkWidget *frame1;
  GtkWidget *vbox1;
  GtkWidget *quest;
  GtkWidget *hseparator1;
  GtkWidget *exp;
  GtkWidget *dialog_action_area1;
  GtkWidget *hbox1;
  GtkWidget *ok_button;
  GtkWidget *cancel_button;

  yesno = gtk_dialog_new ();
  gtk_widget_set_name (yesno, "yesno");
  gtk_object_set_data (GTK_OBJECT (yesno), "yesno", yesno);
  gtk_window_set_title (GTK_WINDOW (yesno), _("TradeClient: Critical Question"));
  gtk_window_set_policy (GTK_WINDOW (yesno), TRUE, TRUE, FALSE);
	gtk_window_set_modal (GTK_WINDOW (yesno), TRUE);
	gtk_widget_set_uposition (yesno, 260, 245);

  dialog_vbox1 = GTK_DIALOG (yesno)->vbox;
  gtk_widget_set_name (dialog_vbox1, "dialog_vbox1");
  gtk_object_set_data (GTK_OBJECT (yesno), "dialog_vbox1", dialog_vbox1);
  gtk_widget_show (dialog_vbox1);

  frame1 = gtk_frame_new (_("Please Answer Yes or No"));
  gtk_widget_set_name (frame1, "frame1");
  gtk_widget_ref (frame1);
  gtk_object_set_data_full (GTK_OBJECT (yesno), "frame1", frame1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), frame1, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame1), 2);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox1, "vbox1");
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (yesno), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (frame1), vbox1);
  gtk_container_set_border_width (GTK_CONTAINER (vbox1), 2);

  quest = gtk_label_new (question);
  gtk_widget_set_name (quest, "quest");
	gtk_label_set_line_wrap (GTK_LABEL (quest), TRUE);
  gtk_widget_ref (quest);
  gtk_object_set_data_full (GTK_OBJECT (yesno), "quest", quest,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (quest);
  gtk_box_pack_start (GTK_BOX (vbox1), quest, FALSE, FALSE, 0);

  hseparator1 = gtk_hseparator_new ();
  gtk_widget_set_name (hseparator1, "hseparator1");
  gtk_widget_ref (hseparator1);
  gtk_object_set_data_full (GTK_OBJECT (yesno), "hseparator1", hseparator1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator1);
  gtk_box_pack_start (GTK_BOX (vbox1), hseparator1, FALSE, TRUE, 0);

  exp = gtk_label_new (explanation);
	gtk_label_set_line_wrap (GTK_LABEL (exp), TRUE);
	
  gtk_widget_set_name (exp, "exp");
  gtk_widget_ref (exp);
  gtk_object_set_data_full (GTK_OBJECT (yesno), "exp", exp,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (exp);
  gtk_box_pack_start (GTK_BOX (vbox1), exp, FALSE, FALSE, 0);

  dialog_action_area1 = GTK_DIALOG (yesno)->action_area;
  gtk_widget_set_name (dialog_action_area1, "dialog_action_area1");
  gtk_object_set_data (GTK_OBJECT (yesno), "dialog_action_area1", dialog_action_area1);
  gtk_widget_show (dialog_action_area1);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area1), 10);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox1, "hbox1");
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT (yesno), "hbox1", hbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (dialog_action_area1), hbox1, TRUE, TRUE, 0);

  ok_button = gtk_button_new_with_label (_("Yes"));
  gtk_widget_set_name (ok_button, "ok_button");
  gtk_widget_ref (ok_button);
  gtk_object_set_data_full (GTK_OBJECT (yesno), "ok_button", ok_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ok_button);
  gtk_box_pack_start (GTK_BOX (hbox1), ok_button, TRUE, TRUE, 0);

  cancel_button = gtk_button_new_with_label (_("No"));
  gtk_widget_set_name (cancel_button, "cancel_button");
  gtk_widget_ref (cancel_button);
  gtk_object_set_data_full (GTK_OBJECT (yesno), "cancel_button", cancel_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cancel_button);
  gtk_box_pack_start (GTK_BOX (hbox1), cancel_button, TRUE, TRUE, 0);

  GTK_WIDGET_SET_FLAGS (cancel_button, GTK_CAN_DEFAULT);
  gtk_widget_grab_focus (cancel_button);
  gtk_widget_grab_default (cancel_button);

	
	gtk_signal_connect (GTK_OBJECT (ok_button), "clicked", func, data);
	gtk_signal_connect (GTK_OBJECT (cancel_button), "clicked",
											GTK_SIGNAL_FUNC (destroy_yesno), NULL);
	gtk_signal_connect (GTK_OBJECT (yesno), "delete_event",
											GTK_SIGNAL_FUNC (destroy_yesno), NULL);
  return yesno;
}

void destroy_yesno (GtkWidget *widget, gpointer data) {
	GtkWidget *window=lookup_widget (widget, "yesno");
	gtk_widget_destroy (window);
}

GtkWidget* create_doc_source (void) {
  GtkWidget *doc_source;
  GtkWidget *dialog_vbox1;
  GtkWidget *frame1;
  GtkWidget *scrolledwindow1;
  GtkWidget *source_text;
  GtkWidget *dialog_action_area1;
  GtkWidget *close_button;

  doc_source = gtk_dialog_new ();
  gtk_widget_set_name (doc_source, "doc_source");
  gtk_object_set_data (GTK_OBJECT (doc_source), "doc_source", doc_source);
  gtk_window_set_title (GTK_WINDOW (doc_source), "Document Source");
  gtk_window_set_policy (GTK_WINDOW (doc_source), TRUE, TRUE, FALSE);
	gtk_widget_set_usize (doc_source, 550, 375);

  dialog_vbox1 = GTK_DIALOG (doc_source)->vbox;
  gtk_widget_set_name (dialog_vbox1, "dialog_vbox1");
  gtk_object_set_data (GTK_OBJECT (doc_source), "dialog_vbox1", dialog_vbox1);
  gtk_widget_show (dialog_vbox1);

  frame1 = gtk_frame_new (NULL);
  gtk_widget_set_name (frame1, "frame1");
  gtk_widget_ref (frame1);
  gtk_object_set_data_full (GTK_OBJECT (doc_source), "frame1", frame1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), frame1, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame1), 2);
  gtk_frame_set_shadow_type (GTK_FRAME (frame1), GTK_SHADOW_ETCHED_OUT);

  scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_set_name (scrolledwindow1, "scrolledwindow1");
  gtk_widget_ref (scrolledwindow1);
  gtk_object_set_data_full (GTK_OBJECT (doc_source), "scrolledwindow1", scrolledwindow1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow1);
  gtk_container_add (GTK_CONTAINER (frame1), scrolledwindow1);
  gtk_container_set_border_width (GTK_CONTAINER (scrolledwindow1), 2);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  source_text = gtk_text_new (NULL, NULL);
  gtk_widget_set_name (source_text, "source_text");
  gtk_widget_ref (source_text);
  gtk_object_set_data_full (GTK_OBJECT (doc_source), "source_text", source_text,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (source_text);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), source_text);

  dialog_action_area1 = GTK_DIALOG (doc_source)->action_area;
  gtk_widget_set_name (dialog_action_area1, "dialog_action_area1");
  gtk_object_set_data (GTK_OBJECT (doc_source), "dialog_action_area1", dialog_action_area1);
  gtk_widget_show (dialog_action_area1);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area1), 10);

  close_button = gtk_button_new_with_label (_("Close"));
  gtk_widget_set_name (close_button, "close_button");
  gtk_widget_ref (close_button);
  gtk_object_set_data_full (GTK_OBJECT (doc_source), "close_button", close_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (close_button);
  gtk_box_pack_start (GTK_BOX (dialog_action_area1), close_button, TRUE, TRUE, 0);
  GTK_WIDGET_SET_FLAGS (close_button, GTK_CAN_DEFAULT);

  gtk_widget_grab_focus (close_button);
  gtk_widget_grab_default (close_button);
  return doc_source;
}

void create_docsource_stream (char *stream) {
	GtkWidget *widget=create_doc_source ();
	gtk_signal_connect (GTK_OBJECT (widget), "delete_event",
	                    GTK_SIGNAL_FUNC (docsource_destroy), NULL);
	gtk_signal_connect (GTK_OBJECT (lookup_widget (widget, "close_button")), "clicked",
	                    GTK_SIGNAL_FUNC (docsource_destroy), NULL);
	gtk_text_insert (GTK_TEXT (lookup_widget (widget, "source_text")), NULL, NULL, NULL, stream, -1);
	free (stream);
	gtk_widget_show (widget);
}

GtkWidget* create_mime_popup (void) {
  GtkWidget *mime_popup;
  GtkAccelGroup *mime_popup_accels;
  GtkWidget *menuitem1;
  GtkWidget *menuitem2;
  GtkWidget *menuitem3;
  GtkWidget *mimetitle, *mimesep;

  mime_popup = gtk_menu_new ();
  gtk_widget_set_name (mime_popup, "mime_popup");
  gtk_object_set_data (GTK_OBJECT (mime_popup), "mime_popup", mime_popup);
  mime_popup_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (mime_popup));

  mimetitle = gtk_menu_item_new_with_label (_("MIME Actions"));
  gtk_widget_set_name (mimetitle, "mimetitle");
  gtk_widget_ref (mimetitle);
  gtk_object_set_data_full (GTK_OBJECT (mime_popup), "mimetitle", mimetitle,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mimetitle);
  gtk_container_add (GTK_CONTAINER (mime_popup), mimetitle);

  mimesep = gtk_menu_item_new();
  gtk_widget_set_name (mimesep, "mimesep");
  gtk_widget_ref (mimesep);
  gtk_object_set_data_full (GTK_OBJECT (mime_popup), "mimesep", mimesep,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mimesep);
  gtk_container_add (GTK_CONTAINER (mime_popup), mimesep);

  menuitem1 = gtk_menu_item_new_with_label (_("Save Attachment to Disk"));
  gtk_widget_set_name (menuitem1, "menuitem1");
  gtk_widget_ref (menuitem1);
  gtk_object_set_data_full (GTK_OBJECT (mime_popup), "menuitem1", menuitem1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menuitem1);
  gtk_container_add (GTK_CONTAINER (mime_popup), menuitem1);

  menuitem2 = gtk_menu_item_new_with_label (_("View"));
  gtk_widget_set_name (menuitem2, "menuitem2");
  gtk_widget_ref (menuitem2);
  gtk_object_set_data_full (GTK_OBJECT (mime_popup), "menuitem2", menuitem2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menuitem2);
  gtk_container_add (GTK_CONTAINER (mime_popup), menuitem2);

  menuitem2 = gtk_menu_item_new_with_label (_("View Source"));
  gtk_widget_set_name (menuitem2, "menuitem4");
  gtk_widget_ref (menuitem2);
  gtk_object_set_data_full (GTK_OBJECT (mime_popup), "menuitem4", menuitem2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menuitem2);
  gtk_container_add (GTK_CONTAINER (mime_popup), menuitem2);

  menuitem3 = gtk_menu_item_new_with_label (_("Open With..."));
  gtk_widget_set_name (menuitem3, "menuitem3");
  gtk_widget_ref (menuitem3);
  gtk_object_set_data_full (GTK_OBJECT (mime_popup), "menuitem3", menuitem3,
                            (GtkDestroyNotify) gtk_widget_unref);
#if 0
  gtk_widget_show (menuitem3);
  gtk_container_add (GTK_CONTAINER (mime_popup), menuitem3);
#endif

  return mime_popup;
}

GtkWidget *mime_popup_new (Attachment *att) {
	GtkWidget *popup=create_mime_popup ();
	if (GTK_IS_WIDGET (tm_globs->mime_popup))
		gtk_widget_destroy (tm_globs->mime_popup);
	tm_globs->mime_popup=popup;
	gtk_signal_connect (GTK_OBJECT (lookup_widget (popup, "menuitem1")), "activate",
	                    GTK_SIGNAL_FUNC (attachment_save), (gpointer)att);
	gtk_signal_connect (GTK_OBJECT (lookup_widget (popup, "menuitem2")), "activate",
	                    GTK_SIGNAL_FUNC (attachment_view), (gpointer)att);
	gtk_signal_connect (GTK_OBJECT (lookup_widget (popup, "menuitem3")), "activate",
	                    GTK_SIGNAL_FUNC (attachment_open_with), (gpointer)att);
	gtk_signal_connect (GTK_OBJECT (lookup_widget (popup, "menuitem4")), "activate",
	                    GTK_SIGNAL_FUNC (attachment_view_source), (gpointer)att);
	return popup;
}

GtkWidget* create_mime_unknown_window (void) {
  GtkWidget *mime_unknown_window;
  GtkWidget *dialog_vbox1;
  GtkWidget *frame1;
  GtkWidget *vbox1;
  GtkWidget *label1;
  GtkWidget *hseparator1;
  GtkWidget *hbox1;
  GSList *action_group = NULL;
  GtkWidget *rs_radio;
  GtkWidget *label2;
  GtkWidget *hbox2;
  GtkWidget *ri_radio;
  GtkWidget *label3;
  GtkWidget *hbox3;
  GtkWidget *re_radio;
  GtkWidget *label4;
  GtkWidget *hbox5;
  GtkWidget *handler;
  GtkWidget *browse;
  GtkWidget *hbox4;
  GtkWidget *store_mime;
  GtkWidget *label5;
  GtkWidget *dialog_action_area1;
  GtkWidget *ok_button;
  GtkWidget *cancel_button;
  GtkTooltips *tooltips;

  tooltips = gtk_tooltips_new ();

  mime_unknown_window = gtk_dialog_new ();
  gtk_widget_set_name (mime_unknown_window, "mime_unknown_window");
  gtk_object_set_data (GTK_OBJECT (mime_unknown_window), "mime_unknown_window", mime_unknown_window);
  gtk_window_set_title (GTK_WINDOW (mime_unknown_window), _("Unknown MIME Type"));
	gtk_window_set_modal (GTK_WINDOW (mime_unknown_window), TRUE);
  gtk_window_set_policy (GTK_WINDOW (mime_unknown_window), TRUE, TRUE, TRUE);

  dialog_vbox1 = GTK_DIALOG (mime_unknown_window)->vbox;
  gtk_widget_set_name (dialog_vbox1, "dialog_vbox1");
  gtk_object_set_data (GTK_OBJECT (mime_unknown_window), "dialog_vbox1", dialog_vbox1);
  gtk_widget_show (dialog_vbox1);

  frame1 = gtk_frame_new (NULL);
  gtk_widget_set_name (frame1, "frame1");
  gtk_widget_ref (frame1);
  gtk_object_set_data_full (GTK_OBJECT (mime_unknown_window), "frame1", frame1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), frame1, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame1), 2);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox1, "vbox1");
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (mime_unknown_window), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (frame1), vbox1);
  gtk_container_set_border_width (GTK_CONTAINER (vbox1), 2);

  label1 = gtk_label_new (_("A Definition for this MIME Type has not been\ndefined yet. What would you like to do with this\nAttachment?"));
  gtk_widget_set_name (label1, "label1");
  gtk_widget_ref (label1);
  gtk_object_set_data_full (GTK_OBJECT (mime_unknown_window), "label1", label1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label1);
  gtk_box_pack_start (GTK_BOX (vbox1), label1, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label1), GTK_JUSTIFY_LEFT);

  hseparator1 = gtk_hseparator_new ();
  gtk_widget_set_name (hseparator1, "hseparator1");
  gtk_widget_ref (hseparator1);
  gtk_object_set_data_full (GTK_OBJECT (mime_unknown_window), "hseparator1", hseparator1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator1);
  gtk_box_pack_start (GTK_BOX (vbox1), hseparator1, FALSE, TRUE, 0);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox1, "hbox1");
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT (mime_unknown_window), "hbox1", hbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, FALSE, FALSE, 0);

  rs_radio = gtk_radio_button_new_with_label (action_group, "");
  action_group = gtk_radio_button_group (GTK_RADIO_BUTTON (rs_radio));
  gtk_widget_set_name (rs_radio, "rs_radio");
  gtk_widget_ref (rs_radio);
  gtk_object_set_data_full (GTK_OBJECT (mime_unknown_window), "rs_radio", rs_radio,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (rs_radio);
  gtk_box_pack_start (GTK_BOX (hbox1), rs_radio, FALSE, FALSE, 0);

  label2 = gtk_label_new (_("Save the Attachment to Disk"));
  gtk_widget_set_name (label2, "label2");
  gtk_widget_ref (label2);
  gtk_object_set_data_full (GTK_OBJECT (mime_unknown_window), "label2", label2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label2);
  gtk_box_pack_start (GTK_BOX (hbox1), label2, FALSE, FALSE, 0);

  hbox2 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox2, "hbox2");
  gtk_widget_ref (hbox2);
  gtk_object_set_data_full (GTK_OBJECT (mime_unknown_window), "hbox2", hbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox2);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox2, FALSE, TRUE, 0);

  ri_radio = gtk_radio_button_new_with_label (action_group, "");
  action_group = gtk_radio_button_group (GTK_RADIO_BUTTON (ri_radio));
  gtk_widget_set_name (ri_radio, "ri_radio");
  gtk_widget_ref (ri_radio);
  gtk_object_set_data_full (GTK_OBJECT (mime_unknown_window), "ri_radio", ri_radio,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ri_radio);
  gtk_box_pack_start (GTK_BOX (hbox2), ri_radio, FALSE, FALSE, 0);

  label3 = gtk_label_new (_("View the Attachment Internally"));
  gtk_widget_set_name (label3, "label3");
  gtk_widget_ref (label3);
  gtk_object_set_data_full (GTK_OBJECT (mime_unknown_window), "label3", label3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label3);
  gtk_box_pack_start (GTK_BOX (hbox2), label3, FALSE, FALSE, 0);

  hbox3 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox3, "hbox3");
  gtk_widget_ref (hbox3);
  gtk_object_set_data_full (GTK_OBJECT (mime_unknown_window), "hbox3", hbox3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox3);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox3, FALSE, TRUE, 0);

  re_radio = gtk_radio_button_new_with_label (action_group, "");
  action_group = gtk_radio_button_group (GTK_RADIO_BUTTON (re_radio));
  gtk_widget_set_name (re_radio, "re_radio");
  gtk_widget_ref (re_radio);
  gtk_object_set_data_full (GTK_OBJECT (mime_unknown_window), "re_radio", re_radio,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (re_radio);
  gtk_box_pack_start (GTK_BOX (hbox3), re_radio, FALSE, FALSE, 0);

  label4 = gtk_label_new (_("View with External Program"));
  gtk_widget_set_name (label4, "label4");
  gtk_widget_ref (label4);
  gtk_object_set_data_full (GTK_OBJECT (mime_unknown_window), "label4", label4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label4);
  gtk_box_pack_start (GTK_BOX (hbox3), label4, FALSE, FALSE, 0);

  hbox5 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox5, "hbox5");
  gtk_widget_ref (hbox5);
  gtk_object_set_data_full (GTK_OBJECT (mime_unknown_window), "hbox5", hbox5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox5);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox5, TRUE, TRUE, 0);

  handler = gtk_entry_new ();
	
  gtk_widget_set_name (handler, "handler");
  gtk_widget_ref (handler);
  gtk_object_set_data_full (GTK_OBJECT (mime_unknown_window), "handler", handler,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (handler);
  gtk_box_pack_start (GTK_BOX (hbox5), handler, TRUE, TRUE, 0);
	gtk_tooltips_set_tip (tooltips, handler, _("Enter the absolute path of the program you want to load the attachment with.  Use a %f where you want the filename passed to the program"), NULL);

  browse = gtk_button_new_with_label (_("Browse"));
  gtk_widget_set_name (browse, "browse");
  gtk_widget_ref (browse);
  gtk_object_set_data_full (GTK_OBJECT (mime_unknown_window), "browse", browse,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (browse);
  gtk_box_pack_start (GTK_BOX (hbox5), browse, TRUE, TRUE, 0);

  hbox4 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox4, "hbox4");
  gtk_widget_ref (hbox4);
  gtk_object_set_data_full (GTK_OBJECT (mime_unknown_window), "hbox4", hbox4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox4);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox4, TRUE, TRUE, 0);

  store_mime = gtk_check_button_new_with_label ("");
  gtk_widget_set_name (store_mime, "store_mime");
  gtk_widget_ref (store_mime);
  gtk_object_set_data_full (GTK_OBJECT (mime_unknown_window), "store_mime", store_mime,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (store_mime);
  gtk_box_pack_start (GTK_BOX (hbox4), store_mime, FALSE, FALSE, 0);

  label5 = gtk_label_new (_("Always use this action for this MIME Type"));
  gtk_widget_set_name (label5, "label5");
  gtk_widget_ref (label5);
  gtk_object_set_data_full (GTK_OBJECT (mime_unknown_window), "label5", label5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label5);
  gtk_box_pack_start (GTK_BOX (hbox4), label5, FALSE, FALSE, 0);

  dialog_action_area1 = GTK_DIALOG (mime_unknown_window)->action_area;
  gtk_widget_set_name (dialog_action_area1, "dialog_action_area1");
  gtk_object_set_data (GTK_OBJECT (mime_unknown_window), "dialog_action_area1", dialog_action_area1);
  gtk_widget_show (dialog_action_area1);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area1), 10);

  ok_button = gtk_button_new_with_label (_("Ok"));
  gtk_widget_set_name (ok_button, "ok_button");
  gtk_widget_ref (ok_button);
  gtk_object_set_data_full (GTK_OBJECT (mime_unknown_window), "ok_button", ok_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ok_button);
  gtk_box_pack_start (GTK_BOX (dialog_action_area1), ok_button, TRUE, TRUE, 0);
  GTK_WIDGET_SET_FLAGS (ok_button, GTK_CAN_DEFAULT);

  cancel_button = gtk_button_new_with_label (_("Cancel"));
  gtk_widget_set_name (cancel_button, "cancel_button");
  gtk_widget_ref (cancel_button);
  gtk_object_set_data_full (GTK_OBJECT (mime_unknown_window), "cancel_button", cancel_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cancel_button);
  gtk_box_pack_start (GTK_BOX (dialog_action_area1), cancel_button, TRUE, TRUE, 0);

  gtk_widget_grab_focus (ok_button);
  gtk_widget_grab_default (ok_button);
  return mime_unknown_window;
}

void mime_attachment_unknown (char *data) {
	GtkWidget *widget=create_mime_unknown_window ();
	clip_handle_editable (lw (widget, "handler"));
	gtk_signal_connect (GTK_OBJECT (widget), "delete_event",
	                    GTK_SIGNAL_FUNC (gtk_widget_destroy), widget);
	gtk_signal_connect (GTK_OBJECT (lookup_widget (widget, "cancel_button")), "clicked",
	                    GTK_SIGNAL_FUNC (mime_unknown_cancel), (gpointer)data);
	gtk_signal_connect (GTK_OBJECT (lookup_widget (widget, "ok_button")), "clicked",
	                    GTK_SIGNAL_FUNC (mime_unknown_accept), (gpointer)data);
	gtk_signal_connect (GTK_OBJECT (lookup_widget (widget, "browse")),
			"clicked", GTK_SIGNAL_FUNC (browse_handler), NULL);
	gtk_widget_show (widget);
}

void mime_unknown_accept (GtkWidget *widget, gpointer data) {
	char *message=(char *)data;
	int hsize=message_hsize (message);
	char *head=(char *)calloc (hsize+2, sizeof(char));
	char *type=NULL;
	char *handle=NULL;
	char *ext=NULL;
	char *filename=NULL;
	Header_Info *hinfo=NULL;

	memmove (head, message, hsize);
	hinfo=parse_header (head);
	free (head);
	filename=get_filename (hinfo->content_d);
	if (filename) {
		ext=strrchr (filename, '.');
		if(ext) ext++;
	}

	type=cut_string (hinfo->content_type, ';', 1, 1);
	if (type[0]=='\0') {
		free (type);
		type=strdup (hinfo->content_type);
	}

	if (GTK_TOGGLE_BUTTON (lookup_widget (widget, "ri_radio"))->active) {
		handle=strdup ("Internal");
		create_docsource_stream (message);
	}
	if (GTK_TOGGLE_BUTTON (lookup_widget (widget, "re_radio"))->active) {
		handle=strdup (gtk_entry_get_text (GTK_ENTRY (lookup_widget (widget, "handler"))));
	}
	if (GTK_TOGGLE_BUTTON (lookup_widget (widget, "rs_radio"))->active) {
		handle=strdup ("Save");
		message_save_body (NULL, message);
	}

	mime_type_add (type, handle, ext);

	if (GTK_TOGGLE_BUTTON (lookup_widget (widget, "re_radio"))->active) {
		if (strlen(handle))
			message_use_ext_prog(NULL, strdup(message));
	}

	if (!GTK_TOGGLE_BUTTON (lookup_widget (widget, "store_mime"))->active) {
		mime_type_delete (type);
	} 
	mime_unknown_cancel (widget, NULL);
	destroy_hinfo (hinfo);
	if (filename) free (filename);
	if (type) free (type);
}

void mime_unknown_cancel (GtkWidget *widget, gpointer data) {
	if (data) free (data);
	gtk_widget_destroy (lookup_widget (widget, "mime_unknown_window"));
}

GtkWidget* create_request_dialog (void) {
  GtkWidget *request_dialog;
  GtkWidget *dialog_vbox2;
  GtkWidget *frame2;
  GtkWidget *table2;
  GtkWidget *start;
  GtkWidget *end;
  GtkWidget *location;
  GtkWidget *scrolledwindow1;
  GtkWidget *Summary;
  GtkWidget *label8;
  GtkWidget *label9;
  GtkWidget *label10;
  GtkWidget *label14;
  GtkWidget *label15;
  GtkWidget *conflict;
  GtkWidget *dialog_action_area2;
  GtkWidget *ok_button;
  GtkWidget *cancel_button;
  GtkWidget *button1;

  request_dialog = gtk_dialog_new ();
  gtk_widget_set_name (request_dialog, "request_dialog");
  gtk_object_set_data (GTK_OBJECT (request_dialog), "request_dialog", request_dialog);
  gtk_window_set_title (GTK_WINDOW (request_dialog), _("Event Request"));
  gtk_window_set_policy (GTK_WINDOW (request_dialog), TRUE, TRUE, FALSE);

  dialog_vbox2 = GTK_DIALOG (request_dialog)->vbox;
  gtk_widget_set_name (dialog_vbox2, "dialog_vbox2");
  gtk_object_set_data (GTK_OBJECT (request_dialog), "dialog_vbox2", dialog_vbox2);
  gtk_widget_show (dialog_vbox2);

  frame2 = gtk_frame_new (_("Calendar Event Request"));
  gtk_widget_set_name (frame2, "frame2");
  gtk_widget_ref (frame2);
  gtk_object_set_data_full (GTK_OBJECT (request_dialog), "frame2", frame2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame2);
  gtk_box_pack_start (GTK_BOX (dialog_vbox2), frame2, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame2), 2);

  table2 = gtk_table_new (5, 2, FALSE);
  gtk_widget_set_name (table2, "table2");
  gtk_widget_ref (table2);
  gtk_object_set_data_full (GTK_OBJECT (request_dialog), "table2", table2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table2);
  gtk_container_add (GTK_CONTAINER (frame2), table2);

  start = gtk_label_new (_("start"));
  gtk_widget_set_name (start, "start");
  gtk_widget_ref (start);
  gtk_object_set_data_full (GTK_OBJECT (request_dialog), "start", start,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (start);
  gtk_table_attach (GTK_TABLE (table2), start, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  end = gtk_label_new (_("end"));
  gtk_widget_set_name (end, "end");
  gtk_widget_ref (end);
  gtk_object_set_data_full (GTK_OBJECT (request_dialog), "end", end,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (end);
  gtk_table_attach (GTK_TABLE (table2), end, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  location = gtk_label_new (_("location"));
  gtk_widget_set_name (location, "location");
  gtk_widget_ref (location);
  gtk_object_set_data_full (GTK_OBJECT (request_dialog), "location", location,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (location);
  gtk_table_attach (GTK_TABLE (table2), location, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_set_name (scrolledwindow1, "scrolledwindow1");
  gtk_widget_ref (scrolledwindow1);
  gtk_object_set_data_full (GTK_OBJECT (request_dialog), "scrolledwindow1", scrolledwindow1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow1);
  gtk_table_attach (GTK_TABLE (table2), scrolledwindow1, 1, 2, 4, 5,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  Summary = gtk_text_new (NULL, NULL);
  gtk_widget_set_name (Summary, "Summary");
  gtk_widget_ref (Summary);
  gtk_object_set_data_full (GTK_OBJECT (request_dialog), "Summary", Summary,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (Summary);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), Summary);

  label8 = gtk_label_new (_("Location:"));
  gtk_widget_set_name (label8, "label8");
  gtk_widget_ref (label8);
  gtk_object_set_data_full (GTK_OBJECT (request_dialog), "label8", label8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label8);
  gtk_table_attach (GTK_TABLE (table2), label8, 0, 1, 0, 1,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  label9 = gtk_label_new (_("Start Time:"));
  gtk_widget_set_name (label9, "label9");
  gtk_widget_ref (label9);
  gtk_object_set_data_full (GTK_OBJECT (request_dialog), "label9", label9,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label9);
  gtk_table_attach (GTK_TABLE (table2), label9, 0, 1, 1, 2,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  label10 = gtk_label_new (_("End Time:"));
  gtk_widget_set_name (label10, "label10");
  gtk_widget_ref (label10);
  gtk_object_set_data_full (GTK_OBJECT (request_dialog), "label10", label10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label10);
  gtk_table_attach (GTK_TABLE (table2), label10, 0, 1, 2, 3,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  label14 = gtk_label_new (_("Summary"));
  gtk_widget_set_name (label14, "label14");
  gtk_widget_ref (label14);
  gtk_object_set_data_full (GTK_OBJECT (request_dialog), "label14", label14,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label14);
  gtk_table_attach (GTK_TABLE (table2), label14, 0, 1, 4, 5,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  label15 = gtk_label_new (_("Conflicts?"));
  gtk_widget_set_name (label15, "label15");
  gtk_widget_ref (label15);
  gtk_object_set_data_full (GTK_OBJECT (request_dialog), "label15", label15,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label15);
  gtk_table_attach (GTK_TABLE (table2), label15, 0, 1, 3, 4,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  conflict = gtk_label_new (_("conflict"));
  gtk_widget_set_name (conflict, "conflict");
  gtk_widget_ref (conflict);
  gtk_object_set_data_full (GTK_OBJECT (request_dialog), "conflict", conflict,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (conflict);
  gtk_table_attach (GTK_TABLE (table2), conflict, 1, 2, 3, 4,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  dialog_action_area2 = GTK_DIALOG (request_dialog)->action_area;
  gtk_widget_set_name (dialog_action_area2, "dialog_action_area2");
  gtk_object_set_data (GTK_OBJECT (request_dialog), "dialog_action_area2", dialog_action_area2);
  gtk_widget_show (dialog_action_area2);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area2), 10);

  ok_button = gtk_button_new_with_label (_("Accept"));
  gtk_widget_set_name (ok_button, "ok_button");
  gtk_widget_ref (ok_button);
  gtk_object_set_data_full (GTK_OBJECT (request_dialog), "ok_button", ok_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ok_button);
  gtk_box_pack_start (GTK_BOX (dialog_action_area2), ok_button, TRUE, TRUE, 0);
  GTK_WIDGET_UNSET_FLAGS (ok_button, GTK_CAN_FOCUS);
  GTK_WIDGET_SET_FLAGS (ok_button, GTK_CAN_DEFAULT);

  cancel_button = gtk_button_new_with_label (_("Decline"));
  gtk_widget_set_name (cancel_button, "cancel_button");
  gtk_widget_ref (cancel_button);
  gtk_object_set_data_full (GTK_OBJECT (request_dialog), "cancel_button", cancel_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cancel_button);
  gtk_box_pack_start (GTK_BOX (dialog_action_area2), cancel_button, TRUE, TRUE, 0);

  button1 = gtk_button_new_with_label (_("Do Nothing"));
  gtk_widget_set_name (button1, "button1");
  gtk_widget_ref (button1);
  gtk_object_set_data_full (GTK_OBJECT (request_dialog), "button1", button1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button1);
  gtk_box_pack_start (GTK_BOX (dialog_action_area2), button1, FALSE, FALSE, 0);

  gtk_widget_grab_focus (ok_button);
  gtk_widget_grab_default (ok_button);
  return request_dialog;
}


GtkWidget* create_return_receipt (void) {
  GtkWidget *return_receipt;
  GtkWidget *dialog_vbox1;
  GtkWidget *frame1;
  GtkWidget *vbox1;
  GtkWidget *label1;
  GtkWidget *hseparator1;
  GtkWidget *table1;
  GtkWidget *label3;
  GtkWidget *sender;
  GtkWidget *label4;
  GtkWidget *combo1;
  GList *combo1_items = NULL;
  GtkWidget *account;
  GtkWidget *label5;
  GtkWidget *subject;
  GtkWidget *dialog_action_area1;
  GtkWidget *ok_button;
  GtkWidget *cancel_button;

  return_receipt = gtk_dialog_new ();
  gtk_widget_set_name (return_receipt, "return_receipt");
  gtk_object_set_data (GTK_OBJECT (return_receipt), "return_receipt", return_receipt);
  gtk_window_set_title (GTK_WINDOW (return_receipt), "Return Receipt Confirmation");
  gtk_window_set_policy (GTK_WINDOW (return_receipt), TRUE, TRUE, TRUE);

  dialog_vbox1 = GTK_DIALOG (return_receipt)->vbox;
  gtk_widget_set_name (dialog_vbox1, "dialog_vbox1");
  gtk_object_set_data (GTK_OBJECT (return_receipt), "dialog_vbox1", dialog_vbox1);
  gtk_widget_show (dialog_vbox1);

  frame1 = gtk_frame_new (NULL);
  gtk_widget_set_name (frame1, "frame1");
  gtk_widget_ref (frame1);
  gtk_object_set_data_full (GTK_OBJECT (return_receipt), "frame1", frame1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), frame1, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame1), 2);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox1, "vbox1");
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (return_receipt), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (frame1), vbox1);
  gtk_container_set_border_width (GTK_CONTAINER (vbox1), 2);

  label1 = gtk_label_new ("The sender of this message has requested a return\nreceipt.  Would you like to send one now?");
  gtk_widget_set_name (label1, "label1");
  gtk_widget_ref (label1);
  gtk_object_set_data_full (GTK_OBJECT (return_receipt), "label1", label1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label1);
  gtk_box_pack_start (GTK_BOX (vbox1), label1, FALSE, FALSE, 0);

  hseparator1 = gtk_hseparator_new ();
  gtk_widget_set_name (hseparator1, "hseparator1");
  gtk_widget_ref (hseparator1);
  gtk_object_set_data_full (GTK_OBJECT (return_receipt), "hseparator1", hseparator1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator1);
  gtk_box_pack_start (GTK_BOX (vbox1), hseparator1, FALSE, TRUE, 2);

  table1 = gtk_table_new (3, 2, FALSE);
  gtk_widget_set_name (table1, "table1");
  gtk_widget_ref (table1);
  gtk_object_set_data_full (GTK_OBJECT (return_receipt), "table1", table1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table1);
  gtk_box_pack_start (GTK_BOX (vbox1), table1, TRUE, TRUE, 0);

  label3 = gtk_label_new ("Sender:");
  gtk_widget_set_name (label3, "label3");
  gtk_widget_ref (label3);
  gtk_object_set_data_full (GTK_OBJECT (return_receipt), "label3", label3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label3);
  gtk_table_attach (GTK_TABLE (table1), label3, 0, 1, 0, 1,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  sender = gtk_entry_new ();
  gtk_widget_set_name (sender, "sender");
  gtk_widget_ref (sender);
  gtk_object_set_data_full (GTK_OBJECT (return_receipt), "sender", sender,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (sender);
  gtk_table_attach (GTK_TABLE (table1), sender, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_entry_set_editable (GTK_ENTRY (sender), FALSE);

  label4 = gtk_label_new ("Account to send receipt:");
  gtk_widget_set_name (label4, "label4");
  gtk_widget_ref (label4);
  gtk_object_set_data_full (GTK_OBJECT (return_receipt), "label4", label4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label4);
  gtk_table_attach (GTK_TABLE (table1), label4, 0, 1, 2, 3,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  combo1 = gtk_combo_new ();
  gtk_widget_set_name (combo1, "combo1");
  gtk_widget_ref (combo1);
  gtk_object_set_data_full (GTK_OBJECT (return_receipt), "combo1", combo1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (combo1);
  gtk_table_attach (GTK_TABLE (table1), combo1, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  combo1_items = g_list_append (combo1_items, "Account1");
  gtk_combo_set_popdown_strings (GTK_COMBO (combo1), combo1_items);
  g_list_free (combo1_items);

  account = GTK_COMBO (combo1)->entry;
  gtk_widget_set_name (account, "account");
  gtk_widget_ref (account);
  gtk_object_set_data_full (GTK_OBJECT (return_receipt), "account", account,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (account);
  gtk_entry_set_text (GTK_ENTRY (account), "Account1");

  label5 = gtk_label_new ("Subject:");
  gtk_widget_set_name (label5, "label5");
  gtk_widget_ref (label5);
  gtk_object_set_data_full (GTK_OBJECT (return_receipt), "label5", label5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label5);
  gtk_table_attach (GTK_TABLE (table1), label5, 0, 1, 1, 2,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  subject = gtk_entry_new ();
  gtk_widget_set_name (subject, "subject");
  gtk_widget_ref (subject);
  gtk_object_set_data_full (GTK_OBJECT (return_receipt), "subject", subject,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (subject);
  gtk_table_attach (GTK_TABLE (table1), subject, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_entry_set_editable (GTK_ENTRY (subject), FALSE);

  dialog_action_area1 = GTK_DIALOG (return_receipt)->action_area;
  gtk_widget_set_name (dialog_action_area1, "dialog_action_area1");
  gtk_object_set_data (GTK_OBJECT (return_receipt), "dialog_action_area1", dialog_action_area1);
  gtk_widget_show (dialog_action_area1);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area1), 10);

  ok_button = gtk_button_new_with_label ("Accept");
  gtk_widget_set_name (ok_button, "ok_button");
  gtk_widget_ref (ok_button);
  gtk_object_set_data_full (GTK_OBJECT (return_receipt), "ok_button", ok_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ok_button);
  gtk_box_pack_start (GTK_BOX (dialog_action_area1), ok_button, TRUE, TRUE, 0);
  GTK_WIDGET_SET_FLAGS (ok_button, GTK_CAN_DEFAULT);

  cancel_button = gtk_button_new_with_label ("Decline");
  gtk_widget_set_name (cancel_button, "cancel_button");
  gtk_widget_ref (cancel_button);
  gtk_object_set_data_full (GTK_OBJECT (return_receipt), "cancel_button", cancel_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cancel_button);
  gtk_box_pack_start (GTK_BOX (dialog_action_area1), cancel_button, TRUE, TRUE, 0);

  gtk_widget_grab_focus (ok_button);
  gtk_widget_grab_default (ok_button);
  return return_receipt;
}


void return_receipt_accept (GtkWidget *widget, char *message) {
	PopAccount *pop=seek_popaccount (seek_popaccount_by_name (
	                gtk_entry_get_text (GTK_ENTRY (lookup_widget (widget, "account")))));
	char *sender, *replyto=NULL, *org=NULL;
	/*char *sender, *tmp, *full_msg, *replyto=NULL, *org=NULL;*/
	MailMessage *mmessage;		
	char *to=rm_crlf (gtk_entry_get_text (GTK_ENTRY (lookup_widget (widget, "sender"))));
	char *date=generate_timestamp ();
	Llist *list=NULL;
	AFS *afs=NULL;
	char *subject=rm_crlf (gtk_entry_get_text (GTK_ENTRY (lookup_widget (widget, "subject"))));


#if DEBUG > 4
	printf( "to=%s\nsubject=%s\ndate=%s\n", to, subject, date ) ;
#endif

	if (!pop) {
		insert_warning ("Internal Error, restarting the program is suggested\n");
		return;
	}

	if (pop->emailaddr) {
		sender=strdup (pop->emailaddr);
	} else {
		sender=strdup ("Defunct");
	}
	
	if (pop->replyaddr)
		if (pop->replyaddr[0]!='\0')
			replyto=strdup(pop->replyaddr);
	if (tm_globs->replyto && replyto==NULL)
		if (tm_globs->replyto[0]!='\0')
			replyto=strdup(tm_globs->replyto);
		else
			replyto=(char *)calloc(2, sizeof(char));
	else if (!replyto)
		replyto=(char *)calloc(2, sizeof(char));

	if (pop->organization)
		if (pop->organization[0]!='\0')
			org=strdup(pop->organization);
	if (tm_globs->organization && org==NULL)
		if (tm_globs->organization[0]!='\0')
			org=strdup(tm_globs->organization);
		else
			org=(char *)calloc(2, sizeof(char));
	else if (!org)
		org=(char *)calloc(2, sizeof(char));

	if (pop->replyaddr)
		if (pop->replyaddr[0]!='\0')
			replyto=strdup(pop->replyaddr);
	if (tm_globs->replyto && replyto==NULL)
		if (tm_globs->replyto[0]!='\0')
			replyto=strdup(tm_globs->replyto);
		else
			replyto=(char *)calloc(2, sizeof(char));
	else if (!replyto)
		replyto=(char *)calloc(2, sizeof(char));


	afs=(AFS *)calloc (1, sizeof (AFS));
	afs->type=strdup ("text/plain");
	afs->data=strdup( _("Your message (attached) has been received.  This message\ndoes not confirm that the recipient read or understood\nthe contents of your message.  This message is only an\nindication that is has been displayed.") ) ;
	list=llist_append (list, afs);

	afs=(AFS *)calloc (1, sizeof (AFS));
	afs->type=strdup ("message/rfc822");
	afs->data=strdup (message);
	list=llist_append (list, afs);

	/* Notice that we hard code RR's to use the lowest message priority.  Yes,
	 * we really do want to be good netizens.
	 */
	mmessage=new_mime_encode (sender, replyto, org, to, calloc (2, sizeof(char)), 
                    calloc (2, sizeof(char)), subject, date, list, 0, "5 (Lowest)",
                    NULL, NULL, NULL, NULL, NULL ) ;
        new_fork_send_message(pop,mmessage,to);
        if( date ) free( date ) ;
        if( to ) free( to ) ;

// The old code
//	mmessage=mime_encode (sender, replyto, org, to, calloc (2, sizeof(char)), 
//	                 calloc (2, sizeof(char)), subject, date, 
//									 list, 0);
//	full_msg=message_fix_for_send (tmp);
//	free (tmp);
//	free (message);

//	fork_send_message (pop, full_msg, to);
	tm_globs->send_timeout=gtk_timeout_add  (750, (GtkFunction)send_message_timeout, NULL);
	

	gtk_widget_destroy (lookup_widget (widget, "return_receipt"));
}

void return_receipt_decline (GtkWidget *widget, gpointer data) {
	free (data);
	gtk_widget_destroy (lookup_widget (widget, "return_receipt"));
}

void return_receipt (char *sender, char *subject, char *message) {
	char *newSubject ;
	const char rrText[] = "Return Receipt (displayed): " ;


	GtkWidget *widget=create_return_receipt ();
	GList *list=pop_create_glist ();
	gtk_entry_set_text (GTK_ENTRY (lookup_widget (widget, "sender")), sender);
	newSubject = malloc( strlen(subject)+strlen( rrText ) + 1 ) ;
	sprintf( newSubject, "%s%s", rrText, subject ) ;
	gtk_entry_set_text (GTK_ENTRY (lookup_widget (widget, "subject")), newSubject);
  gtk_combo_set_popdown_strings (GTK_COMBO (lookup_widget (widget, "combo1")), 
	                               list);
	gtk_entry_set_text (GTK_ENTRY (lookup_widget (widget, "account")), 
	                    tm_globs->default_account);	
	clip_handle_editable (lw (widget, "sender"));
	clip_handle_editable (lw (widget, "subject"));
	gtk_signal_connect (GTK_OBJECT (widget), "delete_event",
	                    GTK_SIGNAL_FUNC (return_receipt_decline), message);
	gtk_signal_connect (GTK_OBJECT (lookup_widget (widget, "ok_button")), "clicked",
	                    GTK_SIGNAL_FUNC (return_receipt_accept), message);
	gtk_signal_connect (GTK_OBJECT (lookup_widget (widget, "cancel_button")), "clicked",
	                    GTK_SIGNAL_FUNC (return_receipt_decline), message);
	gtk_widget_show (widget);
}

void update_filesel (GtkWidget *widget, char *filename, gpointer data) {
	GtkWidget *handler = lookup_widget (data, "handler");
	char *text;
	text = (char *)calloc (strlen (filename) + 5, sizeof (char));
	sprintf (text, "%s \'%%f\'", filename);
	gtk_entry_set_text (GTK_ENTRY (handler), text);
	if (text) free (text);
	gtk_widget_destroy(widget);
}

void browse_handler (GtkWidget *widget) {
	GtkWidget *filesel;
       
	filesel = file_selector_new (NULL, NULL, GTK_SIGNAL_FUNC(update_filesel), GTK_SIGNAL_FUNC(update_filesel), (gpointer)widget);
	gtk_widget_show (filesel);
}
