/* TradeClient <http://tradeclient.sourceforge.net>
 * $Id: file-selector-window.c,v 1.7 2001/03/20 22:19:33 ttabner Exp $
 *
 * Copyright (C) 1999-2000 Bynari Inc.
 * Copyright (C) 2001 Project TradeClient
 *
 * LGPL
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#include "puma.h"

GdkPixmap *open_pix, *close_pix;
GdkBitmap *open_mask, *close_mask;
char *cwd=NULL;

void set_cwd (char *dir) {
	if (cwd) free (cwd);
	if (dir) {
		cwd=strdup (dir);
	} else {
		cwd=NULL;
	}
}

char *get_cwd () {
	return cwd;
}

GtkWidget* create_file_selector (void) {
  GtkWidget *file_selector;
  GtkWidget *dialog_vbox1;
  GtkWidget *frame1;
  GtkWidget *vbox1;
  GtkWidget *hbox1;
  GtkWidget *fs_homedir ;
  GtkWidget *fs_newdir;
  GtkWidget *fs_deletefile;
  GtkWidget *fs_renamefile;
  GtkWidget *fs_updir;
  GtkWidget *fs_curdir;
  GtkWidget *frame2;
  GtkWidget *hpaned1;
  GtkWidget *scrolledwindow3;
  GtkWidget *viewport1;
  GtkWidget *scrolledwindow5;
  GtkWidget *fs_dirtree;
  GtkWidget *label3;
  GtkWidget *scrolledwindow4;
  GtkWidget *fs_filelist;
  GtkWidget *label2;
  GtkWidget *fs_filename;
  GtkWidget *dialog_action_area1;
  GtkWidget *fs_ok_button;
  GtkWidget *fs_cancel_button;

  file_selector = gtk_dialog_new ();
  gtk_widget_set_name (file_selector, "file_selector");
  gtk_object_set_data (GTK_OBJECT (file_selector), "file_selector", file_selector);
  gtk_window_set_title (GTK_WINDOW (file_selector), _("Select File"));
  gtk_window_set_policy (GTK_WINDOW (file_selector), TRUE, TRUE, TRUE);
	gtk_widget_set_usize (file_selector, 600, 500);
	gtk_window_set_modal (GTK_WINDOW (file_selector), TRUE);
	
  dialog_vbox1 = GTK_DIALOG (file_selector)->vbox;
  gtk_widget_set_name (dialog_vbox1, "dialog_vbox1");
  gtk_object_set_data (GTK_OBJECT (file_selector), "dialog_vbox1", dialog_vbox1);
  gtk_widget_show (dialog_vbox1);

  frame1 = gtk_frame_new (NULL);
  gtk_widget_set_name (frame1, "frame1");
  gtk_widget_ref (frame1);
  gtk_object_set_data_full (GTK_OBJECT (file_selector), "frame1", frame1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), frame1, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame1), 2);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox1, "vbox1");
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (file_selector), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (frame1), vbox1);
  gtk_container_set_border_width (GTK_CONTAINER (vbox1), 2);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox1, "hbox1");
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT (file_selector), "hbox1", hbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox1), 2);

  fs_homedir = gtk_button_new_with_label( _("Home") ) ;
  gtk_widget_set_name( fs_homedir, "fs_homedir" ) ;
  gtk_widget_ref( fs_homedir ) ;
  gtk_object_set_data_full( GTK_OBJECT(file_selector), "fs_homedir", fs_homedir,
			    (GtkDestroyNotify)gtk_widget_unref ) ;
  gtk_widget_show( fs_homedir ) ;
  gtk_box_pack_start( GTK_BOX( hbox1 ), fs_homedir, TRUE, FALSE, 0 ) ;

  fs_newdir = gtk_button_new_with_label (_("Create Directory"));
  gtk_widget_set_name (fs_newdir, "fs_newdir");
  gtk_widget_ref (fs_newdir);
  gtk_object_set_data_full (GTK_OBJECT (file_selector), "fs_newdir", fs_newdir,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fs_newdir);
  gtk_box_pack_start (GTK_BOX (hbox1), fs_newdir, TRUE, FALSE, 0);
//	gtk_widget_set_sensitive (fs_newdir, FALSE);

  fs_deletefile = gtk_button_new_with_label (_("Delete File"));
  gtk_widget_set_name (fs_deletefile, "fs_deletefile");
  gtk_widget_ref (fs_deletefile);
  gtk_object_set_data_full (GTK_OBJECT (file_selector), "fs_deletefile", fs_deletefile,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fs_deletefile);
  gtk_box_pack_start (GTK_BOX (hbox1), fs_deletefile, TRUE, FALSE, 0);
	gtk_widget_set_sensitive (fs_deletefile, FALSE);

  fs_renamefile = gtk_button_new_with_label (_("Rename File"));
  gtk_widget_set_name (fs_renamefile, "fs_renamefile");
  gtk_widget_ref (fs_renamefile);
  gtk_object_set_data_full (GTK_OBJECT (file_selector), "fs_renamefile", fs_renamefile,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fs_renamefile);
  gtk_box_pack_start (GTK_BOX (hbox1), fs_renamefile, TRUE, FALSE, 0);
	gtk_widget_set_sensitive (fs_renamefile, FALSE);

  fs_updir = gtk_button_new_with_label (_("Up Directory"));
  gtk_widget_set_name (fs_updir, "fs_updir");
  gtk_widget_ref (fs_updir);
  gtk_object_set_data_full (GTK_OBJECT (file_selector), "fs_updir", fs_updir,
                            (GtkDestroyNotify) gtk_widget_unref);
//  gtk_widget_show (fs_updir);
  gtk_box_pack_start (GTK_BOX (hbox1), fs_updir, TRUE, FALSE, 0);
	gtk_widget_set_sensitive (fs_updir, FALSE);

	fs_curdir = entry_new (file_selector, "fs_curdir");
	gtk_box_pack_start (GTK_BOX (vbox1), fs_curdir, FALSE, FALSE, 0);
	ws (fs_curdir);
	st (fs_curdir, "fs_curdir", "*");

/*  file_mask = gtk_combo_new ();
  gtk_widget_set_name (file_mask, "file_mask");
  gtk_widget_ref (file_mask);
  gtk_object_set_data_full (GTK_OBJECT (file_selector), "file_mask", file_mask,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (file_mask);
  gtk_box_pack_start (GTK_BOX (vbox1), file_mask, FALSE, FALSE, 0);
  file_mask_items = g_list_append (file_mask_items, "*");
  gtk_combo_set_popdown_strings (GTK_COMBO (file_mask), file_mask_items);
  g_list_free (file_mask_items);
//	prot (file_mask);

  fs_curdir = GTK_COMBO (file_mask)->entry;
  gtk_widget_set_name (fs_curdir, "fs_curdir");
  gtk_widget_ref (fs_curdir);
  gtk_object_set_data_full (GTK_OBJECT (file_selector), "fs_curdir", fs_curdir,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fs_curdir);*/

  frame2 = gtk_frame_new (NULL);
  gtk_widget_set_name (frame2, "frame2");
  gtk_widget_ref (frame2);
  gtk_object_set_data_full (GTK_OBJECT (file_selector), "frame2", frame2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame2);
  gtk_box_pack_start (GTK_BOX (vbox1), frame2, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame2), 2);

  hpaned1 = gtk_hpaned_new ();
  gtk_widget_set_name (hpaned1, "hpaned1");
  gtk_widget_ref (hpaned1);
  gtk_object_set_data_full (GTK_OBJECT (file_selector), "hpaned1", hpaned1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hpaned1);
  gtk_container_add (GTK_CONTAINER (frame2), hpaned1);
  gtk_container_set_border_width (GTK_CONTAINER (hpaned1), 2);
  gtk_paned_set_handle_size (GTK_PANED (hpaned1), 8);
  gtk_paned_set_gutter_size (GTK_PANED (hpaned1), 9);
  gtk_paned_set_position (GTK_PANED (hpaned1), 250);

  scrolledwindow3 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_set_name (scrolledwindow3, "scrolledwindow3");
  gtk_widget_ref (scrolledwindow3);
  gtk_object_set_data_full (GTK_OBJECT (file_selector), "scrolledwindow3", scrolledwindow3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow3);
  gtk_container_add (GTK_CONTAINER (hpaned1), scrolledwindow3);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow3), GTK_POLICY_AUTOMATIC, GTK_POLICY_NEVER);

  viewport1 = gtk_viewport_new (NULL, NULL);
  gtk_widget_set_name (viewport1, "viewport1");
  gtk_widget_ref (viewport1);
  gtk_object_set_data_full (GTK_OBJECT (file_selector), "viewport1", viewport1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (viewport1);
  gtk_container_add (GTK_CONTAINER (scrolledwindow3), viewport1);

  scrolledwindow5 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_set_name (scrolledwindow5, "scrolledwindow5");
  gtk_widget_ref (scrolledwindow5);
  gtk_object_set_data_full (GTK_OBJECT (file_selector), "scrolledwindow5", scrolledwindow5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow5);
  gtk_container_add (GTK_CONTAINER (viewport1), scrolledwindow5);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow5), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  fs_dirtree = gtk_ctree_new (1, 0);
  gtk_widget_set_name (fs_dirtree, "fs_dirtree");
  gtk_widget_ref (fs_dirtree);
  gtk_object_set_data_full (GTK_OBJECT (file_selector), "fs_dirtree", fs_dirtree,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fs_dirtree);
  gtk_container_add (GTK_CONTAINER (scrolledwindow5), fs_dirtree);
  gtk_clist_set_column_width (GTK_CLIST (fs_dirtree), 0, 80);
  gtk_clist_column_titles_show (GTK_CLIST (fs_dirtree));
	gtk_ctree_set_show_stub (GTK_CTREE (fs_dirtree), TRUE);

  label3 = gtk_label_new (_("Directory"));
  gtk_widget_set_name (label3, "label3");
  gtk_widget_ref (label3);
  gtk_object_set_data_full (GTK_OBJECT (file_selector), "label3", label3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label3);
  gtk_clist_set_column_widget (GTK_CLIST (fs_dirtree), 0, label3);

  scrolledwindow4 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_set_name (scrolledwindow4, "scrolledwindow4");
  gtk_widget_ref (scrolledwindow4);
  gtk_object_set_data_full (GTK_OBJECT (file_selector), "scrolledwindow4", scrolledwindow4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow4);
  gtk_container_add (GTK_CONTAINER (hpaned1), scrolledwindow4);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow4), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  fs_filelist = gtk_clist_new (3);
  gtk_widget_set_name (fs_filelist, "fs_filelist");
  gtk_widget_ref (fs_filelist);
  gtk_object_set_data_full (GTK_OBJECT (file_selector), "fs_filelist", fs_filelist,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fs_filelist);
  gtk_container_add (GTK_CONTAINER (scrolledwindow4), fs_filelist);
  gtk_clist_set_column_width (GTK_CLIST (fs_filelist), 0, 120);
  gtk_clist_set_column_width (GTK_CLIST (fs_filelist), 1, 80);

  gtk_clist_column_titles_show (GTK_CLIST (fs_filelist));
	gtk_clist_set_sort_column (GTK_CLIST (fs_filelist), 0);
	gtk_clist_set_sort_type (GTK_CLIST (fs_filelist), GTK_SORT_ASCENDING);
	gtk_clist_set_auto_sort (GTK_CLIST (fs_filelist), TRUE);

  label2 = gtk_label_new ("Filename");
  gtk_widget_set_name (label2, "label2");
  gtk_widget_ref (label2);
  gtk_object_set_data_full (GTK_OBJECT (file_selector), "label2", label2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label2);
  gtk_clist_set_column_widget (GTK_CLIST (fs_filelist), 0, label2);

  label2 = gtk_label_new (_("Date"));
  gtk_widget_set_name (label2, "label2");
  gtk_widget_ref (label2);
  gtk_object_set_data_full (GTK_OBJECT (file_selector), "label2", label2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label2);
  gtk_clist_set_column_widget (GTK_CLIST (fs_filelist), 1, label2);

  label2 = gtk_label_new (_("Size"));
  gtk_widget_set_name (label2, "label2");
  gtk_widget_ref (label2);
  gtk_object_set_data_full (GTK_OBJECT (file_selector), "label2", label2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label2);
  gtk_clist_set_column_widget (GTK_CLIST (fs_filelist), 2, label2);
	gtk_clist_set_column_justification (GTK_CLIST (fs_filelist), 2, GTK_JUSTIFY_RIGHT);

  fs_filename = gtk_entry_new_with_max_length (256);
  gtk_widget_set_name (fs_filename, "fs_filename");
  gtk_widget_ref (fs_filename);
  gtk_object_set_data_full (GTK_OBJECT (file_selector), "fs_filename", fs_filename,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fs_filename);
  gtk_box_pack_start (GTK_BOX (vbox1), fs_filename, FALSE, FALSE, 2);

  dialog_action_area1 = GTK_DIALOG (file_selector)->action_area;
  gtk_widget_set_name (dialog_action_area1, "dialog_action_area1");
  gtk_object_set_data (GTK_OBJECT (file_selector), "dialog_action_area1", dialog_action_area1);
  gtk_widget_show (dialog_action_area1);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area1), 5);

  fs_ok_button = gtk_button_new_with_label (_("Ok"));
  gtk_widget_set_name (fs_ok_button, "fs_ok_button");
  gtk_widget_ref (fs_ok_button);
  gtk_object_set_data_full (GTK_OBJECT (file_selector), "fs_ok_button", fs_ok_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fs_ok_button);
  gtk_box_pack_start (GTK_BOX (dialog_action_area1), fs_ok_button, TRUE, TRUE, 0);
  GTK_WIDGET_SET_FLAGS (fs_ok_button, GTK_CAN_DEFAULT);

  fs_cancel_button = gtk_button_new_with_label (_("Cancel"));
  gtk_widget_set_name (fs_cancel_button, "fs_cancel_button");
  gtk_widget_ref (fs_cancel_button);
  gtk_object_set_data_full (GTK_OBJECT (file_selector), "fs_cancel_button", fs_cancel_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fs_cancel_button);
  gtk_box_pack_start (GTK_BOX (dialog_action_area1), fs_cancel_button, TRUE, TRUE, 0);

  gtk_widget_grab_focus (fs_ok_button);
  gtk_widget_grab_default (fs_ok_button);
  return file_selector;
}


GtkWidget *
file_selector_new (char *startdir, char *startname, 
		   GtkSignalFunc okfunc, GtkSignalFunc cancelfunc, 
		   gpointer data) {
  fs_accept_info *accept=(fs_accept_info *)calloc (1, sizeof (fs_accept_info));

  GtkWidget *win = gtk_file_selection_new ("Select A File...");
  gtk_widget_set_name (win, "win");
  gtk_object_set_data (GTK_OBJECT (win), "win", win);
  gtk_widget_ref (win);

  if (startname) gtk_file_selection_set_filename (GTK_FILE_SELECTION (win),
			startname);

  accept->func=okfunc;
  accept->data=data;

  gtk_signal_connect (GTK_OBJECT (win), "delete_event",
		      GTK_SIGNAL_FUNC (gtk_false), NULL);
  gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (win)->cancel_button),
		"clicked", GTK_SIGNAL_FUNC (file_selector_cancel), NULL);
  gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (win)->ok_button),
		"clicked", GTK_SIGNAL_FUNC (file_selector_accept),
		(gpointer)accept);
  return win;
}




void fs_new_directory_window (GtkWidget *widget) {
	GtkCTree *ctree=GTK_CTREE (lw (widget, "fs_dirtree"));
	GtkWidget *dialog=dialog_new ("fs_ndir", "New Sub-directory", 10, 10, 240, 105);
	GtkWidget *frame=frame_new (dialog, NULL, "Enter a new subdirectory name", 2);
	GtkWidget *vbox=GTK_DIALOG (dialog)->vbox;
	GtkWidget *entry=entry_new (dialog, "entry");
	gtk_window_set_modal (GTK_WINDOW (dialog), TRUE);
	ca (frame, entry);
	bps (vbox, frame);
	sc ("ok_button", dialog, "clicked", file_selector_newdir_accept, ctree);
	sc ("cancel_button", dialog, "clicked", file_selector_newdir_cancel, NULL);
	sc ("fs_ndir", dialog, "delete_event", file_selector_newdir_cancel, NULL);
	ws (dialog);
}

void fs_rename_window (GtkWidget *widget) {
	GtkCList *clist=GTK_CLIST (lw (widget, "fs_filelist"));
	GtkWidget *dialog=dialog_new ("fs_ndir", "Rename", 10, 10, 240, 105);
	GtkWidget *frame=frame_new (dialog, NULL, "Enter a new name for the selected file", 2);
	GtkWidget *vbox=GTK_DIALOG (dialog)->vbox;
	GtkWidget *entry=entry_new (dialog, "entry");
	gtk_window_set_modal (GTK_WINDOW (dialog), TRUE);
	ca (frame, entry);
	bps (vbox, frame);
	sc ("ok_button", dialog, "clicked", file_selector_rename_accept, clist);
	sc ("cancel_button", dialog, "clicked", file_selector_rename_cancel, NULL);
	sc ("fs_ndir", dialog, "delete_event", file_selector_rename_cancel, NULL);
	ws (dialog);
}



