/* TradeClient <http://tradeclient.sourceforge.net>
 * $Id: gcalendar.c,v 1.9 2001/03/20 22:19:33 ttabner Exp $
 *
 * Copyright (C) 1999-2000 Bynari Inc.
 * Copyright (C) 2001 Project TradeClient
 *
 * LGPL
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */



#include "puma.h"

void
calendar_day_selected_double_click_msgexp (GtkWidget *widget, CalendarData *data)
{
  GtkWidget *parent=lookup_widget(widget,"window");
  GtkWidget *nmwindow=lookup_widget(parent,"nmwindow");
  GtkWidget *entry=lookup_widget(nmwindow,"msg_exp_entry");
  time_t tt, rt;
  struct tm *ttm;
  char tbuf[10], rbuf[20], buffer[30];
  struct tm rtm;
  tt = time(NULL);
  ttm = gmtime(&tt);
  sprintf( tbuf, "%02d:%02d:%02d",
  ttm->tm_hour, ttm->tm_min, ttm->tm_sec);
  memset (&rtm, 0, sizeof (rtm));
  gtk_calendar_get_date (GTK_CALENDAR(data->window), &rtm.tm_year, &rtm.tm_mon,
&rtm.tm_mday);
  rtm.tm_year -= TM_YEAR_BASE;
  rt = mktime(&rtm);
  strftime (rbuf, 255, "%a, %d %b %Y", gmtime(&rt));
  sprintf(buffer, "%s %s UTC", rbuf, tbuf);
  gtk_entry_set_text(GTK_ENTRY(entry),buffer);
  gtk_widget_destroy(GTK_WIDGET(parent));
}

void
calendar_day_selected_double_click_replyby (GtkWidget *widget, CalendarData *data)
{
  GtkWidget *parent=lookup_widget(widget,"window");
  GtkWidget *nmwindow=lookup_widget(parent,"nmwindow");
  GtkWidget *entry=lookup_widget(nmwindow,"replyby_entry");
  time_t tt, rt;
  struct tm *ttm;
  char tbuf[10], rbuf[20], buffer[30];
  struct tm rtm;
  tt = time(NULL);
  ttm = gmtime(&tt);
  sprintf( tbuf, "%02d:%02d:%02d",
  ttm->tm_hour, ttm->tm_min, ttm->tm_sec);
  memset (&rtm, 0, sizeof (rtm));
  gtk_calendar_get_date (GTK_CALENDAR(data->window), &rtm.tm_year, &rtm.tm_mon, &rtm.tm_mday);
  rtm.tm_year -= TM_YEAR_BASE;
  rt = mktime(&rtm);
  strftime (rbuf, 255, "%a, %d %b %Y", gmtime(&rt));
  sprintf(buffer, "%s %s UTC", rbuf, tbuf);
  gtk_entry_set_text(GTK_ENTRY(entry),buffer);
  gtk_widget_destroy(GTK_WIDGET(parent));
}

void
calendar_day_selected_double_click_todo (GtkWidget *widget, CalendarData *data)
{
  GtkWidget *parent=lookup_widget(widget,"window");
  GtkWidget *nmwindow=lookup_widget(parent,"nmwindow");
  GtkWidget *entry=lookup_widget(nmwindow,"todo_due");
  time_t tt, rt;
  struct tm *ttm;
  char tbuf[10], rbuf[20], buffer[30];
  struct tm rtm;
  tt = time(NULL);
  ttm = gmtime(&tt);
  sprintf( tbuf, "%02d:%02d:%02d",
  ttm->tm_hour, ttm->tm_min, ttm->tm_sec);
  memset (&rtm, 0, sizeof (rtm));
  gtk_calendar_get_date (GTK_CALENDAR(data->window), &rtm.tm_year, &rtm.tm_mon, &rtm.tm_mday);
  rtm.tm_year -= TM_YEAR_BASE;
  rt = mktime(&rtm);
  strftime (rbuf, 255, "%a, %d %b %Y", gmtime(&rt));
  sprintf(buffer, "%s %s UTC", rbuf, tbuf);
  gtk_entry_set_text(GTK_ENTRY(entry),buffer);
  gtk_widget_destroy(GTK_WIDGET(parent));
}

enum {
  calendar_show_header,
  calendar_show_days,
  calendar_month_change, 
  calendar_show_week,
  calendar_monday_first
};

void
calendar_set_flags(CalendarData *calendar)
{
  gint i;
  gint options=0;
  for (i=0;i<5;i++) 
    if (calendar->settings[i])
      {
	options=options + (1<<i);
      }
  if (calendar->window)
    gtk_calendar_display_options (GTK_CALENDAR (calendar->window), options);
}

void create_calendar(int type, GtkWidget *widget)
{
  GtkWidget *window;
  GtkWidget *nmwindow=widget;
  GtkWidget *vbox;
  GtkWidget *hbbox;
  GtkWidget *calendar;
  GtkWidget *separator;
  GtkWidget *ok, *cancel;
  static CalendarData calendar_data;
  
  calendar_data.window = NULL;
  calendar_data.font = NULL;
  calendar_data.font_dialog = NULL;

  calendar_data.settings[0]=1;
  calendar_data.settings[1]=1;
  calendar_data.settings[2]=0;
  calendar_data.settings[3]=1;
  calendar_data.settings[4]=0;

  window = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_widget_set_name (window, "window");
  gtk_object_set_data (GTK_OBJECT (window), "window", window);
  gtk_container_border_width (GTK_CONTAINER (window), 5);

  gtk_widget_set_name (nmwindow, "nmwindow");
  gtk_object_set_data (GTK_OBJECT (nmwindow), "nmwindow", nmwindow);
  gtk_widget_ref (nmwindow);
  gtk_object_set_data_full (GTK_OBJECT (window), "nmwindow", nmwindow,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_window_set_policy(GTK_WINDOW(window), FALSE, FALSE, TRUE);

  vbox = gtk_vbox_new(FALSE, 5);
  gtk_container_add (GTK_CONTAINER (window), vbox);

  calendar=gtk_calendar_new();
  gtk_widget_set_name (calendar, "calendar");
  gtk_widget_ref (calendar);
  gtk_object_set_data_full (GTK_OBJECT (window), "calendar", calendar,
                            (GtkDestroyNotify) gtk_widget_unref);
  calendar_data.window = calendar;
  calendar_set_flags(&calendar_data);
  gtk_box_pack_start(GTK_BOX(vbox), calendar, FALSE, FALSE, 0);

  separator = gtk_hseparator_new ();
  gtk_box_pack_start (GTK_BOX (vbox), separator, FALSE, TRUE, 0);

  hbbox = gtk_hbutton_box_new();
  gtk_box_pack_start(GTK_BOX(vbox), hbbox, FALSE, FALSE, 0);
  gtk_button_box_set_layout(GTK_BUTTON_BOX(hbbox), GTK_BUTTONBOX_SPREAD);
  gtk_button_box_set_spacing(GTK_BUTTON_BOX(hbbox), 0);

  ok=gtk_button_new_with_label("Ok");
  gtk_box_pack_start(GTK_BOX(hbbox),ok,FALSE,FALSE,0);

  cancel=gtk_button_new_with_label("Cancel");
  gtk_box_pack_start(GTK_BOX(hbbox),cancel,FALSE,FALSE,0);
  gtk_signal_connect (GTK_OBJECT (cancel), "clicked",
                      GTK_SIGNAL_FUNC (cancel_callback),
                      NULL);

switch (type) {
        case 1:
  gtk_signal_connect (GTK_OBJECT (calendar), "day_selected_double_click",
                      GTK_SIGNAL_FUNC (calendar_day_selected_double_click_msgexp),
                      &calendar_data);
  gtk_signal_connect (GTK_OBJECT (ok), "clicked",
                      GTK_SIGNAL_FUNC (calendar_day_selected_double_click_msgexp),
                      &calendar_data);
                break;
        case 2:
  gtk_signal_connect (GTK_OBJECT (calendar), "day_selected_double_click",
                      GTK_SIGNAL_FUNC (calendar_day_selected_double_click_replyby),
                      &calendar_data);
  gtk_signal_connect (GTK_OBJECT (ok), "clicked",
                      GTK_SIGNAL_FUNC (calendar_day_selected_double_click_replyby),
                      &calendar_data);
                break;
        default:
  gtk_signal_connect (GTK_OBJECT (calendar), "day_selected_double_click",
                      GTK_SIGNAL_FUNC (calendar_day_selected_double_click_todo),
                      &calendar_data);
  gtk_signal_connect (GTK_OBJECT (ok), "clicked",
                      GTK_SIGNAL_FUNC (calendar_day_selected_double_click_todo),
                      &calendar_data);
		break;
        }


  gtk_widget_show_all(window);
}

void cancel_callback(GtkWidget *widget, gpointer data) {
	GtkWidget *parent=lookup_widget(widget,"window");
	gtk_widget_destroy(parent);
}
