/* TradeClient <http://tradeclient.sourceforge.net>
 * $Id: main-window-callbacks.c,v 1.112 2001/03/20 22:19:33 ttabner Exp $
 *
 * Copyright (C) 1999-2000 Bynari Inc.
 * Copyright (C) 2001 Project TradeClient
 *
 * LGPL
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#include "puma.h"

#define MAX_NEW_MSG_WINDOWS   10
GList *msel=NULL;


int parse_from_line (char *fromline, char **email, char **first, char **last) {
	char *tmp1, *tmp2;
	char *tmpcs;
	if (strstr (fromline, "<")) {
		tmp1=cut_string (fromline, '<', 2, 1);
		*email=cut_string (tmp1, '>', 1, 1);
		free (tmp1);
		if (strstr (fromline, "\"")) {
			tmp1=cut_string (fromline, '"', 1, 2);
			tmp2=cut_string (tmp1, '"', 2, 1);
			free (tmp1);
		} else {
			tmp2=cut_string (fromline, '<', 1, 1);
		}
		if (strstr (tmp2, " ")) {
			*first=cut_string (tmp2, ' ', 1, 1);
			tmpcs=cut_string (tmp2, ' ', 2, 1);
			*last=cut_string(tmpcs,' ',1,1);
			free (tmp2);
			free (tmpcs);
			return TRUE;
		} else {
			*first=tmp2;
			*last=NULL;
			return TRUE;
		}
	} else {
		*email=rm_crlf (fromline);
		*first=NULL;
		*last=NULL;
		return TRUE;
	}
	return FALSE;
}


GtkWidget *make_new_message_window (GtkWidget *widget, gpointer data) {
	int i=0, x, y;
	if (tm_globs->num_accounts>0) {
		do { 
			if (tm_globs->new_messages[i]==NULL)	break;
			i++; 
		} while (i<MAX_NEW_MSG_WINDOWS);
		if (i>=MAX_NEW_MSG_WINDOWS) { 
			insert_warning (_("You cannot open any more new messages.  Close some first\n")); return NULL; 
		}
		tm_globs->new_messages[i]=create_new_message_window ();
		y=x=i*10+20;
#if 0
		gtk_widget_set_uposition (tm_globs->new_messages[i], x, y);
#endif
		gtk_widget_show (tm_globs->new_messages[i]);
		return (tm_globs->new_messages[i]);
	} else {
		insert_warning (_("You do not have any accounts defined\n"));
	}
	return NULL;
}


void get_messages (GtkWidget *widget, gpointer data) {
	gtk_widget_set_sensitive (lookup_widget (tm_globs->main_window, "get_message"), FALSE);
	gtk_widget_set_sensitive (lookup_widget (tm_globs->status, "stopthat"), TRUE);
	gtk_widget_set_sensitive (lookup_widget (tm_globs->status, "skip"), TRUE);
	if (!(tm_globs->flags & HIDE_STATUS_WINDOW)) {	
		show_status (NULL, NULL);
	}

	/* Now, go get those messages by creating children to do the work */
	//TREYgtk_timeout_remove( tm_globs -> getMsgTimeout ) ;
	nf_imap_check_mail (NULL);
    fork_receive_messages (NULL);
	tm_globs->getMsgTimeout = gtk_timeout_add( 125, (GtkFunction)get_message_timeout, NULL ) ;
	
	return ;
}

void make_preferences (GtkWidget *widget, gpointer data) {
	prefs_show (1);
}

void protect_unprotect_actions (int type) {
	gtk_widget_set_sensitive (lookup_widget (tm_globs->main_window, "reply_to"), type);
	gtk_widget_set_sensitive (lookup_widget (tm_globs->main_window, "reply_to_all"), type);
	gtk_widget_set_sensitive (lookup_widget (tm_globs->main_window, "forward"), type);
	gtk_widget_set_sensitive (lookup_widget (tm_globs->main_window, "delete_button"), type);
	gtk_widget_set_sensitive (lookup_widget (tm_globs->main_window, "del_menu"), type);
	gtk_widget_set_sensitive (lookup_widget (tm_globs->main_window, "print"), type);
	gtk_widget_set_sensitive (lookup_widget (tm_globs->main_window, "save_message_as"), TRUE);
}

void populate_attachment_clist (Attachment *att) {
	GtkCList *clist=GTK_CLIST (lookup_widget (tm_globs->main_window, "mime_clist"));
	Attachment *old_att;
	char *cl_data[3];
	int row;
	gtk_clist_freeze (clist);
	old_att=gtk_clist_get_row_data (clist, 0);
	if (old_att) attachments_destroy (old_att);
	gtk_clist_clear (clist);
	if (att) free (att->mtype);
	old_att=att;
	if (att) att=att->next;
	if (old_att) free (old_att);
	while (att) {
		cl_data[0]=att->mtype;
		cl_data[1]=att->fname;
		cl_data[2]=(char *)calloc (1, 64);
		sprintf (cl_data[2], "%d", (int)att->length);
		row=gtk_clist_append (clist, cl_data);
		free (cl_data[2]);
		gtk_clist_set_row_data (clist, row, (gpointer)att);
		att=att->next;
	}
	gtk_clist_thaw (clist);
}

void clicked_on_message (GtkWidget *widget, GdkEventButton *event, gpointer data) {
	int row, column;
	GtkWidget *message_body=lookup_widget (tm_globs->main_window, "message_body");
	GtkWidget *folder_ctree=lookup_widget (tm_globs->main_window, "folder_tree");
	Message *message;
	char *msg, *tmpmsg, *tmp2, *head;
	Attachment *att=NULL;
	Header_Info *hinfo=NULL;
	int hsize=0;
	Folder *folder;
	Folder *vfolder;
	msg_info *info;
	char *number=(char *)calloc (5, sizeof(char));
	gtk_clist_get_selection_info (GTK_CLIST (widget), event->x, event->y, &row, &column);


#if DEBUG > 7
	printf( "clicked on message got row %d.\n", row ) ;
#endif
	info=gtk_clist_get_row_data (GTK_CLIST (widget), row);
	if (!info) {
		free (number);
		return;
	}
	tm_globs->msg_selected=info->msg;
	if ((event->button==1) || (event->button==3)) {
		if (!info) {
			free (number);
			return;
		}
	}

	folder_shade_row( GTK_CLIST(widget), row, info -> row, 0, info->msg->sensitivity ) ;
	message=info->msg;
	folder=info->fl;
	if (message->folder) {
		vfolder=folder_seek (folder_seek_by_name (message->folder));
	} else {
		vfolder=folder;
	}
	if ((event->type==5) && (event->button==1)) {
		gtk_widget_show (message_window_new (info));
		free (number);
		return;
	}
	if (message) {
		switch (event->button) {
			case 1 :
				tmpmsg=message_load (folder, message);
				if ((message->flags & MESSAGE_UNREAD) && tmpmsg!=NULL) {
					hsize=message_hsize (tmpmsg);
					head=(char *)calloc (hsize+2, sizeof(char));
					if (hsize > 0) {
						memmove (head, tmpmsg, hsize);
						hinfo=parse_header (head);
						free (head);
						if (hinfo->disposition_notify) {
							return_receipt (hinfo->disposition_notify, hinfo->subject, strdup (tmpmsg));
						}
					}
				}
				att=(Attachment *)calloc(1, sizeof(Attachment));
				att->mtype=strdup ("dummyatt");
				msg=mime_process (tmpmsg, att, 1);
				tmp2=rm_cr (msg);
				free (msg);
				msg=tmp2;
				populate_attachment_clist (att);
				gtk_text_freeze (GTK_TEXT (message_body));
				gtk_text_set_point (GTK_TEXT(message_body), 0);
				gtk_text_forward_delete (GTK_TEXT(message_body), gtk_text_get_length (GTK_TEXT(message_body)));
				gtk_text_insert (GTK_TEXT(message_body), NULL, NULL, NULL, msg, -1);
				gtk_text_set_point (GTK_TEXT (message_body), 0);
				gtk_text_thaw (GTK_TEXT (message_body));
				gtk_widget_grab_focus (message_body);
				if (message->flags & MESSAGE_UNREAD) {
					message->flags &=~ MESSAGE_UNREAD;
					vfolder->unread--;
					snprintf (number, 5, "%d", vfolder->unread);
					gtk_ctree_node_set_text (GTK_CTREE (folder_ctree), vfolder->tree_item, 1, number);
					snprintf (number, 5, "%d", vfolder->total);
					gtk_ctree_node_set_text (GTK_CTREE (folder_ctree), vfolder->tree_item, 2, number);
				}
				protect_unprotect_actions (TRUE);
				free (msg);
				free (tmpmsg);
				if (hinfo) destroy_hinfo (hinfo);
				break;
			case 2 :
				break;
			case 3 :
				gtk_clist_unselect_all (GTK_CLIST (widget));
				gtk_clist_select_row (GTK_CLIST (widget), row, 0);
				create_popup_window (info->msg);
				break;
			default:
		}
	}
	free (number);
}

GList *message_get_selection () {
	return msel ;
}

void message_selection_null () {
#if DEBUG > 5
  printf( "Destroying list of %d nodes.\n", g_list_length( msel ) ) ;
#endif
  g_list_free( msel ) ;
  msel = NULL ;
}

void clicked_on_message_handler (GtkWidget *widget, gint row, gint column, GdkEventButton *event, gpointer data) {
	msg_info *info=gtk_clist_get_row_data (GTK_CLIST (widget), row);
	tm_globs->msg_selected=info->msg;
	tm_globs->msg_row=row;
	protect_unprotect_actions (TRUE);

#if DEBUG > 5
	printf( "clicked on message\n" ) ;
#endif
	msel=g_list_prepend (msel, info);
#if DEBUG > 5
	printf( "message list has %d nodes.\n", g_list_length( msel ) ) ;
#endif
}

int unclicked_ignore=FALSE;

void unclicked_on_message (GtkWidget *widget, gint row, gint column, GdkEventButton *event, gpointer data) {
	msg_info *info=gtk_clist_get_row_data (GTK_CLIST (widget), row);
	if (unclicked_ignore) {
		unclicked_ignore=FALSE;
		return;
	}
#if DEBUG > 5
	printf( "unclicked on a message.\n" ) ;
#endif
	msel=g_list_remove (msel, info);
#if DEBUG > 5
	printf( "message list has %d nodes.\n", g_list_length( msel ) ) ;
#endif
	if (!msel) {
		protect_unprotect_actions (FALSE);
		tm_globs->msg_selected=NULL;
	}	
}

void message_clist_destroy_row (gpointer data) {
	if (data) free (data);
}

void folder_display (GtkCList *clist, Folder *fl) {
	char *cl_data[6];
	msg_info *info;
	int row, count=0;
	int folderRowCount ;
	Folder *fseek;
	Message *mseek;
	char date[255];
	g_return_if_fail (clist != NULL);
	if (!fl)
		return;
	//g_return_if_fail (fl != NULL);
	
#if DEBUG > 5
	printf( "folder_display() has been called.\n" ) ;
#endif

	gtk_clist_freeze (clist);
	gtk_clist_clear (clist);
	tm_globs->visable=fl;
	for (fseek=folder_first ();fseek;fseek=fseek->next) {
		tm_globs->msg_selected=NULL;
		protect_unprotect_actions (FALSE);
		count=0;
		folderRowCount = 0 ;
		for (mseek=fseek->msglst;mseek;mseek=mseek->next) {
			if (strcasecmp (mseek->folder, fl->name)==0) {
#if 0
				char *status;
				if ((mseek->flags & MESSAGE_REPLY)&&(mseek->flags & MESSAGE_FORWARD))
					status=strdup("RF");
				else if (mseek->flags & MESSAGE_REPLY)
					status=strdup("R");
				else if (mseek->flags & MESSAGE_FORWARD)
					status=strdup("F");
				else
					status=NULL;
				cl_data[0]=status;
#else
				cl_data[0]=NULL;
#endif
				cl_data[1]=mseek->priority;
				cl_data[2]=mseek->subject;
				cl_data[3]=mseek->from;
				cl_data[4]=mseek->date;
				strftime (date, sizeof(date), "%a, %d %b %Y %H:%M:%S %z", localtime(&mseek->time));
				cl_data[5]=strdup(date);
#if 0
				cl_data[5]=ctime (&mseek->time);
#endif
				info=(msg_info *)calloc (1, sizeof(msg_info));
				info->msg=mseek;
				info->fl=fseek;

 				row=gtk_clist_prepend (GTK_CLIST (clist), cl_data);
				free( cl_data[5] ) ;

				/*
				 * This is ULTRA important, otherwise, when we delete a row is will not
				 * have the correct row number as required for proper highlighting since
				 * we are prepending.  Also, remember, when we are prepending, the row
				 * number, as returned from the prepend operation, will ALWAYS be zero!
				 */
				info -> row = folderRowCount ;

				/* Now, call a function to do do all of the actual row work! */
				folder_shade_row (GTK_CLIST(clist), row, folderRowCount, info->msg->flags & MESSAGE_UNREAD, info->msg->sensitivity) ;

				/* Now, update the clist with the current info */
				gtk_clist_set_row_data_full (GTK_CLIST (clist), row, 
							     (gpointer)info, (GtkDestroyNotify)message_clist_destroy_row);
#if DEBUG > 6
				if( folderRowCount != row ) printf( "current row and folder row count differ in in count" \
								    "with row = %d and folder row = %d.\n", row, folderRowCount ) ;
#endif
				folderRowCount++ ;
			}
			count++;
		}
	}
	message_selection_null() ;
	gtk_clist_thaw (GTK_CLIST (clist));
}



void
folder_shade_row (GtkCList *clist, int rowNum, int msgCnt, int unread, char *sens)
{
     int x;

	gtk_clist_freeze (clist);
  
     if (GTK_IS_CLIST (clist))
     {
	  if ((sens) && (strlen(sens) > 0) && (strcmp (sens, "Public-Document") != 0))
	  {
	       if (unread)
	       {
		    if (strcasecmp(sens, "Internal-Document")==0) {
			 for (x=0; x < 6; x++) gtk_clist_set_cell_style (GTK_CLIST (clist), rowNum, x, tm_globs->sens_u1);
		    } else if (strcasecmp(sens, "Personal")==0) {
			 for (x=0; x < 6; x++) gtk_clist_set_cell_style (GTK_CLIST (clist), rowNum, x, tm_globs->sens_u2);
		    } else if (strcasecmp(sens, "Private")==0) {
			 for (x=0; x < 6; x++) gtk_clist_set_cell_style (GTK_CLIST (clist), rowNum, x, tm_globs->sens_u3);
		    } else if (strcasecmp(sens, "Company-Confidential")==0) {
			 for (x=0; x < 6; x++) gtk_clist_set_cell_style (GTK_CLIST (clist), rowNum, x, tm_globs->sens_u4);
		    } else {
			 for (x=0; x < 6; x++) gtk_clist_set_cell_style (GTK_CLIST (clist), rowNum, x, tm_globs->sens_u5);
		    }
	       } else {
		    if (strcasecmp(sens, "Internal-Document")==0) {
			 for (x=0; x < 6; x++) gtk_clist_set_cell_style (GTK_CLIST (clist), rowNum, x, tm_globs->sens_r1);
		    } else if (strcasecmp(sens, "Personal")==0) {
			 for (x=0; x < 6; x++) gtk_clist_set_cell_style (GTK_CLIST (clist), rowNum, x, tm_globs->sens_r2);
		    } else if (strcasecmp(sens, "Private")==0) {
			 for (x=0; x < 6; x++) gtk_clist_set_cell_style (GTK_CLIST (clist), rowNum, x, tm_globs->sens_r3);
		    } else if (strcasecmp(sens, "Company-Confidential")==0) {
			 for (x=0; x < 6; x++) gtk_clist_set_cell_style (GTK_CLIST (clist), rowNum, x, tm_globs->sens_r4);
		    } else {
			 for (x=0; x < 6; x++) gtk_clist_set_cell_style (GTK_CLIST (clist), rowNum, x, tm_globs->sens_r5);
		    }
	       }
	  } else {
	       if ((msgCnt % 2) == 0) {
		    /* even data */
		    if (unread)
		    {
			 for (x=0; x < 6; x++) gtk_clist_set_cell_style (GTK_CLIST (clist), rowNum, x, tm_globs->unread_even);
		    } else {
			 for (x=0; x < 6; x++) gtk_clist_set_cell_style (GTK_CLIST (clist), rowNum, x, tm_globs->read_even);
		    }
	       } else {
		    /* odd data */
		    if (unread)
		    {
			 for (x=0; x < 6; x++) gtk_clist_set_cell_style (GTK_CLIST (clist), rowNum, x, tm_globs->unread_odd);
		    } else {
			 for (x=0; x < 6; x++) gtk_clist_set_cell_style (GTK_CLIST (clist), rowNum, x, tm_globs->read_odd);
		    }
	       }
	  }
     }
	gtk_clist_thaw (clist);
     return;
}


void reindex_accept (GtkWidget *widget, gpointer data) {
	folder_reindex (data);
	folder_display (GTK_CLIST (lookup_widget (tm_globs->main_window, "message_clist")), data);
	gtk_widget_destroy (lookup_widget (widget, "yesno"));
}

void clicked_on_folder (GtkWidget *widget, GtkCTreeNode *node, int column) {
	Folder *folder=gtk_ctree_node_get_row_data (GTK_CTREE (widget), node);
	if (folder->flags & F_INDEX_MISSING) {
		folder_reindex (folder);
		folder_display (GTK_CLIST (lookup_widget (tm_globs->main_window,
		                "message_clist")), folder);

	} else {
	  folder_display (GTK_CLIST (lookup_widget (tm_globs->main_window, "message_clist")), folder);
	}
}

void t_clicked_on_folder (GtkWidget *widget, GdkEventButton *event, gpointer data) {
	int row, column;
	Folder *folder;
	GtkWidget *newf;
	GtkWidget *delete;


	message_selection_null() ;
	if (event) {
		switch (event->button) {
			case 1 :
				gtk_clist_get_selection_info (GTK_CLIST (widget), event->x, event->y, &row, &column);
				folder=gtk_clist_get_row_data (GTK_CLIST (widget), row);
				break;
			case 2 :
				gtk_clist_get_selection_info (GTK_CLIST (widget), event->x, event->y, &row, &column);
				folder=gtk_clist_get_row_data (GTK_CLIST (widget), row);
				break;
			case 3 :
				gtk_clist_get_selection_info (GTK_CLIST (widget), event->x, event->y, &row, &column);
				folder=gtk_clist_get_row_data (GTK_CLIST (widget), row);
				if (folder) {
					gtk_ctree_select (GTK_CTREE (widget), folder->tree_item);
				} else {
					return;
				}
				if (GTK_IS_WIDGET (tm_globs->folder_popup)) {
					gtk_widget_destroy (tm_globs->folder_popup);
				}
				tm_globs->folder_popup=create_folder_popup ();				
/*				if (tm_globs->h1>0) gtk_signal_disconnect (GTK_OBJECT (empty), tm_globs->h1);
 				if (tm_globs->h2>0) gtk_signal_disconnect  (GTK_OBJECT (newf), tm_globs->h2);
  			if (tm_globs->h3>0) gtk_signal_disconnect  (GTK_OBJECT (delete), tm_globs->h3);*/
				//empty=lookup_widget (tm_globs->folder_popup, "empty_folder1");
				newf=lookup_widget (tm_globs->folder_popup, "new_folder1");
				delete=lookup_widget (tm_globs->folder_popup, "delete_folder1");
				if ((strcasecmp (folder->name, "inbox")==0) ||
				    (strcasecmp (folder->name, "outbox")==0) ||
				    (strcasecmp (folder->name, "sent-items")==0) ||
				    (strcasecmp (folder->name, "trash")==0)) {
					gtk_widget_set_sensitive (delete, FALSE);
				} else {
					gtk_widget_set_sensitive (delete, TRUE);
				}				
/*				tm_globs->h1=gtk_signal_connect (GTK_OBJECT (empty), "activate",
       	                    GTK_SIGNAL_FUNC (empty_folder_activate),
				                    (gpointer)folder);*/
 				tm_globs->h2=gtk_signal_connect (GTK_OBJECT (newf), "activate",
                            GTK_SIGNAL_FUNC (new_folder_activate),
                            (gpointer)folder);
  			tm_globs->h3=gtk_signal_connect (GTK_OBJECT (delete), "activate",
                            GTK_SIGNAL_FUNC (delete_folder_activate),
                            (gpointer)folder);
				gtk_menu_popup (GTK_MENU (tm_globs->folder_popup), NULL, NULL, NULL, NULL, 3, 0);

				break;
		}
	}
}



void unclicked_on_folder (GtkWidget *widget, GtkCTreeNode *node, int column) {
	GtkWidget *message_clist=lookup_widget (tm_globs->main_window, "message_clist");
	gtk_clist_freeze (GTK_CLIST (message_clist));
	gtk_clist_clear (GTK_CLIST (message_clist));
	gtk_clist_thaw (GTK_CLIST (message_clist));	
	tm_globs->visable=NULL;
	protect_unprotect_actions (FALSE);
}



void message_clist_remove_row (GtkCList *clist, int row) {
#if DEBUG > 5
  printf ("Removing row %d\n", row);
#endif
}

void destroy_selected_message (GtkWidget *widget, gpointer data) {
	GtkWidget *message_body=lookup_widget (tm_globs->main_window, "message_body");
	GtkWidget *folder_ctree=lookup_widget (tm_globs->main_window, "folder_tree");
	Folder *fl = NULL, *trash;
	msg_info *info=NULL;	
	GList *seek=NULL;
	char *number;
	int row;


#if DEBUG > 6
	printf( "destroying selected message.\n" ) ;
#endif

	/* different methods for getting the same thing done */
	/*for (seek=message_get_selection();seek;seek=seek->next) {*/
	/*for (seek=g_list_last(message_get_selection());seek;seek=g_list_previous(seek)) {*/
	for (seek=message_get_selection();seek;seek=g_list_next(seek)) {
		info=seek->data;
		if( info ) {
		  fl=folder_seek (folder_seek_by_name (info->msg->folder));
		  trash=folder_seek (folder_seek_by_name ("Trash"));
		  if (strcasecmp (info->msg->folder, "trash")==0) {
		    trash->total--;
		    if (info->msg->flags & MESSAGE_UNREAD) 
		      trash->unread--;
		    destroy_message (info->msg);
		  } else {
		    trash->total++;
		    fl->total--;
		    if (info->msg->flags & MESSAGE_UNREAD) {
		      trash->unread++;
		      fl->unread--;
		    }
		    if( info->msg->folder ) free( info->msg->folder ) ;
		    info->msg->folder=strdup ("Trash");
		  }

		  row=gtk_clist_find_row_from_data (GTK_CLIST (lookup_widget (tm_globs->main_window, "message_clist")), (gpointer)info);
		  {
#if DEBUG > 5
		    printf( "when deleting, got a row of %d.\n", row ) ;
#endif
		    unclicked_ignore=TRUE;
		    gtk_clist_remove (GTK_CLIST (lookup_widget (tm_globs->main_window, "message_clist")), row);
		    gtk_text_set_point (GTK_TEXT(message_body), 0);
		    gtk_text_forward_delete (GTK_TEXT(message_body), gtk_text_get_length (GTK_TEXT(message_body)));
		    populate_attachment_clist (NULL);
		    
		    number=(char *)calloc (5, sizeof(char));
		    snprintf (number, 5, "%d", fl->unread);
		    gtk_ctree_node_set_text (GTK_CTREE (folder_ctree), fl->tree_item, 1, number);
		    snprintf (number, 5, "%d", fl->total);
		    gtk_ctree_node_set_text (GTK_CTREE (folder_ctree), fl->tree_item, 2, number);
		    
		    snprintf (number, 5, "%d", trash->unread);
		    gtk_ctree_node_set_text (GTK_CTREE (folder_ctree), trash->tree_item, 1, number);
		    snprintf (number, 5, "%d", trash->total);
		    gtk_ctree_node_set_text (GTK_CTREE (folder_ctree), trash->tree_item, 2, number);

		    free (number);
		  }
		}
	}
	message_selection_null() ;
	protect_unprotect_actions (FALSE);

	/* Now, redisplay the folder */
#if DEBUG > 5
	printf( "Redisplaying folder.\n" ) ;
#endif
	folder_display( GTK_CLIST( lookup_widget( tm_globs->main_window, "message_clist" ) ), fl ) ;

	return ;
}



void msearch_callback (GtkWidget *widget, gpointer data)
{
	GtkWidget *msearch_window=create_msearch_window();
	gtk_widget_show (msearch_window);
}

void
mark_unread_callback (GtkWidget * widget, gpointer data)
{
  GList *seek = NULL;
  msg_info *info = NULL;
  for (seek = message_get_selection (); seek; seek = seek->next)
    {
      info = seek->data;
      if (info)
        {
          Message *msg = info->msg;
          Folder *vfolder = folder_seek (folder_seek_by_name (msg->folder));
          GtkWidget *folder_ctree =
            lookup_widget (tm_globs->main_window, "folder_tree");
          char *number = (char *) calloc (5, sizeof (char));

          if (info->msg->flags & MESSAGE_UNREAD)
            {
              msg->flags &=~ MESSAGE_UNREAD;
              vfolder->unread--;
              snprintf (number, 5, "%d", vfolder->unread);
              gtk_ctree_node_set_text (GTK_CTREE (folder_ctree),
                                       vfolder->tree_item, 1, number);
              if (number)
                free (number);
            }
          else
            {
              msg->flags |= MESSAGE_UNREAD;
              vfolder->unread++;
              snprintf (number, 5, "%d", vfolder->unread);
              gtk_ctree_node_set_text (GTK_CTREE (folder_ctree),
                                       vfolder->tree_item, 1, number);
              if (number)
                free (number);
            }
        }
    }
    message_clist_reset_shading (lookup_widget
                                 (tm_globs->main_window,
                                 "message_clist"));

}

void send_to_html_callback (GtkWidget *widget, gpointer data) {
	int fd;
	GtkWidget *message_body=lookup_widget (tm_globs->main_window, "message_body");
	char *body=gtk_editable_get_chars (GTK_EDITABLE(message_body), 0, -1);
	char *msg=strdup(body);
	char *browser = getenv ("BROWSER");
	char *file = "/tmp/tradeclient/tmpmsg.html";
	char *command;
	MimeType *tmpmtype = mime_type_search_ext ("html");
	char *handler = NULL;
	char *orph ;

	if (tmpmtype) {
		handler = (char *)calloc (strlen (orph=cut_string(tmpmtype->handle, ' ', 1, 1)), sizeof (char));
		free( orph ) ;
		sprintf (handler, "%s", orph=cut_string(tmpmtype->handle, ' ', 1, 1));
		free( orph ) ;
	}

	if (browser) {
		command = (char *)calloc (strlen (browser) + 10 + strlen (file) + 2, sizeof (char));
		sprintf (command, "%s %s &", browser, file);
	} else if (strlen (handler)) {
    		command = (char *)calloc (strlen (handler) + 10 + strlen (file) + 2, sizeof (char));
		sprintf (command, "%s %s &", handler, file);
	} else {
		command = (char *)calloc (strlen ("netscape") + 10 + strlen (file) + 2, sizeof (char));
		sprintf (command, "netscape %s &", file);
	}
	if (handler) free (handler);

	g_free(body);

	mkdir ("/tmp/tradeclient", S_IREAD | S_IWRITE | S_IEXEC);
	fd=open ("/tmp/tradeclient/tmpmsg.html",
		O_CREAT | O_TRUNC | O_WRONLY, S_IRUSR | S_IWUSR);
	if (fd<0) {
		perror ("Cannot open /tmp/tradeclient/tmpmsg.html");
		return;
	}
	write (fd, msg, strlen (msg));
	close (fd);

	if (command) {
		system (command);
		free (command);
	}
}

void delete_activate (GtkWidget *widget, gpointer data) {
	destroy_selected_message (widget, data);
	destroy_message_popup (widget, data);
}

void send_on_its_merry_way_stream (char *msg, char *type) {
	char *email, *first, *last;
	GtkWidget *window;
	GtkTree *tree;
	Header_Info *info;
	RecipSignalData *recip ;
	char *head;
	int hsize;
	if (!msg) {
		return;
	}
	if (!type)
		type=strdup ("Re:");
	hsize=message_hsize (msg);
	head=(char *)calloc (hsize, sizeof (char));
	memmove (head, msg, hsize);
	info=parse_header (head);
	free (head);
	recip = (RecipSignalData *)calloc( 1, sizeof(RecipSignalData) ) ;
	window=make_new_message_window (NULL, NULL);	
	if (strcasecmp (type, "re:")==0) {
		tree=GTK_TREE (lw (window, "recip_tree"));
		if ((info->replyto)&&(strlen(info->replyto)>0))
		{
                        if (!parse_from_line (info->replyto, &email, &first, &last)) {
                                if (email) free (email);
                                if (first) free (first);
                                if (last) free (last);
                        	if (!parse_from_line (info->from, &email, &first, &last)) {
                        	        insert_warning ("Unable to parse from line\n");
                        	        if (email) free (email);
                        	        if (first) free (first);
                        	        if (last) free (last);
                        	        return;
                        	}
			}
		}
		else
		{
			if (!parse_from_line (info->from, &email, &first, &last)) {
				insert_warning ("Unable to parse from line\n");
				if (email) free (email);
				if (first) free (first);
				if (last) free (last);
				return;
			}
		}
		gtk_tree_clear_items (tree, 0, g_list_length (tree->children));

		recip -> tree = tree ;
		recip -> email = email ;
		recip -> type = 0 ;
		new_message_window_add_recip( NULL, recip ) ;

// TREY
		if (email) free (email);
		if (first) free (first);
		if (last) free (last);
	}
	if (info->subject) {
		if (strncasecmp (info->subject, type, strlen (type))==0) {
			gtk_entry_set_text (GTK_ENTRY (lw (window, "subject_entry")), info->subject);
		} else {
			email=(char *)calloc (strlen (info->subject) + 10, sizeof (char));
			sprintf (email, "%s %s", type, info->subject);
			gtk_entry_set_text (GTK_ENTRY (lw (window, "subject_entry")), email);
			free (email);
		}
	}
	if (strcasecmp (type, "re:")==0 && tm_globs->flags & REPLY_NONE)
		return;
	if (tm_globs->flags & REPLY_QUOTED && strcasecmp (type, "re:")==0) {
		char *message ;
		GtkText *text=GTK_TEXT (lw (window, "body_textbox"));
		message = message_get_reply_quoted_stream( msg ) ;

		/* Please the new text into the compose message window. */
		gtk_text_insert (text, NULL, NULL, NULL, message, -1);
		free (message);
	} else {
		GtkCList *clist=GTK_CLIST (lw (window, "attachment_clist"));
		AFS *afs;
		char *cl_data[3];

		afs=(AFS *)calloc (1, sizeof (AFS));
		afs->data=strdup (msg);
		afs->type=strdup ("message/rfc822");
		cl_data[0]=strdup ("message/rfc822");
		cl_data[1]=strdup ("Original Message");
		cl_data[2]=(char *)calloc (20, sizeof (char)); 
		snprintf (cl_data[2], 19, "%lu", (unsigned long)strlen (msg));
		gtk_clist_set_row_data (clist, gtk_clist_append (clist, cl_data), afs); 
		free (cl_data[0]);
		free (cl_data[1]);
		free (cl_data[2]);
	}	
}

void send_on_its_merry_way (Message *msg, char *type) {
	char *email, *first, *last;
	RecipSignalData *recip ;
	GtkWidget *window;
	GtkTree *tree;
	if (!msg)
		return;
	if (!type)
		type=strdup ("Re:");

	recip = calloc( 1, sizeof(RecipSignalData) ) ;
	window=make_new_message_window (NULL, NULL);	
	if (strcasecmp (type, "re:")==0) {
		tree=GTK_TREE (lw (window, "recip_tree"));
                if ((msg->replyto)&&(strlen(msg->replyto)>0))
                {
                        if (!parse_from_line (msg->replyto, &email, &first, &last)) {
                                if (email) free (email);
                                if (first) free (first);
                                if (last) free (last);
                                if (!parse_from_line (msg->from, &email, &first, &last)) {
                                        insert_warning ("Unable to parse from line\n");
                                        if (email) free (email);
                                        if (first) free (first);
                                        if (last) free (last);
                                        return;
                                }
                        }
                }
                else
                {               
                        if (!parse_from_line (msg->from, &email, &first, &last)) {
                                insert_warning ("Unable to parse from line\n");
                                if (email) free (email);
                                if (first) free (first);
                                if (last) free (last);
                                return;
                        }
                }
		gtk_tree_clear_items (tree, 0, g_list_length (tree->children));

		recip -> tree = tree ;
		recip -> email = email ;
		recip -> type = 0 ;
		new_message_window_add_recip( NULL, recip ) ;

		if (email) free (email);
		if (first) free (first);
		if (last) free (last);
	}
	if (msg->subject) {
		if (strncasecmp (msg->subject, type, strlen (type))==0) {
			gtk_entry_set_text (GTK_ENTRY (lw (window, "subject_entry")), msg->subject);
		} else {
			email=(char *)calloc (strlen (msg->subject) + 10, sizeof (char));
			sprintf (email, "%s %s", type, msg->subject);
			gtk_entry_set_text (GTK_ENTRY (lw (window, "subject_entry")), email);
			free (email);
		}
	}
	if (strcasecmp (type, "re:")==0 && tm_globs->flags & REPLY_NONE)
		return;
	if (tm_globs->flags & REPLY_QUOTED && strcasecmp (type, "re:")==0) {
		GtkText *text=GTK_TEXT (lw (window, "body_textbox"));
		char *message;
		message=message_get_reply_quoted (msg);
		gtk_text_insert (text, NULL, NULL, NULL, message, -1);
		free (message);
	} else {
                GtkCList *clist=GTK_CLIST (lw (window, "attachment_clist"));
                AFS *afs;
		char *message, *cl_data[3];
		message=message_load (folder_seek (folder_seek_by_name (msg->rfolder)), msg);
		
		g_return_if_fail (message != NULL);
		
		afs=(AFS *)calloc (1, sizeof (AFS));
		afs->data=strdup (message);
		afs->type=strdup ("message/rfc822");
		cl_data[0]=strdup ("message/rfc822");
		cl_data[1]=strdup ("Original Message");
		cl_data[2]=(char *)calloc (20, sizeof (char)); 
		snprintf (cl_data[2], 19, "%lu", (unsigned long)strlen (message));
		free (message);
		gtk_clist_set_row_data (clist, gtk_clist_append (clist, cl_data), afs);
		free (cl_data[0]);
		free (cl_data[1]);
		free (cl_data[2]);
	}
}

void replyto_clicked (GtkWidget *widget, gpointer data) {
	send_on_its_merry_way (tm_globs->msg_selected, "Re:");
}

void forward_clicked (GtkWidget *widget, gpointer data) {
	send_on_its_merry_way (tm_globs->msg_selected, "Fwd:");
}

void destroy_message_popup (GtkWidget *widget, gpointer data) {
	gtk_widget_destroy (tm_globs->message_popup);
	tm_globs->message_popup=NULL;
}

void replyto_activate (GtkWidget *widget, gpointer data) {
	replyto_clicked (widget, data);
	destroy_message_popup (widget, data);
}

void replytoall_activate (GtkWidget *widget, gpointer data) {
	reply_to_all_clicked (widget, data);
	destroy_message_popup (widget, data);
}

void forward_activate (GtkWidget *widget, gpointer data) {
	forward_clicked (widget, data);
	destroy_message_popup (widget, data);
}


void move_to_activate (GtkWidget *widget, gpointer data) {
	/* find the widget name */
	GtkWidget *folder_ctree=lookup_widget (tm_globs->main_window, "folder_tree");
	GtkWidget *label=GTK_BIN (widget)->child;
	char *name=(char *)calloc (256, sizeof (char));
	char *number=(char *)calloc (5, sizeof (char));
	Folder *fl=tm_globs->visable, *nfl;
	Message *msg=(Message *)data;
	gtk_label_get (GTK_LABEL(label), &name);
	if (strcmp (name, fl->name)==0) {
		insert_message (_("That message is already in folder %s!\n"), name);
	} else {
		nfl=folder_seek (folder_seek_by_name (name));
		nfl->total++;
		msg->folder=strdup (name);
		snprintf (number, 5, "%d", nfl->unread);
		gtk_ctree_node_set_text (GTK_CTREE (folder_ctree), nfl->tree_item, 1, number);
		snprintf (number, 5, "%d", nfl->total);
		gtk_ctree_node_set_text (GTK_CTREE (folder_ctree), nfl->tree_item, 2, number);
		gtk_clist_remove (GTK_CLIST (lookup_widget (tm_globs->main_window, "message_clist")), tm_globs->msg_row);
	}
	destroy_message_popup (widget, data);
}


/*void empty_folder_activate (GtkWidget *widget, gpointer data) {
}*/

void new_folder_activate (GtkWidget *widget, gpointer data) {
	GtkWidget *tree=lookup_widget (tm_globs->create_folder, "folder_tree");
	gtk_widget_show (tm_globs->create_folder);
	if (data) gtk_tree_select_child (GTK_TREE (tree), ((Folder *)data)->ti);
}

void delete_folder_activate (GtkWidget *widget, gpointer data) {
	Folder *folders=folder_first ();
	Folder *fl=(Folder *)data;
	char *home=(char *)calloc (1024, sizeof (char));
	char *fn=(char *)calloc (1024, sizeof (char));
	char *fnsmi=(char *)calloc (1024, sizeof (char));
	sprintf (home, "$(HOME)");
	env_srch_rep (home);
	sprintf (fn, "%s/.tradeclient/%s", home, fl->name);
	sprintf (fnsmi, "%s/.tradeclient/.%s.smi", home, fl->name);
	if (unlink (fn)==-1) {
		perror ("Cannot delete file");
	}
	if (unlink (fnsmi)==-1) {
		perror ("Cannot delete file");
	}
        while (folders) {
		if (folders->parent) {
                if ((strcmp(folders->parent,fl->name))==0)
			delete_folder_activate(NULL,folders);
		}
                folders=folders->next;
        }
	if(fl->parent)
		if ((strlen(fl->parent))>0)
			gtk_tree_remove_item (GTK_TREE (folder_seek
			(folder_seek_by_name (fl->parent))->submenu), fl->ti);
	gtk_ctree_remove_node (GTK_CTREE (lookup_widget (tm_globs->main_window, "folder_tree")), fl->tree_item);
	folder_delete (fl->id);
}

void clicked_on_folder_in_create (GtkWidget *widget, gpointer data) {
	GtkWidget *label=GTK_BIN ((GtkWidget *)data)->child;
	char *name;
	gtk_label_get (GTK_LABEL (label), &name);
	tm_globs->create_folder_in=name;
}

void unclicked_on_folder_in_create (GtkWidget *widget, gpointer data) {
	tm_globs->create_folder_in=NULL;
}	

void accept_create_folder (GtkWidget *widget, gpointer data) {
	GtkWidget *entry;
	char *entrytxt;
	if (widget) {
		entry=lookup_widget (widget, "folder_name");
		entrytxt=gtk_entry_get_text (GTK_ENTRY (entry));
		if (folder_seek_by_name (entrytxt)==-1) {
			if (strlen (gtk_entry_get_text (GTK_ENTRY (entry)))>0) {
				if (tm_globs->create_folder_in) {
					create_new_folder (folder_seek (folder_create (entrytxt, tm_globs->create_folder_in)));
				} else {
					create_new_folder (folder_seek (folder_create (entrytxt, NULL)));
				}
			}
			if (tm_globs->message_popup) gtk_widget_destroy (tm_globs->message_popup);
			tm_globs->message_popup=NULL;
			destroy_create_folder (NULL, NULL);
		} else {
			insert_message (_("A folder already exists with that name.  Please choose another"));
		}
	}
}

void accept_create_folder_two (GtkWidget *widget, gpointer data) {
	GtkWidget *entry;
	char *entrytxt;
	if (widget) {
		entry=lookup_widget (widget, "folder_name");
		entrytxt=gtk_entry_get_text (GTK_ENTRY (entry));
		if (folder_seek_by_name (entrytxt)==-1) {
			if (strlen (gtk_entry_get_text (GTK_ENTRY (entry)))>0) {
				if (tm_globs->create_folder_in) {
					create_new_folder (folder_seek (folder_create (entrytxt, tm_globs->create_folder_in)));
				} else {
					create_new_folder (folder_seek (folder_create (entrytxt, NULL)));
				}
			}
			destroy_create_folder (NULL, NULL);
		} else {
			insert_message (_("A folder already exists with that name.  Please choose another"));
		}
	}
}


void destroy_create_folder (GtkWidget *widget, gpointer data) {
	gtk_widget_hide (tm_globs->create_folder);
}

void delete_folder_clicked (GtkWidget *widget, gpointer data) {
/*	Folder *fold;
	GtkWidget *folder_ctree=lookup_widget (tm_globs->main_window, "folder_tree");
	GtkWidget *folder_tree=lookup_widget (tm_globs->create_folder, "folder_tree");
	GtkWidget *message_clist=lookup_widget (tm_globs->main_window, "message_clist");
	PopAccount *pop;
	if (tm_globs->visable) {
		fold=tm_globs->visable;
		if (strcasecmp (fold->name, "inbox")==0) {
			puma_message (0, "You cannot delete the Inbox!");
			return;
		}
		if (strcasecmp (fold->name, "outbox")==0) {
			puma_message (0, "You cannot delete the Outbox!");
			return;
		}
		if (strcasecmp (fold->name, "trash")==0) {
			puma_message (0, "You cannot delete the Trash! Try emptying it");
			return;
		}
		if (strcasecmp (fold->name, "sent-items")==0) {
			puma_message (0, "You cannot delete Sent-Items!");
			return;
		}
		gtk_ctree_remove_node (GTK_CTREE (folder_ctree), fold->tree_item);
		gtk_tree_remove_item (GTK_TREE (folder_tree), fold->ti);
		gtk_clist_clear (GTK_CLIST (message_clist));
		destroy_folder (fold);
		pop=first_popaccount ();
		while (pop) {
			if (strcasecmp (pop->folder, fold->name)==0) {
				pop->folder=strdup ("Inbox");
			}
			pop=pop->next;
		}
	} else {
		puma_message (0, "Please highlight a folder first.");
	}*/
}

void address_book_clicked (GtkWidget *widget, gpointer data) {
	abook_widget_show (GTK_SIGNAL_FUNC (puma_die));
}

void save_message_activate (GtkWidget *widget, gpointer data) {
	Message *msg=tm_globs->msg_selected;
	if (msg) {
		char *message=message_load (folder_seek (folder_seek_by_name (msg->rfolder)), msg);
		char *tmps=(char *)calloc (strlen (msg->subject)+5, sizeof(char));
		char *tmp=rm_crlf (msg->subject);
		sprintf (tmps, "%s.eml", tmp);
		if (tmp) free (tmp);
		save_string (message, strlen (message), tmps);
		if (tmps) free (tmps);
	}
}

void message_clist_data_get (GtkWidget          *widget,
		       GdkDragContext     *context,
		       GtkSelectionData   *selection_data,
		       guint               info,
		       guint               time,
		       gpointer            data2) {
	if (info==TARGET_ROOTWIN) {
		return;
	} else {
		if (info==TARGET_URL) {
			gtk_selection_data_set (selection_data, selection_data->target, 8, "http://tradeclient.sourceforge.net/", 36);
		} else {
			if (info==TARGET_STRING)
			gtk_selection_data_set (selection_data, selection_data->target, 8, "Unknown", strlen ("Unknown"));
		}
	}
}

void message_clist_data_delete () {}

void folder_ctree_drag_motion (GtkWidget	       *widget,
			    GdkDragContext     *context,
			    gint                x,
			    gint                y,
			    guint               time) {
	int row, col;
	if (tm_globs->a1!=-1) {
		gtk_signal_disconnect (GTK_OBJECT (lookup_widget (tm_globs->main_window, "folder_tree")), tm_globs->a1);
		tm_globs->a1=-1;
	}
	if (tm_globs->a2!=-1) {
		gtk_signal_disconnect (GTK_OBJECT (lookup_widget (tm_globs->main_window, "folder_tree")), tm_globs->a2);
		tm_globs->a2=-1;
	}
	if (tm_globs->a3!=-1) {
		gtk_signal_disconnect (GTK_OBJECT (lookup_widget (tm_globs->main_window, "folder_tree")), tm_globs->a3);
		tm_globs->a3=-1;
	}
	gtk_clist_get_selection_info (GTK_CLIST (widget), x, y-24, &row, &col);
	gtk_clist_select_row (GTK_CLIST (widget), row, col);
}

void folder_ctree_data_received (GtkWidget          *widget,
  		    GdkDragContext     *context,
			    gint                x,
			    gint                y,
			    GtkSelectionData   *data,
			    guint               infob,
			    guint               time) {
	int row, col;
	Folder *fl;
	if (strcmp (data->data, "Unknown")==0) {
		gtk_clist_get_selection_info (GTK_CLIST (widget), x, y-24, &row, &col);
		fl=gtk_clist_get_row_data (GTK_CLIST (widget), row);
		message_transpose_folders (fl);
		GTK_CLIST (widget)->focus_row=row;
		gtk_drag_finish (context, FALSE, FALSE, time);
		gtk_clist_select_row (GTK_CLIST (widget), gtk_clist_find_row_from_data (GTK_CLIST (widget), tm_globs->visable), 0);
	} else {
		insert_warning (_("Warning: Drag authentication failed.  Do not drag from other applications into TradeClient.\n"));
	}
	if (tm_globs->a1==-1) 
		tm_globs->a1=gtk_signal_connect (GTK_OBJECT (lookup_widget (tm_globs->main_window, "folder_tree")), "tree_select_row",
		                                 GTK_SIGNAL_FUNC (clicked_on_folder), NULL);
/*	if (tm_globs->a2==-1) 
		tm_globs->a2=gtk_signal_connect (GTK_OBJECT (lookup_widget (tm_globs->main_window, "folder_tree")), "tree_unselect_row",
		                                 GTK_SIGNAL_FUNC (unclicked_on_folder), NULL);*/
	if (tm_globs->a3==-1) 
		tm_globs->a3=gtk_signal_connect (GTK_OBJECT (lookup_widget (tm_globs->main_window, "folder_tree")), "button_press_event",
		                                 GTK_SIGNAL_FUNC (t_clicked_on_folder), NULL);
}

void folder_ctree_drag_leave (GtkWidget	*widget, GdkDragContext *context, guint time) {
	if (tm_globs->a1==-1) 
		tm_globs->a1=gtk_signal_connect (GTK_OBJECT (lookup_widget (tm_globs->main_window, "folder_tree")), "tree_select_row",
		                                 GTK_SIGNAL_FUNC (clicked_on_folder), NULL);
/*	if (tm_globs->a2==-1) 
		tm_globs->a2=gtk_signal_connect (GTK_OBJECT (lookup_widget (tm_globs->main_window, "folder_tree")), "tree_unselect_row",
		                                 GTK_SIGNAL_FUNC (unclicked_on_folder), NULL);*/
	if (tm_globs->a3==-1) 
		tm_globs->a3=gtk_signal_connect (GTK_OBJECT (lookup_widget (tm_globs->main_window, "folder_tree")), "button_press_event",
		                                 GTK_SIGNAL_FUNC (t_clicked_on_folder), NULL);	
}

void message_clist_clicked_column (GtkWidget *clist, gint column, gpointer data) {
	if (GTK_CLIST (clist)->sort_type==GTK_SORT_ASCENDING) {
		GTK_CLIST (clist)->sort_type=GTK_SORT_DESCENDING;
	} else {
		GTK_CLIST (clist)->sort_type=GTK_SORT_ASCENDING;
	}
	gtk_clist_freeze (GTK_CLIST(clist));
	gtk_clist_set_sort_column (GTK_CLIST(clist), column);
#if 1
	if((column==4)||(column==5))
		gtk_clist_set_compare_func (GTK_CLIST (clist), (GtkCListCompareFunc) new_clist_sort_func);
	else
		gtk_clist_set_compare_func (GTK_CLIST (clist), (GtkCListCompareFunc) NULL);
#endif
	gtk_clist_sort (GTK_CLIST (clist));
	message_clist_reset_shading (clist);
	gtk_clist_thaw (GTK_CLIST (clist));
}

char *parsedate(char *date) {
	char *text[7] = {NULL};
	char *timebuf = NULL;
	char *buffer = NULL;
	int add, month;
	char *cs;

	add = 0;
	text[0] = cut_string(date, ' ', 1, 1);
	if (!isdigit(*text[0]))
		add = 1;

	if (add) {
		cs = cut_string(date, ' ', 1, 2);
		text[0] = cut_string(cs,' ',2,1);
		free (cs);
	} else {
		text[0] = cut_string(date, ' ', 1, 1);
	}
	cs = cut_string(date, ' ', 1, 2+add);
	text[1] = cut_string(cs,' ',2,1+add); // month
	free (cs);
	cs = cut_string(date, ' ', 1, 3+add);
	text[2] = cut_string(cs,' ',2,2+add); // year
	free (cs);
	cs = cut_string(date, ' ', 1, 4+add);
	timebuf = cut_string(cs,' ',2,3+add); // time
	free (cs);
	text[3] = cut_string(timebuf, ':', 1, 1); // hour
	cs = cut_string(timebuf, ':', 1, 2);
	text[4] = cut_string(cs,':',2,1); // minute
	free (cs);
	text[5] = cut_string(timebuf, ':', 2, 2); // day
	text[6] = cut_string(date, ' ', 2, 4+add);

	if((strncasecmp(text[1],"Jan",3)==0))
		month=10;
	else if((strncasecmp(text[1],"Feb",3)==0))
		month=11;
	else if((strncasecmp(text[1],"Mar",3)==0))
		month=12;
	else if((strncasecmp(text[1],"Apr",3)==0))
		month=13;
	else if((strncasecmp(text[1],"May",3)==0))
		month=14;
	else if((strncasecmp(text[1],"Jun",3)==0))
		month=15;
	else if((strncasecmp(text[1],"Jul",3)==0))
		month=16;
	else if((strncasecmp(text[1],"Aug",3)==0))
		month=17;
	else if((strncasecmp(text[1],"Sep",3)==0))
		month=18;
	else if((strncasecmp(text[1],"Oct",3)==0))
		month=19;
	else if((strncasecmp(text[1],"Nov",3)==0))
		month=20;
	else if((strncasecmp(text[1],"Dec",3)==0))
		month=21;
	else
		month=0;

	buffer=(char *)malloc(255*sizeof(char));
	snprintf(buffer,255,"%s%d%s%s%s%s",text[2],month,text[0], text[3], text[4], text[5]);

	if (text[0]) free (text[0]);
	if (text[1]) free (text[1]);
	if (text[2]) free (text[2]);
	if (text[3]) free (text[3]);
	if (text[4]) free (text[4]);
	if (text[5]) free (text[5]);
	if (text[6]) free (text[6]);
	if (timebuf) free (timebuf);

	return buffer;
}

gint new_clist_sort_func (GtkCList *clist, gconstpointer *ptr1, gconstpointer *ptr2) {
	GtkCListRow *row1 = (GtkCListRow *) ptr1;
	GtkCListRow *row2 = (GtkCListRow *) ptr2;
	char *text1 = GTK_CELL_TEXT (row1->cell[clist->sort_column])->text;
	char *text2 = GTK_CELL_TEXT (row2->cell[clist->sort_column])->text;
	char *one, *two;
	int retval;

	if (!text2)
		return (text1 != NULL);
	if (!text1)
		return -1;

	one = parsedate(text1);
	two = parsedate(text2);

	if (!two)
                return (one != NULL);
        if (!one)
                return -1;

	retval = strcmp(one,two);

	if (one) free (one);
	if (two) free (two);

	return retval;
}

void message_resend (GtkWidget *widget, gpointer data) {
	Message *msg=(Message *)data;
	Header_Info *info;
	char *body, *header, *recipline;
	PopAccount *pop=seek_popaccount (seek_popaccount_by_name (tm_globs->default_account));
	int length=0;
	if (!msg) { 
		insert_error (_("Message was not sent successfully\n"));
		return;
	}
	body=message_load (folder_seek (folder_seek_by_name (msg->rfolder)), msg);
	header=message_load_head (folder_seek (folder_seek_by_name (msg->rfolder)), msg);
	info=parse_header (header);
	free (header);
	if (!info->to) {
		insert_error (_("Message has no To line and cannot be resent\n"));
		return;
	}
	length+=strlen (info->to);
	if (info->cc) length+=strlen (info->cc);
	if (info->bcc) length+=strlen (info->bcc);
	recipline=(char *)calloc (length+1, 1);
	sprintf (recipline, "%s", info->to);
	if (info->cc) sprintf (recipline, "%s,%s", recipline, info->cc);
	if (info->bcc) sprintf (recipline, "%s,%s", recipline, info->bcc);

	new_fork_send_message (pop, NULL, recipline);
#if DEBUG
	printf( "I'm pretty sure this is currently broken!!!\n" ) ;
	printf( "I'm pretty sure this is currently broken!!!\n" ) ;
	printf( "I'm pretty sure this is currently broken!!!\n" ) ;
	printf( "I'm pretty sure this is currently broken!!!\n" ) ;
#endif

	tm_globs->send_timeout=gtk_timeout_add  (750, (GtkFunction)send_message_timeout, NULL);

	free (body);
	destroy_hinfo (info);
}

void clicked_on_attachment (GtkWidget *widget, gint row, gint column, GdkEventButton *event, gpointer data) {
	GtkCList *clist=GTK_CLIST (widget);
	Message *message=tm_globs->msg_selected;
	if (message) {
	char *tmpat, *msg, *retmsg;
	Attachment *att=gtk_clist_get_row_data (clist, row);
	Attachment *att2;
	if (!event) 
		return;
	if ((event->type==5) && (event->button==1)) {
		if (!data) {
			msg=message_load (folder_seek (folder_seek_by_name (message->rfolder)), message);
		} else {
			msg=strdup((char *)data);
		}
		tmpat=mime_get_attachment (msg, att);
		att2=(Attachment *)calloc (1, sizeof (Attachment));
		att2->name=strdup ("dummyatt");
		retmsg=mime_process (tmpat, att2, 1);
		free (tmpat);
/*		att3=att2->next;
		free (att2->name);
		free (att2);*/
		if ( (retmsg) && (retmsg[0]!='\0') ) {
			create_docsource_stream (strdup(retmsg));
			free (retmsg);
			retmsg=NULL;
		}
		attachments_destroy (att2);
		if (msg) free (msg);
		if (retmsg) free (retmsg);
	}
	}
}

void clicked_on_attachment_event (GtkWidget *widget, GdkEventButton *event, 
                                  gpointer data) {
	GtkWidget *popup;
	int row, column;
	Attachment *att;
	gtk_clist_get_selection_info (GTK_CLIST (widget), event->x, event->y, &row, &column);
	att=gtk_clist_get_row_data (GTK_CLIST (widget), row);
	if (row < GTK_CLIST (widget)->rows && row >= 0) {
		if (event->button==3) {
			gtk_clist_select_row (GTK_CLIST (widget), row, 0);
			popup=mime_popup_new (att);
			gtk_menu_popup (GTK_MENU (popup), NULL, NULL, NULL, NULL, 3, 0);
		}
	}
}

void attachment_save (GtkWidget *widget, gpointer data) {	
	Message *msg=tm_globs->msg_selected;
	if(msg) {
	Attachment *att=(Attachment *)data;
	char *message;
	char *matt;
	message=message_load (folder_seek(folder_seek_by_name(msg->rfolder)), msg);
	matt=mime_get_attachment (message, att);
	if (message) free (message);
	message_save_body (NULL, (gpointer *)matt);
//	if (matt) free (matt);
	}
}

void attachment_view (GtkWidget *widget, gpointer data) {
	Message *msg=tm_globs->msg_selected;
	if (msg) {
	Attachment *att=(Attachment *)data;
	Attachment *att2=(Attachment *)calloc (1, sizeof(Attachment));
	char *message=message_load (folder_seek(folder_seek_by_name(msg->rfolder)), msg);
	char *matt=mime_get_attachment (message, att);
	int hsize=message_hsize (matt);
	char *head=(char *)calloc(hsize+2, sizeof(char));
	char *retmsg;
	char *tmpmsg;
	Header_Info *hinfo;
	memmove (head, matt, hsize);

	hinfo=parse_header (head);
	free (head);
	if (message) free (message);

	if (hinfo) {
		if (strncasecmp (hinfo->content_type, "message/rfc822", 14)==0) {
			tmpmsg=strdup(matt+hsize);
			message_window_new_stream (tmpmsg);
		} else if (strncasecmp (hinfo->content_type, "multipart/digest", 16)==0) {
			digest_window_create_stream (strdup(matt));
		} else if (mime_handle (hinfo->content_type)==MIMEHANDLE_EXT) {
			message_use_ext_prog (NULL, strdup (matt));
		} else {
			retmsg=mime_process (matt, att2, 1);
			if (retmsg[0]!='\0')
				create_docsource_stream (retmsg);
		}
	}
	if (matt) free (matt);
	free (att2);
	destroy_hinfo (hinfo);
	}
}

void attachment_view_source (GtkWidget *widget, gpointer data) {
	Message *msg=tm_globs->msg_selected;
	if(msg) {
	Attachment *att=(Attachment *)data;
	char *message=message_load (folder_seek(folder_seek_by_name(msg->rfolder)), msg);
	char *matt=mime_get_attachment (message, att);
	int hsize=message_hsize (matt);
	char *head=(char *)calloc(hsize+2, sizeof(char));
	Header_Info *hinfo;
#if DEBUG > 1
	printf ("hsize=%d\n", hsize);
#endif
	memmove (head, matt, hsize);

	hinfo=parse_header (head);
	free (head);
	if (message) free (message);

	if (hinfo) {
		create_docsource_stream (strdup(matt));
	}
	if (matt) free (matt);
	destroy_hinfo (hinfo);
	}
}

void attachment_open_with (GtkWidget *widget, gpointer data) {
//	Message *msg=tm_globs->msg_selected;
//	Attachment *att=(Attachment *)data;
#if DEBUG > 1
	printf ("Viewing attachment with external progam\n");
#endif
}

void message_print_stream (char *stream) {
	int fd;
	char *buf = (char *)malloc (2048 * sizeof (char));
	char *message;
	int flags = tm_globs->flags;
	Attachment *att = (Attachment *) calloc (1, sizeof (Attachment));

	g_return_if_fail (stream != NULL);

	att->mtype = strdup ("dummyatt");

	tm_globs->flags &=~SHOW_ALL_HEADER;
	tm_globs->flags |=SHOW_SOME_HEADER;
	message = mime_process (stream, att, 0);
	tm_globs->flags = flags;
#if DEBUG > 4
	printf ("====== BEGIN printed message =======\n%s\n======= END printed message =======\n", message);
#endif
	mkdir ("/tmp/tradeclient", S_IREAD | S_IWRITE | S_IEXEC);
	fd=open ("/tmp/tradeclient/print-tmp", O_CREAT | O_TRUNC | O_WRONLY, S_IRUSR | S_IWUSR);
	if (fd<0) {
		perror ("Cannot open /tmp/tradeclient/print-tmp");
		return;
	}
	write (fd, message, strlen (stream));
	close (fd);
	snprintf(buf, 2048, "%s /tmp/tradeclient/print-tmp", tm_globs->printer);
	system (buf);
	
	if (message) free (message);
	if (att->mtype) free (att->mtype);
	if (att) free (att);
	free (buf);
	unlink ("/tmp/tradeclient/print-tmp");
}

void message_print (GtkWidget *widget, gpointer data) {
	Message *msg=tm_globs->msg_selected;
	Folder *fl;
	char *full_message;
	if (!msg) 
		return;
	fl=folder_seek (folder_seek_by_name (msg->rfolder));
	full_message=message_load (fl, msg);
	insert_message ("Printing Message ... ");
	message_print_stream (full_message);
	free (full_message);
	insert_message ("Done!\n");
}

#define getnaddr(p,ret,pos,tmps) tmps=strchr(p+pos, ',');\
                                 if (tmps) {\
                                 	ret=(char *)calloc (tmps-(p+pos)+2, sizeof(char));\
                                 	memmove (ret, p+pos, tmps-(p+pos));\
                                 	pos+=tmps-(p+pos)+1;\
                                 } else {\
                                 	ret=(char *)calloc (strlen (p+pos), sizeof(char));\
                                 	memmove (ret, p+pos, strlen (p+pos));\
                                 	pos+=strlen (p+pos);\
                                 }

void reply_to_all_stream (char *message) {
	int hsize;
	Header_Info *hinfo;
	char *tmp, *head;
	GtkWidget *window;
	GtkTree *tree;
	GtkWidget *body=NULL;
	GtkWidget *subject;
	GtkCList *clist2;
	char *cl_data[3];
	RecipSignalData *recip ;
	ADDRESS *adrlist = NIL, *adrseek = NIL;
	char adrbuffer[4096];
	AFS *afs;
	window=make_new_message_window (NULL, NULL);
	tree=GTK_TREE (lw (window, "recip_tree"));
	gtk_tree_clear_items (tree, 0, g_list_length (tree->children));
	body=lookup_widget (window, "body_textbox"); // fixes your problems

	hsize=message_hsize (message);
	head=(char *)calloc (hsize+2, sizeof(char));
	memmove (head, message, hsize);
	hinfo=parse_header (head);
	free (head);
	recip = calloc( 1, sizeof(RecipSignalData) ) ;

	if (!(tm_globs->flags & REPLY_NONE)) {
		if (tm_globs->flags & REPLY_QUOTED) {

			tmp=message_get_reply_quoted_stream (message);
			gtk_text_insert (GTK_TEXT (body), NULL, NULL, NULL, tmp, -1);
			free (tmp);

		} else {
			clist2=GTK_CLIST (lw (window, "attachment_clist"));

			afs=(AFS *)calloc (1, sizeof (AFS));
			afs->data=strdup (message);
			afs->type=strdup ("message/rfc822");
			cl_data[0]=strdup ("message/rfc822");
			cl_data[1]=strdup ("Original Message");
			cl_data[2]=(char *)calloc (20, sizeof (char));
			snprintf (cl_data[2], 19, "%lu", (unsigned long)strlen (message));
			gtk_clist_set_row_data (clist2, gtk_clist_append (clist2, cl_data), afs);
			free (cl_data[0]);
			free (cl_data[1]);
			free (cl_data[2]);
		}
	}
	if (hinfo->from) {
		rfc822_parse_adrlist(&adrlist,hinfo->from,"");
		for (adrseek=adrlist; adrseek; adrseek=adrseek->next) {
			snprintf(adrbuffer, 4096, "%s@%s", adrseek->mailbox,adrseek->host);

			recip -> tree = tree ;
			recip -> email = adrbuffer ;
			recip -> type = 0 ;
			new_message_window_add_recip( NULL, recip ) ;
		}
		mail_free_address(&adrlist);
		adrlist=NIL;
	}
        if (hinfo->to) {
		rfc822_parse_adrlist(&adrlist,hinfo->to,"");
                for (adrseek=adrlist; adrseek; adrseek=adrseek->next) {
                        snprintf(adrbuffer, 4096, "%s@%s", adrseek->mailbox,adrseek->host);
			if(!popaccount_is_my_address(adrbuffer))
			  {
			    recip -> tree = tree ;
			    recip -> email = adrbuffer ;
			    recip -> type = 0 ;
			    new_message_window_add_recip( NULL, recip ) ;
			  }
		}
                mail_free_address(&adrlist);
                adrlist=NIL;
        }
        if (hinfo->cc) {
		rfc822_parse_adrlist(&adrlist,hinfo->cc,"");
                for (adrseek=adrlist; adrseek; adrseek=adrseek->next) {
                        snprintf(adrbuffer, 4096, "%s@%s", adrseek->mailbox,adrseek->host);
			if(!popaccount_is_my_address(adrbuffer))
			  {
			    recip -> tree = tree ;
			    recip -> email = adrbuffer ;
			    recip -> type = 1 ;
			    new_message_window_add_recip( NULL, recip ) ;
			  }
		}
                mail_free_address(&adrlist);
                adrlist=NIL;
        }

	subject=lookup_widget (window, "subject_entry");

	if(!hinfo->subject) hinfo->subject = strdup("");
	tmp=(char *)calloc (strlen(hinfo->subject)+5, sizeof(char));
	if (strncasecmp ("re:", hinfo->subject, 3)!=0)
		snprintf (tmp, strlen(hinfo->subject)+5, "Re: %s", hinfo->subject);
	else
		snprintf (tmp, strlen(hinfo->subject)+5, "%s", hinfo->subject);
	if (tmp) gtk_entry_set_text (GTK_ENTRY (subject), tmp);
	destroy_hinfo (hinfo);
	if (g_list_length (tree->children)==0) {
	  recip -> tree = tree ;
	  recip -> email = NULL ;
	  recip -> type = 0 ;
	  new_message_window_add_recip( NULL, recip ) ;
	}
	if( tmp ) free (tmp);
}

void reply_to_all_clicked (GtkWidget *widget, gpointer data) {
	Message *msg=tm_globs->msg_selected;
	int hsize;
	Header_Info *hinfo;
	char *tmp, *message, *head;
	GtkWidget *window;
	GtkTree *tree;
	GtkWidget *body=NULL;
	GtkWidget *subject;
	GtkWidget *clist=lookup_widget (tm_globs->main_window, "message_clist");
	RecipSignalData *recip ;
	GtkCList *clist2;
	char *cl_data[3];
        ADDRESS *adrlist = NIL, *adrseek = NIL;
        char adrbuffer[4096];
	char *tmpadr;
	AFS *afs;
	msg=tm_globs->msg_selected;
	window=make_new_message_window (NULL, NULL);
	tree=GTK_TREE (lw (window, "recip_tree"));
	gtk_tree_clear_items (tree, 0, g_list_length (tree->children));
	body=lookup_widget (window, "body_textbox"); // fixes your problems

	message=message_load (folder_seek (folder_seek_by_name (msg->rfolder)), msg);

	hsize=message_hsize (message);
	head=(char *)calloc (hsize+2, sizeof(char));
	memmove (head, message, hsize);
	free (message);
	hinfo=parse_header (head);
	free (head);
	recip = calloc( 1, sizeof(RecipSignalData) ) ;

	if (!(tm_globs->flags & REPLY_NONE)) {
		if (tm_globs->flags & REPLY_QUOTED) {

			message=message_get_reply_quoted (msg);
			gtk_text_insert (GTK_TEXT (body), NULL, NULL, NULL, message, -1);
			free (message);

		} else {
			clist2=GTK_CLIST (lw (window, "attachment_clist"));

			afs=(AFS *)calloc (1, sizeof (AFS));
			afs->data=strdup (message);
			afs->type=strdup ("message/rfc822");
			cl_data[0]=strdup ("message/rfc822");
			cl_data[1]=strdup ("Original Message");
			cl_data[2]=(char *)calloc (20, sizeof (char));
			snprintf (cl_data[2], 19, "%lu", (unsigned long)strlen (message));
			gtk_clist_set_row_data (clist2, gtk_clist_append (clist2, cl_data), afs);
			free (cl_data[0]);
			free (cl_data[1]);
			free (cl_data[2]);
		}
	}

	if ((msg)&&(GTK_CLIST (clist)->selection)) {

        if (hinfo->from) {
		tmpadr=strdup(hinfo->from);
                rfc822_parse_adrlist(&adrlist,tmpadr,"");
                for (adrseek=adrlist; adrseek; adrseek=adrseek->next) {
                        snprintf(adrbuffer, 4096, "%s@%s", adrseek->mailbox,adrseek->host);
			recip -> tree = tree ;
			recip -> email = adrbuffer ;
			recip -> type = 0 ;
			new_message_window_add_recip( NULL, recip ) ;
                }
                mail_free_address(&adrlist);
                adrlist=NIL;
		free(tmpadr);
        }
        if (hinfo->to) {
		tmpadr=strdup(hinfo->to);
                rfc822_parse_adrlist(&adrlist,tmpadr,"");
                for (adrseek=adrlist; adrseek; adrseek=adrseek->next) {
                        snprintf(adrbuffer, 4096, "%s@%s", adrseek->mailbox,adrseek->host);
                        if(!popaccount_is_my_address(adrbuffer))
			  {
			    recip -> tree = tree ;
			    recip -> email = adrbuffer ;
			    recip -> type = 0 ;
			    new_message_window_add_recip( NULL, recip ) ;
			  }
                }
                mail_free_address(&adrlist);
                adrlist=NIL;
		free(tmpadr);
        }
        if (hinfo->cc) {
		tmpadr=strdup(hinfo->cc);
                rfc822_parse_adrlist(&adrlist,tmpadr,"");
                for (adrseek=adrlist; adrseek; adrseek=adrseek->next) {
                        snprintf(adrbuffer, 4096, "%s@%s", adrseek->mailbox,adrseek->host);
                        if(!popaccount_is_my_address(adrbuffer))
			  {
			    recip -> tree = tree ;
			    recip -> email = adrbuffer ;
			    recip -> type = 1 ;
			    new_message_window_add_recip( NULL, recip ) ;
			  }
                }
                mail_free_address(&adrlist);
                adrlist=NIL;
		free(tmpadr);
        }

		destroy_hinfo (hinfo);

		subject=lookup_widget (window, "subject_entry");

		tmp=(char *)calloc (strlen(msg->subject)+5, sizeof(char));
		if (strncasecmp ("re:", msg->subject, 3)!=0)
			snprintf (tmp, strlen(msg->subject)+5, "Re: %s", msg->subject);
		else
			snprintf (tmp, strlen(msg->subject)+5, "%s", msg->subject);
		if (tmp) gtk_entry_set_text (GTK_ENTRY (subject), tmp);
		free (tmp);
	}
}

void main_window_sender_add (GtkWidget *widget, gpointer data) {
	Abook *abook=data;
	Message *msg=tm_globs->msg_selected;
	if (msg) {
		char *email, *first, *last;
		if (parse_from_line (msg->from, &email, &first, &last)) {
			if (!abook_entry_seek_by_email (abook, email)) {
				Abook_entry *entry=abook_entry_new (abook);
				abook_entry_set_default (entry, email);
				entry->first=first;
				entry->last=last;
				abook_entry_create (entry, entry);
			} else {
				insert_warning ("You already have them in that addressbook\n");
			}
		} else {
			insert_error ("Unable to parse from line\n");
		}
	}
}




/*
 * This function has really BAD race conditions in it.  We need to make sure
 * that accounts are checked serially for now.  Hopefully in the near future,
 * we'll check all accounts concurrently.
 */
int message_event_loop () {
  int cnt ;
  int isBusy ;
  int busyID ;
  PopAccount *pop;
  time_t t=time (NULL);


#ifdef DMALLOC
  dmalloc_verify( NULL ) ;
#endif
  /*
   * Notice, if we are already checking messages, don't do this!
   * If this is the case, return and don't poll the accounts.
   * The catch is, this only checks against when the use has
   * hit the get messages button.  It doesn't guard against this
   * function being called multiple times per second!
   */
#if DEBUG > 4
  printf( "message_event_loop() is running on timer.\n" ) ;
#endif

  cnt = 0 ;
  if( tm_globs -> pid == -1 ) {
    /*
     * Count how many accounts we have and figure out if any are busy.
     */
    isBusy = 0 ;
    busyID = -1 ;
    
    for( pop = first_popaccount() ; pop ; pop = pop -> next ) {
#if DEBUG > 4
      printf( "#%d has pid of %d && spid of %d.\n", pop -> id, pop -> pid, pop -> spid ) ;
#endif
      if( (pop -> pid != -1) || (pop -> spid != -1) ) isBusy = 1 ;
      if( (busyID == -1 ) && (pop -> busy) ) busyID = cnt ;
      cnt++ ;
    }

#if DEBUG > 4
    printf( "There are %d accounts that may need to be serviced.  isBusy = %d\n", cnt, isBusy ) ;
#endif

    if( (isBusy == 0) && (cnt) ) {
      /* Now, figure out which account to check is next */
      if( busyID == -1 ) busyID = 0 ;
      else {
	pop = seek_popaccount( busyID ) ;
	if( pop ) {
	  pop -> busy = 0 ;
	  busyID = (++busyID)%cnt ;
	}
      }

#ifdef DMALLOC
	dmalloc_verify( NULL ) ;
#endif
      /* Now, see if we need to attend to the account */
#if DEBUG > 4
      printf( "Checking account %d on timer basis.\n", busyID ) ;
#endif
      pop = seek_popaccount( busyID ) ;
      if( pop ) {
	pop -> busy = 1 ;
	if( (pop->check_at == 0) && (pop->timeout != 0) ) pop -> check_at = t + pop->timeout * 60 ;
	if( (pop->check_at <= t) && (pop->timeout != 0) ) {
	  insert_message( _("Automatically fetching messages on account '%s'.  'Get Messages' is disabled for the duration.\n"), pop->name);
	  pop->check_at= t + pop->timeout * 60;	
	  
	  /*
	   * Since we are fetching messages, we need to disable the GUI to keep a conflict
	   * of a double fetch from biting us.  Don't worry, when the fetch announces a
	   * "DONE", the GUI will be unlocked again.  Ya!  Sweet!
	   */
	  gtk_widget_set_sensitive( lookup_widget( tm_globs -> main_window, "get_message" ), FALSE ) ;
	  gtk_widget_set_sensitive( lookup_widget( tm_globs -> status, "stopthat" ), TRUE ) ;
	  gtk_widget_set_sensitive( lookup_widget( tm_globs -> status, "skip"), TRUE ) ;
	  if( !(tm_globs->flags & HIDE_STATUS_WINDOW) ) show_status( NULL, NULL ) ;
	  
	  /* Get the messages */
/* no! don't remove the timeout, wtf? 
	  gtk_timeout_remove( tm_globs -> getMsgTimeout ) ;
*/
#if 0
          if (pop->type==IMAP) {
		nf_imap_check_mail (pop);
          } else {
		fork_receive_message1 (pop->id, 1);
	  }
#else
		fork_receive_messages (pop->id);
#endif
	  
	  /* Make sure we know when it's done. */
	  tm_globs->getMsgTimeout=gtk_timeout_add( 125, (GtkFunction)get_message_timeout, NULL ) ;
	}
      }
    }
  }
#ifdef DMALLOC
  dmalloc_verify( NULL ) ;
#endif

#if DEBUG > 8
  printf( "Counted %d accounts that are ready to fetch from.\n", cnt ) ;
#endif
  return TRUE ;
}



/*
 * This function is the event loop that handles calendar reminders
 * and application execution.  It should fire once every hour.  In
 * short, this loop will look for the nearest event to schedule.
 * When it determines the closest event, it will create another
 * timer to only handle the single event.  In turn, it will cause
 * this event to trigger again to automatically cause it to be
 * rescheduled any other pending (closest) event.  As a reminder,
 * this function should be called anytime an event is added or deleted.
 */
int
calendar_event_loop()
{
  Llist *ev ;
  time_t ct ;
  int waitTime ;
  CalendarEvent *cev ;
  CalendarEvent *nearEvent ;


  /* If there are no pending events, just reschedule us and return. */
#ifdef DMALLOC
  dmalloc_verify( NULL ) ;
#endif
  ev = event_first() ;
  if( ev )
    {

      /* Remember, we really only want the events that have reminders */
      ct = time( NULL ) ;
      nearEvent = (CalendarEvent *)NULL ;
      while( ev )
	{
	  /* Grab the event node from the current linked node */
	  cev = (CalendarEvent *)ev -> data ;
	  if( cev -> flags & EVENT_REMINDER )
	    {
	      if( !nearEvent &&
		  (cev -> start -> time - ((cev -> reminder)*60)) >= ct )
		{
		  nearEvent = cev ;
		}
	      else
		{
		  /*
		   * Don't forget that we need to also include pre-time offset
		   * in our calculation.
		   */
		  if( ((cev -> start -> time - (((cev -> reminder)*60))) >= ct) &&
		      ((cev -> start -> time - ((cev -> reminder)*60)) <
		       (nearEvent -> start -> time - ((nearEvent -> reminder)*60))) )
		    nearEvent = cev ;
		}
	    }

	  /* Go to the next linked node */
	  ev = ev -> next ;
	}

      if( nearEvent )
	{
	  /*
	   * Now we find the soonest that a reminder event will need to fire, so let's
	   * calculate the duration needed for the timer.  Remember to take into account
	   * the early warning option available (e.g. 5-minutes early).
	   */
	  waitTime = (nearEvent -> start -> time - ((nearEvent -> reminder)*60) - ct) * 1000 ;
	  if( waitTime > 0 )
	    {
#if DEBUG > 4
	      printf( "start time = %d, reminder = %d, ct = %d\n",
		      (int)nearEvent -> start -> time, ((nearEvent -> reminder)*60), (int)ct ) ;
	      printf( "Found a near event have sequence of %ld!\n", nearEvent -> sequence ) ;
	      printf( "Will fire in %d seconds.\n", waitTime/1000 ) ;
#endif
	      
	      /* Remember, we need to delete the old event just incase the near event is not the old event */
	      if( tm_globs -> eventTriggerTimeout ) gtk_timeout_remove( tm_globs -> eventTriggerTimeout ) ;

	      /* Schedule the event to fire - notice we pass the event */
	      tm_globs -> eventTriggerTimeout = gtk_timeout_add( waitTime, (GtkFunction)calendar_event_trigger, nearEvent ) ;
	    }
	}
    }

  /* Reschedule us to fire in an hour */
  tm_globs -> eventLoopTimeout = gtk_timeout_add( 60*60*1000, (GtkFunction)calendar_event_loop, NULL ) ;

#ifdef DMALLOC
  dmalloc_verify( NULL ) ;
#endif

  return 0 ;
}


/*
 * This is the trigger timer.  This function will fire when an event has really be
 * fired.  The result is this function will take care of poping up reminder windows
 * or forking to execute other applications.
 */
int
calendar_event_trigger(CalendarEvent *event)
{
  char *text;
  char *program;
  char reminder[6] = {0};
  char msgText[] = "%s at %s in %s minutes." ;


  if ((!event->reminder)||((event->reminder)<=0)) {
    calendar_event_loop();
    return 0;
  }

#ifdef DMALLOC
  dmalloc_verify( NULL ) ;
#endif

  sprintf(reminder, "%d", event->reminder);
  text = (char *)malloc (strlen (event->subject) + strlen(event->location) +
			 strlen (reminder) + strlen(msgText) + 1 ) ;
  sprintf (text, msgText, event->subject,
	   event->location, reminder);

  popup_reminder(text);
  if (text) free (text);

  if (event->program) {
    if (strlen(event->program)>0) {
      program = (char *)malloc( strlen(event->program) + 4 ) ;
      sprintf (program, "%s &", event->program);
      system(program);
      free (program);
    }
  }

#if DEBUG > 4
  printf( "calendar_event_trigger() is scheduling calendar_event_loop().\n" ) ;
#endif

#ifdef DMALLOC
  dmalloc_verify( NULL ) ;
#endif

  calendar_event_loop();

#ifdef DMALLOC
  dmalloc_verify( NULL ) ;
#endif

  return 0 ;
}

void popup_reminder(char *the_text) {
	GtkWidget *window, *box, *text, *button;

  window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_name (window, "window");
  gtk_object_set_data (GTK_OBJECT (window), "window", window);
  gtk_window_set_title (GTK_WINDOW (window), "Event Notification");
  gtk_window_set_default_size (GTK_WINDOW (window), 300, 100);

  box = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (box, "box");
  gtk_widget_ref (box);
  gtk_object_set_data_full (GTK_OBJECT (window), "box", box,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (box);
  gtk_container_add (GTK_CONTAINER (window), box);

  text = gtk_label_new (the_text);
  gtk_widget_set_name (text, "text");
  gtk_widget_ref (text);
  gtk_object_set_data_full (GTK_OBJECT (window), "text", text,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (text);
  gtk_box_pack_start (GTK_BOX (box), text, TRUE, TRUE, 0);

  button = gtk_button_new_with_label ("Ok");
  gtk_widget_set_name (button, "button");
  gtk_widget_ref (button);
  gtk_object_set_data_full (GTK_OBJECT (window), "button", button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button);
  gtk_box_pack_start (GTK_BOX (box), button, FALSE, FALSE, 0);

  gtk_signal_connect (GTK_OBJECT (window), "delete_event",
                      GTK_SIGNAL_FUNC (gtk_false),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (window), "destroy",
                      GTK_SIGNAL_FUNC (gtk_widget_destroy),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button), "clicked",
                      GTK_SIGNAL_FUNC (en_button_clicked),
                      NULL);
  gtk_widget_show (window);
}

void en_button_clicked (GtkWidget *widget, gpointer userdata) {
	gtk_widget_destroy(lookup_widget(widget, "window"));
}

void empty_trash_callback (GtkWidget *widget, gpointer userdata) {
	Folder *fseek;
	Message *mseek;
	char *number;
	Folder *trash = folder_seek (folder_seek_by_name ("Trash"));
	GList *list = NULL;
        GtkWidget *folder_ctree = lookup_widget (tm_globs->main_window, "folder_tree");
	GtkWidget *message_clist = lookup_widget (tm_globs->main_window, "message_clist");
	
	if(!trash) return;

        for (fseek=folder_first ();fseek;fseek=fseek->next) {
		for (mseek=fseek->msglst;mseek;mseek=mseek->next) {
			if (strcasecmp (mseek->folder, "Trash")==0) {
				trash->total = 0;
				trash->unread = 0;

				list = g_list_append (list, mseek);

				number=(char *)calloc (5, sizeof(char));
				snprintf (number, 5, "%d", trash->unread);
				gtk_ctree_node_set_text (GTK_CTREE (folder_ctree), trash->tree_item, 1, number);
				snprintf (number, 5, "%d", trash->total);
				gtk_ctree_node_set_text (GTK_CTREE (folder_ctree), trash->tree_item, 2, number);
				free (number);


			}
		}
	}
	g_list_foreach (list, GTK_SIGNAL_FUNC(destroy_message), NULL);
	g_list_free (list);
	message_selection_null();
	gtk_clist_unselect_all (GTK_CLIST (folder_ctree));
	folder_display (GTK_CLIST (message_clist), trash);
}
