/* TradeClient <http://tradeclient.sourceforge.net>
 * $Id: main-window.c,v 1.34 2001/03/20 22:54:23 ttabner Exp $
 *
 * Copyright (C) 1999-2000 Bynari Inc.
 * Copyright (C) 2001 Project TradeClient
 *
 * LGPL
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#include "puma.h"


GtkTargetEntry target_table[] = {
  { "STRING",     0, TARGET_STRING },
  { "text/plain", 0, TARGET_STRING },
  { "text/uri-list", 0, TARGET_URL },
  { "application/x-rootwin-drop", 0, TARGET_ROOTWIN }
};
guint n_targets = sizeof(target_table) / sizeof(target_table[0]);

GtkWidget* create_main_window () {
  GtkWidget *main_window;
  GtkWidget *table1;
  GtkWidget *toolbar_handlebox;
  GtkWidget *toolbar1;
  GtkWidget *tmp_toolbar_icon;
  GtkWidget *get_message;
  GtkWidget *new_message;
  GtkWidget *reply_to;
  GtkWidget *reply_to_all;
  GtkWidget *forward;
  GtkWidget *delete_button;
  GtkWidget *print;
  GtkWidget *menu_handlebox;
  GtkWidget *main_menubar;
  GtkWidget *file1;
  GtkWidget *file1_menu;
  GtkAccelGroup *file1_menu_accels;
  GtkWidget *new_message2;
  GtkWidget *new_folder1;
  GtkWidget *save_message1;
  GtkWidget *save_message_as;
	GtkWidget *del_menu;
	GtkWidget *mark_unread;
	GtkWidget *msearch;
	GtkWidget *send_to_html;
  GtkWidget *separator5;
  GtkWidget *import1;
  GtkWidget *import1_menu;
  GtkAccelGroup *import1_menu_accels;
  GtkWidget *outlook_pst1;
  GtkWidget *outlook_vcf1;
  GtkWidget *export1;
  GtkWidget *export1_menu;
  GtkAccelGroup *export1_menu_accels;
  GtkWidget *outlook_pst2;
  GtkWidget *outlook_vcf2;
  GtkWidget *separator6;
  GtkWidget *print1;
  GtkWidget *printer_setup1;
  GtkWidget *separator10;
  GtkWidget *empty_trash;
  GtkWidget *mi_undel, *mi_compact;
  GtkWidget *close2;
  GtkWidget *exit1;
	GtkWidget *calendar;
  GtkWidget *settings1;
  GtkWidget *settings1_menu;
  GtkAccelGroup *settings1_menu_accels;
  GtkWidget *preferences1;
  GtkWidget *statusbar1;
  GtkWidget *hpaned1;
  GtkWidget *scrolledwindow15;
  GtkWidget *scrolledwindow152;
  GtkWidget *folder_tree, *folder_ntree;
  GtkWidget *folder_vbox;
  GtkWidget *hseparator1;
  GtkWidget *label39, *label392;
  GtkWidget *label40, *label402;
  GtkWidget *label41, *label412;
  GtkWidget *vpaned1;
  GtkWidget *scrolledwindow16;
  GtkWidget *message_clist;
  GtkWidget *label42;
  GtkWidget *label43;
  GtkWidget *label44;
  GtkWidget *label45;
  GtkWidget *label46;
  GtkWidget *l_date;
  GtkWidget *body_scroller;
  GtkWidget *message_body;
  GtkWidget *help1;
  GtkWidget *help1_menu;
	GtkWidget *address_book;
//	GtkWidget *calendar;
//	GtkWidget *contact;
	GtkWidget *docsource;
	GtkWidget *rules;
	GtkWidget *cal_menuitem;
	GtkWidget *tearoff;
  GtkAccelGroup *help1_menu_accels;
	GtkWidget *mime_frame;
	GtkWidget *mime_vpaned;
	GtkWidget *mime_scrolledwindow;
	GtkWidget *mime_clist;
	GdkPixmap *drag_icon;
	GdkBitmap *drag_mask;
	
	GtkWidget *status;
  GtkWidget *about_bynari_tradeclient1;
  GtkWidget *mwscroll, *mwviewport;
	char *title;
  GtkAccelGroup *accel_group;

  accel_group = gtk_accel_group_new ();

  main_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_name (main_window, "main_window");
  gtk_object_set_data (GTK_OBJECT (main_window), "main_window", main_window);
  gtk_widget_set_usize (main_window, 620, 440);
#if 0
  gtk_widget_set_uposition (main_window, 10, 10);
#endif
	title=(char *)calloc (1024, sizeof(char));
	snprintf (title, 1024, _("TradeClient %s"), VERSION);
  gtk_window_set_title (GTK_WINDOW (main_window), (title));
	free (title);
  gtk_window_set_policy (GTK_WINDOW (main_window), FALSE, TRUE, FALSE);
	
  table1 = gtk_table_new (3, 2, FALSE);
  gtk_widget_show (table1);
  gtk_container_add (GTK_CONTAINER (main_window), table1);

  mwscroll = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (mwscroll);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "mwscroll", mwscroll,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mwscroll);
  gtk_table_attach (GTK_TABLE (table1), mwscroll, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (mwscroll),
		GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);

  mwviewport = gtk_viewport_new (NULL, NULL);
  gtk_widget_ref (mwviewport);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "mwviewport", mwviewport,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mwviewport);
  gtk_container_add (GTK_CONTAINER (mwscroll), mwviewport);

  toolbar_handlebox = gtk_handle_box_new ();
  gtk_widget_show (toolbar_handlebox);
  gtk_container_add (GTK_CONTAINER (mwviewport), toolbar_handlebox);
  gtk_handle_box_set_shadow_type (GTK_HANDLE_BOX (toolbar_handlebox), GTK_SHADOW_NONE);
  gtk_handle_box_set_handle_position (GTK_HANDLE_BOX (toolbar_handlebox), GTK_POS_TOP);

  toolbar1 = gtk_toolbar_new (GTK_ORIENTATION_VERTICAL, GTK_TOOLBAR_BOTH);
  gtk_widget_show (toolbar1);
  gtk_container_add (GTK_CONTAINER (toolbar_handlebox), toolbar1);
  gtk_toolbar_set_button_relief (GTK_TOOLBAR (toolbar1), GTK_RELIEF_NONE);
  tmp_toolbar_icon = pixmap_widget_create (main_window, PIXMAP_GET);
  get_message = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                (_("Get Messages")),
                                "Get New Messages", NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_set_name (get_message, "get_message");
  gtk_widget_ref (get_message);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "get_message", get_message,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (get_message);

  tmp_toolbar_icon = pixmap_widget_create (main_window, PIXMAP_ENVELOPE);
  new_message = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                (_("New Message")),
                                "Compose a new message", NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_set_name (new_message, "new_message");
  gtk_widget_ref (new_message);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "new_message", new_message,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (new_message);

  tmp_toolbar_icon = pixmap_widget_create (main_window, PIXMAP_REPLY);
  reply_to = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                (_("Reply")),
                                "Reply to selected message", NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_set_name (reply_to, "reply_to");
  gtk_widget_ref (reply_to);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "reply_to", reply_to,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (reply_to);
  gtk_widget_set_sensitive (reply_to, FALSE);

  tmp_toolbar_icon = pixmap_widget_create (main_window, PIXMAP_REPLYALL);
  reply_to_all = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                (_("Reply to All")),
                                "Reply to all, on the selected message", NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_set_name (reply_to_all, "reply_to_all");
  gtk_widget_ref (reply_to_all);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "reply_to_all", reply_to_all,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (reply_to_all);
	gtk_widget_set_sensitive (reply_to_all, FALSE);

  tmp_toolbar_icon = pixmap_widget_create (main_window, PIXMAP_FORWARD);
  forward = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                (_("Forward")),
                                "Forward the selected message", NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_set_name (forward, "forward");
  gtk_widget_ref (forward);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "forward", forward,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (forward);
	gtk_widget_set_sensitive (forward, FALSE);

  tmp_toolbar_icon = pixmap_widget_create (main_window, PIXMAP_AX);
  delete_button = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                (_("Delete")),
                                "Delete selected messages", NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_set_name (delete_button, "delete_button");
  gtk_widget_ref (delete_button);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "delete_button", delete_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (delete_button);
	gtk_widget_set_sensitive (delete_button, FALSE);

  tmp_toolbar_icon = pixmap_widget_create (main_window, PIXMAP_PRINT);
  print = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                (_("Print")),
                                "Print the selected message", NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_set_name (print, "print");
  gtk_widget_ref (print);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "print", print,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (print);
	gtk_widget_set_sensitive (print, FALSE);

	tmp_toolbar_icon = pixmap_widget_create (main_window, PIXMAP_ABOOK);
  address_book = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                (_("Address book")),
                                "Open the address book", NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_set_name (address_book, "address_book");
  gtk_widget_ref (address_book);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "address_book", address_book,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (address_book);

	tmp_toolbar_icon = pixmap_widget_create (main_window, PIXMAP_CALENDAR);
  calendar = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                (_("Calendar")),
                                "Open the calendar", NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_set_name (calendar, "calendar");
  gtk_widget_ref (calendar);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "calendar", calendar,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (calendar);
//	gtk_widget_set_sensitive (calendar, FALSE);

/*	tmp_toolbar_icon = pixmap_widget_create (main_window, PIXMAP_CHECKMARK);
  contact = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                ("Contacts"),
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_set_name (contact, "contact");
  gtk_widget_ref (contact);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "contact", contact,
                            (GtkDestroyNotify) gtk_widget_unref);
//  gtk_widget_show (contact);
	gtk_widget_set_sensitive (contact, FALSE);*/



  menu_handlebox = gtk_handle_box_new ();
  gtk_widget_set_name (menu_handlebox, "menu_handlebox");
  gtk_widget_ref (menu_handlebox);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "menu_handlebox", menu_handlebox,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menu_handlebox);
  gtk_table_attach (GTK_TABLE (table1), menu_handlebox, 0, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);

  main_menubar = gtk_menu_bar_new ();
  gtk_widget_set_name (main_menubar, "main_menubar");
  gtk_widget_ref (main_menubar);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "main_menubar", main_menubar,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (main_menubar);
  gtk_container_add (GTK_CONTAINER (menu_handlebox), main_menubar);
  gtk_menu_bar_set_shadow_type (GTK_MENU_BAR (main_menubar), GTK_SHADOW_ETCHED_IN);

  file1 = gtk_menu_item_new_with_label (_("File"));
//	gtk_container_add (GTK_CONTAINER (file1), gtk_label_new ("File"));
  gtk_widget_set_name (file1, "file1");
  gtk_widget_ref (file1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "file1", file1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (file1);
  gtk_container_add (GTK_CONTAINER (main_menubar), file1);

  file1_menu = gtk_menu_new ();
  gtk_widget_set_name (file1_menu, "file1_menu");
  gtk_widget_ref (file1_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "file1_menu", file1_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (file1), file1_menu);
  file1_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (file1_menu));

	tearoff=gtk_tearoff_menu_item_new ();
	gtk_widget_show (tearoff);
	gtk_container_add (GTK_CONTAINER (file1_menu), tearoff);

  new_message2 = gtk_menu_item_new_with_label (_("New Message..."));
  gtk_widget_set_name (new_message2, "new_message2");
  gtk_widget_ref (new_message2);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "new_message2", new_message2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (new_message2);
  gtk_container_add (GTK_CONTAINER (file1_menu), new_message2);
  gtk_widget_add_accelerator (new_message2, "activate", accel_group,
                              GDK_n, GDK_MOD1_MASK,
                              GTK_ACCEL_VISIBLE);

  new_folder1 = gtk_menu_item_new_with_label (_("New Folder..."));
  gtk_widget_set_name (new_folder1, "new_folder1");
  gtk_widget_ref (new_folder1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "new_folder1", new_folder1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (new_folder1);
  gtk_container_add (GTK_CONTAINER (file1_menu), new_folder1);
  gtk_widget_add_accelerator (new_folder1, "activate", accel_group,
                              GDK_f, GDK_MOD1_MASK,
                              GTK_ACCEL_VISIBLE);

  save_message1 = gtk_menu_item_new_with_label (_("Save Message"));
  gtk_widget_set_name (save_message1, "save_message1");
  gtk_widget_ref (save_message1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "save_message1", save_message1,
                            (GtkDestroyNotify) gtk_widget_unref);
//  gtk_widget_show (save_message1);
  gtk_container_add (GTK_CONTAINER (file1_menu), save_message1);
	gtk_widget_set_sensitive (save_message1, FALSE);

  save_message_as = gtk_menu_item_new_with_label (_("Save Message As..."));
  gtk_widget_set_name (save_message_as, "save_message_as");
  gtk_widget_ref (save_message_as);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "save_message_as", save_message_as,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (save_message_as);
  gtk_container_add (GTK_CONTAINER (file1_menu), save_message_as);
  gtk_widget_add_accelerator (save_message_as, "activate", accel_group,
                              GDK_s, GDK_MOD1_MASK,
                              GTK_ACCEL_VISIBLE);
	gtk_widget_set_sensitive (save_message_as, FALSE);

  del_menu = gtk_menu_item_new_with_label (_("Delete Message"));
  gtk_widget_set_name (del_menu, "del_menu");
  gtk_widget_ref (del_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "del_menu", del_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (del_menu);
  gtk_container_add (GTK_CONTAINER (file1_menu), del_menu);
  gtk_widget_add_accelerator (del_menu, "activate", accel_group,
                              GDK_d, GDK_MOD1_MASK,
                              GTK_ACCEL_VISIBLE);

  separator5 = gtk_menu_item_new ();
  gtk_widget_set_name (separator5, "separator5");
  gtk_widget_ref (separator5);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "separator5", separator5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (separator5);
  gtk_container_add (GTK_CONTAINER (file1_menu), separator5);
  gtk_widget_set_sensitive (separator5, FALSE);

  msearch = gtk_menu_item_new_with_label (_("Message Search"));
  gtk_widget_ref (msearch);
  gtk_object_set_data_full (GTK_OBJECT (file1_menu), "msearch", msearch,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (msearch);
  gtk_container_add (GTK_CONTAINER (file1_menu), msearch);
  gtk_widget_add_accelerator (msearch, "activate", accel_group,
                              GDK_m, GDK_MOD1_MASK,
                              GTK_ACCEL_VISIBLE);

  mark_unread = gtk_menu_item_new_with_label (_("Toggle Read State"));
  gtk_widget_ref (mark_unread);
  gtk_object_set_data_full (GTK_OBJECT (file1_menu), "mark_unread", mark_unread,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mark_unread);
  gtk_container_add (GTK_CONTAINER (file1_menu), mark_unread);
  gtk_widget_add_accelerator (mark_unread, "activate", accel_group,
                              GDK_t, GDK_MOD1_MASK,
                              GTK_ACCEL_VISIBLE);

  send_to_html = gtk_menu_item_new_with_label (_("View with Web Browser"));
  gtk_widget_ref (send_to_html);
  gtk_object_set_data_full (GTK_OBJECT (file1_menu), "send_to_html",
	send_to_html, (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (send_to_html);
  gtk_container_add (GTK_CONTAINER (file1_menu), send_to_html);

  separator5 = gtk_menu_item_new ();
  gtk_widget_set_name (separator5, "separator5");
  gtk_widget_ref (separator5);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "separator5", separator5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (separator5);
  gtk_container_add (GTK_CONTAINER (file1_menu), separator5);
  gtk_widget_set_sensitive (separator5, FALSE);

  import1 = gtk_menu_item_new_with_label (_("Import"));
  gtk_widget_set_name (import1, "import1");
  gtk_widget_ref (import1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "import1", import1,
                            (GtkDestroyNotify) gtk_widget_unref);
//  gtk_widget_show (import1);
  gtk_container_add (GTK_CONTAINER (file1_menu), import1);
	gtk_widget_set_sensitive (import1, FALSE);

  import1_menu = gtk_menu_new ();
  gtk_widget_set_name (import1_menu, "import1_menu");
  gtk_widget_ref (import1_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "import1_menu", import1_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (import1), import1_menu);
  import1_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (import1_menu));

  outlook_pst1 = gtk_menu_item_new_with_label (_("Outlook PST"));
  gtk_widget_set_name (outlook_pst1, "outlook_pst1");
  gtk_widget_ref (outlook_pst1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "outlook_pst1", outlook_pst1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (outlook_pst1);
  gtk_container_add (GTK_CONTAINER (import1_menu), outlook_pst1);

  outlook_vcf1 = gtk_menu_item_new_with_label (_("Outlook VCF"));
  gtk_widget_set_name (outlook_vcf1, "outlook_vcf1");
  gtk_widget_ref (outlook_vcf1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "outlook_vcf1", outlook_vcf1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (outlook_vcf1);
  gtk_container_add (GTK_CONTAINER (import1_menu), outlook_vcf1);

  export1 = gtk_menu_item_new_with_label (_("Export"));
  gtk_widget_set_name (export1, "export1");
  gtk_widget_ref (export1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "export1", export1,
                            (GtkDestroyNotify) gtk_widget_unref);
//  gtk_widget_show (export1);
  gtk_container_add (GTK_CONTAINER (file1_menu), export1);
	gtk_widget_set_sensitive (export1, FALSE);

  export1_menu = gtk_menu_new ();
  gtk_widget_set_name (export1_menu, "export1_menu");
  gtk_widget_ref (export1_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "export1_menu", export1_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (export1), export1_menu);
  export1_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (export1_menu));

  outlook_pst2 = gtk_menu_item_new_with_label (("Outlook PST"));
  gtk_widget_set_name (outlook_pst2, "outlook_pst2");
  gtk_widget_ref (outlook_pst2);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "outlook_pst2", outlook_pst2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (outlook_pst2);
  gtk_container_add (GTK_CONTAINER (export1_menu), outlook_pst2);

  outlook_vcf2 = gtk_menu_item_new_with_label (("Outlook VCF"));
  gtk_widget_set_name (outlook_vcf2, "outlook_vcf2");
  gtk_widget_ref (outlook_vcf2);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "outlook_vcf2", outlook_vcf2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (outlook_vcf2);
  gtk_container_add (GTK_CONTAINER (export1_menu), outlook_vcf2);

  separator6 = gtk_menu_item_new ();
  gtk_widget_set_name (separator6, "separator6");
  gtk_widget_ref (separator6);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "separator6", separator6,
                            (GtkDestroyNotify) gtk_widget_unref);
//  gtk_widget_show (separator6);
  gtk_container_add (GTK_CONTAINER (file1_menu), separator6);
  gtk_widget_set_sensitive (separator6, FALSE);

  print1 = gtk_menu_item_new_with_label (_("Print"));
  gtk_widget_set_name (print1, "print1");
  gtk_widget_ref (print1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "print1", print1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (print1);
  gtk_container_add (GTK_CONTAINER (file1_menu), print1);
  gtk_widget_add_accelerator (print1, "activate", accel_group,
                              GDK_p, GDK_MOD1_MASK,
                              GTK_ACCEL_VISIBLE);
//	gtk_widget_set_sensitive (print1, FALSE);

  printer_setup1 = gtk_menu_item_new_with_label (_("Printer Setup"));
  gtk_widget_set_name (printer_setup1, "printer_setup1");
  gtk_widget_ref (printer_setup1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "printer_setup1", printer_setup1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (printer_setup1);
  gtk_container_add (GTK_CONTAINER (file1_menu), printer_setup1);

  separator10 = gtk_menu_item_new ();
  gtk_widget_set_name (separator10, "separator10");
  gtk_widget_ref (separator10);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "separator10", separator10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (separator10);
  gtk_container_add (GTK_CONTAINER (file1_menu), separator10);
  gtk_widget_set_sensitive (separator10, FALSE);

  empty_trash = gtk_menu_item_new_with_label(_("Empty Trash"));
  gtk_widget_set_name(empty_trash,"empty_trash");
  gtk_widget_ref(empty_trash);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "empty_trash",empty_trash,
                  (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show(empty_trash);
  gtk_container_add(GTK_CONTAINER(file1_menu), empty_trash);
  gtk_widget_add_accelerator (empty_trash, "activate", accel_group,
                              GDK_e, GDK_MOD1_MASK,
                              GTK_ACCEL_VISIBLE);

  mi_undel=gtk_menu_item_new_with_label(_("Undelete Messages"));
  gtk_widget_set_name(mi_undel,"mi_undel");
  gtk_widget_ref(mi_undel);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "mi_undel",mi_undel,
		  (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show(mi_undel);
  gtk_container_add(GTK_CONTAINER(file1_menu), mi_undel);

  mi_compact=gtk_menu_item_new_with_label(_("Compact Folders"));
  gtk_widget_set_name(mi_compact,"mi_compact");
  gtk_widget_ref(mi_compact);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "mi_compact",mi_compact,
		  (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show(mi_compact);
  gtk_container_add(GTK_CONTAINER(file1_menu), mi_compact);

  separator10 = gtk_menu_item_new ();
  gtk_widget_set_name (separator10, "separator10");
  gtk_widget_ref (separator10);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "separator10", separator10,
		  (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (separator10);
  gtk_container_add (GTK_CONTAINER (file1_menu), separator10);
  gtk_widget_set_sensitive (separator10, FALSE);

  close2 = gtk_menu_item_new_with_label (_("Close"));
  gtk_widget_set_name (close2, "close2");
  gtk_widget_ref (close2);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "close2", close2,
                            (GtkDestroyNotify) gtk_widget_unref);
//  gtk_widget_show (close2);
  gtk_container_add (GTK_CONTAINER (file1_menu), close2);
  gtk_widget_add_accelerator (close2, "activate", accel_group,
                              GDK_c, GDK_MOD1_MASK,
                              GTK_ACCEL_VISIBLE);

  exit1 = gtk_menu_item_new_with_label (_("Exit TradeClient"));
  gtk_widget_set_name (exit1, "exit1");
  gtk_widget_ref (exit1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "exit1", exit1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (exit1);
  gtk_container_add (GTK_CONTAINER (file1_menu), exit1);
  gtk_widget_add_accelerator (exit1, "activate", accel_group,
                              GDK_q, GDK_MOD1_MASK,
                              GTK_ACCEL_VISIBLE);

	clip_create_menuitem (main_menubar, accel_group);

#if 0
  edit3 = gtk_menu_item_new_with_label (_("Edit"));
  gtk_widget_set_name (edit3, "edit3");
  gtk_widget_ref (edit3);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "edit3", edit3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (edit3);
  gtk_container_add (GTK_CONTAINER (main_menubar), edit3);

  edit3_menu = gtk_menu_new ();
  gtk_widget_set_name (edit3_menu, "edit3_menu");
  gtk_widget_ref (edit3_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "edit3_menu", edit3_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (edit3), edit3_menu);
  edit3_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (edit3_menu));

	tearoff=gtk_tearoff_menu_item_new ();
	gtk_widget_show (tearoff);
	gtk_container_add (GTK_CONTAINER (edit3_menu), tearoff);

  cut = gtk_menu_item_new_with_label (_("Cut"));
  gtk_widget_set_name (cut, "cut");
  gtk_widget_ref (cut);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "cut", cut,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cut);
  gtk_container_add (GTK_CONTAINER (edit3_menu), cut);
  gtk_widget_add_accelerator (cut, "activate", accel_group,
                              GDK_x, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  copy = gtk_menu_item_new_with_label (_("Copy"));
  gtk_widget_set_name (copy, "copy");
  gtk_widget_ref (copy);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "copy", copy,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (copy);
  gtk_container_add (GTK_CONTAINER (edit3_menu), copy);
  gtk_widget_add_accelerator (copy, "activate", accel_group,
                              GDK_c, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  paste = gtk_menu_item_new_with_label (_("Paste"));
  gtk_widget_set_name (paste, "paste");
  gtk_widget_ref (paste);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "paste", paste,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (paste);
  gtk_container_add (GTK_CONTAINER (edit3_menu), paste);
  gtk_widget_add_accelerator (paste, "activate", accel_group,
                              GDK_v, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  selectall = gtk_menu_item_new_with_label (_("Select All"));
  gtk_widget_set_name (selectall, "selectall");
  gtk_widget_ref (selectall);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "selectall", selectall,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (selectall);
  gtk_container_add (GTK_CONTAINER (edit3_menu), selectall);

  clear = gtk_menu_item_new_with_label (_("Clear"));
  gtk_widget_set_name (clear, "clear");
  gtk_widget_ref (clear);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "clear", clear,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (clear);
  gtk_container_add (GTK_CONTAINER (edit3_menu), clear);

  separator7 = gtk_menu_item_new ();
  gtk_widget_set_name (separator7, "separator7");
  gtk_widget_ref (separator7);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "separator7", separator7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (separator7);
  gtk_container_add (GTK_CONTAINER (edit3_menu), separator7);
  gtk_widget_set_sensitive (separator7, FALSE);

  undo2 = gtk_menu_item_new_with_label (_("Undo"));
  gtk_widget_set_name (undo2, "undo2");
  gtk_widget_ref (undo2);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "undo2", undo2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (undo2);
  gtk_container_add (GTK_CONTAINER (edit3_menu), undo2);
	gtk_widget_set_sensitive (undo2,  FALSE);

  redo2 = gtk_menu_item_new_with_label (_("Redo"));
  gtk_widget_set_name (redo2, "redo2");
  gtk_widget_ref (redo2);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "redo2", redo2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (redo2);
  gtk_container_add (GTK_CONTAINER (edit3_menu), redo2);
	gtk_widget_set_sensitive (redo2,  FALSE);

  separator8 = gtk_menu_item_new ();
  gtk_widget_set_name (separator8, "separator8");
  gtk_widget_ref (separator8);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "separator8", separator8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (separator8);
  gtk_container_add (GTK_CONTAINER (edit3_menu), separator8);
  gtk_widget_set_sensitive (separator8, FALSE);

  find2 = gtk_menu_item_new_with_label (_("Find..."));
  gtk_widget_set_name (find2, "find2");
  gtk_widget_ref (find2);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "find2", find2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (find2);
  gtk_container_add (GTK_CONTAINER (edit3_menu), find2);
	gtk_widget_set_sensitive (find2,  FALSE);

  find_again2 = gtk_menu_item_new_with_label (_("Find Again"));
  gtk_widget_set_name (find_again2, "find_again2");
  gtk_widget_ref (find_again2);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "find_again2", find_again2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (find_again2);
  gtk_container_add (GTK_CONTAINER (edit3_menu), find_again2);
	gtk_widget_set_sensitive (find_again2,  FALSE);*/
#endif
  settings1 = gtk_menu_item_new_with_label (_("Windows"));
  gtk_widget_set_name (settings1, "settings1");
  gtk_widget_ref (settings1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "settings1", settings1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (settings1);
  gtk_container_add (GTK_CONTAINER (main_menubar), settings1);

  settings1_menu = gtk_menu_new ();
  gtk_widget_set_name (settings1_menu, "settings1_menu");
  gtk_widget_ref (settings1_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "settings1_menu", settings1_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (settings1), settings1_menu);
  settings1_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (settings1_menu));

	tearoff=gtk_tearoff_menu_item_new ();
	gtk_widget_show (tearoff);
	gtk_container_add (GTK_CONTAINER (settings1_menu), tearoff);

  preferences1 = gtk_menu_item_new_with_label (_("Preferences..."));
  gtk_widget_set_name (preferences1, "preferences1");
  gtk_widget_ref (preferences1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "preferences1", preferences1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (preferences1);
  gtk_container_add (GTK_CONTAINER (settings1_menu), preferences1);
  gtk_widget_add_accelerator (preferences1, "activate", accel_group,
                              GDK_r, GDK_MOD1_MASK,
                              GTK_ACCEL_VISIBLE);

  status = gtk_menu_item_new_with_label (_("Status Window..."));
  gtk_widget_set_name (status, "status");
  gtk_widget_ref (status);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "status", status,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (status);
  gtk_container_add (GTK_CONTAINER (settings1_menu), status);
  gtk_widget_add_accelerator (status, "activate", accel_group,
                              GDK_w, GDK_MOD1_MASK,
                              GTK_ACCEL_VISIBLE);

  docsource = gtk_menu_item_new_with_label (_("Document Source..."));
  gtk_widget_set_name (docsource, "docsource");
  gtk_widget_ref (docsource);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "docsource", docsource,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (docsource);
  gtk_container_add (GTK_CONTAINER (settings1_menu), docsource);

  rules = gtk_menu_item_new_with_label (_("Address Book"));
  gtk_widget_set_name (rules, "rules");
  gtk_widget_ref (rules);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "rules", rules,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (rules);
  gtk_container_add (GTK_CONTAINER (settings1_menu), rules);
  gtk_widget_add_accelerator (rules, "activate", accel_group,
                              GDK_b, GDK_MOD1_MASK,
                              GTK_ACCEL_VISIBLE);

  cal_menuitem = gtk_menu_item_new_with_label (_("Calendar"));
  gtk_widget_set_name (cal_menuitem, "cal_menuitem");
  gtk_widget_ref (cal_menuitem);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "cal_menuitem",
                            cal_menuitem, (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cal_menuitem);
  gtk_container_add (GTK_CONTAINER (settings1_menu), cal_menuitem);
  gtk_widget_add_accelerator (cal_menuitem, "activate", accel_group,
                              GDK_l, GDK_MOD1_MASK,
                              GTK_ACCEL_VISIBLE);

  help1 = gtk_menu_item_new_with_label (_("Help"));
  gtk_widget_set_name (help1, "help1");
  gtk_widget_ref (help1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "help1", help1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (help1);
  gtk_container_add (GTK_CONTAINER (main_menubar), help1);
  gtk_menu_item_right_justify (GTK_MENU_ITEM (help1));

  help1_menu = gtk_menu_new ();
  gtk_widget_set_name (help1_menu, "help1_menu");
  gtk_widget_ref (help1_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "help1_menu", help1_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (help1), help1_menu);
  help1_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (help1_menu));

  tearoff=gtk_tearoff_menu_item_new ();
  gtk_widget_show (tearoff);
  gtk_container_add (GTK_CONTAINER (help1_menu), tearoff);

  about_bynari_tradeclient1 = gtk_menu_item_new_with_label (_("About TradeClient"));
  gtk_widget_set_name (about_bynari_tradeclient1, "about_bynari_tradeclient1");
  gtk_widget_ref (about_bynari_tradeclient1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "about_bynari_tradeclient1", about_bynari_tradeclient1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (about_bynari_tradeclient1);
  gtk_container_add (GTK_CONTAINER (help1_menu), about_bynari_tradeclient1);

  statusbar1 = gtk_statusbar_new ();
  gtk_widget_set_name (statusbar1, "statusbar1");
  gtk_widget_ref (statusbar1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "statusbar1", statusbar1,
                            (GtkDestroyNotify) gtk_widget_unref);
//  gtk_widget_show (statusbar1);
  gtk_table_attach (GTK_TABLE (table1), statusbar1, 0, 2, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  hpaned1 = gtk_hpaned_new ();
  gtk_widget_set_name (hpaned1, "hpaned1");
  gtk_widget_ref (hpaned1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "hpaned1", hpaned1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hpaned1);
  gtk_table_attach (GTK_TABLE (table1), hpaned1, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);
  gtk_paned_set_handle_size (GTK_PANED (hpaned1), 8);
  gtk_paned_set_gutter_size (GTK_PANED (hpaned1), 9);
  //gtk_paned_set_position (GTK_PANED (hpaned1), 131);
  gtk_signal_connect (GTK_OBJECT (hpaned1), "size_allocate",
                         GTK_SIGNAL_FUNC (ppos_set_mnw), NULL);

  folder_vbox = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (folder_vbox, "folder_vbox");
  gtk_widget_ref (folder_vbox);
  gtk_object_set_data_full (GTK_OBJECT (folder_vbox), "folder_vbox",
			folder_vbox, (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (folder_vbox);
  gtk_container_add (GTK_CONTAINER (hpaned1), folder_vbox);

  scrolledwindow15 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_set_name (scrolledwindow15, "scrolledwindow15");
  gtk_widget_ref (scrolledwindow15);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "scrolledwindow15", scrolledwindow15,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow15);
  gtk_box_pack_start (GTK_BOX (folder_vbox),scrolledwindow15, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow15), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  folder_tree = gtk_ctree_new (3, 0);
  gtk_widget_set_name (folder_tree, "folder_tree");
  gtk_widget_ref (folder_tree);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "folder_tree", folder_tree,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (folder_tree);
  gtk_container_add (GTK_CONTAINER (scrolledwindow15), folder_tree);
  gtk_ctree_set_line_style (GTK_CTREE (folder_tree), GTK_CTREE_LINES_SOLID);
  gtk_clist_column_titles_show (GTK_CLIST (folder_tree));
  gtk_signal_connect (GTK_OBJECT (folder_tree), "resize_column",
                         GTK_SIGNAL_FUNC (cpos_set_mnw_fl), NULL);

  label39 = gtk_label_new (_("Local Folders"));
  gtk_widget_set_name (label39, "label39");
  gtk_widget_ref (label39);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "label39", label39,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label39);
  gtk_clist_set_column_widget (GTK_CLIST (folder_tree), 0, label39);

  label40 = gtk_label_new (("U"));
  gtk_widget_set_name (label40, "label40");
  gtk_widget_ref (label40);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "label40", label40,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label40);
  gtk_clist_set_column_widget (GTK_CLIST (folder_tree), 1, label40);

  label41 = gtk_label_new (("T"));
  gtk_widget_set_name (label41, "label41");
  gtk_widget_ref (label41);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "label41", label41,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label41);
  gtk_clist_set_column_widget (GTK_CLIST (folder_tree), 2, label41);

  hseparator1 = gtk_hseparator_new ();
  gtk_widget_set_name (hseparator1, "hseparator1");
  gtk_widget_ref (hseparator1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "hseparator1", hseparator1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator1);
  gtk_box_pack_start (GTK_BOX (folder_vbox), hseparator1, FALSE, FALSE, 3);

  scrolledwindow152 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_set_name (scrolledwindow152, "scrolledwindow15");
  gtk_widget_ref (scrolledwindow152);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "scrolledwindow152", scrolledwindow15,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow152);
  gtk_box_pack_start (GTK_BOX (folder_vbox),scrolledwindow152, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow152), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  folder_ntree = gtk_ctree_new (3, 0);
  gtk_widget_set_name (folder_ntree, "folder_ntree");
  gtk_widget_ref (folder_ntree);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "folder_ntree",
		folder_ntree, (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (folder_ntree);
  gtk_container_add (GTK_CONTAINER (scrolledwindow152), folder_ntree);
  gtk_ctree_set_line_style (GTK_CTREE (folder_ntree), GTK_CTREE_LINES_SOLID);
  gtk_clist_column_titles_show (GTK_CLIST (folder_ntree));
  gtk_ctree_set_line_style (GTK_CTREE (folder_ntree), GTK_CTREE_LINES_NONE);
  gtk_ctree_set_expander_style (GTK_CTREE (folder_ntree), GTK_CTREE_EXPANDER_TRIANGLE);
  gtk_signal_connect (GTK_OBJECT (folder_ntree), "resize_column",
                      GTK_SIGNAL_FUNC (cpos_set_mnw_fl), NULL);
/*
        tm_globs->a3=gtk_signal_connect (GTK_OBJECT (folder_tree), "button_press_event",
                            GTK_SIGNAL_FUNC (t_clicked_on_folder), NULL);
*/
  gtk_signal_connect (GTK_OBJECT (folder_ntree), "button_press_event",
		GTK_SIGNAL_FUNC (nf_imap_folder_sel2), NULL);
 
  label392 = gtk_label_new (_("Net Folders"));
  gtk_widget_set_name (label392, "label392");
  gtk_widget_ref (label392);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "label392", label392,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label392);
  gtk_clist_set_column_widget (GTK_CLIST (folder_ntree), 0, label392);

  label402 = gtk_label_new (("U"));
  gtk_widget_set_name (label402, "label402");
  gtk_widget_ref (label402);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "label402", label402,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label402);
  gtk_clist_set_column_widget (GTK_CLIST (folder_ntree), 1, label402);

  label412 = gtk_label_new (("T"));
  gtk_widget_set_name (label412, "label412");
  gtk_widget_ref (label412);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "label412", label412,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label412);
  gtk_clist_set_column_widget (GTK_CLIST (folder_ntree), 2, label412);

  vpaned1 = gtk_vpaned_new ();
  gtk_widget_set_name (vpaned1, "vpaned1");
  gtk_widget_ref (vpaned1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "vpaned1", vpaned1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vpaned1);
  gtk_container_add (GTK_CONTAINER (hpaned1), vpaned1);
  gtk_paned_set_handle_size (GTK_PANED (vpaned1), 8);
  gtk_paned_set_gutter_size (GTK_PANED (vpaned1), 9);
  gtk_paned_set_position (GTK_PANED (vpaned1), 125);
  gtk_signal_connect (GTK_OBJECT (vpaned1), "size_allocate",
                         GTK_SIGNAL_FUNC (ppos_set_mnw), NULL);


  scrolledwindow16 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_set_name (scrolledwindow16, "scrolledwindow16");
  gtk_widget_ref (scrolledwindow16);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "scrolledwindow16", scrolledwindow16,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow16);
  gtk_container_add (GTK_CONTAINER (vpaned1), scrolledwindow16);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow16), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  message_clist = gtk_clist_new (6);
  gtk_widget_set_name (message_clist, "message_clist");
  gtk_widget_ref (message_clist);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "message_clist", message_clist,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (message_clist);
	gtk_clist_columns_autosize (GTK_CLIST (message_clist));
  gtk_container_add (GTK_CONTAINER (scrolledwindow16), message_clist);
  gtk_clist_set_selection_mode (GTK_CLIST (message_clist), GTK_SELECTION_EXTENDED);
  gtk_clist_column_titles_show (GTK_CLIST (message_clist));

  gtk_signal_connect (GTK_OBJECT (message_clist), "resize_column",
                         GTK_SIGNAL_FUNC (cpos_set_mnw_msg), NULL);

  label42 = gtk_label_new ("S");
  gtk_widget_set_name (label42, "label42");
  gtk_widget_ref (label42);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "label42", label42,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label42);
  gtk_clist_set_column_widget (GTK_CLIST (message_clist), 0, label42);

  label43 = gtk_label_new (("P"));
  gtk_widget_set_name (label43, "pr_label");
  gtk_widget_ref (label43);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "label43", label43,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label43);
  gtk_clist_set_column_widget (GTK_CLIST (message_clist), 1, label43);

  label44 = gtk_label_new (_("Subject"));
  gtk_widget_set_name (label44, "label44");
  gtk_widget_ref (label44);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "label44", label44,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label44);
  gtk_clist_set_column_widget (GTK_CLIST (message_clist), 2, label44);

  label45 = gtk_label_new (_("Sender"));
  gtk_widget_set_name (label45, "label45");
  gtk_widget_ref (label45);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "label45", label45,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label45);
  gtk_clist_set_column_widget (GTK_CLIST (message_clist), 3, label45);

  label46 = gtk_label_new (_("Sent"));
  gtk_widget_set_name (label46, "label46");
  gtk_widget_ref (label46);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "label46", label46,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label46);
  gtk_clist_set_column_widget (GTK_CLIST (message_clist), 4, label46);

  l_date = gtk_label_new (_("Received"));
  gtk_widget_set_name (l_date, "l_date");
  gtk_widget_ref (l_date);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "l_date", l_date,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (l_date);
  gtk_clist_set_column_widget (GTK_CLIST (message_clist), 5, l_date);

  mime_vpaned=gtk_vpaned_new ();
  gtk_widget_set_name (mime_vpaned, "mime_vpaned");
  gtk_widget_ref (mime_vpaned);
  gtk_object_set_data_full(GTK_OBJECT (main_window), "mime_vpaned", mime_vpaned,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mime_vpaned);
  gtk_container_add (GTK_CONTAINER (vpaned1), mime_vpaned);
  gtk_paned_set_handle_size (GTK_PANED (mime_vpaned), 8);
  gtk_paned_set_gutter_size (GTK_PANED (mime_vpaned), 9);
  gtk_paned_set_position (GTK_PANED (mime_vpaned), 175);
  gtk_signal_connect (GTK_OBJECT (mime_vpaned), "size_allocate",
                         GTK_SIGNAL_FUNC (ppos_set_mnw), NULL);

  body_scroller = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_set_name (body_scroller, "body_scroller");
  gtk_widget_ref (body_scroller);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "body_scroller", body_scroller,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (body_scroller);
  gtk_container_add (GTK_CONTAINER (mime_vpaned), body_scroller);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (body_scroller), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  mime_frame=gtk_frame_new (_("Attachments"));
  gtk_widget_show (mime_frame);
  gtk_widget_set_name (mime_frame, "mime_frame");
  gtk_widget_ref (mime_frame);
  gtk_object_set_data_full (GTK_OBJECT (mime_frame), "mime_frame", mime_frame,
														(GtkDestroyNotify) gtk_widget_unref);
  gtk_container_set_border_width (GTK_CONTAINER (mime_frame), 2);
  gtk_container_add (GTK_CONTAINER (mime_vpaned), mime_frame);
  
  gtk_widget_set_usize (mime_frame, 10, 120);

  mime_scrolledwindow=gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (mime_scrolledwindow);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (mime_scrolledwindow), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_container_add (GTK_CONTAINER (mime_frame), mime_scrolledwindow);

  mime_clist = gtk_clist_new (3);
  gtk_widget_set_name (mime_clist, "mime_clist");
  gtk_widget_ref (mime_clist);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "mime_clist", mime_clist,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mime_clist);
  gtk_widget_set_sensitive (mime_clist, TRUE);
  gtk_container_add (GTK_CONTAINER (mime_scrolledwindow), mime_clist);

#if 0
  gtk_clist_set_column_width (GTK_CLIST (mime_clist), 0, 100);
  gtk_clist_set_column_width (GTK_CLIST (mime_clist), 1, 150);
#endif
  gtk_clist_column_titles_show (GTK_CLIST (mime_clist));

  gtk_signal_connect (GTK_OBJECT (mime_clist), "resize_column",
                         GTK_SIGNAL_FUNC (cpos_set_mnw_mime), NULL);

  label44 = gtk_label_new (_("Content Type"));
  gtk_widget_show (label44);
  gtk_clist_set_column_widget (GTK_CLIST (mime_clist), 0, label44);

  label44 = gtk_label_new (_("Filename"));
  gtk_widget_show (label44);
  gtk_clist_set_column_widget (GTK_CLIST (mime_clist), 1, label44);

  label44 = gtk_label_new (_("Size"));
  gtk_widget_show (label44);
  gtk_clist_set_column_widget (GTK_CLIST (mime_clist), 2, label44);

  message_body = gtk_text_new (NULL, NULL);
  gtk_widget_set_name (message_body, "message_body");
  gtk_widget_ref (message_body);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "message_body", message_body,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (message_body);
  gtk_text_set_word_wrap (GTK_TEXT(message_body), TRUE);
  gtk_text_set_line_wrap (GTK_TEXT(message_body), TRUE);
  gtk_container_add (GTK_CONTAINER (body_scroller), message_body);

        gtk_signal_connect (GTK_OBJECT (main_window), "size_allocate",
                            GTK_SIGNAL_FUNC (wsize_set_mnw), NULL);
	gtk_signal_connect (GTK_OBJECT (new_message2), "activate",
	                    GTK_SIGNAL_FUNC (make_new_message_window), NULL);
 	gtk_signal_connect (GTK_OBJECT (main_window), "delete_event",
	                    GTK_SIGNAL_FUNC (puma_die), NULL);
	gtk_signal_connect (GTK_OBJECT (new_message), "clicked",
	                    GTK_SIGNAL_FUNC (make_new_message_window), NULL);
	gtk_signal_connect (GTK_OBJECT (exit1), "activate",
	                    GTK_SIGNAL_FUNC (puma_die), NULL);
	gtk_signal_connect (GTK_OBJECT (get_message), "clicked",
	                    GTK_SIGNAL_FUNC (get_messages), NULL);								
	gtk_signal_connect (GTK_OBJECT (preferences1), "activate",
	                    GTK_SIGNAL_FUNC (make_preferences), NULL);
	gtk_signal_connect (GTK_OBJECT (message_clist), "button_press_event",
	                    GTK_SIGNAL_FUNC (clicked_on_message), NULL);
	gtk_signal_connect (GTK_OBJECT (message_clist), "unselect_row", 
	                    GTK_SIGNAL_FUNC (unclicked_on_message), NULL);
	gtk_signal_connect (GTK_OBJECT (message_clist), "select_row", 
	                    GTK_SIGNAL_FUNC (clicked_on_message_handler), NULL);
	gtk_signal_connect (GTK_OBJECT (message_clist), "click_column",
	                    GTK_SIGNAL_FUNC (message_clist_clicked_column), NULL);
	
	tm_globs->a1=gtk_signal_connect (GTK_OBJECT (folder_tree), "tree_select_row",
	                    GTK_SIGNAL_FUNC (clicked_on_folder), NULL);
	tm_globs->a2=-1;
/*	tm_globs->a2=gtk_signal_connect (GTK_OBJECT (folder_tree), "tree_unselect_row",
	                    GTK_SIGNAL_FUNC (unclicked_on_folder), NULL);*/
	tm_globs->a3=gtk_signal_connect (GTK_OBJECT (folder_tree), "button_press_event",
	                    GTK_SIGNAL_FUNC (t_clicked_on_folder), NULL);
	gtk_signal_connect (GTK_OBJECT (about_bynari_tradeclient1), "activate",
                      GTK_SIGNAL_FUNC (activate_aboutbox), NULL);
	gtk_signal_connect (GTK_OBJECT (delete_button), "clicked", 
	                    GTK_SIGNAL_FUNC (destroy_selected_message), NULL);
	gtk_signal_connect (GTK_OBJECT (del_menu), "activate", 
	                    GTK_SIGNAL_FUNC (destroy_selected_message), NULL);
	gtk_signal_connect (GTK_OBJECT (msearch), "activate",
                            GTK_SIGNAL_FUNC (msearch_callback), NULL);
        gtk_signal_connect (GTK_OBJECT (mark_unread), "activate",
                            GTK_SIGNAL_FUNC (mark_unread_callback), NULL);
        gtk_signal_connect (GTK_OBJECT (send_to_html), "activate",
                            GTK_SIGNAL_FUNC (send_to_html_callback), NULL);
	gtk_signal_connect (GTK_OBJECT (reply_to), "clicked",
	                    GTK_SIGNAL_FUNC (replyto_clicked), NULL);
	gtk_signal_connect (GTK_OBJECT (forward), "clicked",
	                    GTK_SIGNAL_FUNC (forward_clicked), NULL);
	gtk_signal_connect (GTK_OBJECT (print), "clicked",
	                    GTK_SIGNAL_FUNC (message_print), NULL);
	gtk_signal_connect (GTK_OBJECT (print1), "activate",
	                    GTK_SIGNAL_FUNC (message_print), NULL);
	gtk_signal_connect (GTK_OBJECT (printer_setup1), "activate",
	                    GTK_SIGNAL_FUNC (psetup_window), NULL);
        gtk_signal_connect (GTK_OBJECT (empty_trash), "activate",
                        GTK_SIGNAL_FUNC (empty_trash_callback), NULL);
	gtk_signal_connect (GTK_OBJECT (mi_undel), "activate",
			GTK_SIGNAL_FUNC (undelete_messages), NULL);
	gtk_signal_connect (GTK_OBJECT (mi_compact), "activate",
			GTK_SIGNAL_FUNC (compact_folders), NULL);
	gtk_signal_connect (GTK_OBJECT (new_folder1), "activate",
	                    GTK_SIGNAL_FUNC (new_folder_activate), NULL);
	gtk_signal_connect (GTK_OBJECT (address_book), "clicked",
	                    GTK_SIGNAL_FUNC (address_book_clicked), NULL);
	gtk_signal_connect (GTK_OBJECT (calendar), "clicked",
	                    GTK_SIGNAL_FUNC (calendar_show), NULL);
	gtk_signal_connect (GTK_OBJECT (status), "activate",
	                    GTK_SIGNAL_FUNC (show_status), NULL);
	gtk_signal_connect (GTK_OBJECT (docsource), "activate",
	                    GTK_SIGNAL_FUNC (docsource_create), NULL);											
	gtk_signal_connect (GTK_OBJECT (save_message_as), "activate",
	                    GTK_SIGNAL_FUNC (save_message_activate), NULL);
	gtk_signal_connect (GTK_OBJECT (mime_clist), "select_row",
											GTK_SIGNAL_FUNC (clicked_on_attachment), NULL);
	gtk_signal_connect (GTK_OBJECT (mime_clist), "button_press_event",
	                    GTK_SIGNAL_FUNC (clicked_on_attachment_event), NULL);
	gtk_signal_connect (GTK_OBJECT (rules), "activate",
	                    GTK_SIGNAL_FUNC (address_book_clicked), NULL);
	gtk_signal_connect (GTK_OBJECT (cal_menuitem), "activate",
	                    GTK_SIGNAL_FUNC (calendar_show), NULL);
	gtk_signal_connect (GTK_OBJECT (reply_to_all), "clicked",
	                    GTK_SIGNAL_FUNC (reply_to_all_clicked), NULL);


	gtk_window_add_accel_group (GTK_WINDOW (main_window), accel_group);

	
	gtk_drag_source_set (message_clist, GDK_BUTTON1_MASK, target_table,
	                     n_targets, GDK_ACTION_COPY | GDK_ACTION_MOVE);
	gtk_drag_dest_set (folder_tree, GTK_DEST_DEFAULT_ALL, target_table, 
	                   n_targets -1, GDK_ACTION_COPY | GDK_ACTION_MOVE);
	drag_icon =  pixmap_create (main_window, PIXMAP_DRAGICON, &drag_mask);
	gtk_drag_source_set_icon (message_clist, gtk_widget_get_colormap (main_window),
														drag_icon, drag_mask);
	gdk_pixmap_unref (drag_icon);
	gdk_pixmap_unref (drag_mask);

	gtk_signal_connect (GTK_OBJECT (message_clist), "drag_data_get",
	                    GTK_SIGNAL_FUNC (message_clist_data_get), NULL);
	gtk_signal_connect (GTK_OBJECT (folder_tree), "drag_motion",
	                    GTK_SIGNAL_FUNC (folder_ctree_drag_motion), NULL);
	gtk_signal_connect (GTK_OBJECT (folder_tree), "drag_data_received",
	                    GTK_SIGNAL_FUNC (folder_ctree_data_received), NULL);
	gtk_signal_connect (GTK_OBJECT (folder_tree), "drag_leave",
	                    GTK_SIGNAL_FUNC (folder_ctree_drag_leave), NULL);
	clip_handle_editable (message_body);

	return main_window;
}
