/* TradeClient <http://tradeclient.sourceforge.net>
 * $Id: message-window.c,v 1.14 2001/03/20 22:19:33 ttabner Exp $
 *
 * Copyright (C) 1999-2000 Bynari Inc.
 * Copyright (C) 2001 Project TradeClient
 *
 * LGPL
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#include "puma.h"

GtkWidget *create_message_window (void) {
  GtkWidget *message;
  GtkWidget *vbox6;
  GtkWidget *handlebox2;
  GtkWidget *vbox7;
  GtkWidget *menubar2;
  GtkWidget *menuitem1;
  GtkWidget *menuitem1_menu;
  GtkWidget *tearoff;
  GtkAccelGroup *menuitem1_menu_accels;
  GtkWidget *menuitem2;
  GtkWidget *menuitem3;
  GtkWidget *menuitem4;
  GtkWidget *menuitem5;
  GtkWidget *menuitem6;
  GtkWidget *menuitem6_menu;
  GtkAccelGroup *menuitem6_menu_accels;
  GtkWidget *menuitem7;
  GtkWidget *menuitem8;
  GtkWidget *menuitem9;
  GtkWidget *menuitem10;
  GtkWidget *menuitem11;
  GtkWidget *menuitem12;
  GtkWidget *menuitem13;
  GtkWidget *menuitem14;
  GtkWidget *menuitem15;
  GtkWidget *menuitem16;
  GtkWidget *menuitem17;
  GtkWidget *menuitem37;
  GtkWidget *menuitem37_menu;
  GtkAccelGroup *menuitem37_menu_accels;
  GtkWidget *menuitem41;
  GtkWidget *hbox9;
  GtkWidget *replyto;
  GtkWidget *replytoall;
  GtkWidget *forward;
  GtkWidget *vseparator8;
  GtkWidget *saveas;
  GtkWidget *print;
  GtkWidget *frame10;
  GtkWidget *vbox8;
  GtkWidget *table2;
  GtkWidget *label18;
  GtkWidget *label19;
  GtkWidget *label20;
  GtkWidget *sens_label, *sens_entry;
  GtkWidget *expiry_label, *expiry_entry;
  GtkWidget *replyby_label, *replyby_entry;
  GtkWidget *label34;
  GtkWidget *fromline;
  GtkWidget *toline;
  GtkWidget *ccline;
  GtkWidget *subjectline;
  GtkWidget *message_pane;
  GtkWidget *scrolledwindow2;
  GtkWidget *messagebody;
  GtkWidget *frame11;
  GtkWidget *scrolledwindow3;
  GtkWidget *attachment_clist;
  GtkWidget *label25;
  GtkWidget *label26;
  GtkWidget *label27;
  GtkWidget *frame9;
  GtkWidget *label11;
  GtkAccelGroup *accel_group;
  GtkTooltips *tooltips;

  message_selection_null ();
  tooltips = gtk_tooltips_new ();

  accel_group = gtk_accel_group_new ();

  message = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_name (message, "message");
  gtk_object_set_data (GTK_OBJECT (message), "message", message);
  gtk_window_set_title (GTK_WINDOW (message), _("Message: $(SUBJECT)"));
  gtk_window_set_policy (GTK_WINDOW (message), TRUE, TRUE, TRUE);
#if 0
	gtk_widget_set_uposition (message, 155, 100);
#endif
	gtk_widget_set_usize (message, 500,440);
	gtk_window_set_default_size (GTK_WINDOW(message), tm_globs->wsize.message_window.x, tm_globs->wsize.message_window.y);

  vbox6 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox6, "vbox6");
  gtk_widget_ref (vbox6);
  gtk_object_set_data_full (GTK_OBJECT (message), "vbox6", vbox6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox6);
  gtk_container_add (GTK_CONTAINER (message), vbox6);

  handlebox2 = gtk_handle_box_new ();
  gtk_widget_set_name (handlebox2, "handlebox2");
  gtk_widget_ref (handlebox2);
  gtk_object_set_data_full (GTK_OBJECT (message), "handlebox2", handlebox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (handlebox2);
  gtk_box_pack_start (GTK_BOX (vbox6), handlebox2, FALSE, FALSE, 0);

  vbox7 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox7, "vbox7");
  gtk_widget_ref (vbox7);
  gtk_object_set_data_full (GTK_OBJECT (message), "vbox7", vbox7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox7);
  gtk_container_add (GTK_CONTAINER (handlebox2), vbox7);

  menubar2 = gtk_menu_bar_new ();
  gtk_widget_set_name (menubar2, "menubar2");
  gtk_widget_ref (menubar2);
  gtk_object_set_data_full (GTK_OBJECT (message), "menubar2", menubar2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menubar2);
  gtk_box_pack_start (GTK_BOX (vbox7), menubar2, FALSE, FALSE, 0);
  gtk_menu_bar_set_shadow_type (GTK_MENU_BAR (menubar2), GTK_SHADOW_ETCHED_IN);

  menuitem1 = gtk_menu_item_new_with_label (_("File"));
  gtk_widget_set_name (menuitem1, "menuitem1");
  gtk_widget_ref (menuitem1);
  gtk_object_set_data_full (GTK_OBJECT (message), "menuitem1", menuitem1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menuitem1);
  gtk_container_add (GTK_CONTAINER (menubar2), menuitem1);

  menuitem1_menu = gtk_menu_new ();
  gtk_widget_set_name (menuitem1_menu, "menuitem1_menu");
  gtk_widget_ref (menuitem1_menu);
  gtk_object_set_data_full (GTK_OBJECT (message), "menuitem1_menu", menuitem1_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (menuitem1), menuitem1_menu);
  menuitem1_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (menuitem1_menu));

  tearoff=gtk_tearoff_menu_item_new ();
  gtk_widget_show (tearoff);
  gtk_container_add (GTK_CONTAINER (menuitem1_menu), tearoff);
  
  menuitem2 = gtk_menu_item_new_with_label (_("Reply"));
  gtk_widget_set_name (menuitem2, "menuitem2");
  gtk_widget_ref (menuitem2);
  gtk_object_set_data_full (GTK_OBJECT (message), "menuitem2", menuitem2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menuitem2);
  gtk_container_add (GTK_CONTAINER (menuitem1_menu), menuitem2);
  gtk_widget_add_accelerator (menuitem2, "activate", accel_group,
                              GDK_r, GDK_MOD1_MASK,
                              GTK_ACCEL_VISIBLE);

  menuitem3 = gtk_menu_item_new_with_label (_("Reply to All"));
  gtk_widget_set_name (menuitem3, "menuitem3");
  gtk_widget_ref (menuitem3);
  gtk_object_set_data_full (GTK_OBJECT (message), "menuitem3", menuitem3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menuitem3);
  gtk_container_add (GTK_CONTAINER (menuitem1_menu), menuitem3);
  gtk_widget_add_accelerator (menuitem3, "activate", accel_group,
                              GDK_g, GDK_MOD1_MASK,
                              GTK_ACCEL_VISIBLE);

  menuitem4 = gtk_menu_item_new_with_label (_("Forward"));
  gtk_widget_set_name (menuitem4, "menuitem4");
  gtk_widget_ref (menuitem4);
  gtk_object_set_data_full (GTK_OBJECT (message), "menuitem4", menuitem4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menuitem4);
  gtk_container_add (GTK_CONTAINER (menuitem1_menu), menuitem4);
  gtk_widget_add_accelerator (menuitem4, "activate", accel_group,
                              GDK_f, GDK_MOD1_MASK,
                              GTK_ACCEL_VISIBLE);

  menuitem5 = gtk_menu_item_new ();
  gtk_widget_set_name (menuitem5, "menuitem5");
  gtk_widget_ref (menuitem5);
  gtk_object_set_data_full (GTK_OBJECT (message), "menuitem5", menuitem5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menuitem5);
  gtk_container_add (GTK_CONTAINER (menuitem1_menu), menuitem5);
  gtk_widget_set_sensitive (menuitem5, FALSE);

  menuitem6 = gtk_menu_item_new_with_label (_("New"));
  gtk_widget_set_name (menuitem6, "menuitem6");
  gtk_widget_ref (menuitem6);
  gtk_object_set_data_full (GTK_OBJECT (message), "menuitem6", menuitem6,
                            (GtkDestroyNotify) gtk_widget_unref);
//  gtk_widget_show (menuitem6);
  gtk_container_add (GTK_CONTAINER (menuitem1_menu), menuitem6);

  menuitem6_menu = gtk_menu_new ();
  gtk_widget_set_name (menuitem6_menu, "menuitem6_menu");
  gtk_widget_ref (menuitem6_menu);
  gtk_object_set_data_full (GTK_OBJECT (message), "menuitem6_menu", menuitem6_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (menuitem6), menuitem6_menu);
  menuitem6_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (menuitem6_menu));

  menuitem7 = gtk_menu_item_new_with_label (_("Mail Message"));
  gtk_widget_set_name (menuitem7, "menuitem7");
  gtk_widget_ref (menuitem7);
  gtk_object_set_data_full (GTK_OBJECT (message), "menuitem7", menuitem7,
                            (GtkDestroyNotify) gtk_widget_unref);
//  gtk_widget_show (menuitem7);
  gtk_container_add (GTK_CONTAINER (menuitem6_menu), menuitem7);

  menuitem8 = gtk_menu_item_new_with_label (_("Addressbook Entry"));
  gtk_widget_set_name (menuitem8, "menuitem8");
  gtk_widget_ref (menuitem8);
  gtk_object_set_data_full (GTK_OBJECT (message), "menuitem8", menuitem8,
                            (GtkDestroyNotify) gtk_widget_unref);
//  gtk_widget_show (menuitem8);
  gtk_container_add (GTK_CONTAINER (menuitem6_menu), menuitem8);

  menuitem9 = gtk_menu_item_new_with_label (_("Save"));
  gtk_widget_set_name (menuitem9, "menuitem9");
  gtk_widget_ref (menuitem9);
  gtk_object_set_data_full (GTK_OBJECT (message), "menuitem9", menuitem9,
                            (GtkDestroyNotify) gtk_widget_unref);
//  gtk_widget_show (menuitem9);
  gtk_container_add (GTK_CONTAINER (menuitem1_menu), menuitem9);

  menuitem10 = gtk_menu_item_new_with_label (_("Save As..."));
  gtk_widget_set_name (menuitem10, "menuitem10");
  gtk_widget_ref (menuitem10);
  gtk_object_set_data_full (GTK_OBJECT (message), "menuitem10", menuitem10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menuitem10);
  gtk_container_add (GTK_CONTAINER (menuitem1_menu), menuitem10);
  gtk_widget_add_accelerator (menuitem10, "activate", accel_group,
                              GDK_s, GDK_MOD1_MASK,
                              GTK_ACCEL_VISIBLE);

  menuitem11 = gtk_menu_item_new_with_label (_("Print"));
  gtk_widget_set_name (menuitem11, "menuitem11");
  gtk_widget_ref (menuitem11);
  gtk_object_set_data_full (GTK_OBJECT (message), "menuitem11", menuitem11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menuitem11);
  gtk_container_add (GTK_CONTAINER (menuitem1_menu), menuitem11);
  gtk_widget_add_accelerator (menuitem11, "activate", accel_group,
                              GDK_p, GDK_MOD1_MASK,
                              GTK_ACCEL_VISIBLE);

  menuitem12 = gtk_menu_item_new ();
  gtk_widget_set_name (menuitem12, "menuitem12");
  gtk_widget_ref (menuitem12);
  gtk_object_set_data_full (GTK_OBJECT (message), "menuitem12", menuitem12,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menuitem12);
  gtk_container_add (GTK_CONTAINER (menuitem1_menu), menuitem12);
  gtk_widget_set_sensitive (menuitem12, FALSE);

  menuitem13 = gtk_menu_item_new_with_label (_("Save Attachment..."));
  gtk_widget_set_name (menuitem13, "menuitem13");
  gtk_widget_ref (menuitem13);
  gtk_object_set_data_full (GTK_OBJECT (message), "menuitem13", menuitem13,
                            (GtkDestroyNotify) gtk_widget_unref);
//  gtk_widget_show (menuitem13);
  gtk_container_add (GTK_CONTAINER (menuitem1_menu), menuitem13);

  menuitem14 = gtk_menu_item_new ();
  gtk_widget_set_name (menuitem14, "menuitem14");
  gtk_widget_ref (menuitem14);
  gtk_object_set_data_full (GTK_OBJECT (message), "menuitem14", menuitem14,
                            (GtkDestroyNotify) gtk_widget_unref);
//  gtk_widget_show (menuitem14);
  gtk_container_add (GTK_CONTAINER (menuitem1_menu), menuitem14);
  gtk_widget_set_sensitive (menuitem14, FALSE);

  menuitem15 = gtk_menu_item_new_with_label (_("Close"));
  gtk_widget_set_name (menuitem15, "menuitem15");
  gtk_widget_ref (menuitem15);
  gtk_object_set_data_full (GTK_OBJECT (message), "menuitem15", menuitem15,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menuitem15);
  gtk_container_add (GTK_CONTAINER (menuitem1_menu), menuitem15);
  gtk_widget_add_accelerator (menuitem15, "activate", accel_group,
                              GDK_w, GDK_MOD1_MASK,
                              GTK_ACCEL_VISIBLE);

  menuitem16 = gtk_menu_item_new_with_label (_("Exit TradeClient"));
  gtk_widget_set_name (menuitem16, "menuitem16");
  gtk_widget_ref (menuitem16);
  gtk_object_set_data_full (GTK_OBJECT (message), "menuitem16", menuitem16,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menuitem16);
  gtk_container_add (GTK_CONTAINER (menuitem1_menu), menuitem16);
  gtk_widget_add_accelerator (menuitem16, "activate", accel_group,
                              GDK_q, GDK_MOD1_MASK,
                              GTK_ACCEL_VISIBLE);

	menuitem17=clip_create_menuitem (menubar2, accel_group);

/*  menuitem17 = gtk_menu_item_new_with_label (_("Edit"));
  gtk_widget_set_name (menuitem17, "menuitem17");
  gtk_widget_ref (menuitem17);
  gtk_object_set_data_full (GTK_OBJECT (message), "menuitem17", menuitem17,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menuitem17);
  gtk_container_add (GTK_CONTAINER (menubar2), menuitem17);

  menuitem17_menu = gtk_menu_new ();
  gtk_widget_set_name (menuitem17_menu, "menuitem17_menu");
  gtk_widget_ref (menuitem17_menu);
  gtk_object_set_data_full (GTK_OBJECT (message), "menuitem17_menu", menuitem17_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (menuitem17), menuitem17_menu);
  menuitem17_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (menuitem17_menu));

  menuitem20 = gtk_menu_item_new ();
  gtk_widget_set_name (menuitem20, "menuitem20");
  gtk_widget_ref (menuitem20);
  gtk_object_set_data_full (GTK_OBJECT (message), "menuitem20", menuitem20,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menuitem20);
  gtk_container_add (GTK_CONTAINER (menuitem17_menu), menuitem20);
  gtk_widget_set_sensitive (menuitem20, FALSE);

  cut = gtk_menu_item_new_with_label (_("Cut"));
  gtk_widget_set_name (cut, "cut");
  gtk_widget_ref (cut);
  gtk_object_set_data_full (GTK_OBJECT (message), "cut", cut,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cut);
  gtk_container_add (GTK_CONTAINER (menuitem17_menu), cut);
  gtk_widget_add_accelerator (cut, "activate", accel_group,
                              GDK_x, GDK_MOD1_MASK,
                              GTK_ACCEL_VISIBLE);

  copy = gtk_menu_item_new_with_label (_("Copy"));
  gtk_widget_set_name (copy, "copy");
  gtk_widget_ref (copy);
  gtk_object_set_data_full (GTK_OBJECT (message), "copy", copy,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (copy);
  gtk_container_add (GTK_CONTAINER (menuitem17_menu), copy);
  gtk_widget_add_accelerator (copy, "activate", accel_group,
                              GDK_c, GDK_MOD1_MASK,
                              GTK_ACCEL_VISIBLE);

  paste = gtk_menu_item_new_with_label (_("Paste"));
  gtk_widget_set_name (paste, "paste");
  gtk_widget_ref (paste);
  gtk_object_set_data_full (GTK_OBJECT (message), "paste", paste,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (paste);
  gtk_container_add (GTK_CONTAINER (menuitem17_menu), paste);
  gtk_widget_add_accelerator (paste, "activate", accel_group,
                              GDK_v, GDK_MOD1_MASK,
                              GTK_ACCEL_VISIBLE);

  clear = gtk_menu_item_new_with_label (_("Clear"));
  gtk_widget_set_name (clear, "clear");
  gtk_widget_ref (clear);
  gtk_object_set_data_full (GTK_OBJECT (message), "clear", clear,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (clear);
  gtk_container_add (GTK_CONTAINER (menuitem17_menu), clear);
  gtk_widget_add_accelerator (clear, "activate", accel_group,
                              GDK_v, GDK_MOD1_MASK,
                              GTK_ACCEL_VISIBLE);

  selectall = gtk_menu_item_new_with_label (_("Select All"));
  gtk_widget_set_name (selectall, "selectall");
  gtk_widget_ref (selectall);
  gtk_object_set_data_full (GTK_OBJECT (message), "selectall", selectall,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (selectall);
  gtk_container_add (GTK_CONTAINER (menuitem17_menu), selectall);
  gtk_widget_add_accelerator (selectall, "activate", accel_group,
                              GDK_v, GDK_MOD1_MASK,
                              GTK_ACCEL_VISIBLE);

  menuitem24 = gtk_menu_item_new ();
  gtk_widget_set_name (menuitem24, "menuitem24");
  gtk_widget_ref (menuitem24);
  gtk_object_set_data_full (GTK_OBJECT (message), "menuitem24", menuitem24,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menuitem24);
  gtk_container_add (GTK_CONTAINER (menuitem17_menu), menuitem24);
  gtk_widget_set_sensitive (menuitem24, FALSE);*/

  menuitem37 = gtk_menu_item_new_with_label (_("Help"));
  gtk_widget_set_name (menuitem37, "menuitem37");
  gtk_widget_ref (menuitem37);
  gtk_object_set_data_full (GTK_OBJECT (message), "menuitem37", menuitem37,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_right_justify (GTK_MENU_ITEM (menuitem37));
  gtk_widget_show (menuitem37);
  gtk_container_add (GTK_CONTAINER (menubar2), menuitem37);

  menuitem37_menu = gtk_menu_new ();
  gtk_widget_set_name (menuitem37_menu, "menuitem37_menu");
  gtk_widget_ref (menuitem37_menu);
  gtk_object_set_data_full (GTK_OBJECT (message), "menuitem37_menu", menuitem37_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (menuitem37), menuitem37_menu);
  menuitem37_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (menuitem37_menu));
  tearoff=gtk_tearoff_menu_item_new ();
  gtk_widget_show (tearoff);
  gtk_container_add (GTK_CONTAINER (menuitem37_menu), tearoff);

  menuitem41 = gtk_menu_item_new_with_label (_("About TradeClient"));
  gtk_widget_set_name (menuitem41, "menuitem41");
  gtk_widget_ref (menuitem41);
  gtk_object_set_data_full (GTK_OBJECT (message), "menuitem41", menuitem41,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menuitem41);
  gtk_container_add (GTK_CONTAINER (menuitem37_menu), menuitem41);

  hbox9 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox9, "hbox9");
  gtk_widget_ref (hbox9);
  gtk_object_set_data_full (GTK_OBJECT (message), "hbox9", hbox9,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox9);
  gtk_box_pack_start (GTK_BOX (vbox7), hbox9, TRUE, TRUE, 0);

  replyto = gtk_button_new ();
  gtk_widget_set_name (replyto, "replyto");
  gtk_widget_ref (replyto);
  gtk_object_set_data_full (GTK_OBJECT (message), "replyto", replyto,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (replyto);
  gtk_box_pack_start (GTK_BOX (hbox9), replyto, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, replyto, _("Reply to the current message"), NULL);

  replytoall = gtk_button_new ();
  gtk_widget_set_name (replytoall, "replytoall");
  gtk_widget_ref (replytoall);
  gtk_object_set_data_full (GTK_OBJECT (message), "replytoall", replytoall,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (replytoall);
  gtk_box_pack_start (GTK_BOX (hbox9), replytoall, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, replytoall, _("Reply to all recipients for the current message"), NULL);

  forward = gtk_button_new ();
  gtk_widget_set_name (forward, "forward");
  gtk_widget_ref (forward);
  gtk_object_set_data_full (GTK_OBJECT (message), "forward", forward,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (forward);
  gtk_box_pack_start (GTK_BOX (hbox9), forward, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, forward, _("Forward the current message"), NULL);

  vseparator8 = gtk_vseparator_new ();
  gtk_widget_set_name (vseparator8, "vseparator8");
  gtk_widget_ref (vseparator8);
  gtk_object_set_data_full (GTK_OBJECT (message), "vseparator8", vseparator8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vseparator8);
  gtk_box_pack_start (GTK_BOX (hbox9), vseparator8, FALSE, TRUE, 2);

  saveas = gtk_button_new ();
  gtk_widget_set_name (saveas, "saveas");
  gtk_widget_ref (saveas);
  gtk_object_set_data_full (GTK_OBJECT (message), "saveas", saveas,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (saveas);
  gtk_box_pack_start (GTK_BOX (hbox9), saveas, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, saveas, _("Save the current message to a file"), NULL);

  print = gtk_button_new ();
  gtk_widget_set_name (print, "print");
  gtk_widget_ref (print);
  gtk_object_set_data_full (GTK_OBJECT (message), "print", print,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (print);
  gtk_box_pack_start (GTK_BOX (hbox9), print, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, print, _("Print the current message"), NULL);

  frame10 = gtk_frame_new (NULL);
  gtk_widget_set_name (frame10, "frame10");
  gtk_widget_ref (frame10);
  gtk_object_set_data_full (GTK_OBJECT (message), "frame10", frame10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame10);
  gtk_box_pack_start (GTK_BOX (vbox6), frame10, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame10), 2);

  vbox8 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox8, "vbox8");
  gtk_widget_ref (vbox8);
  gtk_object_set_data_full (GTK_OBJECT (message), "vbox8", vbox8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox8);
  gtk_container_add (GTK_CONTAINER (frame10), vbox8);
  gtk_container_set_border_width (GTK_CONTAINER (vbox8), 2);

  table2 = gtk_table_new (7, 2, FALSE);
  gtk_widget_set_name (table2, "table2");
  gtk_widget_ref (table2);
  gtk_object_set_data_full (GTK_OBJECT (message), "table2", table2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table2);
  gtk_box_pack_start (GTK_BOX (vbox8), table2, FALSE, FALSE, 0);

  label18 = gtk_label_new (_("To:"));
  gtk_widget_set_name (label18, "label18");
  gtk_widget_ref (label18);
  gtk_object_set_data_full (GTK_OBJECT (message), "label18", label18,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label18);
  gtk_table_attach (GTK_TABLE (table2), label18, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  label19 = gtk_label_new (_("Cc:"));
  gtk_widget_set_name (label19, "label19");
  gtk_widget_ref (label19);
  gtk_object_set_data_full (GTK_OBJECT (message), "label19", label19,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label19);
  gtk_table_attach (GTK_TABLE (table2), label19, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  label20 = gtk_label_new (_("Subject:"));
  gtk_widget_set_name (label20, "label20");
  gtk_widget_ref (label20);
  gtk_object_set_data_full (GTK_OBJECT (message), "label20", label20,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label20);
  gtk_table_attach (GTK_TABLE (table2), label20, 0, 1, 3, 4,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  sens_label = gtk_label_new (_("Sensitivity:"));
  gtk_widget_set_name (sens_label, "sens_label");
  gtk_widget_ref (sens_label);
  gtk_object_set_data_full (GTK_OBJECT (message), "sens_label", sens_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_table_attach (GTK_TABLE (table2), sens_label, 0, 1, 4, 5,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  sens_entry = gtk_entry_new ();
  gtk_widget_set_name (sens_entry, "sens_entry");
  gtk_widget_ref (sens_entry);
  gtk_object_set_data_full (GTK_OBJECT (message), "sens_entry", sens_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_table_attach (GTK_TABLE (table2), sens_entry, 1, 2, 4, 5,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_entry_set_editable (GTK_ENTRY (sens_entry), FALSE);

  expiry_label = gtk_label_new (_("Expiry-Date:"));
  gtk_widget_set_name (expiry_label, "expiry_label");
  gtk_widget_ref (expiry_label);
  gtk_object_set_data_full (GTK_OBJECT (message), "expiry_label", expiry_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_table_attach (GTK_TABLE (table2), expiry_label, 0, 1, 5, 6,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  expiry_entry = gtk_entry_new ();
  gtk_widget_set_name (expiry_entry, "expiry_entry");
  gtk_widget_ref (expiry_entry);
  gtk_object_set_data_full (GTK_OBJECT (message), "expiry_entry", expiry_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_table_attach (GTK_TABLE (table2), expiry_entry, 1, 2, 5, 6,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_entry_set_editable (GTK_ENTRY (expiry_entry), FALSE);

  replyby_label = gtk_label_new (_("Reply-By:"));
  gtk_widget_set_name (replyby_label, "replyby_label");
  gtk_widget_ref (replyby_label);
  gtk_object_set_data_full (GTK_OBJECT (message), "replyby_label", replyby_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_table_attach (GTK_TABLE (table2), replyby_label, 0, 1, 6, 7,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  replyby_entry = gtk_entry_new ();
  gtk_widget_set_name (replyby_entry, "replyby_entry");
  gtk_widget_ref (replyby_entry);
  gtk_object_set_data_full (GTK_OBJECT (message), "replyby_entry", replyby_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_table_attach (GTK_TABLE (table2), replyby_entry, 1, 2, 6, 7,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_entry_set_editable (GTK_ENTRY (replyby_entry), FALSE);

  label34 = gtk_label_new (_("From:"));
  gtk_widget_set_name (label34, "label34");
  gtk_widget_ref (label34);
  gtk_object_set_data_full (GTK_OBJECT (message), "label34", label34,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label34);
  gtk_table_attach (GTK_TABLE (table2), label34, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  fromline = gtk_entry_new ();
  gtk_widget_set_name (fromline, "fromline");
  gtk_widget_ref (fromline);
  gtk_object_set_data_full (GTK_OBJECT (message), "fromline", fromline,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fromline);
  gtk_entry_set_editable (GTK_ENTRY (fromline), FALSE);
  gtk_table_attach (GTK_TABLE (table2), fromline, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  toline = gtk_entry_new ();
  gtk_widget_set_name (toline, "toline");
  gtk_widget_ref (toline);
  gtk_object_set_data_full (GTK_OBJECT (message), "toline", toline,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (toline);
  gtk_entry_set_editable (GTK_ENTRY (toline), FALSE);
  gtk_table_attach (GTK_TABLE (table2), toline, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  ccline = gtk_entry_new ();
  gtk_widget_set_name (ccline, "ccline");
  gtk_widget_ref (ccline);
  gtk_object_set_data_full (GTK_OBJECT (message), "ccline", ccline,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ccline);
  gtk_entry_set_editable (GTK_ENTRY (ccline), FALSE);
  gtk_table_attach (GTK_TABLE (table2), ccline, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  subjectline = gtk_entry_new ();
  gtk_widget_set_name (subjectline, "subjectline");
  gtk_widget_ref (subjectline);
  gtk_object_set_data_full (GTK_OBJECT (message), "subjectline", subjectline,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (subjectline);
  gtk_entry_set_editable (GTK_ENTRY (subjectline), FALSE);
  gtk_table_attach (GTK_TABLE (table2), subjectline, 1, 2, 3, 4,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  message_pane = gtk_vpaned_new ();
  gtk_widget_set_name (message_pane, "message_pane");
  gtk_widget_ref (message_pane);
  gtk_object_set_data_full (GTK_OBJECT (message), "message_pane", message_pane,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (message_pane);
  gtk_box_pack_start (GTK_BOX (vbox8), message_pane, TRUE, TRUE, 0);
  gtk_paned_set_handle_size (GTK_PANED (message_pane), 8);
  gtk_paned_set_gutter_size (GTK_PANED (message_pane), 9);
  gtk_paned_set_position (GTK_PANED (message_pane), tm_globs->ppos.msgw_vp1);
  gtk_signal_connect (GTK_OBJECT (message_pane), "size_allocate",
                         GTK_SIGNAL_FUNC (ppos_set_msgw), NULL);

  scrolledwindow2 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_set_name (scrolledwindow2, "scrolledwindow2");
  gtk_widget_ref (scrolledwindow2);
  gtk_object_set_data_full (GTK_OBJECT (message), "scrolledwindow2", scrolledwindow2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow2);
  gtk_container_add (GTK_CONTAINER (message_pane), scrolledwindow2);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow2), GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);

  messagebody = gtk_text_new (NULL, NULL);
  gtk_widget_set_name (messagebody, "messagebody");
  gtk_widget_ref (messagebody);
  gtk_object_set_data_full (GTK_OBJECT (message), "messagebody", messagebody,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (messagebody);
  gtk_container_add (GTK_CONTAINER (scrolledwindow2), messagebody);

  frame11 = gtk_frame_new (_("Attachments"));
  gtk_widget_set_name (frame11, "frame11");
  gtk_widget_ref (frame11);
  gtk_object_set_data_full (GTK_OBJECT (message), "frame11", frame11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame11);
  gtk_container_add (GTK_CONTAINER (message_pane), frame11);

  scrolledwindow3 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_set_name (scrolledwindow3, "scrolledwindow3");
  gtk_widget_ref (scrolledwindow3);
  gtk_object_set_data_full (GTK_OBJECT (message), "scrolledwindow3", scrolledwindow3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow3);
  gtk_container_add (GTK_CONTAINER (frame11), scrolledwindow3);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow3), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  attachment_clist = gtk_clist_new (3);
  gtk_widget_set_name (attachment_clist, "attachment_clist");
  gtk_widget_ref (attachment_clist);
  gtk_object_set_data_full (GTK_OBJECT (message), "attachment_clist", attachment_clist,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (attachment_clist);
  gtk_container_add (GTK_CONTAINER (scrolledwindow3), attachment_clist);

  gtk_clist_set_column_width (GTK_CLIST (attachment_clist), 0, tm_globs->cpos.msgw[0]);
  gtk_clist_set_column_width (GTK_CLIST (attachment_clist), 1, tm_globs->cpos.msgw[1]);
  gtk_clist_set_column_width (GTK_CLIST (attachment_clist), 2, tm_globs->cpos.msgw[2]);
  gtk_clist_column_titles_show (GTK_CLIST (attachment_clist));

  gtk_signal_connect (GTK_OBJECT (attachment_clist), "resize_column",
                         GTK_SIGNAL_FUNC (cpos_set_msgw), NULL);

  label25 = gtk_label_new (_("Content Type"));
  gtk_widget_set_name (label25, "label25");
  gtk_widget_ref (label25);
  gtk_object_set_data_full (GTK_OBJECT (message), "label25", label25,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label25);
  gtk_clist_set_column_widget (GTK_CLIST (attachment_clist), 0, label25);

  label26 = gtk_label_new (_("Filename"));
  gtk_widget_set_name (label26, "label26");
  gtk_widget_ref (label26);
  gtk_object_set_data_full (GTK_OBJECT (message), "label26", label26,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label26);
  gtk_clist_set_column_widget (GTK_CLIST (attachment_clist), 1, label26);

  label27 = gtk_label_new (_("Size"));
  gtk_widget_set_name (label27, "label27");
  gtk_widget_ref (label27);
  gtk_object_set_data_full (GTK_OBJECT (message), "label27", label27,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label27);
  gtk_clist_set_column_widget (GTK_CLIST (attachment_clist), 2, label27);

  frame9 = gtk_frame_new (NULL);
  gtk_widget_set_name (frame9, "frame9");
  gtk_widget_ref (frame9);
  gtk_object_set_data_full (GTK_OBJECT (message), "frame9", frame9,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame9);
  gtk_box_pack_start (GTK_BOX (vbox6), frame9, FALSE, FALSE, 0);
  gtk_frame_set_shadow_type (GTK_FRAME (frame9), GTK_SHADOW_IN);

  label11 = gtk_label_new ("");
  gtk_widget_set_name (label11, "label11");
  gtk_widget_ref (label11);
  gtk_object_set_data_full (GTK_OBJECT (message), "label11", label11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label11);
  gtk_container_add (GTK_CONTAINER (frame9), label11);

  gtk_object_set_data (GTK_OBJECT (message), "tooltips", tooltips);

  gtk_window_add_accel_group (GTK_WINDOW (message), accel_group);

  return message;
}

void message_window_connect_signals (GtkWidget *win, char *message) {
	GtkWidget *scratch;

	scratch = pixmap_widget_create (win, PIXMAP_REPLY);
	gtk_widget_show (scratch);
	gtk_container_add (GTK_CONTAINER (lookup_widget (win, "replyto")), scratch);

	scratch = pixmap_widget_create (win, PIXMAP_REPLYALL);
	gtk_widget_show (scratch);
	gtk_container_add (GTK_CONTAINER (lookup_widget (win, "replytoall")), scratch);

	scratch = pixmap_widget_create (win, PIXMAP_FORWARD);
	gtk_widget_show (scratch);
	gtk_container_add (GTK_CONTAINER (lookup_widget (win, "forward")), scratch);

	scratch = pixmap_widget_create (win, PIXMAP_SAVE);
	gtk_widget_show (scratch);
	gtk_container_add (GTK_CONTAINER (lookup_widget (win, "saveas")), scratch);

	scratch = pixmap_widget_create (win, PIXMAP_PRINT);
	gtk_widget_show (scratch);
	gtk_container_add (GTK_CONTAINER (lookup_widget (win, "print")), scratch);


        gtk_signal_connect (GTK_OBJECT (win), "size_allocate",
                            GTK_SIGNAL_FUNC (wsize_set_msgw), NULL);
	gtk_signal_connect (GTK_OBJECT (win), "delete_event",
	                    GTK_SIGNAL_FUNC (message_window_destroy), (gpointer)message);
	gtk_signal_connect (GTK_OBJECT (lookup_widget (win, "menuitem15")), "activate",
	                    GTK_SIGNAL_FUNC (message_window_close), (gpointer)message);

	gtk_signal_connect (GTK_OBJECT (lookup_widget (win, "replyto")), "clicked",
	                    GTK_SIGNAL_FUNC (message_window_replyto), (gpointer)message);
	gtk_signal_connect (GTK_OBJECT (lookup_widget (win, "menuitem2")), "activate",
	                    GTK_SIGNAL_FUNC (message_window_replyto), (gpointer)message);

	gtk_signal_connect (GTK_OBJECT (lookup_widget (win, "replytoall")), "clicked",
	                    GTK_SIGNAL_FUNC (message_window_replytoall), (gpointer)message);
	gtk_signal_connect (GTK_OBJECT (lookup_widget (win, "menuitem3")), "activate",
	                    GTK_SIGNAL_FUNC (message_window_replytoall), (gpointer)message);

	gtk_signal_connect (GTK_OBJECT (lookup_widget (win, "forward")), "clicked",
	                    GTK_SIGNAL_FUNC (message_window_forward), (gpointer)message);
	gtk_signal_connect (GTK_OBJECT (lookup_widget (win, "menuitem4")), "activate",
	                    GTK_SIGNAL_FUNC (message_window_forward), (gpointer)message);

	gtk_signal_connect (GTK_OBJECT (lookup_widget (win, "saveas")), "clicked",
	                    GTK_SIGNAL_FUNC (message_window_save), (gpointer)message);
	gtk_signal_connect (GTK_OBJECT (lookup_widget (win, "menuitem10")), "activate",
	                    GTK_SIGNAL_FUNC (message_window_save), (gpointer)message);

	gtk_signal_connect (GTK_OBJECT (lookup_widget (win, "print")), "clicked",
	                    GTK_SIGNAL_FUNC (message_window_print), (gpointer)message);
	gtk_signal_connect (GTK_OBJECT (lookup_widget (win, "menuitem11")), "activate",
	                    GTK_SIGNAL_FUNC (message_window_print), (gpointer)message);
	
	gtk_signal_connect (GTK_OBJECT (lookup_widget (win, "attachment_clist")), "select_row",
	                    GTK_SIGNAL_FUNC (clicked_on_attachment), (gpointer)message);
	gtk_signal_connect (GTK_OBJECT (lookup_widget (win, "attachment_clist")), "button_press_event",
	                    GTK_SIGNAL_FUNC (message_attachment_event), (gpointer)message);
	
	gtk_signal_connect (GTK_OBJECT (lookup_widget (win, "menuitem16")), "activate",
	                    GTK_SIGNAL_FUNC (puma_die), NULL);
	gtk_signal_connect (GTK_OBJECT (lookup_widget (win, "menuitem41")), "activate",
	                    GTK_SIGNAL_FUNC (activate_aboutbox), NULL);

	clip_handle_editable (lw (win, "fromline"));
	clip_handle_editable (lw (win, "toline"));
	clip_handle_editable (lw (win, "ccline"));
	clip_handle_editable (lw (win, "subjectline"));
	clip_handle_editable (lw (win, "messagebody"));
}

GtkWidget *message_window_new (msg_info *info) {
	GtkWidget *win=create_message_window ();
	GtkCList *clist=GTK_CLIST (lookup_widget (win, "attachment_clist"));
	Attachment *att=(Attachment *)calloc (1, sizeof (Attachment)), *tatt;
	Header_Info *hinfo;
	char *tmpmsg, *msg=NULL, *cl_data[3], *head;
	if (!info)
		return NULL;	
	gtk_window_set_title (GTK_WINDOW (win), info->msg->subject);

	tmpmsg=message_load (info->fl, info->msg);
	message_window_connect_signals (win, tmpmsg);
	head=message_load_head (info->fl, info->msg);
	hinfo=parse_header (head);
	free (head);
	att->mtype=strdup ("dummyatt");
	msg=mime_process (tmpmsg, att, 0);
	tatt=att->next;
	free (att->mtype);
	free (att);
	att=tatt;
	while (att) {
		cl_data[0]=att->mtype;
		cl_data[1]=att->fname;
		cl_data[2]=(char *)calloc (20, 1);
		sprintf (cl_data[2], "%d", (int)att->length);
		gtk_clist_set_row_data (clist, gtk_clist_append (clist, cl_data), (gpointer)att);
		free (cl_data[2]);
		att=att->next;
	}

	if (hinfo->from) gtk_entry_set_text (GTK_ENTRY (lookup_widget (win, "fromline")), hinfo->from);
	if (hinfo->subject) gtk_entry_set_text (GTK_ENTRY (lookup_widget (win, "subjectline")), hinfo->subject);
	if (hinfo->to) gtk_entry_set_text (GTK_ENTRY (lookup_widget (win, "toline")), hinfo->to);
	if (hinfo->cc) gtk_entry_set_text (GTK_ENTRY (lookup_widget (win, "ccline")), hinfo->cc);
	if ((hinfo->sensitivity)&&(strlen(hinfo->sensitivity))&&(strcmp(hinfo->sensitivity,"Public-Document"))) {
		gtk_widget_show (lookup_widget (win, "sens_label"));
		gtk_widget_show (lookup_widget (win, "sens_entry"));
		gtk_entry_set_text (GTK_ENTRY (lookup_widget (win, "sens_entry")), hinfo->sensitivity);
	}
        if ((hinfo->replyby)&&(strlen(hinfo->replyby))) {
                gtk_widget_show (lookup_widget (win, "replyby_label"));
                gtk_widget_show (lookup_widget (win, "replyby_entry"));
                gtk_entry_set_text (GTK_ENTRY (lookup_widget (win, "replyby_entry")), hinfo->replyby);
        }
        if ((hinfo->expiry)&&(strlen(hinfo->expiry))) {
                gtk_widget_show (lookup_widget (win, "expiry_label"));
                gtk_widget_show (lookup_widget (win, "expiry_entry"));
                gtk_entry_set_text (GTK_ENTRY (lookup_widget (win, "expiry_entry")), hinfo->expiry);
        }
	if (msg) gtk_text_insert (GTK_TEXT (lookup_widget (win, "messagebody")), NULL, NULL,
	                 NULL, msg, -1);
	destroy_hinfo (hinfo);
	free (msg);
	gtk_widget_show (win);
	return win;
}

GtkWidget *message_window_new_stream (char *message) {
	GtkWidget *win=create_message_window ();
	GtkCList *clist=GTK_CLIST (lookup_widget (win, "attachment_clist"));
	int hsize=message_hsize (message);
	char *head=(char *)calloc (hsize, 1);
	Header_Info *hinfo;
	char *body, *tmp;
	Attachment *att=NULL, *old_att;
	char *cl_data[3];
	
	memmove (head, message, hsize);
	hinfo=parse_header (head);
	free( head ) ;
	att=(Attachment *)calloc (1, sizeof (Attachment));
	att->mtype=strdup ("dummyatt");
	body=mime_process (message, att, 0);
	free (att->mtype);
	old_att=att;
	att=att->next;
	free (old_att);
	gtk_window_set_title (GTK_WINDOW (win), hinfo->subject);
	message_window_connect_signals (win, message);
	
	if (hinfo->from) {
		tmp=rm_crlf (hinfo->from);
		gtk_entry_set_text (GTK_ENTRY (lookup_widget (win, "fromline")), tmp);
		free (tmp);
	}
	if (hinfo->subject) {
		tmp=rm_crlf (hinfo->subject);
		gtk_entry_set_text (GTK_ENTRY (lookup_widget (win, "subjectline")), tmp);
		free (tmp);
	}
	if (hinfo->to) {
		tmp=rm_crlf (hinfo->to);
		gtk_entry_set_text (GTK_ENTRY (lookup_widget (win, "toline")), tmp);
		free (tmp);
	}
	if (hinfo->cc) {
		tmp=rm_crlf (hinfo->cc);
		gtk_entry_set_text (GTK_ENTRY (lookup_widget (win, "ccline")), tmp);
		free (tmp);
	}
	if (body)
		gtk_text_insert (GTK_TEXT (lookup_widget (win, "messagebody")), NULL, NULL,
		                 NULL, body, -1);	
	while (att) {
		cl_data[0]=att->mtype;
		cl_data[1]=att->fname;
		cl_data[2]=(char *)calloc (20, 1);
		sprintf (cl_data[2], "%d", (int)att->length);
		gtk_clist_set_row_data (clist, gtk_clist_append (clist, cl_data), (gpointer)att);
		free (cl_data[2]);
		att=att->next;
	}
	gtk_widget_show (win);
	return win;
}
