/* TradeClient <http://tradeclient.sourceforge.net>
 * $Id: mime.c,v 1.52 2001/03/20 22:19:33 ttabner Exp $
 *
 * Copyright (C) 1999-2000 Bynari Inc.
 * Copyright (C) 2001 Project TradeClient
 *
 * LGPL
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#include "puma.h"

#undef write
Llist *mimetypes;
#define NA 127

/*
   These functions are crazy in size but seem to be pretty solid. If you
   notice me doing something weird tell me.
*/


/*
   pretty standard tatic tables for base64, quoted printable, encoding,
   decoding, et cetera, et cetera.
*/
static char index_qp[256] = {
	NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA,
	NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA,
	NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA,
	 0, 1, 2, 3,  4, 5, 6, 7,  8, 9,NA,NA, NA,NA,NA,NA,

	NA,10,11,12, 13,14,15,NA, NA,NA,NA,NA, NA,NA,NA,NA,
	NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA,
	NA,10,11,12, 13,14,15,NA, NA,NA,NA,NA, NA,NA,NA,NA,
	NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA,

	NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA,
	NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA,
	NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA,
	NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA,

	NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA,
	NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA,
	NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA,
	NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA
};

static char index_b64[256] = {
	NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA,
	NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA,
	NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,62, NA,NA,NA,63,
	52,53,54,55, 56,57,58,59, 60,61,NA,NA, NA,NA,NA,NA,

	NA, 0, 1, 2,  3, 4, 5, 6,  7, 8, 9,10, 11,12,13,14,
	15,16,17,18, 19,20,21,22, 23,24,25,NA, NA,NA,NA,NA,
	NA,26,27,28, 29,30,31,32, 33,34,35,36, 37,38,39,40,
	41,42,43,44, 45,46,47,48, 49,50,51,NA, NA,NA,NA,NA,

	NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA,
	NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA,
	NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA,
	NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA,

	NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA,
	NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA,
	NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA,
	NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA
};

static char index_no_enc[256] = {
	NA,NA,NA,NA, NA,NA,NA,NA, NA,00,NA,NA, NA,NA,NA,NA,//16
	NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,00,//32
	00,00,00,00, 00,00,00,00, 00,00,00,00, 00,00,00,00,//48
	00,00,00,00, 00,00,00,00, 00,00,00,00, NA,00,00,00,//64

	00,00,00,00, 00,00,00,00, 00,00,00,00, 00,00,00,00,//80
	00,00,00,00, 00,00,00,00, 00,00,00,00, 00,00,00,00,//96
	00,00,00,00, 00,00,00,00, 00,00,00,00, 00,00,00,00,//112
	00,00,00,00, 00,00,00,00, 00,00,00,00, 00,00,NA,NA,//128

	NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA,
	NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA,
	NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA,
	NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA,

	NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA,
	NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA,
	NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA,
	NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA, NA,NA,NA,NA
};

static char b64[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
static char hextable[16] = "0123456789ABCDEF";

char gethex (int num) {
	return hextable[num];
}

void attachments_destroy (Attachment *att) {
	Attachment *tmpatt;
	while (att) {
		if (att->name) free (att->name);
		if (att->fname) free (att->fname);
		if (att->mtype) free (att->mtype);
		tmpatt=att->next;
		free (att);
		att=tmpatt;
	}
}

/*
   check the first 4096 chars to determine how we should encode if 10% or
   less need encoding we will just user qp if more then base64 here we come
   :)
*/
int encode_with (char *string, unsigned long len) {
	int i, numtoenc, len2=len;

	if (!string) return FALSE;
	numtoenc=0;
	if (len2>4096) len2=4096;

	for (i=0; i<len2; i++) {
		if (index_no_enc[((int)string[i])]==NA)
			numtoenc++;
	}
	if (numtoenc>0) {
		if (numtoenc>(len2*0.1))
			return ENC_BASE64;
		else
			return ENC_QP;
	}
	return ENC_NONE;
}

unsigned long hash_string (char *str) {
	int len=strlen(str);
	int i;
	unsigned long sum=0;

	if (!str) return 1;
	if (str[0]=='\0') return (unsigned long)str;

	for (i=0; i<len; i++) {
		sum+=str[i];
	}
	sum=sum/(len/2);
	return sum;
}

/*
   a suggested seed should be something like a hash of the subject + a hash
   of the recipients address + a hash of the timeofday
*/
char *generate_boundary (unsigned int seed, int length) {
	char *ret=(char *)calloc(length+14, sizeof(char));
	int i=0;

	if (!length) {
		free (ret);
		return NULL;
	}

	srandom (seed);
	memmove (ret, "------------", 12);
	for (i=0; i<length; i++) {
		ret[i+12]=hextable[(int)(random()%16)];
	}
	return ret;
}

MimeType *mime_type_add (char *type, char *handle, char *ext) {
	MimeType *mtype=(MimeType *)calloc (1, sizeof (MimeType));
	if (mime_type_search_type (type)!=NULL) {
		return NULL;
	}
	if (type) mtype->type=strdup (type);
	if (handle) mtype->handle=strdup (handle);
	if (ext) mtype->ext=strdup (ext);
	if (mimetypes) {
		llist_append (mimetypes, mtype);
	} else {
		mimetypes=llist_append (NULL, mtype);
	}
	mime_types_rehash_clist ();
	return mtype;
}

MimeType *mime_type_search_type (char *type) {
	Llist *seek=mimetypes;
	MimeType *mtype = NULL;
	if (type) {
		while (seek) {
			mtype=(MimeType *)seek->data;
			if (!mtype) return NULL;
			if (strncasecmp (type, mtype->type, strlen (mtype->type))==0) return mtype;
			seek=seek->next;
		}
	} else {
#if DEBUG > 2
		printf ("mime_type_search_type: argument 1 'type' == NULL\n");
#endif
	}
	return NULL;
}

MimeType *mime_type_search_ext (char *ext) {
	Llist *seek=mimetypes;
	MimeType *mtype;
	if (ext) {
		while (seek) {
			mtype=(MimeType *)seek->data;
			if (strstr (mtype->ext, ext)!=NULL) return mtype;
			seek=seek->next;
		}
	} else {
#if DEBUG > 1
		printf ("mime_type_search_ext: ext is null\n");
#endif
	}
	return NULL;
}

void mime_type_delete (char *type) {
	MimeType *mtype;
	if (type) {
		mtype=mime_type_search_type (type);
		if (mtype) {
			mimetypes=llist_detach (mimetypes, (void *)mtype);
			if (mtype->type) free (mtype->type);
			if (mtype->handle) free (mtype->handle);
			if (mtype->ext) free (mtype->ext);
			free (mtype);
		}
	}
	mime_types_rehash_clist ();
}

Llist *mime_type_first () {
	return mimetypes;
}


/*
   I found these on most linux systems installed by default, seems to work
   fine for most standard thing.
*/
void mime_type_add_defaults () {
	if (mimetypes==NULL) {
		mime_type_add ("text/plain", "Internal", "txt,text");
		mime_type_add ("text/html", "netscape '%f'", "htm,html");

		mime_type_add ("message/rfc822", "Internal", "eml");

		mime_type_add ("application/octet-stream", "Save", "");
		mime_type_add ("application/java-archive", "Save", "jar");
		mime_type_add ("application/mac-binhex40", "Save", "hqx");
		mime_type_add ("application/pdf", "xpdf '%f'", "pdf");
		mime_type_add ("application/rtf", "Save", "rtf");
		mime_type_add ("application/x-gzip", "Save", "gz");
		mime_type_add ("application/x-cpio", "Save", "cpio");
		mime_type_add ("application/x-gtar", "Save", "tar");
		mime_type_add ("application/x-tar", "Save", "tar");
		mime_type_add ("application/x-zip-compressed", "Save", "zip");
		mime_type_add ("application/x-stuffit", "Save", "sit");
		mime_type_add ("application/x-tex", "Save", "tex");
		mime_type_add ("application/x-texinfo", "Save", "texi,texinfo");
		mime_type_add ("application/x-latex", "Save", "latex");
		mime_type_add ("application/x-dvi", "Save", "dvi");

		mime_type_add ("video/mpeg", "xanim '%f'", "mpeg,mpg,mpv,mpe,vbs,mpegv");
		mime_type_add ("video/quicktime", "xanim '%f'", "qt,mov,moov");
		mime_type_add ("video/x-msvideo", "xanim '%f'", "avi");
		mime_type_add ("video/x-mpeg2", "xanim '%f'", "mpv2,mp2v");

		mime_type_add ("audio/x-mpeg", "xterm -e mpg123 '%f'", "mp3,mp2,mpa,abs,mpega");
		mime_type_add ("audio/x-wav", "xterm -e play '%f'", "wav");
		mime_type_add ("audio/x-aiff", "xterm -e play '%f'", "aif,aiff,aifc");

		mime_type_add ("image/jpeg", "xv '%f'", "jpg,jpeg");
		mime_type_add ("image/gif", "xv '%f'", "gif");
		mime_type_add ("image/targa", "xv '%f'", "tga");
		mime_type_add ("image/tiff", "xv '%f'", "tiff,tif");
		mime_type_add ("image/png", "xv '%f'", "png");
		mime_type_add ("image/x-MS-bmp", "xv '%f'", "bmp");
		mime_type_add ("image/x-portable-pixmap", "xv '%f'", "ppm");
		mime_type_add ("image/x-portable-graymap", "xv '%f'", "pgm");
		mime_type_add ("image/x-portable-bitmap", "xv '%f'", "pbm");
		mime_type_add ("image/x-xpixmap", "xv '%f'", "xpm");
		mime_type_add ("image/x-xbitmap", "xv '%f'", "xbm");
		mime_type_add ("image/x-rgb", "xv '%f'", "rgb");
	}
}

int mime_handle (char *ttype) {
	MimeType *mtype=mime_type_search_type (ttype);

	if (mtype==NULL)
		return MIMEHANDLE_NONE;
	if (strncasecmp (mtype->handle, "Internal", 8)==0)
		return MIMEHANDLE_INT;
	if (strncasecmp (mtype->handle, "Save", 4)==0)
		return MIMEHANDLE_SAVE;
	if (strncasecmp (mtype->handle, "Prompt", 4)==0)
		return MIMEHANDLE_PROMPT;

	return MIMEHANDLE_EXT;
}

char *
get_boundary (char *content_type) {
  char *boundary;
  char *tmp=NULL, *tmp2=NULL;
  if (content_type!=NULL) {
    tmp=strpbrk(content_type, "Bb");
    while (tmp!=NULL) {
      tmp++;
      if (strncasecmp (tmp, "oundary=", 8)==0) {
	tmp+=8;
	if (*tmp=='"') {
	  tmp++;
	  tmp2=strchr (tmp, '"');
	} else {
	  tmp2=strpbrk(tmp, "\f\t\r\n ");

	  /*
	   * Let's see if the quotes where simply left off.
	   * If tmp2 is still null, let's assume that the quotes were
	   * left off of the boundary declaration and use what was
	   * left since we DID find a boundary statement!!!!
	   */
	  if( !tmp2 ) {
	    return strdup( tmp ) ;
	  }
	}
	if (tmp2!=NULL) {
	  boundary=(char *)calloc((tmp2-tmp)+1, sizeof(char));
	  memmove (boundary, tmp, tmp2-tmp);
	  return boundary;
	}
      }
      tmp=strpbrk(tmp, "Ff");
    }
  }
  return NULL;
}


char *get_name (char *content_type) {
	char *name;
	char *tmp=NULL, *tmp2=NULL;
	if (content_type!=NULL) {
		tmp=strpbrk(content_type, "Nn");
		while (tmp!=NULL) {
			tmp++;
			if (strncasecmp (tmp, "ame=", 4)==0) {
				tmp+=8;
				if (*tmp=='"') {
					tmp++;
					tmp2=strchr (tmp, '"');
				} else {
					tmp2=strpbrk(tmp, "\f\t\r\n ");
				}
				if (tmp2!=NULL) {
					name=(char *)calloc((tmp2-tmp)+1, sizeof(char));
					memmove (name, tmp, tmp2-tmp);
					return name;
				}
			}
			tmp=strpbrk(tmp, "Ff");
		}
	}
	return NULL;
}

char *get_filename (char *content_d) {
	char *filename;
	char *tmp=NULL, *tmp2=NULL;
	char *maybe=NULL;
	if (content_d!=NULL) {
		tmp=strpbrk(content_d, "Ff");
		while (tmp!=NULL) {
			tmp++;
			if (strncasecmp (tmp, "ilename=", 8)==0) {
				tmp+=8;
				maybe = tmp;
				if (*tmp=='"') {
					tmp++;
					tmp2=strchr (tmp, '"');
				} else {
					tmp2=strpbrk(tmp, "\f\t\r\n ");
				}
				if (tmp2!=NULL) {
					filename=(char *)calloc((tmp2-tmp)+1, sizeof(char));
					memmove (filename, tmp, tmp2-tmp);
					return filename;
				}
			}
			tmp=strpbrk(tmp, "Ff");
		}
#if 1
		if (tmp == NULL) {
			if (maybe != NULL) {
				filename = strdup (maybe);
				return filename;
			}
		}
#endif
	}
	return NULL;
}

/* TODO: verify this function */
int mime_enc_type (char *content_t_e) {
	if (content_t_e!=NULL) {
		switch (content_t_e[0]) {
			case 'q':
			case 'Q':
				if (strncasecmp(content_t_e+1, "uoted-printable", 15)==0)
					return ENC_QP;
				break;
			case '7':
			case '8':
				if (strncasecmp(content_t_e+1, "bit", 3)==0)
					return ENC_NONE;
				break;
			case 'b':
			case 'B':
				if (strncasecmp(content_t_e+1, "ase64", 5)==0)
					return ENC_BASE64;
				if (strncasecmp(content_t_e+1, "inary", 5)==0)
					return ENC_NONE;
			default:
				printf (_("Unknown content encoding '%s'\n"), content_t_e);
		}
	}
	return ENC_NONE;
}

char *mime_dec_base64 (char *data, unsigned long *bpos) {
	int len=strlen(data);
	int i,c1,c2,c3,c4;
	int Done=FALSE;
	char *tmpret=(char *)calloc(len+2, sizeof(char));
	char *ret;

#define getnc(p)	p[i];i++;

	*bpos=0;

	for (i=0; i<len;) {

		c1=getnc(data);
		if ( (c1!='=') && (index_b64[(unsigned char)c1]==NA) ) continue;

		if (Done==TRUE) continue;

		c2=getnc(data);
		while ( (i<len) && (c2!='=') && (index_b64[(unsigned char)c2]==NA) ) {
			c2=getnc(data);
		}

		c3=getnc(data);
		while ( (i<len) && (c3!='=') && (index_b64[(unsigned char)c3]==NA) ) {
			c3=getnc(data);
		}

		c4=getnc(data);
		while ( (i<len) && (c4!='=') && (index_b64[(unsigned char)c4]==NA) ) {
			c4=getnc(data);
		}

		if (i>len) {
			free (tmpret);
			return NULL;
		}

		if ((c1=='=')&&(c2=='=')) {
			Done=TRUE;
			continue;
		}

		c1=index_b64[(unsigned char)c1];
		c2=index_b64[(unsigned char)c2];
		tmpret[*bpos]=( (c1<<2) | ((c2&0x30)>>4) );
		*bpos+=1;
		if (c3=='=') {
			Done=TRUE;
		} else {
			c3=index_b64[(unsigned char)c3];
			tmpret[*bpos]=( ((c2&0x0F)<<4) | ((c3&0x3C)>>2) );
			*bpos+=1;
			if (c4=='=') {
				Done=TRUE;
			} else {
				c4=index_b64[(unsigned char)c4];
				tmpret[*bpos]=( ((c3&0x03)<<6) | c4);
				*bpos+=1;
			}
		}
	}
	ret=(char *)calloc(*bpos+1, sizeof(char));
	memmove (ret, tmpret, *bpos+1);
	free (tmpret);
	return ret;
}

char *mime_dec_qp (char *data, unsigned long *bpos) {
	int len=strlen(data);
	int i,c1,c2;
	char *tmpret=(char *)calloc(len+2, sizeof(char));
	char *ret;
	char *tmps=rm_cr(data);

	*bpos=0;

	for (i=0; i<len; i++) {
		c1=tmps[i];
		if (c1=='=') {
			i++;
			c1=tmps[i];

			if (c1!='\n') {
				c1=index_qp[(unsigned char)c1];
				i++;
				c2=tmps[i];

				c2=index_qp[(unsigned char)c2];
// need global option to strip CR's for now, lets leave them alown
//				if ( ((c1<<4) | c2) != '\r') {
					tmpret[*bpos]=((c1<<4) | c2);
					*bpos+=1;
//				}
			}
		} else {
			tmpret[*bpos]=c1;
			*bpos+=1;
		}
	}
	ret=(char *)calloc(*bpos+1, sizeof(char));
	memmove (ret, tmpret, *bpos);
	free (tmpret);
	free (tmps);
	return ret;
}

char *mime_enc_base64 (unsigned char *data, unsigned long len, unsigned long maxlen) {
	int c1,c2,c3, cpl=0;
	unsigned long dpos=0, rpos=0;
	char *tmpret=(char *)calloc(len*3, sizeof(char));
	char *ret=NULL;

#ifdef getnc
#undef getnc
#endif

#define getnc(p)	p[dpos];dpos++;
#define putnc(p, c) p[rpos]=c;rpos++;

	if ((maxlen!=0)&&(maxlen<73))
		return NULL;

	for (dpos=0; dpos<=len;) {
		c1=getnc(data);
		c2=getnc(data);
		putnc(tmpret, b64[c1>>2])
		if (dpos>len) {
			putnc(tmpret, b64[((c1&0x3)<<4)])
			putnc(tmpret, '=')
			putnc(tmpret, '=')
		} else {
			c3=getnc(data);
			if (dpos>len) {
				putnc(tmpret, b64[((c1&0x3)<<4) | ((c2&0xF0)>>4)])
				putnc(tmpret, b64[((c2&0xF)<<2)])
				putnc(tmpret, '=')
			} else {
				putnc(tmpret, b64[((c1&0x3)<<4) | ((c2&0xF0)>>4)])
				putnc(tmpret, b64[((c2&0xF)<<2) | ((c3&0xC0)>>6)])
				putnc(tmpret, b64[(c3&0x3F)])
			}
		}
		cpl+=4;
		if (cpl>71) {
			putnc(tmpret, '\r')
			putnc(tmpret, '\n')
/*
   FIXME: might want to check for max length so the message can be broken
   into smaller chunks
*/
			cpl=0;
		}
	}
	if (cpl) {
		putnc(tmpret, '\r')
		putnc(tmpret, '\n')
	}
	ret=(char *)calloc(rpos+2, sizeof(char));
	memmove (ret, tmpret, rpos);
	free (tmpret);
	return ret;
}

char *mime_enc_qp (char *data, unsigned long len, unsigned long maxlen) {
	int c, cpl=0;
	unsigned long dpos=0, rpos=0;
	char *tmpret=(char *)calloc(len*3, sizeof(char));
	char *ret=NULL;

#ifdef getnc
#undef getnc
#endif
#ifdef putnc
#undef putnc
#endif

#define getnc(p)	p[dpos];dpos++;
#define putnc(p, c) p[rpos]=c;rpos++;

	if ((maxlen!=0)&&(maxlen<73))
		return NULL;

	for (dpos=0; dpos<=len;) {
		c=getnc(data);
		if (dpos>len) break;
		if (index_no_enc[c-1]==NA) {
			putnc (tmpret, '=')
			putnc (tmpret, hextable[(c&0xF0)>>4])
			putnc (tmpret, hextable[c&0xF])
			cpl+=2;
		} else {
			putnc(tmpret, c)
		}
		cpl++;
		if (c=='\n') cpl=0;
		if (cpl>71) {
			putnc(tmpret, '=')
			putnc(tmpret, '\r')
			putnc(tmpret, '\n')
/*
   FIXME: might want to check for max length so the message can be broken
   into smaller chunks
*/
			cpl=0;
		}
	}
	if (cpl) {
		putnc(tmpret, '\r')
		putnc(tmpret, '\n')
	}
	ret=(char *)calloc(rpos+2, sizeof(char));
	memmove (ret, tmpret, rpos);
	free (tmpret);
	return ret;
}

void message_save_body (GtkWidget *widget, gpointer data) {
	char *body, *head ;
	char *message=((char *)data);
	unsigned long hsize = message_hsize (message);
	unsigned long msize = strlen( message ) ;
	Header_Info *hinfo=NULL;
	char *tmps=NULL, *sdata=NULL;
	unsigned long slen;


	head = body = NULL ;
	head=(char *)calloc(hsize+2, sizeof(char));
	body=(char *)calloc((msize - hsize) + 2, sizeof(char));

	memmove (head, message, hsize);
	memmove (body, message+hsize, msize - hsize);
	hinfo=parse_header (head);

	switch (mime_enc_type (hinfo->content_t_e)) {
		case ENC_BASE64:
			sdata=mime_dec_base64 (body, &slen);
			break;
		case ENC_QP:
			sdata=mime_dec_qp (body, &slen);
			break;
		case ENC_NONE:
			sdata=strdup (body);
			slen=strlen (body);
			break;
	}

	if (hinfo->content_d) {
		tmps=get_filename (hinfo->content_d);
	} else {
		tmps=strdup ("no-name");
	}

	save_string (sdata, slen, tmps);

	if (widget) gtk_widget_destroy (lookup_widget (widget, "yesno"));

	free (tmps);
	free (head);
	free (body);
	destroy_hinfo (hinfo);
	free (message);
}

void message_use_ext_prog (GtkWidget *widget, gpointer data) {
	char *message=((char *)data);
	unsigned long hsize=message_hsize (message);
	char *head=(char *)calloc(hsize+2, sizeof(char));
	char *body=(char *)calloc(strlen (message)-hsize+2, sizeof(char));
	char *file=NULL, *tmps=NULL, *sdata=NULL, *tmps2=NULL;
	Header_Info *hinfo=NULL;
	MimeType *mtype;

	int fd;
	unsigned long slen;

	memmove (head, message, hsize);
	memmove (body, message+hsize, strlen (message)-hsize);
	hinfo=parse_header (head);
	mtype=mime_type_search_type (hinfo->content_type);

	switch (mime_enc_type (hinfo->content_t_e)) {
		case ENC_BASE64:
			sdata=mime_dec_base64 (body, &slen);
			break;
		case ENC_QP:
			sdata=mime_dec_qp (body, &slen);
			break;
		case ENC_NONE:
			sdata=strdup (body);
			slen=strlen (body);
			break;
	}

	/* Only do this if we have a content disposition and it's NOT "inline". */
	if( (hinfo -> content_d) && 
	    (strncmp( "inline", hinfo -> content_d, 6) != 0) ) {
		tmps=get_filename (hinfo->content_d);
	} else {
		if (hinfo->content_type) {
			if (mtype->ext) {
				tmps2=cut_string (mtype->ext, ',', 1, 1);
				if (tmps2[0]=='\0') {
					free (tmps2);
					tmps2=strdup(mtype->ext);
				}
				tmps=(char *)calloc (255, sizeof(char));
				snprintf (tmps, 255, "%d.%s", (int)time(NULL), tmps2);
			} else {
				tmps=(char *)calloc (255, sizeof(char));
				snprintf (tmps, 255, "%d", (int)time(NULL));
			}
		} else {
			tmps=(char *)calloc (255, sizeof(char));
			snprintf (tmps, 255, "%d", (int)time(NULL));
		}
	}
	if (tmps2) free (tmps2);

	if( tmps ) {
	  file=(char *)calloc (strlen(tmps)+20, sizeof(char));
	  mkdir ("/tmp/tradeclient/", S_IREAD | S_IWRITE | S_IEXEC);
	  snprintf (file, strlen(tmps)+20, "/tmp/tradeclient/%s", tmps);
	  free (tmps);
	  fd=open (file, O_CREAT|O_WRONLY, S_IRUSR|S_IWUSR);
	  write (fd, sdata, slen);
	  close (fd);

	  tmps=(char *)calloc(strlen(mtype->handle)+strlen(file)+20, sizeof(char));
	  snprintf (tmps, strlen(mtype->handle)+strlen(file)+20, "%s", mtype->handle);
	  substitute (tmps, "%f", file);
	  
	  tmps2=strdup (tmps);
	  snprintf (tmps, strlen(mtype->handle)+strlen(file)+20, "%s", tmps2);

	  spawn_with_status(tmps, 0);
	  free (tmps);
	  free (tmps2);
	}


	if( widget ) gtk_widget_destroy( lookup_widget (widget, "yesno") ) ;
	free( head ) ;
	free( body ) ;
	free( file ) ;
	free( sdata ) ;
	destroy_hinfo( hinfo ) ;
	free ( message ) ;
}

void message_view (GtkWidget *widget, gpointer data) {
	char *message=((char *)data);
	unsigned long hsize=message_hsize (message);
	char *head=(char *)calloc(hsize+2, sizeof(char));
	Header_Info *hinfo=NULL;

	memmove (head, message, hsize);
	hinfo=parse_header (head);
	free (head);

	if (strncasecmp (hinfo->content_type, "message/rfc822", 14)==0) {
		message_window_new_stream (message);
	} else {
		create_docsource_stream (message);
	}
	hinfo_destroy (hinfo);
	free (message);
}

/* Modified by Charles Hornberger <charlie@tradeclient.org>
 * Attempts to fix MIME boundary bug, and deal with mangled MIME boundaries.
 */
char *mime_process (char *message, Attachment *att, int popup) {
  Header_Info *hinfo, *tmphinfo;
  int hsize=message_hsize (message);
  int tmplen,bsize;
  MimeType *mtype;
  Attachment *attseek=att, *tmpatt;
  unsigned long slen=0;
  int digest=FALSE;
  char *head=(char *)calloc(hsize+1, sizeof(char));
  char *body=NULL;
  char *boundary=NULL;
  char *ret=NULL;
  char *rethead=NULL;
  char *retbody=NULL;
  char *tmps=NULL;
  char *msg=NULL;
  char *tmp1=NULL, *tmp2=NULL, *tmp3l, *tmphead=NULL;
  GtkWidget *yesno;
  char *virusMsg = "";
/*
  char *virusMsg = _("This message has been modified in transit or is invalid.  This may be\n" \
		     "because an attachment contained a virus which has been incorrectly\n" \
		     "removed by a virus scanner or the message originator wanted to send\n" \
		     "a message with the intent of crashing your mail client (a.k.a \"a mail-bomb\").\n" \
		     "The original message body, if any, is included below:\n\n\n") ;
*/

#if DEBUG > 9
  struct timeval tv1, tv2;
  float tf1,tf2;
  gettimeofday (&tv1, NULL);
#endif
#ifdef DMALLOC
  dmalloc_verify( 0 ) ;
#endif
  memmove (head, message, hsize);
  hinfo=parse_header (head);

  /* if we can't parse the header, give up now */

  if (hinfo==NULL) {
#if DEBUG > 9
    gettimeofday (&tv2, NULL);
    tf1=(tv1.tv_sec&0x000000ff)+((float)tv1.tv_usec/(float)1000000);
    tf2=(tv2.tv_sec&0x000000ff)+((float)tv2.tv_usec/(float)1000000);
    printf ("takes %f seconds for mime_process\n", (tf2-tf1));
#endif
    free (head);
    return NULL;
  }

    rethead=header_displayable (head);

  /* if we can't determine the content type, simply return the message */

  if (hinfo->content_type==NULL) {
    retbody=(char *)calloc(strlen (message)+2, sizeof(char));
    memmove (retbody, message+hsize, strlen (message)-hsize);
    if (rethead) {
      ret=(char *)calloc(strlen (retbody)+strlen (rethead)+2, sizeof(char));
      memmove (ret, rethead, strlen (rethead));
      memmove (ret+strlen (rethead), retbody, strlen (retbody));
      free (rethead);
    } else {
      ret=(char *)calloc(strlen (retbody)+2, sizeof(char));
      memmove (ret, retbody, strlen (retbody));
    }

#if DEBUG > 9
    gettimeofday (&tv2, NULL);
    tf1=(tv1.tv_sec&0x000000ff)+((float)tv1.tv_usec/(float)1000000);
    tf2=(tv2.tv_sec&0x000000ff)+((float)tv2.tv_usec/(float)1000000);
    printf ("takes %f seconds for mime_process\n", (tf2-tf1));
#endif
    destroy_hinfo (hinfo);
    free (retbody);
    free (head);
    return ret;
  }

      /*
   * FIXME: this line below needs to search the entire content_type and be
   * case insentive.
      */
#ifdef DMALLOC
      dmalloc_verify( 0 ) ;
#endif
      if (strncasecmp (hinfo->content_type, "multipart", 9)==0) {

	if (strncasecmp (hinfo->content_type, "multipart/digest", 16)==0)
	  digest=TRUE;

	boundary=get_boundary (hinfo->content_type);

	/* This is really an error, just not sure what to do with it at this time! */
    if(boundary==NULL) {
      free (head);
      free (rethead);
      return NULL ;
    }
    bsize=strlen(boundary);

    /* copy the message, minus the head, into 'body' */
	body=(char *)calloc(strlen (message)-hsize+2, sizeof(char));
	memmove (body, message+hsize, strlen (message)-hsize);

    /* look for the boundary */
	tmp1=strstr (body, boundary);

    /* if we found it, advance our 'tmp1' pointer past it and any newlines */
	if( tmp1 ) {
	  tmp1+=bsize;
	  if (digest==FALSE) {
	    if ((*tmp1=='\n')||(*tmp1=='\r')) tmp1++;
	    if ((*tmp1=='\n')||(*tmp1=='\r')) tmp1++;
	  } else {
	    for (;((*tmp1=='\n') || (*tmp1=='\r'));tmp1++) {}
	  }
    }

    /* otherwise, simply return the body and our 'virus message' */
    else {
	  tmp1 = malloc( strlen(body) + strlen(virusMsg) + 1 ) ;
	  strcpy( tmp1, virusMsg ) ;
	  strcat( tmp1, body ) ;
	  free( body ) ;
      free( head) ;
      free( rethead) ;
	  return tmp1 ;
	}

	tmplen=message_hsize (tmp1);
	tmphead=(char *)calloc(tmplen+2, sizeof(char));
	memmove (tmphead, tmp1, tmplen);
	tmphinfo=parse_header (tmphead);
	if (tmphead) free (tmphead);

	if (((mime_handle (tmphinfo->content_type)==MIMEHANDLE_INT) ||
	     (strncasecmp (tmphinfo->content_type, "multipart/alternative", 21)==0)) &&
	    (digest==FALSE)) {

#ifdef DMALLOC
	  dmalloc_verify( 0 ) ;
#endif
	  if (strncasecmp (tmphinfo->content_type, "multipart/alternative", 21)==0) {

        /* look for the next boundary */
	    tmp2=strstr (tmp1, boundary);

        /* if we didn't find another boundary, return what's left of the body */
        if(tmp2==NULL) {
          tmp2 = malloc( strlen(body) + strlen(virusMsg) + 1 );
          strcpy( tmp2, virusMsg );
          strcat( tmp2, body );
          free( body );
          free( head );
          free( rethead );
          destroy_hinfo( tmphinfo );
          return tmp2 ;
        }

        /* back up to the _beginning_ of the boundary string */
	    tmp3l=tmp2;
        while( *tmp3l != '\n' ) tmp3l-- ;

	    tmps=(char *)calloc(tmp3l-tmp1+2, sizeof(char));
	    memmove (tmps, tmp1, tmp3l-tmp1);
	    retbody=mime_process (tmps, attseek, 0);
	    attseek=((Attachment *)attseek->next);
	    attseek->offset+=(tmp1-body)+hsize;
	    tmp2+=bsize;
	    tmp1=tmp2;
	    free (tmps);
      }

      else {

	    tmp1+=tmplen;

        /* look for the next boundary */
	    tmp2=strstr (tmp1, boundary);

        /* if we didn't find another boundary, return what's left of the body */
        if(tmp2==NULL) {
          tmp2 = malloc( strlen(body) + strlen(virusMsg) + 1 );
          strcpy( tmp2, virusMsg );
          strcat( tmp2, body );
          free( body );
          free( head );
          free( rethead );
          destroy_hinfo( tmphinfo );
          return tmp2 ;
        }

        /* back up to the _beginning_ of the boundary string */
        tmp3l=tmp2;
	    while( *tmp3l != '\n' ) tmp3l-- ;

	    tmps=(char *)calloc(abs(tmp1-tmp3l)+2, sizeof(char));
	    memmove( tmps, tmp1, abs(tmp1-tmp3l) ) ;
	    tmp2+=bsize;
	    tmp1=tmp2;
	    switch (mime_enc_type (tmphinfo->content_t_e)) {
	    case ENC_BASE64:
	      retbody=mime_dec_base64 (tmps, &slen);
	      break;
	    case ENC_QP:
	      retbody=mime_dec_qp (tmps, &slen);
	      break;
	    case ENC_NONE:
	      retbody=strdup (tmps);
	      slen=strlen (tmps);
	      break;
	    }
	    free (tmps);
	  }
    }

    /* apparently we don't know how to handle this content type ... so  let's ask
     * the user what to do */
    else {
#ifdef DMALLOC
	  dmalloc_verify( 0 ) ;
#endif
	  tmpatt=(Attachment *)calloc(1, sizeof(Attachment));
	  tmpatt->offset=(tmp1-body)+hsize;
	  if (digest==FALSE) {
	    tmpatt->name=get_name (tmphinfo->content_type);
	    tmpatt->fname=get_filename (tmphinfo->content_d);
	    tmpatt->mtype=cut_string (tmphinfo->content_type, ';', 1, 1);
	  } else {
	    if (tmphinfo->from) tmpatt->name=strdup (tmphinfo->from);
	    else tmpatt->name=strdup ("");
	    if (tmphinfo->subject) tmpatt->fname=strdup (tmphinfo->subject);
	    else tmphinfo->subject=strdup ("");
	    tmpatt->mtype=cut_string (tmphinfo->content_type, ';', 1, 1);
	  }
	  if (tmpatt->mtype[0]=='\0') {
	    free (tmpatt->mtype);
	    tmpatt->mtype=strdup (tmphinfo->content_type);
	  }
	  tmp3l=strstr (tmp1, boundary);
	  if(tmp3l) {
	    for (;*tmp3l!='\n'; tmp3l--) {}
	    tmpatt->length=tmp3l-tmp1;
	    attseek->next=((void *)tmpatt);
	    attseek=((Attachment *)attseek->next);

	    tmp2=tmp1;
	    tmp1=strstr (tmp2, boundary);
	    tmp1+=bsize;
	  }
	}

	destroy_hinfo (tmphinfo);
	tmphinfo=NULL;
	if (digest==FALSE) {
	  if ((*tmp1=='\n')||(*tmp1=='\r')) tmp1++;
	  if ((*tmp1=='\n')||(*tmp1=='\r')) tmp1++;
	} else {
	  for (;((*tmp1=='\n') || (*tmp1=='\r'));tmp1++) {}
	}

	while ( (tmp1!=NULL) && (strncmp (tmp1, "--", 2)!=0) ) {

#ifdef DMALLOC
	  dmalloc_verify( 0 ) ;
#endif
	  tmplen=message_hsize (tmp1);
	  tmphead=(char *)calloc(tmplen+2, sizeof(char));
	  memmove (tmphead, tmp1, tmplen);
	  tmphinfo=parse_header (tmphead);

	  if (tmphead) free (tmphead);

	  tmpatt=(Attachment *)calloc(1, sizeof(Attachment));
	  tmpatt->offset=(tmp1-body)+hsize;
	  if (digest==FALSE) {
	    tmpatt->name=get_name (tmphinfo->content_type);
	    tmpatt->fname=get_filename (tmphinfo->content_d);
	    tmpatt->mtype=cut_string (tmphinfo->content_type, ';', 1, 1);
	  } else {
	    if (tmphinfo->from) tmpatt->name=strdup (tmphinfo->from);
	    else tmpatt->name=strdup ("");
	    if (tmphinfo->subject) tmpatt->fname=strdup (tmphinfo->subject);
	    else tmphinfo->subject = strdup ("");
	    tmpatt->mtype=cut_string (tmphinfo->content_type, ';', 1, 1);
	  }
	  if (tmpatt->mtype[0]=='\0') {
	    free (tmpatt->mtype);
	    tmpatt->mtype=strdup (tmphinfo->content_type);
	  }
	  tmp3l=strstr (tmp1, boundary);
	  if (tmp3l) {
	    for (;*tmp3l!='\n'; tmp3l--) {}
	  } else {
	    tmp3l=tmp1+strlen (tmp1);
	  }
	  tmpatt->length=tmp3l-tmp1;
	  attseek->next=((void *)tmpatt);
	  attseek=((Attachment *)attseek->next);

	  destroy_hinfo (tmphinfo);
	  tmphinfo=NULL;

	  tmp2=tmp1;
	  tmp1=strstr (tmp2, boundary);
	  if (tmp1) {
	    tmp1+=bsize;
	    if (digest==FALSE) {
	      if ((*tmp1=='\n')||(*tmp1=='\r')) tmp1++;
	      if ((*tmp1=='\n')||(*tmp1=='\r')) tmp1++;
	    } else {
	      for (;((*tmp1=='\n') || (*tmp1=='\r'));tmp1++) {}
	    }

	  } else {
	    tmp1=NULL;
	  }
	}

	free (boundary);
	free (body);

	if (!retbody) retbody=strdup (_("Message is only encoded attachments"));

	if (rethead) {
	  ret=(char *)calloc(strlen (retbody)+strlen (rethead)+4, sizeof(char));
	  memmove (ret, rethead, strlen (rethead));
	  memmove (ret+strlen (rethead), retbody, strlen (retbody));
	  free (rethead);
	} else {
	  ret=(char *)calloc(strlen (retbody)+4, sizeof(char));
	  memmove (ret, retbody, strlen (retbody));
	}

#if DEBUG > 9
	gettimeofday (&tv2, NULL);
	tf1=(tv1.tv_sec&0x000000ff)+((float)tv1.tv_usec/(float)1000000);
	tf2=(tv2.tv_sec&0x000000ff)+((float)tv2.tv_usec/(float)1000000);
	printf ("takes %f seconds for mime_process\n", (tf2-tf1));
#endif

	destroy_hinfo (hinfo);
	free (retbody);
	free (head);
	return ret;

      } else {
	tmps=cut_string (hinfo->content_type, ';', 1, 1);
	if (tmps[0]=='\0') {
	  free (tmps);
	  tmps=strdup(hinfo->content_type);
	}

	mtype=mime_type_search_type (tmps);

	switch (mime_handle (tmps)) {
	case MIMEHANDLE_SAVE:
	  if (ret==NULL) {
	    free (rethead);
	    rethead=(char *)calloc (2, sizeof(char));
	    retbody=(char *)calloc (2, sizeof(char)); 
	  }
	  //						msg=strdup(message);
#ifdef DMALLOC
	  dmalloc_verify( 0 ) ;
#endif

	  if (popup) {
	    yesno=create_yesno (_("Save to disk"), _("Would you like to save this message to disk?"), GTK_SIGNAL_FUNC (message_save_body), ((gpointer)strdup(message)));
	    gtk_widget_show (yesno);
	  }
	  break;
	case MIMEHANDLE_NONE:
	case MIMEHANDLE_PROMPT:
	  if (popup) {
	    mime_attachment_unknown (strdup(message));
	  }
	  retbody=(char *)calloc (2, sizeof(char)); 
	  if (rethead) free (rethead);
	  rethead=(char *)calloc (2, sizeof(char));
	  break;
	case MIMEHANDLE_INT:
	  if (strncasecmp (tmps, "message/rfc822", 14)==0) {
	    message_window_new_stream (strdup (message+hsize));
	    if (rethead) free (rethead);
	    rethead=(char *)calloc(2, sizeof(char));
	    retbody=(char *)calloc(2, sizeof(char));
	  } else {
	    tmp3l=(char *)calloc(strlen(message)+2, sizeof(char));
	    if(*(message+hsize)=='\n')
	      memmove (tmp3l, message+hsize+1, strlen(message)-hsize-1);
	    else
	      memmove (tmp3l, message+hsize, strlen(message)-hsize);
	    switch (mime_enc_type (hinfo->content_t_e)) {
	    case ENC_BASE64:
	      retbody=mime_dec_base64 (tmp3l, &slen);
	      break;
	    case ENC_QP:
	      retbody=mime_dec_qp (tmp3l, &slen);
	      break;
	    case ENC_NONE:
	      retbody=strdup (tmp3l);
	      slen=strlen (tmp3l);
	      break;
	    }
	    free (tmp3l);
	  }
	  break;
	case MIMEHANDLE_EXT:
	  retbody=(char *)calloc (2, sizeof(char)); 
	  if (rethead) free (rethead);
	  rethead=(char *)calloc (2, sizeof(char));
	  if (popup) {
	    msg=strdup(message);
	    yesno=create_yesno (_("Use external program"), _("Would you like to view this message with the program selected?"), GTK_SIGNAL_FUNC (message_use_ext_prog), ((gpointer)msg));
	    gtk_widget_show (yesno);
	  }
	  break;
	}
	if (tmps) free (tmps);

	if (rethead) {
	  ret=(char *)calloc(strlen (retbody)+strlen (rethead)+4, sizeof(char));
	  if (rethead[0]!='\0')
	    memmove (ret, rethead, strlen (rethead));
	  if (retbody[0]!='\0')
	    memmove (ret+strlen (rethead), retbody, strlen (retbody));
	  free (rethead);
	} else {
	  ret=(char *)calloc(strlen (retbody)+2, sizeof(char));
	  if (retbody[0]!='\0')
	    memmove (ret, retbody, strlen (retbody));
	}

#if DEBUG > 9
	gettimeofday (&tv2, NULL);
	tf1=(tv1.tv_sec&0x000000ff)+((float)tv1.tv_usec/(float)1000000);
	tf2=(tv2.tv_sec&0x000000ff)+((float)tv2.tv_usec/(float)1000000);
	printf ("takes %f seconds for mime_process\n", (tf2-tf1));
#endif

#ifdef DMALLOC
	dmalloc_verify( 0 ) ;
#endif
	destroy_hinfo (hinfo);
	free (retbody);
	free (head);
	return ret;
      }

#ifdef DMALLOC
  dmalloc_verify( 0 ) ;
#endif
  destroy_hinfo (hinfo);
  free (retbody);
  free (head);
  if (tmps) free (tmps);
#ifdef DMALLOC
  dmalloc_verify( 0 ) ;
#endif
  return NULL;

}

char *mime_get_attachment (char *message, Attachment *att) {
  char *ret;
#ifdef DMALLOC
  dmalloc_verify( 0 ) ;
#endif
  if (message) {
    if (att) {
      ret=(char *)calloc (att->length+2, sizeof(char));
      message+=att->offset;
      memmove (ret, message, att->length);
#ifdef DMALLOC
      dmalloc_verify( 0 ) ;
#endif
      return ret;
    }
  }
#ifdef DMALLOC
  dmalloc_verify( 0 ) ;
#endif
  return NULL;
}


MailMessage *new_mime_encode (char *from, char *replyto, char *org, char *to, char *cc,
			      char *bcc, char *subject, char *timestamp, Llist *atlst,
			      int returnreceipt, char *priority, char *sensitivity,
			      char *keyword, char *expire, char *replyby,
			      char *messageflag ) {
  AFS *tmpat=NULL;
  MimeType *mtype;
  int attachnr;
  int seekCntr ;
  MailMessage *mmessage=NULL;
  FILE *fd;
  Llist *lseek=NULL;
  struct stat *st;
  int atmemb=llist_length (atlst);//size;
  char tmp[1024] ;
  char *tmps2,*tmps3;
  int hdrCnt, hdrCntr ;
  int numPriority ;
  char *textPriority ;
  char *osInfo ;


  hdrCnt = hdrCntr = seekCntr = 0 ;
  mmessage=(MailMessage *)calloc(1, sizeof(MailMessage));

#ifdef DEBUG
  printf ("new_mime_encode: Assembling the header\n");
#endif

#if DEBUG > 4
  printf( "from = %s.\n", from ) ;
#endif

  if(from) {
    mmessage->from=(char *)calloc(strlen(from)+1, sizeof(char));
    memmove(mmessage->from,from,strlen(from));
    if( !replyto ) mmessage->replyto = strdup( from ) ;
  }

#if DEBUG > 4
  printf( "from = %s.\n", from ) ;
#endif

  if(replyto) {
    mmessage->replyto=(char *)calloc(strlen(replyto)+1, sizeof(char));
    memmove(mmessage->replyto,replyto,strlen(replyto));
  }

  if(subject) {
    mmessage->subject=(char *)calloc(strlen(subject)+1, sizeof(char));
    memmove(mmessage->subject,subject,strlen(subject));
  }

  if(to) {
    mmessage->to=(char *)calloc(strlen(to)+1, sizeof(char));
    memmove(mmessage->to,to,strlen(to));
  }

  if(cc) {
    mmessage->cc=(char *)calloc(strlen(cc)+1, sizeof(char));
    memmove(mmessage->cc,cc,strlen(cc));
  }

  if(bcc) {
    mmessage->bcc=(char *)calloc(strlen(bcc)+1, sizeof(char));
    memmove(mmessage->bcc,bcc,strlen(bcc));
  }

  if(org) {
    mmessage->organization=(char *)calloc(strlen(org)+1, sizeof(char));
    memmove(mmessage->organization,org,strlen(org));
    hdrCnt++ ;
  }

  if(timestamp) {
    mmessage->timestamp=(char *)calloc(strlen(timestamp)+1, sizeof(char));
    memmove(mmessage->timestamp,timestamp,strlen(timestamp));
  }

  /*
   * Take care of the return receipt flag.  This
   * way, we always have room for it.
   */
  hdrCnt++ ;
  mmessage -> rr = returnreceipt ;
#if DEBUG > 6
  printf( "MSG: mmessage has rr turned '%s'.\n", returnreceipt?"ON":"OFF" ) ;
#endif

  /*
   * Add in extra header lines for needed items.
   * This gives us, x-mailer, 3-priority lines, plus hdrCnt, plus NULL,
   * plus language, plus sensitivity, plus keywords, plus reply by, 
   * plus expire on, plus x-message-flags, for a total of hdrCnt + 11 ;
   */
  hdrCnt += 11 ;
  mmessage -> extraHeader = (char **)calloc( hdrCnt, sizeof(char *) ) ;
  mmessage -> extraValue = (char **)calloc( hdrCnt, sizeof(char *) ) ;

  /* Organization */
  if( org ) {
    mmessage -> extraHeader[hdrCntr] = strdup( "Organization" ) ;
    mmessage -> extraValue[hdrCntr] = strdup( org ) ;
    hdrCntr++ ;
  }

  mmessage -> extraHeader[hdrCntr] = strdup( "X-Mailer" ) ;
  snprintf( tmp, 1022, "TradeClient %s [%s] %s", VERSION, lang_getlang(), (osInfo = generate_os_info()) ) ;
  mmessage -> extraValue[hdrCntr] = strdup( tmp ) ;
  free( osInfo ) ;
  hdrCntr++ ;


  /* Now, parse out the priority needed below */
  textPriority = malloc( strlen(priority) ) ;
  sscanf( priority, "%d (%s)", &numPriority, textPriority ) ;
  if( textPriority[strlen(textPriority)-1] == ')' ) textPriority[strlen(textPriority)-1] = (char)0x00 ;
  
  /* Priority 1 simply reads as
   * ( "n (verbage)" string where n = 1 - 5 and text is the below strings
   */
  if( priority ) {
    mmessage -> extraHeader[hdrCntr] = strdup( "X-Priority" ) ;
    mmessage -> extraValue[hdrCntr] = strdup( priority ) ;
    hdrCntr++ ;
  }
  
  /* Priority 2
   * (Should read as Lowest, Low, Normal, High, Highest; same as importance)
   */
  if( priority ) {
    mmessage -> extraHeader[hdrCntr] = strdup( "X-MSMail-Priority" ) ;
    mmessage -> extraValue[hdrCntr] = strdup( textPriority ) ;
    hdrCntr++ ;
  }
  
  /*
   * Priority 3 (Importance should read as Lowest, Low, Normal, High, Highest).
   */
  if( priority ) {
    mmessage -> extraHeader[hdrCntr] = strdup( "Importance" ) ;
    mmessage -> extraValue[hdrCntr] = strdup( textPriority ) ;
    hdrCntr++ ;
  }
  
  /* Free the parsed priority string as it is no longer needed. */
  free( textPriority ) ;
  
  /* Language of choice */
  mmessage -> extraHeader[hdrCntr] = strdup( "X-Accept-Language" ) ;
  mmessage -> extraValue[hdrCntr] = strdup( lang_getlang() ) ;
  hdrCntr++ ;
  
  /*
   * Now, process the following header values: sensitivity, expire on,
   * keywords (categories), message flags, and reply by.
   */
  if( sensitivity ) {
    mmessage -> extraHeader[hdrCntr] = strdup( "Sensitivity" ) ;
    mmessage -> extraValue[hdrCntr] = strdup( sensitivity ) ;
    hdrCntr++ ;
  }

  if( keyword ) {
    mmessage -> extraHeader[hdrCntr] = strdup( "Keywords" ) ;
    mmessage -> extraValue[hdrCntr] = strdup( keyword ) ;
    hdrCntr++ ;
  }

  if( expire ) {
    mmessage -> extraHeader[hdrCntr] = strdup( "Expiry-Date" ) ;
    mmessage -> extraValue[hdrCntr] = strdup( expire ) ;
    hdrCntr++ ;
  }

  if( replyby ) {
    mmessage -> extraHeader[hdrCntr] = strdup( "Reply-By" ) ;
    mmessage -> extraValue[hdrCntr] = strdup( replyby ) ;
    hdrCntr++ ;
  }

  if( messageflag ) {
    mmessage -> extraHeader[hdrCntr] = strdup( "X-Message-Flag" ) ;
    mmessage -> extraValue[hdrCntr] = strdup(  messageflag ) ;
    hdrCntr++ ;
  }

  /* Terminate our key/value sequence */
  mmessage -> extraHeader[hdrCntr] = (char *)NULL ;
  mmessage -> extraValue[hdrCntr] = (char *)NULL ;
  
  if (atmemb<2) {
#ifdef DEBUG
    printf ("new_mime_encode: Found only one attachment (probably the message body)\n");
#endif
  } else {
#ifdef DEBUG
    printf ("mime_encode: Found %d attachments\n", atmemb);
#endif
    mmessage->attach_count=atmemb;
    lseek=atlst;
    
    attachnr=0;
    while (lseek) {
      tmpat=((AFS *)lseek->data);

      if (tmpat->filename) {
	st=(struct stat *)calloc (1, sizeof(struct stat));
	stat (tmpat->filename, st);
	fd=fopen (tmpat->filename, "r") ;
	if(fd!=0){
	  mmessage->attach[attachnr]=(char *)calloc (st->st_size, sizeof(char));
	  tmps2=(char *)calloc(strlen(tmpat->filename),sizeof(char));
	  tmps2=strrchr (tmpat->filename,'.');
	  if (tmps2) {
	    tmps2++;
	    mtype=mime_type_search_ext (tmps2);
	    if(mtype) {
	      mmessage->attachtype[attachnr]=(char *)calloc (1024, sizeof(char));
#if DEBUG > 6
	      printf("encoding attachment as type '%s'.\n",mtype->type);
#endif							
	      snprintf(mmessage->attachtype[attachnr],1024,"%s",mtype->type);
	    } else {
	      mmessage->attachtype[attachnr]=cpystr("application/occet-stream");
	    }	
	  } else {
	    mmessage->attachtype[attachnr]=cpystr("application/occet-stream");
	  }	
	  tmps3=(char *)calloc(strlen(tmpat->filename),sizeof(char));
	  tmps3=strrchr(tmpat->filename,'/');
	  mmessage->attachname[attachnr]=(char *)calloc (strlen(tmps3),sizeof(char));
	  if (tmps3) {
	    tmps3++;
	    mmessage->attachname[attachnr]=cpystr(tmps3);
	  }
	  fread (mmessage->attach[attachnr], sizeof (char), st->st_size, fd);
	  mmessage->attach[attachnr]=mime_enc_base64(mmessage->attach[attachnr],st->st_size,0);

	  fclose (fd);
	} else {
	  printf("cannot open file %s for reading",tmpat->filename);
	}
	
	attachnr++;
      } else {
	/*
	 * We only want to add attachments if it's not the body text.
	 * This means that it's the second plus attachment as the body
	 * counts as the first one on a multi-part.
	 */
	if( seekCntr ) {
#if DEBUG > 4
	  printf( "Adding an attachment that is not associated with a file.\n" ) ;
	  printf( "Attachment text is '%s'.\n", tmpat -> data ) ;
#endif
	  /*
	   * Now, nclude the attachment name for easy reference.  We'll just
	   * base the name on the assumption that it's an rfc822 message.
	   */
	  mmessage -> attachname[attachnr] = strdup( "rfc822.txt" ) ;
	  
	  /*
	   * We hit here if there is an attachment but no files, just text.
	   * More than likely, it's a message text body that needs to copied as an
	   * attachment.  This really means that it still needs to be base64 encoded.
	   */
#if 0
	  // This was leaking memory because of the strdup() call
	  mmessage -> attach[attachnr] = mime_enc_base64( tmpat -> data,
							  strlen(tmpat -> data), 0 ) ) ;
#else
	mmessage -> attach[attachnr] = strdup ( tmpat -> data ) ;

#endif
	  
	/* okay, set the MIME type for the attachment, which is whatever the MIME type is */
	if( tmpat -> type ) mmessage -> attachtype[attachnr] = strdup( tmpat -> type ) ;
	else mmessage -> attachtype[attachnr] = strdup( "text/plain" ) ;
	
	  /* Increment the attachment counter. */
	  attachnr++;
	}
      }
      seekCntr++ ;
      lseek = lseek -> next ;
    }
  }
  tmpat=((AFS *)atlst->data);

  /* Looks like the old logic leaked memory like the Titanic does water! */
  mmessage -> body = strdup( tmpat -> data ) ;

  /* Fix up the attachment count */
  mmessage -> attach_count = seekCntr ;

  return mmessage ;
}


char *mime_encode (char *from, char *replyto, char *org, char *to, char *cc,
                   char *bcc, char *subject, char *timestamp, Llist *atlst,
	                 int returnreceipt, char *priority) {
	char *os_info=generate_os_info ();
	char *lang=lang_getlang();
	AFS *tmpat=NULL;

	int enc_type, nread;
	MimeType *mtype;
	char *tmps1=(char *)calloc(1024, sizeof(char));
	char *tmps2;
	char *tmps3;
	char *tmps4;
	char *tmps5=(char *)calloc(1024, sizeof(char));
	char *tmphead=NULL;
	char *tmpbody;
	char *boundary=NULL;
	char *head=NULL;
	char *body=NULL;
	char *ret=NULL;
	FILE *fd;
	Llist *lseek=NULL;
	struct stat *st;

	int hsize, atmemb=llist_length (atlst);//size, i;

/* assemble the header */
	hsize=strlen (from)+8+
	      strlen (org)+16+
	      strlen (replyto)+8+
	      strlen (to)+8+
	      strlen (cc)+8+
	      strlen (bcc)+8+
	      strlen (subject)+10+
	      strlen (timestamp)+8+
				800; // for good mesure


	/* I see no reason we need to reinvent the wheel here!! Duh! */
#ifdef DEBUG
	printf ("mime_encode: Assembling the header\n");
#endif

	head=(char *)calloc(hsize+2, sizeof(char));
	addtext (head, "Date: ", 6);
	addtext (head, timestamp, strlen(timestamp));
	addtext (head, "\r\n", 2);

	addtext (head, "From: ", 6);
	addtext (head, from, strlen(from));
	addtext (head, "\r\n", 2);

	if (returnreceipt!=0) {
		addtext (head, "Disposition-Notification-To: ", 29);
		addtext (head, from, strlen(from));
		addtext (head, "\r\n", 2);
	}

	if (replyto[0]!='\0') {
		addtext (head, "Reply-To: ", 10);
		addtext (head, replyto, strlen(replyto));
		addtext (head, "\r\n", 2);
	}

	if (org[0]!='\0') {
		addtext (head, "Organization: ", 14);
		addtext (head, org, strlen(org));
		addtext (head, "\r\n", 2);
	}

	addtext (head, "X-Mailer: TradeClient ", 23);
	snprintf (tmps1, 1022, "%s [%s] %s", VERSION, lang, os_info);
	addtext (head, tmps1, strlen(tmps1));
	addtext (head, "\r\n", 2);

	addtext (head, "X-Priority: ", 12);
	snprintf (tmps5, 1022, "%s", priority);
	addtext (head, tmps5, strlen(tmps5)); 
	addtext (head, "\r\n", 2); 
	
	addtext (head, "X-MSMail-Priority: ", 20);
	snprintf (tmps5, 1022, "%s", priority);
	addtext (head, tmps5, strlen(tmps5));  
	addtext (head, "\r\n", 2); 
	
	addtext (head, "MIME-Version: 1.0", 17);
	addtext (head, "\r\n", 2);

	addtext (head, "To: ", 4);
	addtext (head, to, strlen(to));
	addtext (head, "\r\n", 2);

	if (cc[0]!='\0') {
		addtext (head, "Cc: ", 4);
		addtext (head, cc, strlen(cc));
		addtext (head, "\r\n", 2);
	}

	if (bcc[0]!='\0') {
		addtext (head, "Bcc: ", 5);
		addtext (head, bcc, strlen(bcc));
		addtext (head, "\r\n", 2);
	}

	if (subject[0]!='\0') {
		addtext (head, "Subject: ", 9);
		tmps2=rm_crlf (subject);
		addtext (head, tmps2, strlen(tmps2));
		free (tmps2);
		addtext (head, "\r\n", 2);
	}

#ifdef DEBUG
	printf ("mime_encode: Start of processing attachments\n");
#endif

	if (atmemb<2) {
#ifdef DEBUG
		printf ("mime_encode: Found only one attachment (probly the body)\n");
#endif
		if (atlst)
			tmpat=((AFS *)atlst->data);
		if (tmpat) {
			tmphead=(char *)calloc (600, sizeof(char));
			if (tmpat->filename) {
				tmps2=strrchr (tmpat->filename,'.');
				if (tmps2)
					tmps2++;
				mtype=mime_type_search_ext (tmps2);

				fd=fopen (tmpat->filename, "r");
				tmps2=(char *)calloc (4100, sizeof(char));
				nread=fread (tmps2, sizeof(char), 4096, fd);
				enc_type=encode_with (tmps2, nread);
				free (tmps2);

				st=(struct stat *)calloc (1, sizeof(struct stat));
				stat (tmpat->filename, st);
				tmps2=(char *)calloc (st->st_size+2, sizeof(char));
				fseek (fd, 0, SEEK_SET);
				fread (tmps2, sizeof (char), st->st_size, fd);
				fclose (fd);

				addtext (head, "Content-Type: ", 14);
				if (mtype!=NULL) {
					addtext (head, mtype->type, strlen(mtype->type));
				} else {
					if (enc_type==ENC_BASE64) {
						addtext (head, "application/octet-stream", 24);
					} else {
						addtext (head, "text/plain", 10);
					}
				}
				tmps3=strrchr(tmpat->filename,'/');
				if (tmps3)
					tmps3++;
				else
					tmps3=tmpat->filename;

				addtext (head, ";\r\n\tname=\"", 10);
				addtext (tmphead, tmps3, strlen (tmps3));
				addtext (head, "\"\r\n", 3);

				switch (enc_type) {
					case ENC_BASE64:
						addtext (head, "Content-Transfer-Encoding: Base64", 33);
						addtext (head, "\r\n", 2);
						body=mime_enc_base64 (tmps2, st->st_size, 0);
						free (tmps2);
						break;
					case ENC_QP:
						addtext (head, "Content-Transfer-Encoding: Quoted-printable", 43);
						addtext (head, "\r\n", 2);
						body=mime_enc_qp (tmps2, st->st_size, 0);
						free (tmps2);
						break;
					case ENC_NONE:
					default:
						addtext (head, "Content-Transfer-Encoding: 7bit", 31);
						addtext (head, "\r\n", 2);
						body=tmps2;
						tmps2=NULL;
						break;
				}
				addtext (head, "Content-Disposition: attachment;\r\n\tfilename=\"", 45);
				addtext (tmphead, tmps3, strlen (tmps3));
				addtext (head, "\"\r\n", 3);
				free (st);
			} else {
				addtext (head, "Content-Type: ", 14);
				addtext (head, tmpat->type, strlen(tmpat->type));
				addtext (head, "; charset=us-ascii", 18);
				addtext (head, "\r\n", 2);
				if (strncmp (tmpat->type,"message/rfc822", 14)) {
					switch (encode_with (tmpat->data, strlen(tmpat->data))) {
						case ENC_BASE64:
							addtext (head, "Content-Transfer-Encoding: Base64", 33);
							addtext (head, "\r\n", 2);
							body=mime_enc_base64 (tmpat->data, strlen(tmpat->data), 0);
							break;
						case ENC_QP:
							addtext (head, "Content-Transfer-Encoding: Quoted-printable", 43);
							addtext (head, "\r\n", 2);
							body=mime_enc_qp (tmpat->data, strlen(tmpat->data), 0);
							break;
						case ENC_NONE:
							default:
							addtext (head, "Content-Transfer-Encoding: 7bit", 31);
							addtext (head, "\r\n", 2);
							body=strdup(tmpat->data);
							break;
					}
				} else {
					addtext (head, "Content-Transfer-Encoding: 7bit", 31);
					addtext (head, "\r\n", 2);
					tmps2=tmpat->data;
					if (*tmps2=='>') {
						while (*tmps2!='\n') { tmps2++; }
						tmps2++;
					}
					body=strdup (tmps2);
					tmps2=NULL;
				}
			}
		} else {
			body=(char *)calloc (2, sizeof(char));
		}

		addtext (head, "\r\n", 2);

	} else {
#ifdef DEBUG
		printf ("mime_encode: Found %d attachments\n", atmemb);
#endif
		//seems to be a fairly random number
		boundary=generate_boundary (((unsigned int)(hash_string(to)+
		                            hash_string(subject)+time(NULL))/4), 24);
		addtext (head, "Content-Type: multipart/mixed;\r\n\tboundary=\"", 43);
		addtext (head, boundary, strlen(boundary));
		addtext (head, "\"\r\n", 3);
		body=(char *)calloc (400, sizeof(char));
		addtext (body, "\r\n\
This message has been encoding in MIME format.  If you are reading this,
then your email client does not support this format.  As such, it is
recommended that you contact your system administrator to find out how to
obtain a MIME compliant email client or contact the message originator and
request this email be resent in a format that is supported by your email client.\
\r\n\r\n", 376);

		lseek=atlst;

#ifdef DEBUG
		printf ("mime_encode: Finished header, attaching rest of message\n");
#endif

		while (lseek) {
			tmphead=(char *)calloc (600, sizeof(char));
			tmpat=((AFS *)lseek->data);
			if (tmpat->filename) {
				tmps2=strrchr (tmpat->filename,'.');
				if (tmps2)
					tmps2++;
				mtype=mime_type_search_ext (tmps2);

#ifdef DEBUG
				printf ("mime_encode: Attachment is a file '%s', opening for reading.\n", tmpat->filename);
#endif

				fd=fopen (tmpat->filename, "r");
				tmps2=(char *)calloc (4100, sizeof(char));
				if (!fd) break;
				nread=fread (tmps2, sizeof(char), 4096, fd);
#ifdef DEBUG
				printf ("mime_encode: Checking for the encodeing method we should use\n");
#endif
				enc_type=encode_with (tmps2, nread);
				free (tmps2);

				st=(struct stat *)calloc (1, sizeof(struct stat));
				stat (tmpat->filename, st);
				tmps2=(char *)calloc (st->st_size+2, sizeof(char));
				fseek (fd, 0, SEEK_SET);
				fread (tmps2, sizeof (char), st->st_size, fd);
				fclose (fd);

				addtext (tmphead, "Content-Type: ", 14);

				if (mtype!=NULL) {
					addtext (tmphead, mtype->type, strlen(mtype->type));
				} else {
					if (enc_type==ENC_BASE64) {
						addtext (tmphead, "application/octet-stream", 24);
					} else {
						addtext (tmphead, "text/plain", 10);
					}
				}
				tmps3=strrchr(tmpat->filename,'/');
				if (tmps3)
					tmps3++;
				else
					tmps3=tmpat->filename;

				addtext (tmphead, ";\r\n\tname=\"", 10);
				addtext (tmphead, tmps3, strlen (tmps3));
				addtext (tmphead, "\"\r\n", 3);

#ifdef DEBUG
				printf ("mime_encode: Encodeing...");
				fflush (stdout);
#endif

				switch (enc_type) {
					case ENC_BASE64:
						addtext (tmphead, "Content-Transfer-Encoding: Base64", 33);
						addtext (tmphead, "\r\n", 2);
						tmpbody=mime_enc_base64 (tmps2, st->st_size, 0);
						free (tmps2);
						break;
					case ENC_QP:
						addtext (tmphead, "Content-Transfer-Encoding: Quoted-printable", 43);
						addtext (tmphead, "\r\n", 2);
						tmpbody=mime_enc_qp (tmps2, st->st_size, 0);
						free (tmps2);
						break;
					case ENC_NONE:
					default:
						addtext (tmphead, "Content-Transfer-Encoding: 7bit", 31);
						addtext (tmphead, "\r\n", 2);
						tmpbody=tmps2;
						tmps2=NULL;
						break;
				}

#ifdef DEBUG
				printf ("done.\n");
#endif

				addtext (tmphead, "Content-Disposition: attachment;\r\n\tfilename=\"", 45);
				addtext (tmphead, tmps3, strlen (tmps3));
				addtext (tmphead, "\"\r\n", 3);
				free (st);
			} else {
				if (strncmp (tmpat->type,"message/rfc822", 14)!=0) {
					addtext (tmphead, "Content-Type: ", 14);
					addtext (tmphead, tmpat->type, strlen(tmpat->type));
					addtext (tmphead, "; charset=us-ascii", 18);
					addtext (tmphead, "\r\n", 2);
					switch (encode_with (tmpat->data, strlen(tmpat->data))) {
						case ENC_BASE64:
							addtext (tmphead, "Content-Transfer-Encoding: Base64", 33);
							addtext (tmphead, "\r\n", 2);
							tmpbody=mime_enc_base64 (tmpat->data, strlen(tmpat->data), 0);
							break;
						case ENC_QP:
							addtext (tmphead, "Content-Transfer-Encoding: Quoted-printable", 43);
							addtext (tmphead, "\r\n", 2);
							tmpbody=mime_enc_qp (tmpat->data, strlen(tmpat->data), 0);
							break;
						case ENC_NONE:
						default:
							addtext (tmphead, "Content-Transfer-Encoding: 7bit", 31);
							addtext (tmphead, "\r\n", 2);
							tmpbody=strdup(tmpat->data);
							break;
					}
				} else {
					addtext (tmphead, "Content-Type: ", 14);
					addtext (tmphead, tmpat->type, strlen(tmpat->type));
					addtext (tmphead, "; charset=us-ascii", 18);
					addtext (tmphead, "\r\n", 2);
					addtext (head, "Content-Transfer-Encoding: 7bit", 31);
					addtext (head, "\r\n", 2);
					tmps2=tmpat->data;
					if (*tmps2=='>') {
						while (*tmps2!='\n') { tmps2++; }
						tmps2++;
					}
					tmpbody=strdup (tmps2);
					tmps2=NULL;
				}
			}
			addtext (tmphead, "\r\n", 2);

			tmps3=(char *)calloc(strlen(tmphead)+strlen(tmpbody)+4, sizeof(char));
			addtext (tmps3, tmphead, strlen(tmphead));
			addtext (tmps3, tmpbody, strlen(tmpbody));
			addtext (tmps3, "\r\n", 2);
			free (tmphead);
			free (tmpbody);

			tmps4=(char *)calloc (strlen(tmps3)+strlen(body)+
			                      strlen(boundary)+8, sizeof(char));
			addtext (tmps4, body, strlen(body));
			addtext (tmps4, "--", 2);
			addtext (tmps4, boundary, strlen(boundary));
			addtext (tmps4, "\r\n", 2);
			addtext (tmps4, tmps3, strlen(tmps3));
			free (tmps3);
			free (body);
			body=tmps4;

			lseek=lseek->next;
		}
		tmps4=(char *)calloc (strlen(body)+strlen(boundary)+8, sizeof(char));
		addtext (tmps4, body, strlen(body));
		addtext (tmps4, "--", 2);
		addtext (tmps4, boundary, strlen(boundary));
		addtext (tmps4, "--\r\n", 4);
		free (body);
		body=tmps4;
	}

	ret=(char *)calloc(strlen(head)+strlen(body)+4, sizeof(char));
	addtext (ret, head, strlen(head));
	addtext (ret, body, strlen(body));
	addtext (ret, "\r\n", 2);

#ifdef DEBUG
	printf( "The header is:\n%s\n\n", head ) ;
	printf( "The body is:\n%s\n\n", body ) ;
	printf( "The total message is:\n%s\n\n", ret ) ;
#endif

	if (head) free (head);
	if (body) free (body);
#if 0
	if (lang) free (lang);
#endif
	if (os_info) free (os_info);
	if (tmps1) free (tmps1);
	if (boundary) free (boundary);
	if (atmemb<2) free (tmphead);
	return ret;
}
