/* TradeClient <http://tradeclient.sourceforge.net>
 * $Id: msearch.c,v 1.39 2001/03/20 22:19:33 ttabner Exp $
 *
 * Copyright (C) 1999-2000 Bynari Inc.
 * Copyright (C) 2001 Project TradeClient
 *
 * LGPL
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#include "msearch.h"

GList *found = NULL;
int msearch_cancel_flag = 0;
int searching = 0;

GtkWidget *
create_msearch_window (void)
{
  GtkWidget *msearch_window;
  GtkWidget *vbox1;
  GtkWidget *progressbar;
  GtkWidget *prog_frame;
  GtkWidget *vbox2;
  GtkWidget *hbox1;
  GtkWidget *combo1;
  GtkWidget *search_folder;	// entry for the folder we're going to search in
  GtkWidget *child_button;	// toggle button to search subfolders or not
  GtkWidget *case_button;
  GtkWidget *any_all_frame;
  GtkWidget *hbox2;
  GSList *hbox2_group = NULL;
  GtkWidget *any_button;	// match any of the criteria,
  GtkWidget *all_button;	// or all of it
  GtkWidget *vbox3;
  GtkWidget *hbox5;
  GtkWidget *option_frame;
  GtkWidget *folder_frame;
  GtkWidget *search_frame;
  GtkWidget *search_frame2;
  GtkWidget *search_tree;	// tree that contains all the search items
  GtkWidget *scrolledwindow2;
  GtkWidget *scrolledwindow3;
  GtkWidget *viewport1;
  GtkWidget *viewport2;
  GtkWidget *search_english;	// textbox that shows the search criteria in
  // english or something like that
  GtkWidget *scrolledwindow1;
  GtkWidget *message_clist;
  GtkWidget *s_label;
  GtkWidget *p_label;
  GtkWidget *subject_label;
  GtkWidget *sender_label;
  GtkWidget *sent_label;
  GtkWidget *received_label;
  GtkWidget *hbuttonbox2;
  GtkWidget *search_button;
  GtkWidget *cancel_button;
  GtkWidget *done_button;
  char *all_folders = "* All Folders";
  GList *folders = folder_create_glist ();

  folders = g_list_prepend (folders, all_folders);

  msearch_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_name (msearch_window, "msearch_window");
  gtk_object_set_data (GTK_OBJECT (msearch_window), "msearch_window",
		       msearch_window);
  gtk_window_set_title (GTK_WINDOW (msearch_window), "Message Search");
  gtk_widget_set_usize (GTK_WIDGET (msearch_window), 540, 400);
  gtk_window_set_default_size (GTK_WINDOW (msearch_window),
			       tm_globs->wsize.msearch_window.x,
			       tm_globs->wsize.msearch_window.y);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox1, "vbox1");
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (msearch_window), "vbox1", vbox1,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (msearch_window), vbox1);

  vbox2 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox2, "vbox2");
  gtk_widget_ref (vbox2);
  gtk_object_set_data_full (GTK_OBJECT (msearch_window), "vbox2", vbox2,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox2);
  gtk_box_pack_start (GTK_BOX (vbox1), vbox2, FALSE, TRUE, 0);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox1, "hbox1");
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT (msearch_window), "hbox1", hbox1,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox2), hbox1, FALSE, TRUE, 0);

  folder_frame = gtk_frame_new ("Look in");
  gtk_widget_set_name (folder_frame, "folder_frame");
  gtk_widget_ref (folder_frame);
  gtk_object_set_data_full (GTK_OBJECT (msearch_window), "folder_frame",
			    folder_frame,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (folder_frame);
  gtk_box_pack_start (GTK_BOX (hbox1), folder_frame, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (folder_frame), 3);

  combo1 = gtk_combo_new ();
  gtk_widget_set_name (combo1, "combo1");
  gtk_widget_ref (combo1);
  gtk_object_set_data_full (GTK_OBJECT (msearch_window), "combo1", combo1,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (combo1);
  gtk_container_add (GTK_CONTAINER (folder_frame), combo1);
  gtk_container_set_border_width (GTK_CONTAINER (combo1), 3);
  gtk_combo_set_popdown_strings (GTK_COMBO (combo1), folders);

  search_folder = GTK_COMBO (combo1)->entry;
  gtk_widget_set_name (search_folder, "search_folder");
  gtk_widget_ref (search_folder);
  gtk_object_set_data_full (GTK_OBJECT (msearch_window), "search_folder",
			    search_folder,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (search_folder);
  gtk_entry_set_editable (GTK_ENTRY (search_folder), FALSE);

  option_frame = gtk_frame_new ("Options");
  gtk_widget_set_name (option_frame, "option_frame");
  gtk_widget_ref (option_frame);
  gtk_object_set_data_full (GTK_OBJECT (msearch_window), "option_frame",
			    option_frame,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (option_frame);
  gtk_box_pack_start (GTK_BOX (hbox1), option_frame, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (option_frame), 3);

  hbox5 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox5, "hbox5");
  gtk_widget_ref (hbox5);
  gtk_object_set_data_full (GTK_OBJECT (msearch_window), "hbox5", hbox5,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox5);
  gtk_container_add (GTK_CONTAINER (option_frame), hbox5);

  child_button = gtk_check_button_new_with_label ("Include subfolders");
  gtk_widget_set_name (child_button, "child_button");
  gtk_widget_ref (child_button);
  gtk_object_set_data_full (GTK_OBJECT (msearch_window), "child_button",
			    child_button,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (child_button);
  gtk_box_pack_start (GTK_BOX (hbox5), child_button, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (child_button), 3);

  case_button = gtk_check_button_new_with_label ("Ignore case");
  gtk_widget_set_name (case_button, "case_button");
  gtk_widget_ref (case_button);
  gtk_object_set_data_full (GTK_OBJECT (msearch_window), "case_button",
			    case_button, (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (case_button);
  gtk_box_pack_start (GTK_BOX (hbox5), case_button, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (case_button), 3);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (case_button), TRUE);

  any_all_frame = gtk_frame_new ("Match");
  gtk_widget_set_name (any_all_frame, "any_all_frame");
  gtk_widget_ref (any_all_frame);
  gtk_object_set_data_full (GTK_OBJECT (msearch_window), "any_all_frame",
			    any_all_frame,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (any_all_frame);
  gtk_box_pack_start (GTK_BOX (hbox1), any_all_frame, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (any_all_frame), 3);

  hbox2 = gtk_hbox_new (TRUE, 0);
  gtk_widget_set_name (hbox2, "hbox2");
  gtk_widget_ref (hbox2);
  gtk_object_set_data_full (GTK_OBJECT (msearch_window), "hbox2", hbox2,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox2);
  gtk_container_add (GTK_CONTAINER (any_all_frame), hbox2);
  gtk_container_set_border_width (GTK_CONTAINER (hbox2), 5);

  any_button = gtk_radio_button_new_with_label (hbox2_group, "Any");
  hbox2_group = gtk_radio_button_group (GTK_RADIO_BUTTON (any_button));
  gtk_widget_set_name (any_button, "any_button");
  gtk_widget_ref (any_button);
  gtk_object_set_data_full (GTK_OBJECT (msearch_window), "any_button",
			    any_button, (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (any_button);
  gtk_box_pack_start (GTK_BOX (hbox2), any_button, FALSE, FALSE, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (any_button), TRUE);

  all_button = gtk_radio_button_new_with_label (hbox2_group, "All");
  hbox2_group = gtk_radio_button_group (GTK_RADIO_BUTTON (all_button));
  gtk_widget_set_name (all_button, "all_button");
  gtk_widget_ref (all_button);
  gtk_object_set_data_full (GTK_OBJECT (msearch_window), "all_button",
			    all_button, (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (all_button);
  gtk_box_pack_start (GTK_BOX (hbox2), all_button, FALSE, FALSE, 0);

  vbox3 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox3, "vbox3");
  gtk_widget_ref (vbox3);
  gtk_object_set_data_full (GTK_OBJECT (msearch_window), "vbox3", vbox3,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox3);
  gtk_box_pack_start (GTK_BOX (vbox2), vbox3, FALSE, TRUE, 0);

  scrolledwindow3 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_set_name (scrolledwindow3, "scrolledwindow3");
  gtk_widget_ref (scrolledwindow3);
  gtk_object_set_data_full (GTK_OBJECT (msearch_window), "scrolledwindow3",
			    scrolledwindow3,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow3);
  gtk_box_pack_start (GTK_BOX (vbox2), scrolledwindow3, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (scrolledwindow3), 2);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow3),
				  GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);
  gtk_widget_set_usize (scrolledwindow3, -2, 125);

  viewport2 = gtk_viewport_new (NULL, NULL);
  gtk_widget_set_name (viewport2, "viewport2");
  gtk_widget_ref (viewport2);
  gtk_object_set_data_full (GTK_OBJECT (msearch_window), "viewport2",
			    viewport2, (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (viewport2);
  gtk_container_add (GTK_CONTAINER (scrolledwindow3), viewport2);

  search_frame = gtk_frame_new (NULL);
  gtk_widget_set_name (search_frame, "search_frame");
  gtk_widget_ref (search_frame);
  gtk_object_set_data_full (GTK_OBJECT (msearch_window), "search_frame",
			    search_frame,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (search_frame);
  gtk_container_add (GTK_CONTAINER (viewport2), search_frame);
  gtk_container_set_border_width (GTK_CONTAINER (search_frame), 2);

  search_tree = gtk_tree_new ();
  gtk_widget_set_name (search_tree, "search_tree");
  gtk_widget_ref (search_tree);
  gtk_object_set_data_full (GTK_OBJECT (msearch_window), "search_tree",
			    search_tree, (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (search_tree);
  gtk_container_add (GTK_CONTAINER (search_frame), search_tree);

  on_add_button_clicked (NULL, GTK_TREE (search_tree));
  gtk_signal_connect (GTK_OBJECT (search_tree), "select_child",
		      GTK_SIGNAL_FUNC (search_tree_selected), NULL);

  search_frame2 = gtk_frame_new (NULL);
  gtk_widget_set_name (search_frame2, "search_frame2");
  gtk_widget_ref (search_frame2);
  gtk_object_set_data_full (GTK_OBJECT (msearch_window), "search_frame2",
			    search_frame2,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (search_frame2);
  gtk_box_pack_start (GTK_BOX (vbox2), search_frame2, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (search_frame2), 2);

  scrolledwindow2 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_set_name (scrolledwindow2, "scrolledwindow2");
  gtk_widget_ref (scrolledwindow2);
  gtk_object_set_data_full (GTK_OBJECT (msearch_window), "scrolledwindow2",
			    scrolledwindow2,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow2);
  gtk_container_add (GTK_CONTAINER (search_frame2), scrolledwindow2);
  gtk_container_set_border_width (GTK_CONTAINER (scrolledwindow2), 2);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow2),
				  GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);
  gtk_widget_set_usize (scrolledwindow2, -2, 70);

  viewport1 = gtk_viewport_new (NULL, NULL);
  gtk_widget_set_name (viewport1, "viewport1");
  gtk_widget_ref (viewport1);
  gtk_object_set_data_full (GTK_OBJECT (msearch_window), "viewport1",
			    viewport1, (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (viewport1);
  gtk_container_add (GTK_CONTAINER (scrolledwindow2), viewport1);

  search_english = gtk_text_new (NULL, NULL);
  gtk_widget_set_name (search_english, "search_english");
  gtk_widget_ref (search_english);
  gtk_object_set_data_full (GTK_OBJECT (msearch_window), "search_english",
			    search_english,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (search_english);
  gtk_container_add (GTK_CONTAINER (viewport1), search_english);

  prog_frame = gtk_frame_new (NULL);
  gtk_widget_set_name (prog_frame, "prog_frame");
  gtk_widget_ref (prog_frame);
  gtk_object_set_data_full (GTK_OBJECT (msearch_window), "prog_frame",
			    prog_frame, (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (prog_frame);
  gtk_box_pack_start (GTK_BOX (vbox1), prog_frame, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (prog_frame), 2);

  progressbar = gtk_progress_bar_new ();
  gtk_widget_set_name (progressbar, "progressbar");
  gtk_widget_ref (progressbar);
  gtk_object_set_data_full (GTK_OBJECT (msearch_window), "progressbar",
			    progressbar, (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (progressbar);
  gtk_container_add (GTK_CONTAINER (prog_frame), progressbar);

  scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_set_name (scrolledwindow1, "scrolledwindow1");
  gtk_widget_ref (scrolledwindow1);
  gtk_object_set_data_full (GTK_OBJECT (msearch_window), "scrolledwindow1",
			    scrolledwindow1,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow1);
  gtk_box_pack_start (GTK_BOX (vbox1), scrolledwindow1, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1),
				  GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  message_clist = gtk_clist_new (6);
  gtk_widget_set_name (message_clist, "message_clist");
  gtk_widget_ref (message_clist);
  gtk_object_set_data_full (GTK_OBJECT (msearch_window), "message_clist",
			    message_clist,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (message_clist);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), message_clist);
  gtk_container_set_border_width (GTK_CONTAINER (message_clist), 3);
  gtk_clist_set_column_width (GTK_CLIST (message_clist), 0,
			      tm_globs->cpos.msw[0]);
  gtk_clist_set_column_width (GTK_CLIST (message_clist), 1,
			      tm_globs->cpos.msw[1]);
  gtk_clist_set_column_width (GTK_CLIST (message_clist), 2,
			      tm_globs->cpos.msw[2]);
  gtk_clist_set_column_width (GTK_CLIST (message_clist), 3,
			      tm_globs->cpos.msw[3]);
  gtk_clist_set_column_width (GTK_CLIST (message_clist), 4,
			      tm_globs->cpos.msw[4]);
  gtk_clist_set_column_width (GTK_CLIST (message_clist), 5,
			      tm_globs->cpos.msw[5]);
  gtk_clist_column_titles_show (GTK_CLIST (message_clist));

  s_label = gtk_label_new ("S");
  gtk_widget_set_name (s_label, "s_label");
  gtk_widget_ref (s_label);
  gtk_object_set_data_full (GTK_OBJECT (msearch_window), "s_label",
			    s_label, (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (s_label);
  gtk_clist_set_column_widget (GTK_CLIST (message_clist), 0, s_label);

  p_label = gtk_label_new ("P");
  gtk_widget_set_name (p_label, "p_label");
  gtk_widget_ref (p_label);
  gtk_object_set_data_full (GTK_OBJECT (msearch_window), "p_label",
			    p_label, (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (p_label);
  gtk_clist_set_column_widget (GTK_CLIST (message_clist), 1, p_label);

  subject_label = gtk_label_new ("Subject");
  gtk_widget_set_name (subject_label, "subject_label");
  gtk_widget_ref (subject_label);
  gtk_object_set_data_full (GTK_OBJECT (msearch_window), "subject_label",
			    subject_label,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (subject_label);
  gtk_clist_set_column_widget (GTK_CLIST (message_clist), 2, subject_label);

  sender_label = gtk_label_new ("Sender");
  gtk_widget_set_name (sender_label, "sender_label");
  gtk_widget_ref (sender_label);
  gtk_object_set_data_full (GTK_OBJECT (msearch_window), "sender_label",
			    sender_label,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (sender_label);
  gtk_clist_set_column_widget (GTK_CLIST (message_clist), 3, sender_label);

  sent_label = gtk_label_new ("Sent");
  gtk_widget_set_name (sent_label, "sent_label");
  gtk_widget_ref (sent_label);
  gtk_object_set_data_full (GTK_OBJECT (msearch_window), "sent_label",
			    sent_label, (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (sent_label);
  gtk_clist_set_column_widget (GTK_CLIST (message_clist), 4, sent_label);

  received_label = gtk_label_new ("Received");
  gtk_widget_set_name (received_label, "received_label");
  gtk_widget_ref (received_label);
  gtk_object_set_data_full (GTK_OBJECT (msearch_window), "received_label",
			    received_label,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (received_label);
  gtk_clist_set_column_widget (GTK_CLIST (message_clist), 5, received_label);

  hbuttonbox2 = gtk_hbutton_box_new ();
  gtk_widget_set_name (hbuttonbox2, "hbuttonbox2");
  gtk_widget_ref (hbuttonbox2);
  gtk_object_set_data_full (GTK_OBJECT (msearch_window), "hbuttonbox2",
			    hbuttonbox2, (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbuttonbox2);
  gtk_box_pack_start (GTK_BOX (vbox1), hbuttonbox2, FALSE, TRUE, 0);

  search_button = gtk_button_new_with_label ("Search");
  gtk_widget_set_name (search_button, "search_button");
  gtk_widget_ref (search_button);
  gtk_object_set_data_full (GTK_OBJECT (msearch_window), "search_button",
			    search_button,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (search_button);
  gtk_container_add (GTK_CONTAINER (hbuttonbox2), search_button);
  GTK_WIDGET_SET_FLAGS (search_button, GTK_CAN_DEFAULT);

  cancel_button = gtk_button_new_with_label ("Cancel");
  gtk_widget_set_name (cancel_button, "cancel_button");
  gtk_widget_ref (cancel_button);
  gtk_object_set_data_full (GTK_OBJECT (msearch_window), "cancel_button",
			    cancel_button,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cancel_button);
  gtk_container_add (GTK_CONTAINER (hbuttonbox2), cancel_button);
  GTK_WIDGET_SET_FLAGS (cancel_button, GTK_CAN_DEFAULT);

  done_button = gtk_button_new_with_label ("Done");
  gtk_widget_set_name (done_button, "done_button");
  gtk_widget_ref (done_button);
  gtk_object_set_data_full (GTK_OBJECT (msearch_window), "done_button",
			    done_button, (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (done_button);
  gtk_container_add (GTK_CONTAINER (hbuttonbox2), done_button);
  GTK_WIDGET_SET_FLAGS (done_button, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (message_clist), "click_column",
		      GTK_SIGNAL_FUNC (message_clist_clicked_column), NULL);
  gtk_signal_connect (GTK_OBJECT (message_clist), "resize_column",
		      GTK_SIGNAL_FUNC (cpos_set_msw), NULL);
  gtk_signal_connect (GTK_OBJECT (msearch_window), "size_allocate",
		      GTK_SIGNAL_FUNC (wsize_set_msw), NULL);
  gtk_signal_connect (GTK_OBJECT (msearch_window), "delete_event",
		      GTK_SIGNAL_FUNC (gtk_false), NULL);
  gtk_signal_connect (GTK_OBJECT (msearch_window), "destroy",
		      GTK_SIGNAL_FUNC (msearch_destroy), NULL);
  gtk_signal_connect (GTK_OBJECT (search_folder), "changed",
		      GTK_SIGNAL_FUNC (on_search_folder_changed), NULL);
  gtk_signal_connect (GTK_OBJECT (child_button), "toggled",
		      GTK_SIGNAL_FUNC (on_child_button_toggled), NULL);
  gtk_signal_connect (GTK_OBJECT (case_button), "toggled",
		      GTK_SIGNAL_FUNC (on_case_button_toggled), NULL);
  gtk_signal_connect (GTK_OBJECT (any_button), "toggled",
		      GTK_SIGNAL_FUNC (on_any_button_toggled), NULL);
  gtk_signal_connect (GTK_OBJECT (all_button), "toggled",
		      GTK_SIGNAL_FUNC (on_all_button_toggled), NULL);
  gtk_signal_connect (GTK_OBJECT (search_button), "clicked",
		      GTK_SIGNAL_FUNC (msearch_search), NULL);
  gtk_signal_connect (GTK_OBJECT (cancel_button), "clicked",
		      GTK_SIGNAL_FUNC (msearch_cancel), NULL);
  gtk_signal_connect (GTK_OBJECT (done_button), "clicked",
		      GTK_SIGNAL_FUNC (msearch_destroy), NULL);
  gtk_signal_connect (GTK_OBJECT (message_clist), "button_press_event",
		      GTK_SIGNAL_FUNC (on_message_clist_button_press_event),
		      NULL);

  gtk_widget_grab_focus (search_button);
  return msearch_window;
}

void
msearch_destroy (GtkObject * object, gpointer user_data)
{
  GtkWidget *msearch_window =
    lookup_widget (GTK_WIDGET (object), "msearch_window");
  GtkWidget *msearch_clist = lookup_widget (msearch_window,
					    "message_clist");
  msearch_destroy_clist_contents (GTK_CLIST (msearch_clist));
  gtk_widget_destroy (msearch_window);
}

void
on_child_button_toggled (GtkWidget * widget, gpointer user_data)
{
  GtkWidget *search_english = lookup_widget (widget, "search_english");
  search_english_update (search_english);
}

void
on_case_button_toggled (GtkWidget * widget, gpointer user_data)
{
  GtkWidget *search_english = lookup_widget (widget, "search_english");
  search_english_update (search_english);
}

void
on_any_button_toggled (GtkWidget * widget, gpointer user_data)
{
  GtkWidget *search_english = lookup_widget (widget, "search_english");
  search_english_update (search_english);
}

void
on_all_button_toggled (GtkWidget * widget, gpointer user_data)
{
  GtkWidget *search_english = lookup_widget (widget, "search_english");
  search_english_update (search_english);
}

void
on_search_folder_changed (GtkEditable * editable, gpointer user_data)
{
  GtkWidget *search_english =
    lookup_widget (GTK_WIDGET (editable), "search_english");
  search_english_update (search_english);
}

void
on_search_attribute_changed (GtkEditable * editable, gpointer user_data)
{
  GtkWidget *search_english =
    lookup_widget (GTK_WIDGET (editable), "search_english");
  search_english_update (search_english);
}

void
on_search_criteria_changed (GtkEditable * editable, gpointer user_data)
{
  GtkWidget *search_english =
    lookup_widget (GTK_WIDGET (editable), "search_english");
  search_english_update (search_english);
}

void
on_search_text_changed (GtkEditable * editable, gpointer user_data)
{
  GtkWidget *search_english =
    lookup_widget (GTK_WIDGET (editable), "search_english");
  search_english_update (search_english);
}

void
search_english_update (GtkWidget * text)
{
  char *folder =
    gtk_entry_get_text (GTK_ENTRY (lookup_widget (text, "search_folder")));
  GtkWidget *include = lookup_widget (text, "child_button");
  GtkWidget *ignore = lookup_widget (text, "case_button");
  GtkWidget *anyall = lookup_widget (text, "all_button");
  GtkWidget *tree = lookup_widget (text, "search_tree");
  GList *trseek = NULL;
  int count = 0;

  gtk_text_set_point (GTK_TEXT (text), 0);
  gtk_text_forward_delete (GTK_TEXT (text),
			   gtk_text_get_length (GTK_TEXT (text)));

  gtk_text_insert (GTK_TEXT (text), NULL, NULL, NULL, "Search in ", -1);
  if (strcasecmp (folder, "* All Folders") == 0)
    gtk_text_insert (GTK_TEXT (text), NULL, NULL, NULL, "all folders", -1);
  else
    gtk_text_insert (GTK_TEXT (text), NULL, NULL, NULL, folder, -1);

  if (GTK_TOGGLE_BUTTON (include)->active)
    gtk_text_insert (GTK_TEXT (text), NULL, NULL, NULL,
		     ", including subfolders", -1);
  if (GTK_TOGGLE_BUTTON (ignore)->active)
    gtk_text_insert (GTK_TEXT (text), NULL, NULL, NULL,
		     ", ignoring case", -1);
  if (GTK_TOGGLE_BUTTON (anyall)->active)
    gtk_text_insert (GTK_TEXT (text), NULL, NULL, NULL, ", for all matches",
		     -1);
  else
    gtk_text_insert (GTK_TEXT (text), NULL, NULL, NULL, ", for any matches",
		     -1);

  for (trseek = GTK_TREE (tree)->children; trseek; trseek = trseek->next)
    {
      GtkWidget *trtarget = trseek->data;
      char *where =
	gtk_entry_get_text (GTK_ENTRY
			    (gtk_object_get_data (GTK_OBJECT (trtarget),
						  "search_attribute")));
      char *is =
	gtk_entry_get_text (GTK_ENTRY
			    (gtk_object_get_data (GTK_OBJECT (trtarget),
						  "search_criteria")));
      char *to =
	gtk_entry_get_text (GTK_ENTRY
			    (gtk_object_get_data (GTK_OBJECT (trtarget),
						  "search_text")));
      if (count++)
	gtk_text_insert (GTK_TEXT (text), NULL, NULL, NULL, ", and", -1);
      else
	gtk_text_insert (GTK_TEXT (text), NULL, NULL, NULL, ",", -1);
      gtk_text_insert (GTK_TEXT (text), NULL, NULL, NULL, " where ", -1);
      switch (*where)
	{
	case 'S':
	  gtk_text_insert (GTK_TEXT (text), NULL, NULL, NULL,
			   "the subject header is", -1);
	  break;
	case 'F':
	  gtk_text_insert (GTK_TEXT (text), NULL, NULL, NULL,
			   "the from header is", -1);
	  break;
        case 'R':
          gtk_text_insert (GTK_TEXT (text), NULL, NULL, NULL,
                           "the reply-to header is", -1);
          break;
	case 'T':
	  gtk_text_insert (GTK_TEXT (text), NULL, NULL, NULL,
			   "the to header is", -1);
	  break;
	case 'C':
	  gtk_text_insert (GTK_TEXT (text), NULL, NULL, NULL,
			   "the cc header is", -1);
	  break;
	case 'B':
	  gtk_text_insert (GTK_TEXT (text), NULL, NULL, NULL,
			   "the bcc header is", -1);
	  break;
	case 'M':
	  gtk_text_insert (GTK_TEXT (text), NULL, NULL, NULL,
			   "the message body is", -1);
	  break;
	case 'K':
	  gtk_text_insert (GTK_TEXT (text), NULL, NULL, NULL,
			   "the keywords are", -1);
	  break;
	case 'P':
	  gtk_text_insert (GTK_TEXT (text), NULL, NULL, NULL,
			   "the priority is", -1);
	  break;
	default:
	  break;

	}
      if ((*is) == 'N')
	gtk_text_insert (GTK_TEXT (text), NULL, NULL, NULL, " not exactly equal to", -1);
      else if ((*is) == 'E')
	gtk_text_insert (GTK_TEXT (text), NULL, NULL, NULL, " exactly equal to", -1);
      else
	gtk_text_insert (GTK_TEXT (text), NULL, NULL, NULL, " similar to or contains", -1);
      gtk_text_insert (GTK_TEXT (text), NULL, NULL, NULL, " \"", -1);
      gtk_text_insert (GTK_TEXT (text), NULL, NULL, NULL, to, -1);
      gtk_text_insert (GTK_TEXT (text), NULL, NULL, NULL, "\"", -1);
    }

  gtk_text_insert (GTK_TEXT (text), NULL, NULL, NULL, ".", -1);
}

GtkWidget *
on_add_button_clicked (GtkWidget * placeholder, GtkTree * tree)
{
  GtkWidget *treeitem = NULL;
  GtkWidget *hbox5;
  GtkWidget *hbox3;
  GtkWidget *where_label;
  GtkWidget *combo2;
  GList *combo2_items = NULL;
  GtkWidget *search_attribute;	// selection of header targets or the message
  GtkWidget *is_label;
  GtkWidget *combo3;
  GList *combo3_items = NULL;
  GtkWidget *search_criteria;	// match if 'equal' or 'not equal' or 'similar'
  GtkWidget *hbox4;
  GtkWidget *to_label;
  GtkWidget *search_text;	// the text we're to match is here
  GtkTooltips *tooltips;

  tooltips = gtk_tooltips_new();

  g_return_val_if_fail (tree != NULL, NULL);

  treeitem = gtk_tree_item_new ();
  gtk_widget_show (treeitem);
  gtk_tree_append (tree, treeitem);
  gtk_tooltips_set_tip (tooltips, treeitem, _("Right click the region to the left of this text field to add or delete message search criteria"), NULL);

  hbox5 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (hbox5, "hbox5");
  gtk_widget_ref (hbox5);
  gtk_object_set_data_full (GTK_OBJECT (treeitem), "hbox5", hbox5,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox5);
  gtk_container_add (GTK_CONTAINER (treeitem), hbox5);

  hbox3 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox3, "hbox3");
  gtk_widget_ref (hbox3);
  gtk_object_set_data_full (GTK_OBJECT (treeitem), "hbox3", hbox3,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox3);
  gtk_box_pack_start (GTK_BOX (hbox5), hbox3, TRUE, TRUE, 0);

  where_label = gtk_label_new ("Where");
  gtk_widget_set_name (where_label, "where_label");
  gtk_widget_ref (where_label);
  gtk_object_set_data_full (GTK_OBJECT (treeitem), "where_label",
			    where_label, (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (where_label);
  gtk_box_pack_start (GTK_BOX (hbox3), where_label, FALSE, FALSE, 0);
  gtk_misc_set_padding (GTK_MISC (where_label), 3, 0);

  combo2 = gtk_combo_new ();
  gtk_widget_set_name (combo2, "combo2");
  gtk_widget_ref (combo2);
  gtk_object_set_data_full (GTK_OBJECT (treeitem), "combo2", combo2,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (combo2);
  gtk_box_pack_start (GTK_BOX (hbox3), combo2, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (combo2), 3);
  combo2_items = g_list_append (combo2_items, "Subject");
  combo2_items = g_list_append (combo2_items, "From");
  combo2_items = g_list_append (combo2_items, "Reply-To");
  combo2_items = g_list_append (combo2_items, "To");
  combo2_items = g_list_append (combo2_items, "Cc");
  combo2_items = g_list_append (combo2_items, "Bcc");
  combo2_items = g_list_append (combo2_items, "Message");
  combo2_items = g_list_append (combo2_items, "Keyword");
  combo2_items = g_list_append (combo2_items, "Priority");
  gtk_combo_set_popdown_strings (GTK_COMBO (combo2), combo2_items);
  g_list_free (combo2_items);

  search_attribute = GTK_COMBO (combo2)->entry;
  gtk_widget_set_name (search_attribute, "search_attribute");
  gtk_widget_ref (search_attribute);
  gtk_object_set_data_full (GTK_OBJECT (treeitem), "search_attribute",
			    search_attribute,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (search_attribute);
  gtk_entry_set_editable (GTK_ENTRY (search_attribute), FALSE);
  gtk_entry_set_text (GTK_ENTRY (search_attribute), "Message");

  is_label = gtk_label_new ("is");
  gtk_widget_set_name (is_label, "is_label");
  gtk_widget_ref (is_label);
  gtk_object_set_data_full (GTK_OBJECT (treeitem), "is_label", is_label,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (is_label);
  gtk_box_pack_start (GTK_BOX (hbox3), is_label, FALSE, FALSE, 0);
  gtk_misc_set_padding (GTK_MISC (is_label), 3, 0);

  combo3 = gtk_combo_new ();
  gtk_widget_set_name (combo3, "combo3");
  gtk_widget_ref (combo3);
  gtk_object_set_data_full (GTK_OBJECT (treeitem), "combo3", combo3,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (combo3);
  gtk_box_pack_start (GTK_BOX (hbox3), combo3, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (combo3), 3);
  combo3_items = g_list_append (combo3_items, "Equal");
  combo3_items = g_list_append (combo3_items, "Not Equal");
  combo3_items = g_list_append (combo3_items, "Similar");
  gtk_combo_set_popdown_strings (GTK_COMBO (combo3), combo3_items);
  g_list_free (combo3_items);

  search_criteria = GTK_COMBO (combo3)->entry;
  gtk_widget_set_name (search_criteria, "search_criteria");
  gtk_widget_ref (search_criteria);
  gtk_object_set_data_full (GTK_OBJECT (treeitem), "search_criteria",
			    search_criteria,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (search_criteria);
  gtk_entry_set_editable (GTK_ENTRY (search_criteria), FALSE);
  gtk_entry_set_text (GTK_ENTRY (search_criteria), "Similar");

  hbox4 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox4, "hbox4");
  gtk_widget_ref (hbox4);
  gtk_object_set_data_full (GTK_OBJECT (treeitem), "hbox4", hbox4,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox4);
  gtk_box_pack_start (GTK_BOX (hbox5), hbox4, TRUE, TRUE, 0);

  to_label = gtk_label_new ("to");
  gtk_widget_set_name (to_label, "to_label");
  gtk_widget_ref (to_label);
  gtk_object_set_data_full (GTK_OBJECT (treeitem), "to_label", to_label,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (to_label);
  gtk_box_pack_start (GTK_BOX (hbox4), to_label, FALSE, FALSE, 0);
  gtk_misc_set_padding (GTK_MISC (to_label), 3, 0);

  search_text = gtk_entry_new ();
  gtk_widget_set_name (search_text, "search_text");
  gtk_widget_ref (search_text);
  gtk_object_set_data_full (GTK_OBJECT (treeitem), "search_text",
			    search_text, (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (search_text);
  gtk_box_pack_start (GTK_BOX (hbox4), search_text, TRUE, TRUE, 0);
  clip_handle_editable (search_text);

  gtk_signal_connect (GTK_OBJECT (treeitem), "button_press_event",
		      GTK_SIGNAL_FUNC (treeitem_button_event), NULL);
  gtk_signal_connect (GTK_OBJECT (search_text), "activate",
		      GTK_SIGNAL_FUNC (msearch_search), NULL);
  gtk_signal_connect (GTK_OBJECT (search_attribute), "changed",
		      GTK_SIGNAL_FUNC (on_search_attribute_changed), NULL);
  gtk_signal_connect (GTK_OBJECT (search_criteria), "changed",
		      GTK_SIGNAL_FUNC (on_search_criteria_changed), NULL);
  gtk_signal_connect (GTK_OBJECT (search_text), "changed",
		      GTK_SIGNAL_FUNC (on_search_text_changed), NULL);

  gtk_object_set_data (GTK_OBJECT (treeitem), "tooltips", tooltips);
  return treeitem;
}

void
search_tree_selected (GtkTree * tree, GtkWidget * child)
{
  // we're just going to unselect the tree item, otherwise it looks funny
  gtk_tree_unselect_child (tree, child);
  if (GTK_IS_HBOX (GTK_BIN (child)->child))
    {
      GtkBoxChild *bchild =
	GTK_BOX (GTK_BIN (child)->child)->children->next->next->data;
      if (GTK_IS_ENTRY (bchild->widget))
	{
	  gtk_widget_grab_focus (bchild->widget);
	}
    }
}

GtkWidget *
treeitem_popup (void)
{
  GtkWidget *menu;
  GtkWidget *title, *sep, *add, *delete;

  menu = gtk_menu_new ();
  gtk_widget_set_name (menu, "menu");
  gtk_widget_ref (menu);
  gtk_object_set_data_full (GTK_OBJECT (menu), "menu", menu,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menu);
  gtk_object_set_data (GTK_OBJECT (menu), "menu", menu);

  title = gtk_menu_item_new_with_label ("Search Actions");
  gtk_widget_set_name (title, "title");
  gtk_widget_ref (title);
  gtk_object_set_data_full (GTK_OBJECT (menu), "title", title,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (title);
  gtk_container_add (GTK_CONTAINER (menu), title);

  sep = gtk_menu_item_new ();
  gtk_widget_show (sep);
  gtk_container_add (GTK_CONTAINER (menu), sep);

  add = gtk_menu_item_new_with_label ("Add");
  gtk_widget_set_name (add, "add");
  gtk_widget_ref (add);
  gtk_object_set_data_full (GTK_OBJECT (menu), "add", add,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_container_add (GTK_CONTAINER (menu), add);
  gtk_widget_show (add);

  delete = gtk_menu_item_new_with_label ("Delete");
  gtk_widget_set_name (delete, "delete");
  gtk_widget_ref (delete);
  gtk_object_set_data_full (GTK_OBJECT (menu), "delete", delete,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_container_add (GTK_CONTAINER (menu), delete);
  gtk_widget_show (delete);

  return menu;
}

void
treeitem_button_event (GtkWidget * widget, GdkEventButton * event,
		       gpointer user_data)
{
  GtkWidget *menu = treeitem_popup ();
  GtkWidget *tree = lookup_widget (widget, "search_tree");

  gtk_signal_connect (GTK_OBJECT (lookup_widget (menu, "add")), "activate",
		      GTK_SIGNAL_FUNC (on_add_button_clicked),
		      (gpointer) tree);
  gtk_signal_connect (GTK_OBJECT (lookup_widget (menu, "delete")), "activate",
		      GTK_SIGNAL_FUNC (treeitem_delete), widget);

  if ((event->button == 1) || (event->button == 3))
    gtk_menu_popup (GTK_MENU (menu), NULL, NULL, NULL, NULL, 1, 0);
}

void
treeitem_delete (GtkWidget * widget, gpointer user_data)
{
  GtkWidget *treeitem = user_data;
  GtkWidget *tree = lookup_widget (treeitem, "search_tree");
  GtkWidget *text = lookup_widget (treeitem, "search_english");
  GList *seek;
  int total = -1;

  for (seek = GTK_TREE (tree)->children; seek; seek = seek->next)
    total++;

  // we're not going to delete the last item from the tree
  if (total)
    gtk_container_remove (GTK_CONTAINER (tree), treeitem);

  search_english_update (text);
}

void
msearch_search (GtkWidget * widget, gpointer user_data)
{
  char *match = NULL;
  int i, total, trtotal, mfound;
  unsigned long pcount, ptotal;
  float prog = 0;
  Folder *fl;
  GList *flseek, *trseek, *msg;
  Message *mseek;
  char *whole = NULL, *message = NULL;
  Header_Info *header = NULL;
  char *folder =
    gtk_entry_get_text (GTK_ENTRY (lookup_widget (widget, "search_folder")));
  GtkWidget *progress = lookup_widget (widget, "progressbar");
  GtkWidget *include = lookup_widget (widget, "child_button");
  GtkWidget *ignorecase = lookup_widget (widget, "case_button");
  GtkWidget *anyall = lookup_widget (widget, "all_button");
  GtkWidget *tree = lookup_widget (widget, "search_tree");
  Attachment *att = (Attachment *) calloc (1, sizeof (Attachment));
  GtkWidget *msearch_clist = lookup_widget (widget, "message_clist");
  char *cl_data[6];
  char date[255];
  msg_info *info;
  int row;
  int ignore = 0;

  if (searching)
    return;
  searching = 1;

  msearch_cancel_flag = 0;

  gtk_progress_set_show_text (GTK_PROGRESS (progress), TRUE);

  if (GTK_TOGGLE_BUTTON (ignorecase)->active)
    ignore = 1;

  att->mtype = strdup ("dummyatt");

  // if the GList *found has items, we're going to go ahead and destroy it
#if 1
  if (found)
    msearch_destroy_clist_contents (GTK_CLIST (msearch_clist));
#endif
  // make sure there are items in the tree, to be safe
  trtotal = 0;
  for (trseek = GTK_TREE (tree)->children; trseek; trseek = trseek->next)
    trtotal++;
  if (!trtotal)
    return;

  // progress bar counting totals
  gtk_progress_bar_update (GTK_PROGRESS_BAR (progress), 0.0);
  pcount = 0;
  ptotal = 0;
  for (flseek = folder_create_glist (); flseek; flseek = flseek->next)
    {
      fl = folder_seek (folder_seek_by_name (flseek->data));
      for (mseek = fl->msglst; mseek; mseek = mseek->next)
	{
	  ptotal = ptotal + mseek->size;
	}
    }

  // for each folder
  for (flseek = folder_create_glist (); flseek; flseek = flseek->next)
    {
      fl = folder_seek (folder_seek_by_name (flseek->data));
      // for each message in the current folder
      for (mseek = fl->msglst; mseek; mseek = mseek->next)
	{
	  if (msearch_cancel_flag)
	    break;

	  // do progressbar updates
	  pcount = pcount + mseek->size;
	  if (ptotal != 0)
	    prog = (float) pcount / (float) ptotal;
	  if (pcount > ptotal)
	    pcount = ptotal;
	  if (prog > 0 && prog < 1)
	    gtk_progress_bar_update (GTK_PROGRESS_BAR (progress), prog);
	  while (gtk_events_pending ())
	    gtk_main_iteration ();

	  // if all folders is selected, or the current folder is selected,
	  // or the parent of the current folder is selected, if that
	  // checkbutton is active...
	  if ((strcasecmp (folder, "* All Folders") == 0)
	      || (strcasecmp (mseek->folder, folder) == 0)
	      || ((GTK_TOGGLE_BUTTON (include)->active)
		  &&
		  (strcasecmp
		   (folder_seek (folder_seek_by_name (mseek->folder))->parent,
		    folder) == 0)))
	    {
	      // this is going to be like a truth table or something
	      match = (char *) malloc ((trtotal + 1) * sizeof (char));
	      mfound = 0;
	      i = 0;
	      // for each tree item in the tree
	      for (trseek = GTK_TREE (tree)->children; trseek;
		   trseek = trseek->next)
		{
		  GtkWidget *trtarget = trseek->data;
		  int equal = 0;
		  int sim = 0;	// similar
		  char *where =
		    gtk_entry_get_text (GTK_ENTRY
					(gtk_object_get_data
					 (GTK_OBJECT (trtarget),
					  "search_attribute")));
		  char *is =
		    gtk_entry_get_text (GTK_ENTRY
					(gtk_object_get_data
					 (GTK_OBJECT (trtarget),
					  "search_criteria")));
		  char *to =
		    gtk_entry_get_text (GTK_ENTRY
					(gtk_object_get_data
					 (GTK_OBJECT (trtarget),
					  "search_text")));
		  gtk_editable_select_region (GTK_EDITABLE
					      (gtk_object_get_data (GTK_OBJECT
								    (trtarget),
								    "search_text")),
					      0, -1);
		  if (!strlen (to))
		    break;
		  mfound = 0;
		  if ((strcmp (is, "Equal")) == 0)
		    equal = 1;
		  if ((strcmp (is, "Similar")) == 0)
		    sim = 1;

		  whole = NULL;
		  message = NULL;
		  header = NULL;

		  switch (*where)
		    {
		    case 'S':	// Subject
		      {
			if (mseek->subject)
			  mfound =
			    msearch_check (mseek->subject, to,
					   equal, sim, ignore);
			break;
		      }
		    case 'F':	// From
		      {
			if (mseek->from)
			  mfound =
			    msearch_check (mseek->from, to,
					   equal, sim, ignore);
			break;
		      }
                    case 'R':   // Reply-To
                      {
                        if (mseek->replyto)
                          mfound =
                            msearch_check (mseek->replyto, to,
                                           equal, sim, ignore);
                        break;
                      }
		    case 'T':	// To
		      {
			whole =
			  message_load (folder_seek
					(folder_seek_by_name
					 (mseek->rfolder)), mseek);
			header = parse_header (whole);
			if (header->to)
			  mfound =
			    msearch_check (header->to, to,
					   equal, sim, ignore);
			break;
		      }
		    case 'C':	// Cc
		      {
			whole =
			  message_load (folder_seek
					(folder_seek_by_name
					 (mseek->rfolder)), mseek);
			header = parse_header (whole);
			if (header->cc)
			  mfound =
			    msearch_check (header->cc, to,
					   equal, sim, ignore);
			break;
		      }
		    case 'B':	// Bcc
		      {
			whole =
			  message_load (folder_seek
					(folder_seek_by_name
					 (mseek->rfolder)), mseek);
			header = parse_header (whole);
			if (header->bcc)
			  mfound =
			    msearch_check (header->bcc, to,
					   equal, sim, ignore);
			break;
		      }
		    case 'M':	// Message
		      {
			whole =
			  message_load (folder_seek
					(folder_seek_by_name
					 (mseek->rfolder)), mseek);
			message = mime_process (whole, att, 0);
			if (message)
			  mfound =
			    msearch_check (message, to, equal, sim, ignore);
			break;
		      }
		    case 'K':	// Keywords
		      {
			if (mseek->keywords)
			  mfound =
			    msearch_check (mseek->keywords, to,
					   equal, sim, ignore);
			break;
		      }
		    case 'P':	// Priority
		      {
			if (mseek->priority)
			  mfound =
			    msearch_check (mseek->priority, to,
					   equal, sim, ignore);
			break;
		      }
		    default:
		      mfound = 0;
		      break;
		    }

		  if (whole)
		    free (whole);
		  if (message)
		    free (message);
		  if (header)
		    destroy_hinfo (header);

		  if (mfound)
		    *(match + i) = '1';
		  else
		    *(match + i) = '0';
		  i++;
		}
	    }
	  gtk_progress_bar_update (GTK_PROGRESS_BAR (progress), 1.0);
	  if (match)
	    *(match + (trtotal)) = '\0';
	  total = 0;
	  if (match) {
	  for (i = 0; i < strlen (match); i++)
	    if ((*(match + i)) == '1')
	      total++;
	  if (total)
	    {
	      int gotit = 1;
	      if ((GTK_TOGGLE_BUTTON (anyall)->active)
		  && (total != strlen (match)))
		gotit = 0;
	      if (gotit)
		{
		  found = g_list_append (found, mseek);
		}
	    }
	      free (match);
	      match = NULL;
	    }
	}
    }
  gtk_clist_freeze (GTK_CLIST (msearch_clist));
  gtk_clist_clear (GTK_CLIST (msearch_clist));
  // time to update the message clist if we have anything found
  if (found)
    {
      for (msg = found; msg; msg = msg->next)
	{
	  mseek = msg->data;
	  cl_data[0] = NULL;
	  cl_data[1] = mseek->priority;
	  cl_data[2] = mseek->subject;
	  cl_data[3] = mseek->from;
	  cl_data[4] = mseek->date;
	  strftime (date, sizeof (date), "%a, %d %b %Y %H:%M:%S %z",
		    localtime (&mseek->time));
	  cl_data[5] = strdup (date);
	  //cl_data[5] = ctime (&mseek->time);
	  info = (msg_info *) calloc (1, sizeof (msg_info));
	  info->msg = mseek;
	  info->fl = folder_seek (folder_seek_by_name (mseek->rfolder));
	  row = gtk_clist_prepend (GTK_CLIST (msearch_clist), cl_data);
	  info->row = row;
	  gtk_clist_set_row_data_full (GTK_CLIST (msearch_clist), row,
				       (gpointer) info, NULL);
	}

    }
  message_clist_reset_shading (msearch_clist);
  //message_clist_clicked_column (message_clist, 5, NULL);
  gtk_clist_thaw (GTK_CLIST (msearch_clist));

  searching = 0;

  free (att->mtype);
  free (att);
  gtk_progress_set_show_text (GTK_PROGRESS (progress), FALSE);
}

void
msearch_destroy_clist_contents (GtkCList * clist)
{
  gpointer *row;

  gtk_clist_freeze (clist);
  while ((row = gtk_clist_get_row_data (clist, 0)))
    {
      free (row);
      gtk_clist_remove (clist, 0);
    }
  g_list_free (found);
  found = NULL;
  gtk_clist_clear (clist);
  gtk_clist_thaw (clist);
}

void
on_message_clist_button_press_event (GtkWidget * widget,
				     GdkEventButton * event,
				     gpointer user_data)
{
  int row, column;
  msg_info *info;

  if (event->type != GDK_2BUTTON_PRESS)
    return;

  gtk_clist_get_selection_info (GTK_CLIST (widget), event->x, event->y,
				&row, &column);
  info = gtk_clist_get_row_data (GTK_CLIST (widget), row);
  if (!info)
    return;
  gtk_widget_show (message_window_new (info));
}

int
msearch_check (char *this, char *that, int equal, int sim, int ignore)
{
  if (ignore)
    {
      char *lthis = msearch_lower (this);
      char *lthat = msearch_lower (that);
      if (((strcasecmp (this, that) == 0) && (equal))
	  || ((strcasecmp (this, that) != 0) && (!equal)
	      && (!sim)) || ((strstr (lthis, lthat) != NULL) && (sim)))
	{
	  if (lthis)
	    free (lthis);
	  if (lthat)
	    free (lthat);
	  return 1;
	}
    }
  else
    {
      if (((strcmp (this, that) == 0) && (equal))
	  || ((strcmp (this, that) != 0) && (!equal)
	      && (!sim)) || ((strstr (this, that) != NULL) && (sim)))
	return 1;
    }
  return 0;
}

char *
msearch_lower (char *string)
{
  char *newstring = strdup (string);
  int i;

  for (i = 0; i < strlen (string); i++)
    {
      *(newstring + i) = tolower (*(string + i));
    }
  return newstring;
}

void
msearch_cancel (void)
{
  msearch_cancel_flag = 1;
}
