/* TradeClient <http://tradeclient.sourceforge.net>
 * $Id: new-folder.c,v 1.3 2001/03/20 22:19:33 ttabner Exp $
 *
 * Copyright (C) 1999-2000 Bynari Inc.
 * Copyright (C) 2001 Project TradeClient
 *
 * LGPL
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#include "puma.h"

GtkWidget* create_create_folder () {
  GtkWidget *create_folder;
  GtkWidget *dialog_vbox2;
  GtkWidget *vbox2;
  GtkWidget *frame2;
  GtkWidget *frame5;
  GtkWidget *scrolledwindow3;
  GtkWidget *folder_tree;
  GtkWidget *hbox3;
  GtkWidget *label2;
  GtkWidget *folder_name;
  GtkWidget *dialog_action_area2;
  GtkWidget *hbox2;
  GtkWidget *ok_button;
  GtkWidget *cancel_button;

  create_folder = gtk_dialog_new ();
  gtk_object_set_data (GTK_OBJECT (create_folder), "create_folder", create_folder);
  gtk_window_set_title (GTK_WINDOW (create_folder), "Create a new folder");
  gtk_window_set_policy (GTK_WINDOW (create_folder), TRUE, TRUE, FALSE);

  dialog_vbox2 = GTK_DIALOG (create_folder)->vbox;
  gtk_object_set_data (GTK_OBJECT (create_folder), "dialog_vbox2", dialog_vbox2);
  gtk_widget_show (dialog_vbox2);

  vbox2 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox2);
  gtk_object_set_data_full (GTK_OBJECT (create_folder), "vbox2", vbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox2);
  gtk_box_pack_start (GTK_BOX (dialog_vbox2), vbox2, TRUE, TRUE, 0);

  frame2 = gtk_frame_new (_("Create new folder in"));
  gtk_widget_ref (frame2);
  gtk_object_set_data_full (GTK_OBJECT (create_folder), "frame2", frame2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame2);
  gtk_box_pack_start (GTK_BOX (vbox2), frame2, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame2), 2);

  frame5 = gtk_frame_new (NULL);
  gtk_widget_ref (frame5);
  gtk_object_set_data_full (GTK_OBJECT (create_folder), "frame5", frame5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame5);
  gtk_container_add (GTK_CONTAINER (frame2), frame5);
  gtk_container_set_border_width (GTK_CONTAINER (frame5), 2);
  gtk_frame_set_shadow_type (GTK_FRAME (frame5), GTK_SHADOW_OUT);

  scrolledwindow3 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow3);
  gtk_object_set_data_full (GTK_OBJECT (create_folder), "scrolledwindow3", scrolledwindow3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow3);
  gtk_container_add (GTK_CONTAINER (frame5), scrolledwindow3);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow3), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  folder_tree = gtk_tree_new ();
  gtk_widget_ref (folder_tree);
  gtk_object_set_data_full (GTK_OBJECT (create_folder), "folder_tree", folder_tree,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (folder_tree);
  gtk_scrolled_window_add_with_viewport (GTK_SCROLLED_WINDOW (scrolledwindow3), folder_tree);

  hbox3 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox3);
  gtk_object_set_data_full (GTK_OBJECT (create_folder), "hbox3", hbox3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox3);
  gtk_box_pack_start (GTK_BOX (vbox2), hbox3, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox3), 4);

  label2 = gtk_label_new (_("Folder Name "));
  gtk_widget_ref (label2);
  gtk_object_set_data_full (GTK_OBJECT (create_folder), "label2", label2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label2);
  gtk_box_pack_start (GTK_BOX (hbox3), label2, FALSE, FALSE, 0);

  folder_name = gtk_entry_new ();
  gtk_widget_ref (folder_name);
  gtk_object_set_data_full (GTK_OBJECT (create_folder), "folder_name", folder_name,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (folder_name);
  gtk_box_pack_start (GTK_BOX (hbox3), folder_name, TRUE, TRUE, 0);

  dialog_action_area2 = GTK_DIALOG (create_folder)->action_area;
  gtk_object_set_data (GTK_OBJECT (create_folder), "dialog_action_area2", dialog_action_area2);
  gtk_widget_show (dialog_action_area2);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area2), 10);

  hbox2 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox2);
  gtk_object_set_data_full (GTK_OBJECT (create_folder), "hbox2", hbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox2);
  gtk_box_pack_start (GTK_BOX (dialog_action_area2), hbox2, TRUE, TRUE, 0);

  ok_button = gtk_button_new_with_label (_("Ok"));
  gtk_widget_ref (ok_button);
  gtk_object_set_data_full (GTK_OBJECT (create_folder), "ok_button", ok_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ok_button);
  gtk_box_pack_start (GTK_BOX (hbox2), ok_button, TRUE, TRUE, 0);
  GTK_WIDGET_SET_FLAGS (ok_button, GTK_CAN_DEFAULT);

  cancel_button = gtk_button_new_with_label (_("Cancel"));
  gtk_widget_ref (cancel_button);
  gtk_object_set_data_full (GTK_OBJECT (create_folder), "cancel_button", cancel_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cancel_button);
  gtk_box_pack_start (GTK_BOX (hbox2), cancel_button, TRUE, TRUE, 0);

  gtk_widget_grab_focus (ok_button);
  gtk_widget_grab_default (ok_button);

	gtk_signal_connect (GTK_OBJECT (ok_button), "clicked",
											GTK_SIGNAL_FUNC (accept_create_folder_two), NULL);
	gtk_signal_connect (GTK_OBJECT (cancel_button), "clicked",
											GTK_SIGNAL_FUNC (destroy_create_folder), NULL);
	gtk_signal_connect (GTK_OBJECT (create_folder), "delete_event",
											GTK_SIGNAL_FUNC (destroy_create_folder), NULL);

  return create_folder;
}
