/* TradeClient <http://tradeclient.sourceforge.net>
 * $Id: pixmap.c,v 1.5 2001/03/20 22:19:33 ttabner Exp $
 *
 * Copyright (C) 1999-2000 Bynari Inc.
 * Copyright (C) 2001 Project TradeClient
 *
 * LGPL
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#include "puma.h"

#include "../pics/dragicon.xpm"
#include "../pics/print.xpm"
#include "../pics/address_book.xpm"
#include "../pics/encryption.xpm"
#include "../pics/folder_close.xpm"
#include "../pics/reply-toall.xpm"
#include "../pics/attachment.xpm"
#include "../pics/new-message.xpm"
#include "../pics/folder_open.xpm"
#include "../pics/reply.xpm"
#include "../pics/bynari-logo.xpm"
#include "../pics/esclamation.xpm"
#include "../pics/forward.xpm"
#include "../pics/save-as.xpm"
#include "../pics/checkmark.xpm"
#include "../pics/find.xpm"
#include "../pics/get-messages.xpm"
#include "../pics/save.xpm"
#include "../pics/delete.xpm"
#include "../pics/flag.xpm"
#include "../pics/paperclip.xpm"
#include "../pics/send.xpm"
#include "../pics/calendar.xpm"
#include "../pics/spell.xpm"

GtkWidget *pixmap_widget_create (GtkWidget *parent, PixmapDef pixmapdef) {
	GtkWidget *widget;
	GdkBitmap *mask;
	GdkPixmap *pixmap=pixmap_create (parent, pixmapdef, &mask);
	widget = gtk_pixmap_new (pixmap, mask);

	return widget;
}

GdkPixmap *pixmap_create (GtkWidget *widget, PixmapDef pixmap, GdkBitmap **mask) {
	GdkPixmap *gdkpixmap=NULL;
	GdkColormap *colormap=gtk_widget_get_colormap (widget);
	switch (pixmap) {
		case PIXMAP_ABOOK :
		  gdkpixmap = gdk_pixmap_colormap_create_from_xpm_d (NULL, colormap, mask,
			                                                   NULL, (char **)address_book_xpm);
			break;
		case PIXMAP_ATTACH :
		  gdkpixmap = gdk_pixmap_colormap_create_from_xpm_d (NULL, colormap, mask,
		                                                     NULL, attachment_xpm);
			break;
		case PIXMAP_AX :
		  gdkpixmap = gdk_pixmap_colormap_create_from_xpm_d (NULL, colormap, mask,
			                                                   NULL, delete_xpm);
			break;
		case PIXMAP_CALENDAR :
		  gdkpixmap = gdk_pixmap_colormap_create_from_xpm_d (NULL, colormap, mask,
			                                                   NULL, calendar_xpm);
			break;
		case PIXMAP_CHECKMARK :
		  gdkpixmap = gdk_pixmap_colormap_create_from_xpm_d (NULL, colormap, mask,
			                                                   NULL, checkmark_xpm);
			break;
		case PIXMAP_BYNARI:
		  gdkpixmap = gdk_pixmap_colormap_create_from_xpm_d (NULL, colormap, mask,
			                                                   NULL, bynari_logo_xpm);
			break;
		case PIXMAP_DRAGICON :
		  gdkpixmap = gdk_pixmap_colormap_create_from_xpm_d (NULL, colormap, mask,
			                                                   NULL, dragicon_xpm);
			break;
		case PIXMAP_CRYPT :
		  gdkpixmap = gdk_pixmap_colormap_create_from_xpm_d (NULL, colormap, mask,
			                                                   NULL, encryption_xpm);
			break;
		case PIXMAP_ENVELOPE :
		  gdkpixmap = gdk_pixmap_colormap_create_from_xpm_d (NULL, colormap, mask,
			                                                   NULL, new_message_xpm);
			break;
		case PIXMAP_BANG :
		  gdkpixmap = gdk_pixmap_colormap_create_from_xpm_d (NULL, colormap, mask,
			                                                   NULL, esclamation_xpm);
			break;
		case PIXMAP_FIND :
		  gdkpixmap = gdk_pixmap_colormap_create_from_xpm_d (NULL, colormap, mask,
			                                                   NULL, find_xpm);
			break;
		case PIXMAP_FLAG :
		  gdkpixmap = gdk_pixmap_colormap_create_from_xpm_d (NULL, colormap, mask,
			                                                   NULL, flag_xpm);
			break;
		case PIXMAP_FOLDER_OPEN :
		  gdkpixmap = gdk_pixmap_colormap_create_from_xpm_d (NULL, colormap, mask,
			                                                   NULL, folder_open_xpm);
			break;
		case PIXMAP_FOLDER_CLOSE :
		  gdkpixmap = gdk_pixmap_colormap_create_from_xpm_d (NULL, colormap, mask,
			                                                   NULL, folder_close_xpm);
			break;
		case PIXMAP_FORWARD :
		  gdkpixmap = gdk_pixmap_colormap_create_from_xpm_d (NULL, colormap, mask,
			                                                   NULL, forward_xpm);
			break;
		case PIXMAP_GET :
		  gdkpixmap = gdk_pixmap_colormap_create_from_xpm_d (NULL, colormap, mask,
			                                                   NULL, get_messages_xpm);
			break;
		case PIXMAP_PAPERCLIP :
		  gdkpixmap = gdk_pixmap_colormap_create_from_xpm_d (NULL, colormap, mask,
			                                                   NULL, paperclip_xpm);
			break;
		case PIXMAP_PRINT :
		  gdkpixmap = gdk_pixmap_colormap_create_from_xpm_d (NULL, colormap, mask,
			                                                   NULL, print_xpm);
			break;
		case PIXMAP_REPLY :
		  gdkpixmap = gdk_pixmap_colormap_create_from_xpm_d (NULL, colormap, mask,
			                                                   NULL, reply_xpm);
			break;
		case PIXMAP_REPLYALL :
		  gdkpixmap = gdk_pixmap_colormap_create_from_xpm_d (NULL, colormap, mask,
			                                                   NULL, reply_toall_xpm);
			break;
		case PIXMAP_SAVE :
		  gdkpixmap = gdk_pixmap_colormap_create_from_xpm_d (NULL, colormap, mask,
			                                                   NULL, save_xpm);
			break;
		case PIXMAP_SAVEAS :
		  gdkpixmap = gdk_pixmap_colormap_create_from_xpm_d (NULL, colormap, mask,
			                                                   NULL, save_as_xpm);
			break;
		case PIXMAP_SEND :
		  gdkpixmap = gdk_pixmap_colormap_create_from_xpm_d (NULL, colormap, mask,
			                                                   NULL, send_xpm);
			break;
		case PIXMAP_SPELL :
			gdkpixmap = gdk_pixmap_colormap_create_from_xpm_d(NULL,
					colormap, mask, NULL, spell_xpm);
			break;
	}
	if (!gdkpixmap) 
		return NULL;
	return gdkpixmap;
}
