/* TradeClient <http://tradeclient.sourceforge.net>
 * $Id: pref-windows-callbacks.c,v 1.44 2001/03/20 22:19:33 ttabner Exp $
 *
 * Copyright (C) 1999-2000 Bynari Inc.
 * Copyright (C) 2001 Project TradeClient
 *
 * LGPL
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#include "puma.h"

GtkWidget *prefs_widget=NULL;
gint server_row=-1;

GtkWidget *prefs_get_widget () {
	return prefs_widget;
}

void prefs_show (int show) {
	PopAccount *fseek=first_popaccount ();
	GList *list=NULL;
	if (!GTK_IS_WIDGET (prefs_widget)) {
		prefs_widget=create_preference_dialog ();
	}
	mime_types_rehash_clist ();	
	for (fseek=first_popaccount ();fseek;fseek=fseek->next) {
		list = g_list_append (list, fseek->name);
		prefs_display_server (GTK_CLIST (lw (prefs_widget, "server_clist")), fseek);
	}
	if(list) {
	  gtk_combo_set_popdown_strings (GTK_COMBO (lookup_widget (prefs_widget, "combo2")), list);
	  if(tm_globs->default_account)
	    gtk_entry_set_text (GTK_ENTRY (GTK_COMBO (lookup_widget (prefs_widget, "combo2"))->entry), tm_globs->default_account);
	  g_list_free (list);
	}
	rule_rehash ();
	preferences_rehash_interface ();
	if (show)
		gtk_widget_show (prefs_widget);
}

int prefs_hide () {
	if (GTK_IS_WIDGET (prefs_widget)) {
		gtk_widget_hide (prefs_widget);
		
		preferences_rehash_varibles ();
		save_preferences ();
	}
	return FALSE;
}

void prefs_server_selected (GtkCList *clist, int row) {
	server_row=row;
}

void prefs_server_unselected (GtkCList *clist) {
	server_row=-1;
}

void prefs_pop3_new () {
	PopAccount *account=seek_popaccount (new_popaccount (NULL, NULL, NULL, NULL, 
	       110, NULL, NULL, 25, 0, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL));	
	account->type=POP3;
	prefs_server_window (account, account);
}

void prefs_imap_new () {
	PopAccount *account=seek_popaccount (new_popaccount (NULL, NULL, NULL,
				NULL, 143, NULL, NULL, 25, 0, 0, NULL, NULL,
				NULL, NULL, NULL, NULL, NULL, 0, NULL));
	account->type=IMAP;
	prefs_server_window (account, account);
}

void prefs_edit_account () {
	PopAccount *account;
	if (server_row==-1) 
		return;
	account=gtk_clist_get_row_data (GTK_CLIST (lw (prefs_widget, "server_clist")), server_row);
	prefs_server_window (account, NULL);
}

void prefs_delete_account () {
	PopAccount *account;
	int startAgain ;
	
	if (server_row==-1) 
		return;
	if( tm_globs -> getMsgTimeout ) {
	  startAgain = 1 ;
	  gtk_timeout_remove( tm_globs -> getMsgTimeout ) ;
	} else startAgain = 0 ;
	account=gtk_clist_get_row_data (GTK_CLIST (lw (prefs_widget, "server_clist")), server_row);
	destroy_popaccount (account->id);
	gtk_clist_remove (GTK_CLIST (lw (prefs_widget, "server_clist")), server_row);
	server_row=-1;
	if( startAgain ) tm_globs -> getMsgTimeout = gtk_timeout_add( 950, (GtkFunction)message_event_loop, NULL ) ;
}

void prefs_display_server (GtkCList *clist, PopAccount *account) {
	char *cl_data[2];
	int row;
	g_return_if_fail (clist   != NULL);
	g_return_if_fail (account != NULL);
//	g_return_if_fail (prefs_widget != NULL);
	
	row=gtk_clist_find_row_from_data (clist, account);
	if (row==-1) {
		cl_data[0]=account->name;
		switch( account->type ) {
		case POP3:
			cl_data[1]=strdup ("POP3");
		  break ;

		case IMAP:
			cl_data[1]=strdup ("IMAP");
		  break ;

		default:
			cl_data[1]=strdup ("Custom");
		  break ;
		}

		row=gtk_clist_append (clist, cl_data);
		free (cl_data[1]);
		gtk_clist_set_row_data (clist, row, account);
	} else {
		gtk_clist_set_text (clist, row, 0, account->name);
	}
	grey_out_stuff ();
	{/* handle default account stuff */
		GtkWidget *def=lw (prefs_widget, "combo2");
		GList *accounts=pop_create_glist ();
		if (accounts) gtk_combo_set_popdown_strings (GTK_COMBO (def), accounts);
		if (tm_globs->default_account) {
			gtk_entry_set_text (GTK_ENTRY (GTK_COMBO (def)->entry), tm_globs->default_account);
		} else {
			gtk_entry_set_text (GTK_ENTRY (GTK_COMBO (def)->entry), account->name);
		}
	}
}

void prefs_accept_pop3 (GtkWidget *widget, PopAccount *account) {
	int flags=0;
	char *signature;
	g_return_if_fail (account != NULL);
	if (TBA (widget, "save_password")) {
	  flags |= REMBER_PASSWORD_ALWAYS;
	}
	if (TBA (widget, "delete_mail"))	flags |= DELETEFROMSERVER;
	if (TBA (widget, "use_sig")) flags |= USE_THIS_SIG;
	if (TBA (widget, "use_unix_sig")) flags |= USE_THIS_UNIX_SIG;
	if (TBA (widget, "check_with_others")) flags |= CHECK_WITH_ALL;	
	if (TBA (widget, "ff_button")) flags |= FORCE_FETCH;
#ifdef WANTSSL
	if (TBA (widget, "ssl_button")) flags |= SSL_CONN;
	if (TBA (widget, "cert_button")) flags |= SSL_VERIFY_CERT;
#endif
	signature=gtk_editable_get_chars (GTK_EDITABLE (lw (widget, "signature")), 0, -1);
//widget, 	printf ("Signature: %s\n", signature);
	edit_popaccount (account->id, gt (widget, "account_name"), gt (widget, "pop3_host"),
	                 gt (widget, "pop3_login"), gt (widget, "password"), gv(widget, "pop3_port"), 
	                 gt (widget, "smtp_host"), gt (widget, "smtp_login"), gv(widget, "smtp_port"), 
	                 flags, 5, gt (widget, "store_mail_in"), gt (widget, "your_name"), 
	                 gt (widget, "email_addy"), gt (widget, "reply_to"), gt (widget, "org"), 
	                 signature, NULL, NULL);	
	g_free (signature);
	if (TBA (widget, "check_mail")) {
		account->timeout=gv (widget, "check_mail_duration");
	} else {
		account->timeout=0;
	}
	prefs_display_server (GTK_CLIST (lw (prefs_widget, "server_clist")), account);
	tm_globs->num_accounts++;
	gtk_widget_destroy (lw (widget, "pop3_server"));
}

void prefs_cancel_pop3 (GtkWidget *widget, PopAccount *account) {
	if (account) 
		destroy_popaccount (account->id);
	gtk_widget_destroy (lw (widget, "pop3_server"));
}

void preferences_hide_status_toggled (GtkWidget *widget, gpointer data) {

	if (GTK_IS_TOGGLE_BUTTON (widget)) {
		if (GTK_TOGGLE_BUTTON (widget)->active) {
			tm_globs->flags |=HIDE_STATUS_WINDOW;
		} else {
			tm_globs->flags &=~HIDE_STATUS_WINDOW;
		}
	}
}

void mime_types_display_type (GtkCList *clist, MimeType *type) {
	char *cl_data[3];
	int row;
	if (type) {
		if (clist) {
			row=gtk_clist_find_row_from_data (clist, (gpointer)type);
			if (row!=-1) {
				gtk_clist_set_text (clist, row, 0, type->ext);
				gtk_clist_set_text (clist, row, 1, type->type);
				gtk_clist_set_text (clist, row, 2, _(type->handle));
			} else {
				cl_data[0]=NULL;cl_data[1]=NULL;cl_data[2]=NULL;
				if (type->ext) cl_data[0]=strdup (type->ext);
				if (type->type) cl_data[1]=strdup (type->type);
				if (type->handle) cl_data[2]=strdup (_(type->handle));
				row=gtk_clist_append (clist, cl_data);
				gtk_clist_set_row_data (clist, row, (gpointer)type);
				if (cl_data[0]) free (cl_data[0]);
				if (cl_data[1]) free (cl_data[1]);
				if (cl_data[2]) free (cl_data[2]);
			}
		} else {
#if DEBUG>=1
			printf ("mime_types_display_type: argument 2 'clist' == NULL.  Something is wrong\n");
#endif
		}
	} else {
#if DEBUG>=2
		printf ("mime_types_display_type: argument 2 'type' == NULL\n");
#endif
	}
}

int mime_row;

void mime_types_select_row (GtkWidget *widget, gint row, gint column, GdkEventButton *event, gpointer data) {
#if DEBUG>=4
	printf ("selection: %p selection->data: %p selection_end: %p selection_end->data: %p\n",
					GTK_CLIST (widget)->selection, GTK_CLIST (widget)->selection->data,
					GTK_CLIST (widget)->selection_end, GTK_CLIST (widget)->selection_end->data);
	printf ("focus_row: %d\n", GTK_CLIST (widget)->focus_row);
#endif
	mime_row=row;
	gtk_widget_set_sensitive (lookup_widget (prefs_widget, "edit_type"), TRUE);
	gtk_widget_set_sensitive (lookup_widget (prefs_widget, "delete_type"), TRUE);
}

void mime_types_unselect_row (GtkWidget *widget, gint row, gint column, GdkEventButton *event, gpointer data) {
	gtk_widget_set_sensitive (lookup_widget (prefs_widget, "edit_type"), FALSE);
	gtk_widget_set_sensitive (lookup_widget (prefs_widget, "delete_type"), FALSE);
	mime_row=-1;
}

void mime_types_connect_signals (GtkWidget *window, gpointer data) {
	gtk_signal_connect (GTK_OBJECT (window), "delete_event",
	                    GTK_SIGNAL_FUNC (mime_types_destroy_window), data);
	gtk_signal_connect (GTK_OBJECT (lookup_widget (window, "ok_button")), "clicked",
	                    GTK_SIGNAL_FUNC (mime_types_accept_window), data);
	gtk_signal_connect (GTK_OBJECT (lookup_widget (window, "cancel_button")), "clicked",
	                    GTK_SIGNAL_FUNC (mime_types_cancel_window), data);
	gtk_signal_connect (GTK_OBJECT (lookup_widget (window, "re_radio")), "toggled",
	                    GTK_SIGNAL_FUNC (mime_types_external_toggle), data);
	gtk_signal_connect (GTK_OBJECT (lookup_widget (window, "button4")),
			"clicked", GTK_SIGNAL_FUNC (browse_handler), NULL);
}

void mime_types_add_type (GtkWidget *widget, gpointer data) {
	GtkWidget *window=create_mime_type_window ();
	mime_types_connect_signals (window, NULL);
	gtk_widget_show (window);
}

void mime_types_edit_type (GtkWidget *widget, gpointer data) {
	GtkWidget *window=create_mime_type_window ();
	GtkCList *clist=GTK_CLIST (lookup_widget (prefs_widget, "mime_clist"));
	MimeType *mtype=(MimeType *)gtk_clist_get_row_data (clist, mime_row);
	if (mime_row == -1) 
		return;
	mime_types_connect_signals (window, (gpointer)mtype);	
	gtk_entry_set_text (GTK_ENTRY (lookup_widget (window, "extensions")), mtype->ext);
	gtk_entry_set_text (GTK_ENTRY (lookup_widget (window, "mime_type")), mtype->type);
	if (mtype->handle) {	
		if (strcasecmp (mtype->handle, "internal")==0) {
			gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (lookup_widget (window, "ri_radio")), TRUE);
		} else {
			if (strcasecmp (mtype->handle, "save")==0) {
				gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (lookup_widget (window, "rs_radio")), TRUE);
			} else {
				if (strcasecmp (mtype->handle, "prompt")==0) {
					gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (lookup_widget (window, "rp_radio")), TRUE);
				} else {
					gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (lookup_widget (window, "re_radio")), TRUE);
					gtk_entry_set_text (GTK_ENTRY (lookup_widget (window, "handler")), mtype->handle);
				}
			}
		}
	}
	gtk_widget_show (window);
}

void mime_types_delete_type (GtkWidget *widget, gpointer data) {
	GtkCList *clist=GTK_CLIST (lookup_widget (prefs_widget, "mime_clist"));
	MimeType *mtype=(MimeType *)gtk_clist_get_row_data (clist, mime_row);
	if (mime_row == -1)
		return;
	mime_type_delete (mtype->type);
	mime_row=-1;
	gtk_clist_remove (clist, mime_row);
}

void mime_types_accept_window (GtkWidget *widget, MimeType *mtype) {
//	MimeType *mtype;
	if (!mtype) {
		mtype=mime_type_add (strdup (gt (widget, "mime_type")), 
		                     strdup (gt (widget, "extensions")), 
												 NULL);
		if (mtype==NULL) {
			insert_warning (_("A MIME Handler of that type already exists\n"));
		}
	}
	if (mtype->type) free (mtype->type);
	mtype->type=strdup (gtk_entry_get_text (GTK_ENTRY (lookup_widget (widget, "mime_type"))));
 	if (mtype->ext) free (mtype->ext);
	mtype->ext=strdup (gtk_entry_get_text (GTK_ENTRY (lookup_widget (widget, "extensions"))));
	if (mtype->handle) free (mtype->handle);
	if (GTK_TOGGLE_BUTTON (lookup_widget (widget, "ri_radio"))->active) {
		mtype->handle=strdup ("Internal");
	} else {
		if (GTK_TOGGLE_BUTTON (lookup_widget (widget, "rs_radio"))->active) {
			mtype->handle=strdup ("Save");
		} else {
			if (GTK_TOGGLE_BUTTON (lookup_widget (widget, "rp_radio"))->active) {
				mtype->handle=strdup ("Prompt");
			} else {
				mtype->handle=strdup (gtk_entry_get_text (GTK_ENTRY (lookup_widget (widget, "handler"))));
			}
		}
	}
	mime_types_destroy_window (widget, NULL, NULL);
	mime_types_display_type (GTK_CLIST (lookup_widget(prefs_widget, "mime_clist")), mtype);
}

void mime_types_cancel_window (GtkWidget *widget, gpointer data) {
	mime_types_destroy_window (widget, NULL, NULL);
}

void mime_types_destroy_window (GtkWidget *widget, GdkEvent *event, gpointer data) {
	gtk_widget_destroy (lookup_widget (widget, "mime_type_window"));
}

void mime_types_external_toggle (GtkWidget *widget, gpointer data) {
	if (GTK_TOGGLE_BUTTON (widget)->active) {
		gtk_widget_set_sensitive (lookup_widget (widget, "handler"), TRUE);
	} else {
		gtk_widget_set_sensitive (lookup_widget (widget, "handler"), FALSE);
	}
}

void mime_types_rehash_clist () {
	GtkCList *clist;
	Llist *seek=mime_type_first ();
	if (GTK_IS_WIDGET (prefs_widget)) {
		clist=GTK_CLIST (lookup_widget (prefs_widget, "mime_clist"));
		gtk_clist_freeze (clist);
		gtk_clist_clear (clist);
		while (seek) {
			mime_types_display_type (clist, (MimeType *)seek->data);
			seek=seek->next;
		}
		gtk_clist_thaw (clist);
	}
}

void header_none_selected (GtkWidget *widget, gpointer data) {
	if (GTK_TOGGLE_BUTTON (widget)->active) {
		tm_globs->flags &=~SHOW_SOME_HEADER;
		tm_globs->flags &=~SHOW_ALL_HEADER;
	}
}

void header_some_selected (GtkWidget *widget, gpointer data) {
	if (GTK_TOGGLE_BUTTON (widget)->active) {
		tm_globs->flags &=~SHOW_ALL_HEADER;
		tm_globs->flags |=SHOW_SOME_HEADER;
	}
}

void header_all_selected (GtkWidget *widget, gpointer data) {
	if (GTK_TOGGLE_BUTTON (widget)->active) {
		tm_globs->flags |=SHOW_ALL_HEADER;
		tm_globs->flags &=~SHOW_SOME_HEADER;
	}
}

void reply_none_selected (GtkWidget *widget, gpointer data) {
	if (GTK_TOGGLE_BUTTON (widget)->active) {
		tm_globs->flags &=~REPLY_NONE;
		tm_globs->flags |=REPLY_NONE;
	}
}

void reply_quoted_selected (GtkWidget *widget, gpointer data) {
	if (GTK_TOGGLE_BUTTON (widget)->active) {
		tm_globs->flags &=~REPLY_NONE;
		tm_globs->flags &=~REPLY_QUOTED;
		tm_globs->flags |=REPLY_QUOTED;
	}
}

void reply_attached_selected (GtkWidget *widget, gpointer data) {
	if (GTK_TOGGLE_BUTTON (widget)->active) {
		tm_globs->flags &=~REPLY_NONE;
		tm_globs->flags &=~REPLY_QUOTED;
	}
}

void wasted_value_changed (GtkAdjustment *adjustment) {
	tm_globs->wasted=adjustment->value;
//	tm_globs->flags=adjustment->value;
}

void compact_folders (GtkWidget *widget, gpointer data) {
	Folder *folder;


	insert_message ("Processing compact folders request.  Please wait...\n");
	insert_message ("Analyzing folders...\n");
	folders_compact ();

	insert_message ("Recreating message list for folders...\n");
	for (folder=folder_first ();folder;folder=folder->next) {
		message_list_destroy (folder);
		folder->msglst=NULL;
	}

	insert_message ("Reindexing folders...\n");
	for (folder=folder_first ();folder;folder=folder->next) {
		folder_reindex (folder);
	}

	insert_message ("Done.\n");
	folder_display (GTK_CLIST (lookup_widget (tm_globs->main_window, "message_clist")), tm_globs->visable);
	prefs_setup_info ();
}

void undelete_messages (GtkWidget *widget, gpointer data) {
	Folder *fl;
	char *number;
	GtkWidget *folder_ctree=lookup_widget (tm_globs->main_window, "folder_tree");

#if DEBUG > 4
	printf("undeleting messages\n");
#endif

	insert_message ("This may take some time, depending on mailbox size.\n");
	insert_message ("During this process, user interaction wil be suspended.\n");
	insert_message ("Undeleting messages..");

	while (gtk_events_pending ())
		gtk_main_iteration ();

	number=(char *)calloc (5, sizeof(char));
	fl=folder_first ();
	while (fl) {
		insert_message (".");
		while (gtk_events_pending ())
			gtk_main_iteration ();

		folder_reindex (fl);
		snprintf (number, 5, "%d", fl->unread);
		gtk_ctree_node_set_text (GTK_CTREE (folder_ctree), fl->tree_item, 1, number);
		snprintf (number, 5, "%d", fl->total);
		gtk_ctree_node_set_text (GTK_CTREE (folder_ctree), fl->tree_item, 2, number);
		fl=fl->next;
	}

	free (number);
	insert_message (" Finished.\n");
	if ((tm_globs->flags & HIDE_STATUS_WHEN_DONE)) {
		destroy_status (tm_globs->status, NULL);
	}
}

int rule_row=-1;

void filter_rules_select_rule (GtkWidget *widget, gint row, gint column, GdkEventButton *event, gpointer data) {
	rule_row=row;
}

void filter_rules_unselect_rule (GtkWidget *widget, gint row, gint column, GdkEventButton *event, gpointer data) {
	rule_row=-1;
}

void filter_rules_add_rule  (GtkWidget *widget, gpointer data) {
	FilterRule *rule=filter_new_rule ();
	rule_editor_create (rule, rule);
}

void filter_rules_edit_rule (GtkWidget *widget, gpointer data) {
	if (rule_row!=-1) {
		FilterRule *rule=gtk_clist_get_row_data (GTK_CLIST (lw (widget, "rule_clist")), 
		                                         rule_row);
		rule_editor_create (rule, NULL);
	}
}

void filter_rules_delete_rule (GtkWidget *widget, gpointer data) {
	if (rule_row!=-1) {
		FilterRule *rule=gtk_clist_get_row_data (GTK_CLIST (lw (widget, "rule_clist")), 
		                                         rule_row);
		filter_delete_rule (rule);
		gtk_clist_remove (GTK_CLIST (lw (widget, "rule_clist")), rule_row);
		rule_row=-1;
	}
}

void filter_rules_move_up (GtkWidget *widget, gpointer data) {
	GtkCList *clist=GTK_CLIST (lw (widget, "rule_clist"));	
	if (rule_row!=-1 && rule_row !=0) {
		FilterRule *rule=gtk_clist_get_row_data (clist, rule_row);
		gtk_clist_swap_rows (clist, rule_row, rule_row-1);
		rule_row--;
		filter_move_up (rule);
	}
}

void filter_rules_move_down (GtkWidget *widget, gpointer data) {
	GtkCList *clist=GTK_CLIST (lw (widget, "rule_clist"));	
	if (rule_row!=-1 && rule_row!=clist->rows-1) {
		FilterRule *rule=gtk_clist_get_row_data (clist, rule_row);
		gtk_clist_swap_rows (clist, rule_row, rule_row+1);
		rule_row++;
		filter_move_down (rule);
	}
}

void preferences_rehash_varibles () {
	GtkWidget *prefs=prefs_widget;
	int hideflags = tm_globs->flags;
#if DEBUG>7
	printf ("real_name   : '%20.20s'<%p>\n", tm_globs->real_name, tm_globs->real_name);
	printf ("email       : '%20.20s'<%p>\n", tm_globs->email, tm_globs->email);
	printf ("replyto     : '%20.20s'<%p>\n", tm_globs->replyto, tm_globs->replyto);
	printf ("organization: '%20.20s'<%p>\n", tm_globs->organization, tm_globs->organization);
	printf ("signature   : '%20.20s'<%p>\n", tm_globs->signature, tm_globs->signature);
#endif
	if (tm_globs->real_name) free (tm_globs->real_name);
	if (tm_globs->email) free (tm_globs->email);
	if (tm_globs->replyto) free (tm_globs->replyto);
	if (tm_globs->organization) free (tm_globs->organization);
#if 0
	if (tm_globs->signature) g_free (tm_globs->signature);
#else
	if (tm_globs->signature) free (tm_globs->signature);
#endif

	tm_globs->real_name=strdup (gtk_entry_get_text (GTK_ENTRY (lookup_widget (prefs, "name_entry"))));
	tm_globs->email=strdup (gtk_entry_get_text (GTK_ENTRY (lookup_widget (prefs, "email_addy_entry"))));
	tm_globs->replyto=strdup (gtk_entry_get_text (GTK_ENTRY (lookup_widget (prefs, "reply_entry"))));
	tm_globs->organization=strdup (gtk_entry_get_text (GTK_ENTRY (lookup_widget (prefs, "org_entry"))));
	tm_globs->default_account=strdup (gtk_entry_get_text (GTK_ENTRY (lookup_widget (prefs, "combo_entry2"))));
#ifdef WANTLDAP
	set_ldap_host(strdup (gtk_entry_get_text (GTK_ENTRY (lookup_widget (prefs, "l_entry_host")))));
	set_ldap_ppassword(strdup (gtk_entry_get_text (GTK_ENTRY (lookup_widget (prefs, "l_entry_password")))));
	set_ldap_base(strdup (gtk_entry_get_text (GTK_ENTRY (lookup_widget (prefs, "l_entry_base")))));
	set_ldap_username(strdup (gtk_entry_get_text (GTK_ENTRY (lookup_widget (prefs, "l_entry_username")))));
	set_ldap_port(strdup (gtk_entry_get_text (GTK_ENTRY (lookup_widget (prefs, "l_entry_port")))));
#endif
	tm_globs->signature=gtk_editable_get_chars (GTK_EDITABLE (lookup_widget (prefs, "autosignature")), 0, -1);
	tm_globs->flags=0;
	if (GTK_TOGGLE_BUTTON (lookup_widget (prefs, "use_autosig"))->active) {
		tm_globs->flags |= USE_SIGNATURE;
	}
	if (GTK_TOGGLE_BUTTON (lookup_widget (prefs, "use_unix_sig"))->active) {
		tm_globs->flags |=USE_UNIX_SIG;
	}
	if ((hideflags) && (hideflags & HIDE_STATUS_WHEN_DONE))
		tm_globs->flags |= HIDE_STATUS_WHEN_DONE;
	if (GTK_IS_WIDGET (tm_globs->status)) {
		if (GTK_TOGGLE_BUTTON (lookup_widget (tm_globs->status, "checkbutton2"))->active) {
			tm_globs->flags |=HIDE_STATUS_WHEN_DONE;
		}
	}
	if (GTK_TOGGLE_BUTTON (lookup_widget (prefs, "hide_status"))->active) {
		tm_globs->flags |=HIDE_STATUS_WINDOW;
	}
	if (GTK_TOGGLE_BUTTON (lookup_widget (prefs, "header_some"))->active) {
		tm_globs->flags |=SHOW_SOME_HEADER;
	}
	if (GTK_TOGGLE_BUTTON (lookup_widget (prefs, "header_all"))->active) {
		tm_globs->flags |=SHOW_ALL_HEADER;
	}
	if (GTK_TOGGLE_BUTTON (lookup_widget (prefs, "reply_none"))->active) {
		tm_globs->flags |=REPLY_NONE;
	}
	if (GTK_TOGGLE_BUTTON (lookup_widget (prefs, "reply_quoted"))->active) {
		tm_globs->flags |=REPLY_QUOTED;
	}
}

void preferences_rehash_interface () {
	GtkWidget *widget=prefs_widget;
	GList *accts=pop_create_glist ();
	PopAccount *seek;
	if (!GTK_IS_WIDGET (prefs_widget))
		return;
	if (accts) gtk_combo_set_popdown_strings (GTK_COMBO (lw (prefs_widget, "combo2")), accts);
#if DEBUG > 3
	printf ("flags: %08lX\n", tm_globs->flags);
	printf ("real_name: %p\n", tm_globs->real_name);
	printf ("email: %p\n", tm_globs->email);
	printf ("replyto: %p\n", tm_globs->replyto);
	printf ("organization: %p\n", tm_globs->organization);
	printf ("default_account: %p\n", tm_globs->default_account);
	printf ("signature: %p\n", tm_globs->signature);
#endif

	st (widget, "name_entry", tm_globs->real_name);
	st (widget, "email_addy_entry", tm_globs->email);
	st (widget, "reply_entry", tm_globs->replyto);
	st (widget, "org_entry", tm_globs->organization);
	st (widget, "combo_entry2", tm_globs->default_account);
	st (widget, "autosignature", tm_globs->signature);
#ifdef WANTLDAP
	st (widget, "l_entry_host", tm_globs->ldap_host);
	st (widget, "l_entry_username", tm_globs->ldap_username);
	st (widget, "l_entry_password", tm_globs->ldap_password);
	st (widget, "l_entry_base", tm_globs->ldap_base);
#endif
	if (tm_globs->flags & USE_SIGNATURE)
		tba (widget, "use_autosig");
	if (tm_globs->flags & HIDE_STATUS_WINDOW)
		tba (widget, "hide_status");
	if (tm_globs->flags & SHOW_SOME_HEADER) {
		tba (widget, "header_some");
	} else {
		if ((tm_globs->flags & SHOW_ALL_HEADER) == SHOW_ALL_HEADER) {
			tba (widget, "header_all");
		} else {
				tba (widget, "header_none");
		}
	}
	if (tm_globs->flags & REPLY_NONE) {
		tba (widget, "reply_none");
	} else {
		if (tm_globs->flags & REPLY_QUOTED) {
			tba (widget, "reply_quoted");
		} else {
			tba (widget, "reply_attach");
		}
	}
	for (seek=first_popaccount();seek;seek=seek->next) {
		prefs_display_server (GTK_CLIST (lw (widget, "server_clist")), seek);
	}
}

void insert_autosig_callback (GtkWidget *widget, gpointer data)
{
#if DEBUG > 3
	printf ("insert_autosig_callback(): begin\n");
#endif

#if DEBUG > 3
	printf ("insert_autosig_callback(): end\n");
#endif
}

void prefs_server_bpe(GtkWidget *widget, GdkEvent *event, gpointer data) {
        if (event->type == GDK_BUTTON_PRESS) return;
	prefs_edit_account (NULL, NULL);
}

void paned_pos_rehash() {
	if (!tm_globs->ppos.mnw_hp1) tm_globs->ppos.mnw_hp1 = 186;
	if (!tm_globs->ppos.mnw_vp1) tm_globs->ppos.mnw_vp1 = 161;
	if (!tm_globs->ppos.mnw_vp2) tm_globs->ppos.mnw_vp2 = 175;
	if (!tm_globs->ppos.msgw_vp1) tm_globs->ppos.msgw_vp1 = 150;

	gtk_paned_set_position(GTK_PANED(lookup_widget(GTK_WIDGET(tm_globs->main_window),"hpaned1")),tm_globs->ppos.mnw_hp1);
	gtk_paned_set_position(GTK_PANED(lookup_widget(GTK_WIDGET(tm_globs->main_window),"vpaned1")),tm_globs->ppos.mnw_vp1);
	gtk_paned_set_position(GTK_PANED(lookup_widget(GTK_WIDGET(tm_globs->main_window),"mime_vpaned")),tm_globs->ppos.mnw_vp2);
}

void paned_pos_set(char *ppos) {
  char *cs;
  char *orph ;


  if ((atoi(orph=cut_string(ppos,' ',1,1))) >= 0) {
    free( orph ) ;
    cs = cut_string(ppos,' ',1,2);
    tm_globs->ppos.mnw_hp1=atoi(orph=cut_string(cs,' ',2,1));
    free( orph ) ;
    free (cs);
    cs = cut_string(ppos,' ',1,3);
    tm_globs->ppos.mnw_vp1=atoi(orph=cut_string(cs,' ',2,2));
    free( orph ) ;
    free (cs);
    cs = cut_string(ppos,' ',1,4);
    tm_globs->ppos.mnw_vp2=atoi(orph=cut_string(cs,' ',2,3));
    free( orph ) ;
    free (cs);
    tm_globs->ppos.msgw_vp1=atoi(orph=cut_string(ppos,' ',2,4));
    free( orph ) ;
  } else {
    free( orph ) ;
  }
}


void window_sizes_set (char *sizes) {
  char *cs;
  char *orph ;


  if ((atoi(orph=cut_string(sizes,' ',1,1))) >= 0) {
    free( orph ) ;
    cs = cut_string(sizes,' ',1,2);
    tm_globs->wsize.main_window.x=atoi(orph=cut_string(cs,' ',2,1));
    free( orph ) ;
    free (cs);
    cs = cut_string(sizes,' ',1,3);
    tm_globs->wsize.main_window.y=atoi(orph=cut_string(cs,' ',2,2));
    free( orph ) ;
    free (cs);
    cs = cut_string(sizes,' ',1,4);
    tm_globs->wsize.new_message_window.x=atoi(orph=cut_string(cs,' ',2,3));
    free( orph ) ;
    free (cs);
    cs = cut_string(sizes,' ',1,5);
    tm_globs->wsize.new_message_window.y=atoi(orph=cut_string(cs,' ',2,4));
    free( orph ) ;
    free (cs);
    cs = cut_string(sizes,' ',1,6);
    tm_globs->wsize.message_window.x=atoi(orph=cut_string(cs,' ',2,5));
    free( orph ) ;
    free (cs);
    cs = cut_string(sizes,' ',1,7);
    tm_globs->wsize.message_window.y=atoi(orph=cut_string(cs,' ',2,6));
    free( orph ) ;
    free (cs);
    cs = cut_string(sizes,' ',1,8);
    tm_globs->wsize.calendar_window.x=atoi(orph=cut_string(cs,' ',2,7));
    free( orph ) ;
    free (cs);
    cs = cut_string(sizes,' ',1,9);
    tm_globs->wsize.calendar_window.y=atoi(orph=cut_string(cs,' ',2,8));
    free( orph ) ;
    free (cs);
    cs = cut_string(sizes,' ',1,10);
    tm_globs->wsize.msearch_window.x=atoi(orph=cut_string(cs,' ',2,9));
    free( orph ) ;
    free (cs);
    tm_globs->wsize.msearch_window.y=atoi(orph=cut_string(sizes,' ',2,10));
    free( orph ) ;
  }

  return ;
}

void clist_pos_rehash() {
	GtkWidget *fl=lookup_widget(tm_globs->main_window,"folder_tree");
	GtkWidget *fl2=lookup_widget(tm_globs->main_window,"folder_ntree");
	GtkWidget *msg=lookup_widget(tm_globs->main_window,"message_clist");
	GtkWidget *mime=lookup_widget(tm_globs->main_window,"mime_clist");
	int i;

	if (!fl) return;

	if (!tm_globs->cpos.mw_fl[0]) tm_globs->cpos.mw_fl[0] = 122;
	if (!tm_globs->cpos.mw_fl[1]) tm_globs->cpos.mw_fl[1] = 20;
	if (!tm_globs->cpos.mw_fl[2]) tm_globs->cpos.mw_fl[2] = 16;
	if (!tm_globs->cpos.mw_msg[0]) tm_globs->cpos.mw_msg[0] = 17;
	if (!tm_globs->cpos.mw_msg[1]) tm_globs->cpos.mw_msg[1] = 17;
	if (!tm_globs->cpos.mw_msg[2]) tm_globs->cpos.mw_msg[2] = 150;
	if (!tm_globs->cpos.mw_msg[3]) tm_globs->cpos.mw_msg[3] = 100;
	if (!tm_globs->cpos.mw_msg[4]) tm_globs->cpos.mw_msg[4] = 100;
	if (!tm_globs->cpos.mw_msg[5]) tm_globs->cpos.mw_msg[5] = 100;
	if (!tm_globs->cpos.mw_mime[0]) tm_globs->cpos.mw_mime[0] = 91;
	if (!tm_globs->cpos.mw_mime[1]) tm_globs->cpos.mw_mime[1] = 150;
	if (!tm_globs->cpos.mw_mime[2]) tm_globs->cpos.mw_mime[2] = 23;
	if (!tm_globs->cpos.msgw[0]) tm_globs->cpos.msgw[0] = 142;
	if (!tm_globs->cpos.msgw[1]) tm_globs->cpos.msgw[1] = 201;
	if (!tm_globs->cpos.msgw[2]) tm_globs->cpos.msgw[2] = 114;
	if (!tm_globs->cpos.nmsgw[0]) tm_globs->cpos.nmsgw[0] = 133;
	if (!tm_globs->cpos.nmsgw[1]) tm_globs->cpos.nmsgw[1] = 185;
	if (!tm_globs->cpos.nmsgw[2]) tm_globs->cpos.nmsgw[2] = 134;
	if (!tm_globs->cpos.ab[0]) tm_globs->cpos.ab[0] = 173;
	if (!tm_globs->cpos.ab[1]) tm_globs->cpos.ab[1] = 173;
        if (!tm_globs->cpos.msw[0]) tm_globs->cpos.msw[0] = 17;
        if (!tm_globs->cpos.msw[1]) tm_globs->cpos.msw[1] = 17;
        if (!tm_globs->cpos.msw[2]) tm_globs->cpos.msw[2] = 150;
        if (!tm_globs->cpos.msw[3]) tm_globs->cpos.msw[3] = 100;
        if (!tm_globs->cpos.msw[4]) tm_globs->cpos.msw[4] = 100;
        if (!tm_globs->cpos.msw[5]) tm_globs->cpos.msw[5] = 100;

	for (i=0;i<3;i++) {
		gtk_clist_set_column_width (GTK_CLIST (fl), i, tm_globs->cpos.mw_fl[i]);
		gtk_clist_set_column_width (GTK_CLIST (fl2), i, tm_globs->cpos.mw_fl[i]);
        }
	for (i=0;i<6;i++)
		gtk_clist_set_column_width (GTK_CLIST (msg), i, tm_globs->cpos.mw_msg[i]);
	for (i=0;i<3;i++)
		gtk_clist_set_column_width (GTK_CLIST (mime), i, tm_globs->cpos.mw_mime[i]);
}

void clist_pos_set (char *pos) {
  char *cs;
  char *orph ;


  if ((atoi(orph=cut_string(pos,' ',1,1))) >= 0) {
    free( orph ) ;
    cs = cut_string(pos,' ',1,2);
    tm_globs->cpos.mw_fl[0] = atoi(orph=cut_string(cs,' ',2,1));
    free( orph ) ;
    free (cs);
    cs = cut_string(pos,' ',1,3);
    tm_globs->cpos.mw_fl[1] = atoi(orph=cut_string(cs,' ',2,2));
    free( orph ) ;
    free (cs);
    cs = cut_string(pos,' ',1,4);
    tm_globs->cpos.mw_fl[2] = atoi(orph=cut_string(cs,' ',2,3));
    free( orph ) ;
    free (cs);
    cs = cut_string(pos,' ',1,5);
    tm_globs->cpos.mw_msg[0] = atoi(orph=cut_string(cs,' ',2,4));
    free( orph ) ;
    free (cs);
    cs = cut_string(pos,' ',1,6);
    tm_globs->cpos.mw_msg[1] = atoi(orph=cut_string(cs,' ',2,5));
    free( orph ) ;
    free (cs);
    cs = cut_string(pos,' ',1,7);
    tm_globs->cpos.mw_msg[2] = atoi(orph=cut_string(cs,' ',2,6));
    free( orph ) ;
    free (cs);
    cs = cut_string(pos,' ',1,8);
    tm_globs->cpos.mw_msg[3] = atoi(orph=cut_string(cs,' ',2,7));
    free( orph ) ;
    free (cs);
    cs = cut_string(pos,' ',1,9);
    tm_globs->cpos.mw_msg[4] = atoi(orph=cut_string(cs,' ',2,8));
    free( orph ) ;
    free (cs);
    cs = cut_string(pos,' ',1,10);
    tm_globs->cpos.mw_msg[5] = atoi(orph=cut_string(cs,' ',2,9));
    free( orph ) ;
    free (cs);
    cs = cut_string(pos,' ',1,11);
    tm_globs->cpos.mw_mime[0] = atoi(orph=cut_string(cs,' ',2,10));
    free( orph ) ;
    free (cs);
    cs = cut_string(pos,' ',1,12);
    tm_globs->cpos.mw_mime[1] = atoi(orph=cut_string(cs,' ',2,11));
    free( orph ) ;
    free (cs);
    cs = cut_string(pos,' ',1,13);
    tm_globs->cpos.mw_mime[2] = atoi(orph=cut_string(cs,' ',2,12));
    free( orph ) ;
    free (cs);
    cs = cut_string(pos,' ',1,14);
    tm_globs->cpos.msgw[0] = atoi(orph=cut_string(cs,' ',2,13));
    free( orph ) ;
    free (cs);
    cs = cut_string(pos,' ',1,15);
    tm_globs->cpos.msgw[1] = atoi(orph=cut_string(cs,' ',2,14));
    free( orph ) ;
    free (cs);
    cs = cut_string(pos,' ',1,16);
    tm_globs->cpos.msgw[2] = atoi(orph=cut_string(cs,' ',2,15));
    free( orph ) ;
    free (cs);
    cs = cut_string(pos,' ',1,17);
    tm_globs->cpos.nmsgw[0] = atoi(orph=cut_string(cs,' ',2,16));
    free( orph ) ;
    free (cs);
    cs = cut_string(pos,' ',1,18);
    tm_globs->cpos.nmsgw[1] = atoi(orph=cut_string(cs,' ',2,17));
    free( orph ) ;
    free (cs);
    cs = cut_string(pos,' ',1,19);
    tm_globs->cpos.nmsgw[2] = atoi(orph=cut_string(cs,' ',2,18));
    free( orph ) ;
    free (cs);
    cs = cut_string(pos,' ',1,20);
    tm_globs->cpos.ab[0] = atoi(orph=cut_string(cs,' ',2,19));
    free( orph ) ;
    free (cs);
    cs = cut_string(pos,' ',1,21);
    tm_globs->cpos.ab[1] = atoi(orph=cut_string(cs,' ',2,20));
    free( orph ) ;
    free (cs);
    cs = cut_string(pos,' ',1,22);
    tm_globs->cpos.msw[0] = atoi(orph=cut_string(cs,' ',2,21));
    free( orph ) ;
    free (cs);
    cs = cut_string(pos,' ',1,23);
    tm_globs->cpos.msw[1] = atoi(orph=cut_string(cs,' ',2,22));
    free( orph ) ;
    free (cs);
    cs = cut_string(pos,' ',1,24);
    tm_globs->cpos.msw[2] = atoi(orph=cut_string(cs,' ',2,23));
    free( orph ) ;
    free (cs);
    cs = cut_string(pos,' ',1,25);
    tm_globs->cpos.msw[3] = atoi(orph=cut_string(cs,' ',2,24));
    free( orph ) ;
    free (cs);
    cs = cut_string(pos,' ',1,26);
    tm_globs->cpos.msw[4] = atoi(orph=cut_string(cs,' ',2,25));
    free( orph ) ;
    free (cs);
    tm_globs->cpos.msw[5] = atoi(orph=cut_string(pos,' ',2,26));
    free( orph ) ;
  }
}



void window_sizes_rehash() {
	if (!tm_globs->wsize.main_window.x) tm_globs->wsize.main_window.x = 620;
	if (!tm_globs->wsize.main_window.y) tm_globs->wsize.main_window.y = 440;
        if (!tm_globs->wsize.message_window.x) tm_globs->wsize.message_window.x = 500;
        if (!tm_globs->wsize.message_window.y) tm_globs->wsize.message_window.y = 440;
        if (!tm_globs->wsize.new_message_window.x) tm_globs->wsize.new_message_window.x = 500;
        if (!tm_globs->wsize.new_message_window.y) tm_globs->wsize.new_message_window.y = 440;
        if (!tm_globs->wsize.calendar_window.x) tm_globs->wsize.calendar_window.x = 620;
        if (!tm_globs->wsize.calendar_window.y) tm_globs->wsize.calendar_window.y = 440;
        if (!tm_globs->wsize.msearch_window.x) tm_globs->wsize.msearch_window.x = 540;
        if (!tm_globs->wsize.msearch_window.y) tm_globs->wsize.msearch_window.y = 400;

	gtk_window_set_default_size(GTK_WINDOW(tm_globs->main_window),tm_globs->wsize.main_window.x, tm_globs->wsize.main_window.y);
}

void wsize_set_msw(GtkWidget *widget, GdkEvent *event, gpointer data) {
        tm_globs->wsize.msearch_window.x = widget->allocation.width;
        tm_globs->wsize.msearch_window.y = widget->allocation.height;
}

void wsize_set_mnw(GtkWidget *widget, GdkEvent *event, gpointer data) {
	tm_globs->wsize.main_window.x = widget->allocation.width;
	tm_globs->wsize.main_window.y = widget->allocation.height;
}

void wsize_set_msgw(GtkWidget *widget, GdkEvent *event, gpointer data) {
        tm_globs->wsize.message_window.x = widget->allocation.width;
        tm_globs->wsize.message_window.y = widget->allocation.height;
}

void wsize_set_nmsgw(GtkWidget *widget, GdkEvent *event, gpointer data) {
        tm_globs->wsize.new_message_window.x = widget->allocation.width;
        tm_globs->wsize.new_message_window.y = widget->allocation.height;
}

void wsize_set_calw(GtkWidget *widget, GdkEvent *event, gpointer data) {
        tm_globs->wsize.calendar_window.x = widget->allocation.width;
        tm_globs->wsize.calendar_window.y = widget->allocation.height;
}

void ppos_set_mnw(GtkWidget *widget, GdkEvent *event, gpointer data) {
	GtkWidget *window=tm_globs->main_window;
	GtkWidget *hp1=lookup_widget(window,"hpaned1");
	GtkWidget *vp1=lookup_widget(window,"vpaned1");
	GtkWidget *vp2=lookup_widget(window,"mime_vpaned");

	tm_globs->ppos.mnw_hp1 = GTK_PANED(hp1)->handle_xpos;
	tm_globs->ppos.mnw_vp1 = GTK_PANED(vp1)->handle_ypos;
	tm_globs->ppos.mnw_vp2 = GTK_PANED(vp2)->handle_ypos;
}

void ppos_set_msgw(GtkWidget *widget, GdkEvent *event, gpointer data) {
	tm_globs->ppos.msgw_vp1 = GTK_PANED(widget)->handle_ypos;
}

void cpos_set_msw(GtkCList *clist, gint column, gint width, gpointer data) {
        tm_globs->cpos.msw[column] = width;
}

void cpos_set_mnw_fl(GtkCList *clist, gint column, gint width, gpointer data) {
	tm_globs->cpos.mw_fl[column] = width;
}

void cpos_set_mnw_msg(GtkCList *clist, gint column, gint width, gpointer data) {
	tm_globs->cpos.mw_msg[column] = width;
}
void cpos_set_mnw_mime(GtkCList *clist, gint column, gint width, gpointer data) {
	tm_globs->cpos.mw_mime[column] = width;
}

void cpos_set_msgw(GtkCList *clist, gint column, gint width, gpointer data) {
	tm_globs->cpos.msgw[column] = width;
}

void cpos_set_nmsgw(GtkCList *clist, gint column, gint width, gpointer data) {
	tm_globs->cpos.nmsgw[column] = width;
}

void cpos_set_ab(GtkCList *clist, gint column, gint width, gpointer data) {
	tm_globs->cpos.ab[column] = width;
}
