/* TradeClient <http://tradeclient.sourceforge.net>
 * $Id: status-callbacks.c,v 1.5 2001/03/20 22:19:33 ttabner Exp $
 *
 * Copyright (C) 1999-2000 Bynari Inc.
 * Copyright (C) 2001 Project TradeClient
 *
 * LGPL
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#include "puma.h"

void stop_transaction_clicked (GtkWidget *widget, gpointer data) {
	pipe_child_stat_put (STOP, "", 0);
}

void skip_account_clicked (GtkWidget *widget, gpointer data) {
	pipe_child_stat_put (SKIP, "", 0);
}

void status_toggle_error_only (GtkWidget *widget, gpointer data) {
	if (GTK_IS_WIDGET (prefs_get_widget ())) {
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (lookup_widget (prefs_get_widget (), "hide_status")), 
		                              GTK_TOGGLE_BUTTON (widget)->active);
	}
	if (GTK_TOGGLE_BUTTON (widget)->active) {
		tm_globs->flags |= HIDE_STATUS_WINDOW ;
	} else {
		tm_globs->flags &= ~HIDE_STATUS_WINDOW ;
	}

	return ;
}


void status_toggle_hide_when_done (GtkWidget *widget, gpointer data) {
  if (GTK_TOGGLE_BUTTON (widget)->active) {
    tm_globs->flags |= HIDE_STATUS_WHEN_DONE ;
  }	else {
    tm_globs->flags &= ~HIDE_STATUS_WHEN_DONE ;
  }

  return ;
}



void destroy_status (GtkWidget *widget, gpointer data) {
	gtk_widget_hide (widget);
}



void show_status (GtkWidget *widget, gpointer data) {
	if (!GTK_IS_WIDGET (tm_globs->status)) {
		tm_globs->status=create_status_window ();
	}
	if (tm_globs->flags & HIDE_STATUS_WINDOW) {
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (lookup_widget (tm_globs->status, "checkbutton1")), TRUE);
	}
	if (tm_globs->flags & HIDE_STATUS_WHEN_DONE) {
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (lookup_widget (tm_globs->status, "checkbutton2")), TRUE);
	}
	gtk_widget_show (tm_globs->status);

	return ;
}
